/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 5 $
 *   $Date: 24.01.07 20:16 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Softel.Common;
using Softel.MiddleTier.Client;

namespace Softel.Windows.Forms.TwoGridParam
{
	/// <summary>
	/// Summary description for BaseGridParam.
	/// </summary>
	public class TwoGridParam : Content, ITreeBaseForm
	{
		private ToolBar m_tbMain;
		private Panel m_pnlLeft;
		private Splitter m_splLeft;
		private IContainer components;

		private ParamsDialog m_pdMain;
		private ActionList m_alMain;
		private Action m_actSave;
		private Action m_actDelete;
		private Action m_actRefresh;
		private ImageList SoftelImageList;
		private ToolBarButton m_btnSave;
		private ToolBarButton m_btnDelete;
		private ToolBarButton m_btnRefresh;
		private ContextMenu m_cmMain;
		private MenuItem m_miAdd;
		private MenuItem m_miModify;
		private MenuItem m_miDelete;
		private System.Windows.Forms.Panel m_pnlGrids;
		private Softel.Windows.Forms.CuteSoftelGrid m_grdMain;
		private Softel.Windows.Forms.CuteSoftelGrid m_grdSecond;
		private System.Windows.Forms.Splitter m_splTopBottom;
		private Hashtable htArgs;

		public TwoGridParam()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		private Param CreateParam(
			string strName,
			string strCaption,
			string strType)
		{
			ParamsType ptTyp = new ParamsType();
			object DefVal = new object();
			switch (strType)
			{
				case "DateTime":
					ptTyp = ParamsType.DateTime;
					DefVal = DateTime.Today;
					break;
				case "Int":
					ptTyp = ParamsType.Int;
					DefVal = 0;
					break;
				case "Boolean":
					ptTyp = ParamsType.Boolean;
					DefVal = false;
					break;
				case "Float":
					ptTyp = ParamsType.Float;
					DefVal = 0.0;
					break;
				case "Data":
					ptTyp = ParamsType.Data;
					break;
				case "String":
					ptTyp = ParamsType.String;
					DefVal = "";
					break;
				case "Image":
					ptTyp = ParamsType.Image;
					break;
			}
			htArgs[strName] = DefVal;
			Param parCr = new Param(
				strName,
				strCaption,
				ptTyp,
				ResourceControl.String1,
				strCaption,
				DefVal);
			return parCr;
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TwoGridParam));
			this.m_tbMain = new System.Windows.Forms.ToolBar();
			this.m_btnSave = new System.Windows.Forms.ToolBarButton();
			this.m_btnDelete = new System.Windows.Forms.ToolBarButton();
			this.m_btnRefresh = new System.Windows.Forms.ToolBarButton();
			this.SoftelImageList = new System.Windows.Forms.ImageList(this.components);
			this.m_pnlLeft = new System.Windows.Forms.Panel();
			this.m_splLeft = new System.Windows.Forms.Splitter();
			this.m_alMain = new Softel.Windows.Forms.ActionList(this.components);
			this.m_actSave = new Softel.Windows.Forms.Action(this.components);
			this.m_actDelete = new Softel.Windows.Forms.Action(this.components);
			this.m_actRefresh = new Softel.Windows.Forms.Action(this.components);
			this.m_cmMain = new System.Windows.Forms.ContextMenu();
			this.m_miAdd = new System.Windows.Forms.MenuItem();
			this.m_miModify = new System.Windows.Forms.MenuItem();
			this.m_miDelete = new System.Windows.Forms.MenuItem();
			this.m_pnlGrids = new System.Windows.Forms.Panel();
			this.m_splTopBottom = new System.Windows.Forms.Splitter();
			this.m_grdSecond = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_grdMain = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_pnlGrids.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.m_grdSecond)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdMain)).BeginInit();
			this.SuspendLayout();
			// 
			// m_tbMain
			// 
			this.m_tbMain.AccessibleDescription = resources.GetString("m_tbMain.AccessibleDescription");
			this.m_tbMain.AccessibleName = resources.GetString("m_tbMain.AccessibleName");
			this.m_tbMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tbMain.Anchor")));
			this.m_tbMain.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("m_tbMain.Appearance")));
			this.m_tbMain.AutoSize = ((bool)(resources.GetObject("m_tbMain.AutoSize")));
			this.m_tbMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tbMain.BackgroundImage")));
			this.m_tbMain.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.m_btnSave,
																						this.m_btnDelete,
																						this.m_btnRefresh});
			this.m_tbMain.ButtonSize = ((System.Drawing.Size)(resources.GetObject("m_tbMain.ButtonSize")));
			this.m_tbMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tbMain.Dock")));
			this.m_tbMain.DropDownArrows = ((bool)(resources.GetObject("m_tbMain.DropDownArrows")));
			this.m_tbMain.Enabled = ((bool)(resources.GetObject("m_tbMain.Enabled")));
			this.m_tbMain.Font = ((System.Drawing.Font)(resources.GetObject("m_tbMain.Font")));
			this.m_tbMain.ImageList = this.SoftelImageList;
			this.m_tbMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tbMain.ImeMode")));
			this.m_tbMain.Location = ((System.Drawing.Point)(resources.GetObject("m_tbMain.Location")));
			this.m_tbMain.Name = "m_tbMain";
			this.m_tbMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tbMain.RightToLeft")));
			this.m_tbMain.ShowToolTips = ((bool)(resources.GetObject("m_tbMain.ShowToolTips")));
			this.m_tbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tbMain.Size")));
			this.m_tbMain.TabIndex = ((int)(resources.GetObject("m_tbMain.TabIndex")));
			this.m_tbMain.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("m_tbMain.TextAlign")));
			this.m_tbMain.Visible = ((bool)(resources.GetObject("m_tbMain.Visible")));
			this.m_tbMain.Wrappable = ((bool)(resources.GetObject("m_tbMain.Wrappable")));
			// 
			// m_btnSave
			// 
			this.m_alMain.SetAction(this.m_btnSave, this.m_actSave);
			this.m_btnSave.Enabled = ((bool)(resources.GetObject("m_btnSave.Enabled")));
			this.m_btnSave.ImageIndex = ((int)(resources.GetObject("m_btnSave.ImageIndex")));
			this.m_btnSave.Text = resources.GetString("m_btnSave.Text");
			this.m_btnSave.ToolTipText = resources.GetString("m_btnSave.ToolTipText");
			this.m_btnSave.Visible = ((bool)(resources.GetObject("m_btnSave.Visible")));
			// 
			// m_btnDelete
			// 
			this.m_alMain.SetAction(this.m_btnDelete, this.m_actDelete);
			this.m_btnDelete.Enabled = ((bool)(resources.GetObject("m_btnDelete.Enabled")));
			this.m_btnDelete.ImageIndex = ((int)(resources.GetObject("m_btnDelete.ImageIndex")));
			this.m_btnDelete.Text = resources.GetString("m_btnDelete.Text");
			this.m_btnDelete.ToolTipText = resources.GetString("m_btnDelete.ToolTipText");
			this.m_btnDelete.Visible = ((bool)(resources.GetObject("m_btnDelete.Visible")));
			// 
			// m_btnRefresh
			// 
			this.m_alMain.SetAction(this.m_btnRefresh, this.m_actRefresh);
			this.m_btnRefresh.Enabled = ((bool)(resources.GetObject("m_btnRefresh.Enabled")));
			this.m_btnRefresh.ImageIndex = ((int)(resources.GetObject("m_btnRefresh.ImageIndex")));
			this.m_btnRefresh.Text = resources.GetString("m_btnRefresh.Text");
			this.m_btnRefresh.ToolTipText = resources.GetString("m_btnRefresh.ToolTipText");
			this.m_btnRefresh.Visible = ((bool)(resources.GetObject("m_btnRefresh.Visible")));
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageSize = ((System.Drawing.Size)(resources.GetObject("SoftelImageList.ImageSize")));
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			this.SoftelImageList.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// m_pnlLeft
			// 
			this.m_pnlLeft.AccessibleDescription = resources.GetString("m_pnlLeft.AccessibleDescription");
			this.m_pnlLeft.AccessibleName = resources.GetString("m_pnlLeft.AccessibleName");
			this.m_pnlLeft.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlLeft.Anchor")));
			this.m_pnlLeft.AutoScroll = ((bool)(resources.GetObject("m_pnlLeft.AutoScroll")));
			this.m_pnlLeft.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlLeft.AutoScrollMargin")));
			this.m_pnlLeft.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlLeft.AutoScrollMinSize")));
			this.m_pnlLeft.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlLeft.BackgroundImage")));
			this.m_pnlLeft.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlLeft.Dock")));
			this.m_pnlLeft.Enabled = ((bool)(resources.GetObject("m_pnlLeft.Enabled")));
			this.m_pnlLeft.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlLeft.Font")));
			this.m_pnlLeft.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlLeft.ImeMode")));
			this.m_pnlLeft.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlLeft.Location")));
			this.m_pnlLeft.Name = "m_pnlLeft";
			this.m_pnlLeft.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlLeft.RightToLeft")));
			this.m_pnlLeft.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlLeft.Size")));
			this.m_pnlLeft.TabIndex = ((int)(resources.GetObject("m_pnlLeft.TabIndex")));
			this.m_pnlLeft.Text = resources.GetString("m_pnlLeft.Text");
			this.m_pnlLeft.Visible = ((bool)(resources.GetObject("m_pnlLeft.Visible")));
			// 
			// m_splLeft
			// 
			this.m_splLeft.AccessibleDescription = resources.GetString("m_splLeft.AccessibleDescription");
			this.m_splLeft.AccessibleName = resources.GetString("m_splLeft.AccessibleName");
			this.m_splLeft.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splLeft.Anchor")));
			this.m_splLeft.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splLeft.BackgroundImage")));
			this.m_splLeft.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splLeft.Dock")));
			this.m_splLeft.Enabled = ((bool)(resources.GetObject("m_splLeft.Enabled")));
			this.m_splLeft.Font = ((System.Drawing.Font)(resources.GetObject("m_splLeft.Font")));
			this.m_splLeft.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splLeft.ImeMode")));
			this.m_splLeft.Location = ((System.Drawing.Point)(resources.GetObject("m_splLeft.Location")));
			this.m_splLeft.MinExtra = ((int)(resources.GetObject("m_splLeft.MinExtra")));
			this.m_splLeft.MinSize = ((int)(resources.GetObject("m_splLeft.MinSize")));
			this.m_splLeft.Name = "m_splLeft";
			this.m_splLeft.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splLeft.RightToLeft")));
			this.m_splLeft.Size = ((System.Drawing.Size)(resources.GetObject("m_splLeft.Size")));
			this.m_splLeft.TabIndex = ((int)(resources.GetObject("m_splLeft.TabIndex")));
			this.m_splLeft.TabStop = false;
			this.m_splLeft.Visible = ((bool)(resources.GetObject("m_splLeft.Visible")));
			// 
			// m_alMain
			// 
			this.m_alMain.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																				 this.m_actSave,
																				 this.m_actDelete,
																				 this.m_actRefresh});
			this.m_alMain.ImageList = this.SoftelImageList;
			this.m_alMain.ShowTextOnToolBar = false;
			this.m_alMain.Tag = null;
			// 
			// m_actSave
			// 
			this.m_actSave.Checked = false;
			this.m_actSave.Enabled = true;
			this.m_actSave.Hint = resources.GetString("m_actSave.Hint");
			this.m_actSave.ImageIndex = ((int)(resources.GetObject("m_actSave.ImageIndex")));
			this.m_actSave.MergeOrder = 12;
			this.m_actSave.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actSave.Tag = null;
			this.m_actSave.Text = resources.GetString("m_actSave.Text");
			this.m_actSave.Visible = true;
			this.m_actSave.Execute += new System.EventHandler(this.m_actSave_Execute);
			// 
			// m_actDelete
			// 
			this.m_actDelete.Checked = false;
			this.m_actDelete.Enabled = true;
			this.m_actDelete.Hint = resources.GetString("m_actDelete.Hint");
			this.m_actDelete.ImageIndex = ((int)(resources.GetObject("m_actDelete.ImageIndex")));
			this.m_actDelete.MergeOrder = 13;
			this.m_actDelete.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDelete.Tag = null;
			this.m_actDelete.Text = resources.GetString("m_actDelete.Text");
			this.m_actDelete.Visible = true;
			this.m_actDelete.Execute += new System.EventHandler(this.m_actDelete_Execute);
			// 
			// m_actRefresh
			// 
			this.m_actRefresh.Checked = false;
			this.m_actRefresh.Enabled = true;
			this.m_actRefresh.Hint = resources.GetString("m_actRefresh.Hint");
			this.m_actRefresh.ImageIndex = ((int)(resources.GetObject("m_actRefresh.ImageIndex")));
			this.m_actRefresh.MergeOrder = 21;
			this.m_actRefresh.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actRefresh.Tag = null;
			this.m_actRefresh.Text = resources.GetString("m_actRefresh.Text");
			this.m_actRefresh.Visible = true;
			this.m_actRefresh.Execute += new System.EventHandler(this.m_actRefresh_Execute);
			// 
			// m_cmMain
			// 
			this.m_cmMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.m_miAdd,
																					 this.m_miModify,
																					 this.m_miDelete});
			this.m_cmMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmMain.RightToLeft")));
			// 
			// m_miAdd
			// 
			this.m_miAdd.Enabled = ((bool)(resources.GetObject("m_miAdd.Enabled")));
			this.m_miAdd.Index = 0;
			this.m_miAdd.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miAdd.Shortcut")));
			this.m_miAdd.ShowShortcut = ((bool)(resources.GetObject("m_miAdd.ShowShortcut")));
			this.m_miAdd.Text = resources.GetString("m_miAdd.Text");
			this.m_miAdd.Visible = ((bool)(resources.GetObject("m_miAdd.Visible")));
			this.m_miAdd.Click += new System.EventHandler(this.AddItem);
			// 
			// m_miModify
			// 
			this.m_miModify.Enabled = ((bool)(resources.GetObject("m_miModify.Enabled")));
			this.m_miModify.Index = 1;
			this.m_miModify.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miModify.Shortcut")));
			this.m_miModify.ShowShortcut = ((bool)(resources.GetObject("m_miModify.ShowShortcut")));
			this.m_miModify.Text = resources.GetString("m_miModify.Text");
			this.m_miModify.Visible = ((bool)(resources.GetObject("m_miModify.Visible")));
			// 
			// m_miDelete
			// 
			this.m_miDelete.Enabled = ((bool)(resources.GetObject("m_miDelete.Enabled")));
			this.m_miDelete.Index = 2;
			this.m_miDelete.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDelete.Shortcut")));
			this.m_miDelete.ShowShortcut = ((bool)(resources.GetObject("m_miDelete.ShowShortcut")));
			this.m_miDelete.Text = resources.GetString("m_miDelete.Text");
			this.m_miDelete.Visible = ((bool)(resources.GetObject("m_miDelete.Visible")));
			// 
			// m_pnlGrids
			// 
			this.m_pnlGrids.AccessibleDescription = resources.GetString("m_pnlGrids.AccessibleDescription");
			this.m_pnlGrids.AccessibleName = resources.GetString("m_pnlGrids.AccessibleName");
			this.m_pnlGrids.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlGrids.Anchor")));
			this.m_pnlGrids.AutoScroll = ((bool)(resources.GetObject("m_pnlGrids.AutoScroll")));
			this.m_pnlGrids.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlGrids.AutoScrollMargin")));
			this.m_pnlGrids.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlGrids.AutoScrollMinSize")));
			this.m_pnlGrids.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlGrids.BackgroundImage")));
			this.m_pnlGrids.Controls.Add(this.m_splTopBottom);
			this.m_pnlGrids.Controls.Add(this.m_grdSecond);
			this.m_pnlGrids.Controls.Add(this.m_grdMain);
			this.m_pnlGrids.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlGrids.Dock")));
			this.m_pnlGrids.Enabled = ((bool)(resources.GetObject("m_pnlGrids.Enabled")));
			this.m_pnlGrids.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlGrids.Font")));
			this.m_pnlGrids.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlGrids.ImeMode")));
			this.m_pnlGrids.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlGrids.Location")));
			this.m_pnlGrids.Name = "m_pnlGrids";
			this.m_pnlGrids.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlGrids.RightToLeft")));
			this.m_pnlGrids.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlGrids.Size")));
			this.m_pnlGrids.TabIndex = ((int)(resources.GetObject("m_pnlGrids.TabIndex")));
			this.m_pnlGrids.Text = resources.GetString("m_pnlGrids.Text");
			this.m_pnlGrids.Visible = ((bool)(resources.GetObject("m_pnlGrids.Visible")));
			// 
			// m_splTopBottom
			// 
			this.m_splTopBottom.AccessibleDescription = resources.GetString("m_splTopBottom.AccessibleDescription");
			this.m_splTopBottom.AccessibleName = resources.GetString("m_splTopBottom.AccessibleName");
			this.m_splTopBottom.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splTopBottom.Anchor")));
			this.m_splTopBottom.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splTopBottom.BackgroundImage")));
			this.m_splTopBottom.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splTopBottom.Dock")));
			this.m_splTopBottom.Enabled = ((bool)(resources.GetObject("m_splTopBottom.Enabled")));
			this.m_splTopBottom.Font = ((System.Drawing.Font)(resources.GetObject("m_splTopBottom.Font")));
			this.m_splTopBottom.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splTopBottom.ImeMode")));
			this.m_splTopBottom.Location = ((System.Drawing.Point)(resources.GetObject("m_splTopBottom.Location")));
			this.m_splTopBottom.MinExtra = ((int)(resources.GetObject("m_splTopBottom.MinExtra")));
			this.m_splTopBottom.MinSize = ((int)(resources.GetObject("m_splTopBottom.MinSize")));
			this.m_splTopBottom.Name = "m_splTopBottom";
			this.m_splTopBottom.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splTopBottom.RightToLeft")));
			this.m_splTopBottom.Size = ((System.Drawing.Size)(resources.GetObject("m_splTopBottom.Size")));
			this.m_splTopBottom.TabIndex = ((int)(resources.GetObject("m_splTopBottom.TabIndex")));
			this.m_splTopBottom.TabStop = false;
			this.m_splTopBottom.Visible = ((bool)(resources.GetObject("m_splTopBottom.Visible")));
			// 
			// m_grdSecond
			// 
			this.m_grdSecond.AccessibleDescription = resources.GetString("m_grdSecond.AccessibleDescription");
			this.m_grdSecond.AccessibleName = resources.GetString("m_grdSecond.AccessibleName");
			this.m_grdSecond.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdSecond.Anchor")));
			this.m_grdSecond.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdSecond.BackgroundImage")));
			this.m_grdSecond.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdSecond.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdSecond.CaptionFont")));
			this.m_grdSecond.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdSecond.CaptionText = resources.GetString("m_grdSecond.CaptionText");
			this.m_grdSecond.ContextMenu = this.m_cmMain;
			this.m_grdSecond.DataMember = "";
			this.m_grdSecond.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdSecond.Dock")));
			this.m_grdSecond.Enabled = ((bool)(resources.GetObject("m_grdSecond.Enabled")));
			this.m_grdSecond.Font = ((System.Drawing.Font)(resources.GetObject("m_grdSecond.Font")));
			this.m_grdSecond.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdSecond.HighlightRow = true;
			this.m_grdSecond.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdSecond.ImeMode")));
			this.m_grdSecond.Location = ((System.Drawing.Point)(resources.GetObject("m_grdSecond.Location")));
			this.m_grdSecond.Name = "m_grdSecond";
			this.m_grdSecond.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdSecond.RightToLeft")));
			this.m_grdSecond.Size = ((System.Drawing.Size)(resources.GetObject("m_grdSecond.Size")));
			this.m_grdSecond.TabIndex = ((int)(resources.GetObject("m_grdSecond.TabIndex")));
			this.m_grdSecond.Visible = ((bool)(resources.GetObject("m_grdSecond.Visible")));
			// 
			// m_grdMain
			// 
			this.m_grdMain.AccessibleDescription = resources.GetString("m_grdMain.AccessibleDescription");
			this.m_grdMain.AccessibleName = resources.GetString("m_grdMain.AccessibleName");
			this.m_grdMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdMain.Anchor")));
			this.m_grdMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdMain.BackgroundImage")));
			this.m_grdMain.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdMain.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdMain.CaptionFont")));
			this.m_grdMain.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdMain.CaptionText = resources.GetString("m_grdMain.CaptionText");
			this.m_grdMain.ContextMenu = this.m_cmMain;
			this.m_grdMain.DataMember = "";
			this.m_grdMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdMain.Dock")));
			this.m_grdMain.Enabled = ((bool)(resources.GetObject("m_grdMain.Enabled")));
			this.m_grdMain.Font = ((System.Drawing.Font)(resources.GetObject("m_grdMain.Font")));
			this.m_grdMain.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdMain.HighlightRow = true;
			this.m_grdMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdMain.ImeMode")));
			this.m_grdMain.Location = ((System.Drawing.Point)(resources.GetObject("m_grdMain.Location")));
			this.m_grdMain.Name = "m_grdMain";
			this.m_grdMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdMain.RightToLeft")));
			this.m_grdMain.Size = ((System.Drawing.Size)(resources.GetObject("m_grdMain.Size")));
			this.m_grdMain.TabIndex = ((int)(resources.GetObject("m_grdMain.TabIndex")));
			this.m_grdMain.Visible = ((bool)(resources.GetObject("m_grdMain.Visible")));
			// 
			// TwoGridParam
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.m_pnlGrids);
			this.Controls.Add(this.m_splLeft);
			this.Controls.Add(this.m_pnlLeft);
			this.Controls.Add(this.m_tbMain);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "TwoGridParam";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.TabText = resources.GetString("$this.TabText");
			this.Text = resources.GetString("$this.Text");
			this.ToolTipText = resources.GetString("$this.ToolTipText");
			this.m_pnlGrids.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.m_grdSecond)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdMain)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		public void InitParams(Hashtable htParams)
		{
			htArgs = htParams;
		}
		public Hashtable GetInitParams()
		{
			return htArgs;
		}
		public void Reload()
		{
			EnableButtons(false);
			CreateParamsDialog();
			GetParams();
//			m_grdMain.SetDataGridTableStyle(htArgs["SP_Tuning"].ToString(),
//			                                htArgs["Params_Tuning"].ToString());
//			m_grdSecond.SetDataGridTableStyle(htArgs["SP_Tuning"].ToString(),
//			                                htArgs["Params_Tuning"].ToString());
			GetGrid();
			GetGridSecond();
		}

		private void GetParams()
		{
			string[] strNames = htArgs["ParamName"].ToString().Split('|');
			for (int i = 0; i < m_pdMain.Params.Count; i++)
			{
				htArgs[strNames[i]] = m_pdMain.Params[strNames[i]];
			}
		}

		private void CreateParamsDialog()
		{
			m_pdMain = new ParamsDialog();

			string[] strNames = htArgs["ParamName"].ToString().Split('|');
			string[] strCaptions = htArgs["ParamCaption"].ToString().Split('|');
			string[] strTypes = htArgs["ParamType"].ToString().Split('|');

			for (int i = 0; i < strNames.LongLength; i++)
			{
				Param parAdded = CreateParam(
					strNames[i],
					strCaptions[i],
					strTypes[i]);
				htArgs[strNames[i]] = "";
				m_pdMain.Params.Add(parAdded);
			}

			m_pdMain.Text = ResourceControl.String2;
			m_pdMain.PropertyGrid.PropertySort = PropertySort.Categorized;
			m_pdMain.PropertyGrid.Parent = m_pnlLeft;
			m_pnlLeft.Width = 350;
			m_pdMain.PropertyGrid.ToolbarVisible = false;
			m_pdMain.PropertyGrid.Dock = DockStyle.Fill;
			if (m_pnlLeft.Controls.Count > 1)
				m_pnlLeft.Controls.RemoveAt(0);

		}

		private void GetGrid()
		{
			Command cmdProc = new Command();
			cmdProc.CommandName = htArgs["SP_PG"].ToString();
			string[] strFields = htArgs["Field_PG"].ToString().Split('|');
			string[] strParams = htArgs["Params_PG"].ToString().Split('|');
			if (htArgs["Params_PG"].ToString() != System.DBNull.Value.ToString() &&
				htArgs["Params_PG"].ToString() != "")
			for (int i = 0; i < strFields.LongLength; i++)
			{
				cmdProc.InputParams["@" + strFields[i]] =
					htArgs[strParams[i]];
			}
			cmdProc.Execute(true);

			m_grdMain.DataSource = cmdProc.DataSet.Tables[0];
		}

		private void GetGridSecond()
		{
			Command cmdProc = new Command();
			cmdProc.CommandName = htArgs["SP_Tuning"].ToString();
			string[] strFields = htArgs["Field_Tuning"].ToString().Split('|');
			string[] strParams = htArgs["Params_Tuning"].ToString().Split('|');
			if (htArgs["Params_Tuning"].ToString() != System.DBNull.Value.ToString() &&
				htArgs["Params_Tuning"].ToString() != "")
			for (int i = 0; i < strFields.LongLength; i++)
			{
				cmdProc.InputParams["@" + strFields[i]] =
					htArgs[strParams[i]];
			}
			cmdProc.Execute(true);

			m_grdSecond.DataSource = cmdProc.DataSet.Tables[0];
		}

		private void m_actDelete_Execute(object sender, EventArgs e)
		{
		}

		private void EnableButtons(bool bEnable)
		{
			m_actSave.Enabled = bEnable;
			m_actDelete.Enabled = bEnable;
		}

		private void m_actRefresh_Execute(object sender, EventArgs e)
		{
			Reload();
		}

		private void m_actSave_Execute(object sender, EventArgs e)
		{
		}

		private void AddItem(object sender, EventArgs e)
		{
//			int iIndex;
//			if(Operation(OperationType.Insert,m_grdMaster,null,ref m_dtTuningMaster,m_htMasterParam,out iIndex))
//			{
//				FillInside(m_strGetMaster,m_grdMaster,m_htMasterParam,ref m_dtMaster,m_actDelete,m_actEdit);
//				m_grdMaster.SelectRow(m_strKeyFieldMaster,iIndex.ToString());
//			}
		}
	}
}
/********************* SniipSoftel *****************
 *
 *    $History: TwoGridParam.cs $
 *   
 *   *****************  Version 5  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/BaseGridParam
 *   
 *   *****************  Version 4  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/BaseGridParam
 *   
 *   *****************  Version 3  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/BaseGridParam
 *
 ********************* SniipSoftel *****************/
