/********************* SniipSoftel *****************
 *
 *   $Author: Autobuild $
 *   $Revision: 4 $
 *   $Date: 19.12.06 23:18 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Drawing;
using System.Windows.Forms;

namespace Softel.Windows.Forms.CuteGridColumns
{
	public class CuteGridPaintCellEventArgs : EventArgs
	{
		#region Private variables

		private Rectangle m_bounds;
		private CurrencyManager m_source;

		private Brush m_BackBrush;
		private Brush m_ForeBrush;
		private Color m_TextBoxBackColor;
		private Color m_TextBoxForeColor;
		private Font m_Font;
		private Brush m_SelectionBackBrush;
		private Brush m_SelectionForeBrush;
		private bool m_alignToRight;
		private Graphics m_g;
		private bool m_CustomPaint;

		private DataGridColumnStyle m_Column;
		private int m_rowNum;
		private object m_Value;

		#endregion

		#region Public variables

		public Rectangle bounds
		{
			get { return m_bounds; }
		}

		private CurrencyManager source
		{
			get { return m_source; }
		}

		public Brush BackBrush
		{
			get { return m_BackBrush; }
			set { m_BackBrush = value; }
		}

		public Brush ForeBrush
		{
			get { return m_ForeBrush; }
			set { m_ForeBrush = value; }
		}

		public Color TextBoxBackColor
		{
			get { return m_TextBoxBackColor; }
			set { m_TextBoxBackColor = value; }
		}

		public Color TextBoxForeColor
		{
			get { return m_TextBoxForeColor; }
			set { m_TextBoxForeColor = value; }
		}

		public Font Font
		{
			get { return m_Font; }
			set { m_Font = value; }
		}

		public Brush SelectionBackBrush
		{
			get { return m_SelectionBackBrush; }
			set { m_SelectionBackBrush = value; }
		}

		public Brush SelectionForeBrush
		{
			get { return m_SelectionForeBrush; }
			set { m_SelectionForeBrush = value; }
		}

		public bool alignToRight
		{
			get { return m_alignToRight; }
			set { m_alignToRight = value; }
		}

		public Graphics g
		{
			get { return m_g; }
		}

		public bool CustomPaint
		{
			get { return m_CustomPaint; }
			set { m_CustomPaint = value; }
		}

		public DataGridColumnStyle Column
		{
			get { return m_Column; }
		}

		public int rowNum
		{
			get { return m_rowNum; }
		}

		public object Value
		{
			get { return m_Value; }
		}

		#endregion

		public CuteGridPaintCellEventArgs(Graphics _g, Rectangle _bounds, CurrencyManager _source,
		                                  DataGridColumnStyle _column, int _rownum, object _value,
		                                  Brush _backBrush, Brush _foreBrush, bool _alignToRight)
		{
			InitBasicParams(_g, _bounds, _source, _column, _rownum, _value);

			m_alignToRight = _alignToRight;

			m_BackBrush = _backBrush;
			m_ForeBrush = _foreBrush;
			m_SelectionBackBrush = _backBrush;
			m_SelectionForeBrush = _foreBrush;

		}

		public CuteGridPaintCellEventArgs(Graphics _g, Rectangle _bounds, CurrencyManager _source,
		                                  DataGridColumnStyle _column, int _rownum, object _value,
		                                  Color _textBoxBackColor, Color _textBoxForeColor)
		{
			InitBasicParams(_g, _bounds, _source, _column, _rownum, _value);

			m_TextBoxBackColor = _textBoxBackColor;
			m_TextBoxForeColor = _textBoxForeColor;

		}

		private void InitBasicParams(Graphics _g, Rectangle _bounds, CurrencyManager _source,
		                             DataGridColumnStyle _column, int _rownum, object _value)
		{
			m_CustomPaint = false;
			m_bounds = _bounds;
			m_g = _g;
			m_source = _source;
			m_Column = _column;
			m_rowNum = _rownum;
			m_Value = _value;
		}
	}
}
/********************* SniipSoftel *****************
 *
 *    $History: CuteGridPaintCellEventArgs.cs $
 *   
 *   *****************  Version 4  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/CuteSoftelGrid/CuteGridColumns
 *
 ********************* SniipSoftel *****************/
