/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 7 $
 *   $Date: 24.01.07 20:16 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Softel.MiddleTier.Client;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Windows.Forms
{
	///        
	/// </summary>
	/// <example>
	///   
	/// 
	/// <code>
	///  Hashtable htArgs = new Hashtable();
	///  htArgs.Add("tuning", "zone_desk");-       Interconnect
	///  SingleGridForm objGridForm = new SingleGridForm(htArgs);
	///  objGridForm.TabText=((Action)sender).Text;
	///  objGridForm.ShowDialog();
	///       hashtable - 
	///											  
	///	  1)hash-          tuning.
	///	         ui_type   
	///	   Ui_Dictionary
	///	        ui_dictionary,ui_Params_Type  ui_params 
	///	             .
	///	     ui_dictionary,ui_params     
	///   2)hash -        
	///              ui_dictionary  ontrol_field( )=1
	///         ui_dictionary
	///   
	///field                                               caption                                                                                                                                                                                                                                                         
	///-------------------------------------------------- --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- 
	///  name                                                ()
	///  desk                                                
	///  get                                                 
	///  key_field                                             
	///  (     ;)
	///  ui_type                                              
	///  del                                                 
	///  history_field                                       (bool)
	///	   true -        @all,  
	///	      checkbox   
	///  control_field                                       (bool)
	///    true         
	///    hashtable 
	///  read_only                                            (bool) 
	///    true   .
	///
	///         ui_params_types 
	///field                                                caption                                                                                                                                                                                                                                                         
	///---- -------------------------------------------------- --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- 
	///  Name                                               
	///    ui_type  ui_dictionary
	///  InsertCommand                                       
	///  UpdateCommand                                       
	///  Caption                                             
	///
	///         ui_params.  c    
	///    ParamsDialog
	///field                                                caption                                                                                                                                                                                                                                                         
	///---- -------------------------------------------------- --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- 
	///  field                                              
	///  caption                                            
	///  desk                                               
	///  storedproc                                         lookup 
	///  datakey                                             lookup 
	///  datavalue                                           lookup 
	///  list                                                
	///  orderby                                                 params_dialoge
	///  readonly                                             
	///   true     ParamsDialog 
	///  is_update                                           
	///   true     ParamsDialog   
	///  is_insert                                           
	///   true     ParamsDialog   
	///  defaultvalue                                         
	///  must_be_filled                                      
	///  data_type                                           
	///  category                                           
	///  IsNew                                                  lookup 
	///  StoredProcParam                                         
	///  ParamTypeParam                                       
	///  list_type                                           
	///  max_value                                           
	///  min_value                                           
	///  visible                                               
	/// </code>
	/// </example>
	public class SingleGridCtrl : BaseGridCtrl
	{
		private GroupBox m_grbParam;
		private CheckBox m_chkChange;
		private IContainer components;
		private DataTable m_dtTuningMaster;

		public DataTable m_dtMaster;

		public CuteSoftelGrid m_grdMaster;
		public Hashtable m_htMasterParam;

		private GlobalImageList m_gil;


		private bool m_bControlFieldMaster;


		private string m_strGetMaster;


		private string m_strDeleteMaster;


		private string m_strKeyFieldMaster;


		private bool m_bMasterAll;


		private string m_strTuningMaster;

		private bool m_bInit;


		/// <summary>
		///  ,      
		///  
		/// </summary>
		public SingleGridCtrl()
		{
			InitializeComponent();
		}

		/// <summary>
		/// ,        <see cref=""/>   
		///    
		/// </summary>
		/// <param name="htArgs">  <see cref="Hashtable">,   </param>
		/// <remarks>
		/// 	<para>     :</para>
		/// 	<list type="bullet">
		/// 		<item>cln_id - id </item>
		/// 		<item>ac_id - id  </item>
		/// 		<item>sub_id - id </item>
		/// 	</list>
		/// </remarks>
		public SingleGridCtrl(Hashtable htArgs) : base(htArgs)
		{
			InitializeComponent();
			m_htMasterParam = new Hashtable();

//			m_htMasterParam = htArgs;

			m_bInit = ReadDictionary();
			if (m_bMasterAll)
				m_htMasterParam.Add("all", null);


		}

		public void SetStyle(string strSP, string strParam)
		{
			m_grdMaster.SetDataGridTableStyle(strSP, strParam);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SingleGridCtrl));
			this.m_grbParam = new System.Windows.Forms.GroupBox();
			this.m_chkChange = new System.Windows.Forms.CheckBox();
			this.m_grdMaster = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_gil = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_grbParam.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).BeginInit();
			this.SuspendLayout();
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			// 
			// m_tbMain
			// 
			this.m_tbMain.Name = "m_tbMain";
			this.m_tbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tbMain.Size")));
			// 
			// m_actInsert
			// 
			this.m_actInsert.Execute += new System.EventHandler(this.m_actMasterInsert_Execute);
			// 
			// m_actEdit
			// 
			this.m_actEdit.Execute += new System.EventHandler(this.m_actMasterEdit_Execute);
			// 
			// m_actDelete
			// 
			this.m_actDelete.Execute += new System.EventHandler(this.m_actMasterDelete_Execute);
			// 
			// m_grbParam
			// 
			this.m_grbParam.AccessibleDescription = resources.GetString("m_grbParam.AccessibleDescription");
			this.m_grbParam.AccessibleName = resources.GetString("m_grbParam.AccessibleName");
			this.m_grbParam.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grbParam.Anchor")));
			this.m_grbParam.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grbParam.BackgroundImage")));
			this.m_grbParam.Controls.Add(this.m_chkChange);
			this.m_grbParam.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grbParam.Dock")));
			this.m_grbParam.Enabled = ((bool)(resources.GetObject("m_grbParam.Enabled")));
			this.m_grbParam.Font = ((System.Drawing.Font)(resources.GetObject("m_grbParam.Font")));
			this.m_grbParam.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grbParam.ImeMode")));
			this.m_grbParam.Location = ((System.Drawing.Point)(resources.GetObject("m_grbParam.Location")));
			this.m_grbParam.Name = "m_grbParam";
			this.m_grbParam.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grbParam.RightToLeft")));
			this.m_grbParam.Size = ((System.Drawing.Size)(resources.GetObject("m_grbParam.Size")));
			this.m_grbParam.TabIndex = ((int)(resources.GetObject("m_grbParam.TabIndex")));
			this.m_grbParam.TabStop = false;
			this.m_grbParam.Text = resources.GetString("m_grbParam.Text");
			this.m_grbParam.Visible = ((bool)(resources.GetObject("m_grbParam.Visible")));
			// 
			// m_chkChange
			// 
			this.m_chkChange.AccessibleDescription = resources.GetString("m_chkChange.AccessibleDescription");
			this.m_chkChange.AccessibleName = resources.GetString("m_chkChange.AccessibleName");
			this.m_chkChange.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_chkChange.Anchor")));
			this.m_chkChange.Appearance = ((System.Windows.Forms.Appearance)(resources.GetObject("m_chkChange.Appearance")));
			this.m_chkChange.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_chkChange.BackgroundImage")));
			this.m_chkChange.CheckAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.CheckAlign")));
			this.m_chkChange.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_chkChange.Dock")));
			this.m_chkChange.Enabled = ((bool)(resources.GetObject("m_chkChange.Enabled")));
			this.m_chkChange.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("m_chkChange.FlatStyle")));
			this.m_chkChange.Font = ((System.Drawing.Font)(resources.GetObject("m_chkChange.Font")));
			this.m_chkChange.Image = ((System.Drawing.Image)(resources.GetObject("m_chkChange.Image")));
			this.m_chkChange.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.ImageAlign")));
			this.m_chkChange.ImageIndex = ((int)(resources.GetObject("m_chkChange.ImageIndex")));
			this.m_chkChange.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_chkChange.ImeMode")));
			this.m_chkChange.Location = ((System.Drawing.Point)(resources.GetObject("m_chkChange.Location")));
			this.m_chkChange.Name = "m_chkChange";
			this.m_chkChange.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_chkChange.RightToLeft")));
			this.m_chkChange.Size = ((System.Drawing.Size)(resources.GetObject("m_chkChange.Size")));
			this.m_chkChange.TabIndex = ((int)(resources.GetObject("m_chkChange.TabIndex")));
			this.m_chkChange.Text = resources.GetString("m_chkChange.Text");
			this.m_chkChange.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.TextAlign")));
			this.m_chkChange.Visible = ((bool)(resources.GetObject("m_chkChange.Visible")));
			this.m_chkChange.CheckedChanged += new System.EventHandler(this.m_chkChange_CheckedChanged);
			// 
			// m_grdMaster
			// 
			this.m_grdMaster.AccessibleDescription = resources.GetString("m_grdMaster.AccessibleDescription");
			this.m_grdMaster.AccessibleName = resources.GetString("m_grdMaster.AccessibleName");
			this.m_grdMaster.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdMaster.Anchor")));
			this.m_grdMaster.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdMaster.BackgroundImage")));
			this.m_grdMaster.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdMaster.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.CaptionFont")));
			this.m_grdMaster.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdMaster.CaptionText = resources.GetString("m_grdMaster.CaptionText");
			this.m_grdMaster.ContextMenu = this.m_cmMain;
			this.m_grdMaster.DataMember = "";
			this.m_grdMaster.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdMaster.Dock")));
			this.m_grdMaster.Enabled = ((bool)(resources.GetObject("m_grdMaster.Enabled")));
			this.m_grdMaster.Font = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.Font")));
			this.m_grdMaster.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdMaster.HighlightRow = true;
			this.m_grdMaster.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdMaster.ImeMode")));
			this.m_grdMaster.Location = ((System.Drawing.Point)(resources.GetObject("m_grdMaster.Location")));
			this.m_grdMaster.Name = "m_grdMaster";
			this.m_grdMaster.ReadOnly = true;
			this.m_grdMaster.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdMaster.RightToLeft")));
			this.m_grdMaster.Size = ((System.Drawing.Size)(resources.GetObject("m_grdMaster.Size")));
			this.m_grdMaster.TabIndex = ((int)(resources.GetObject("m_grdMaster.TabIndex")));
			this.m_grdMaster.Visible = ((bool)(resources.GetObject("m_grdMaster.Visible")));
			this.m_grdMaster.Navigate += new System.Windows.Forms.NavigateEventHandler(this.m_grdMaster_Navigate);
			// 
			// m_gil
			// 
			this.m_gil.ImageList = this.SoftelImageList;
			this.m_gil.Parent = this;
			// 
			// SingleGridCtrl
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.Controls.Add(this.m_grdMaster);
			this.Controls.Add(this.m_grbParam);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Name = "SingleGridCtrl";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.Size = ((System.Drawing.Size)(resources.GetObject("$this.Size")));
			this.Load += new System.EventHandler(this.SingleGridForm_Load);
			this.Controls.SetChildIndex(this.m_tbMain, 0);
			this.Controls.SetChildIndex(this.m_grbParam, 0);
			this.Controls.SetChildIndex(this.m_grdMaster, 0);
			this.m_grbParam.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		///     "",  
		/// </summary>
		public override void Reload()
		{
			if (!m_bInit)
				return;

			if (m_bControlFieldMaster)
				this.AddFieldFromHash(m_htMasterParam);


			if (m_bMasterAll)
				m_htMasterParam["all"] = Convert.ToInt32(m_chkChange.Checked);

			FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);

			FillDetail(m_strTuningMaster, m_grdMaster, ref m_dtTuningMaster);

			DisableAction(m_dtTuningMaster, m_strDeleteMaster, m_actDelete, m_actInsert, m_actEdit);


		}


		/// <summary>
		///     
		/// </summary>
		/// <param name="sender">,  </param>
		/// <param name="e"> </param>
		private void SingleGridForm_Load(object sender, EventArgs e)
		{
			if (this.Tuning != null && this.Tuning != "")
				Reload();
			else
				MessageBox.Show(ResourceControl.String30, ResourceControl.String31, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

		}

		/// <summary>
		///    
		/// </summary>
		/// <returns></returns>
		private bool ReadDictionary()
		{
			m_strTuningMaster = this.Tuning;
			using (Command cmdElement = new Command())
			{
				if (m_strTuningMaster != null)
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningMaster;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];

					if (dtElement.Rows.Count == 0)
						return false;


					m_strGetMaster = dtElement.Rows[0]["get"].ToString();
					m_strDeleteMaster = dtElement.Rows[0]["del"].ToString();
					m_strKeyFieldMaster = dtElement.Rows[0]["key_field"].ToString();

					if (dtElement.Rows[0]["history_field"] != DBNull.Value)
						m_bMasterAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
					else
						m_bMasterAll = false;

					m_grdMaster.CaptionText = dtElement.Rows[0]["desk"].ToString();

					if (dtElement.Rows[0]["control_field"] != DBNull.Value)
						m_bControlFieldMaster = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
					else
						m_bControlFieldMaster = false;


				}
				else
					return false;
			}


			if (!m_bMasterAll)
				m_grbParam.Visible = false;


			return true;

		}


		private void m_actMasterInsert_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdMaster, null, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());
			}

		}

		private void m_actMasterEdit_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdMaster, m_strKeyFieldMaster, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());
			}

		}

		private void m_actMasterDelete_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDeleteMaster, m_strKeyFieldMaster, m_grdMaster))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);

			}


		}

		private void m_chkChange_CheckedChanged(object sender, EventArgs e)
		{
			Reload();
		}

		private void m_grdMaster_Navigate(object sender, NavigateEventArgs ne)
		{
		}


	}
}
/********************* SniipSoftel *****************
 *
 *    $History: SingleGridCtrl.cs $
 *   
 *   *****************  Version 7  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 6  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 5  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *
 ********************* SniipSoftel *****************/
