/********************* SniipSoftel *****************
 *
 *   $Author: Gavrilov $
 *   $Revision: 10 $
 *   $Date: 29.05.07 18:26 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Softel.MiddleTier.Client;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Windows.Forms
{
	///        
	/// </summary>
	/// <example>
	///   
	/// 
	/// <code>
	///  Hashtable htArgs = new Hashtable();
	///  htArgs.Add("tuning", "switch");-      Interconnect 
	///  TwoGridForm objGridForm = new TwoGridForm(htArgs);
	///  objGridForm.ShowDialog();
	///       hashtable - 
	///											  
	///	  1)hash-          tuning.
	///	         ui_type   
	///	   Ui_Dictionary
	///	        ui_dictionary,ui_Params_Type  ui_params, ui_dictionary_realation 
	///	             .
	///	     ui_dictionary,ui_params     
	///   2)hash -        
	///              ui_dictionary  ontrol_field( )=1
	///      ui_dictionary,ui_Params_Type  ui_params   SingleGridForm
	///   3)        ui_type                
	///         ui_dictionary_relation 
	///
	///
	///field                                              caption                                                                                                                                                                                                                                                         
	///  master_id                                              
	///    dict_id   UI_Dictionary
	///  detail_id                                            
	///    dict_id   UI_Dictionary
	///  connection_field                                     
	///       ;
	public class TwoGrid : BaseGrid
	{
		private GroupBox m_grbParam;
		private CheckBox m_chkChange;
		private IContainer components;
		private DataTable m_dtTuningMaster;
		private DataTable m_dtTuningDetail;
		private DataTable m_dtMaster;
		private DataTable m_dtDetail;
		private CuteSoftelGrid m_grdDetail;
		private CuteSoftelGrid m_grdMaster;
		private Hashtable m_htMasterParam;
		private Hashtable m_htDetailParam;
		private GlobalImageList m_gil;
		private Splitter m_splTop;
		private Panel m_pnlDetail;
		private ToolBar m_tbDetail;
		private ToolBarButton m_tbbInsertDetail;
		private ToolBarButton m_tbbEditDetail;
		private ToolBarButton m_tbbDeleteDetail;

		private ContextMenu m_cmDetail;
		private MenuItem m_miInsertDetail;
		private MenuItem m_miEditDetail;
		private MenuItem m_miDeleteDetail;

		private string m_strConnectField;

		private bool m_bControlFieldDetail;
		private bool m_bControlFieldMaster;

		private string m_strGetDetail;
		private string m_strGetMaster;

		private string m_strDeleteDetail;
		private string m_strDeleteMaster;

		private string m_strKeyFieldDetail;
		private string m_strKeyFieldMaster;

		private bool m_bDetailAll;
		private bool m_bMasterAll;
		private bool m_bReadOnlyMaster;
		private bool m_bReadOnlyDetail;


		private string m_strTuningDetail;

		private string m_strTuningMaster;
		private Action m_actInsertDetail;
		private Action m_actEditDetail;
		private Action m_actDeleteDetail;
		private bool m_bInit;


		/// <summary>
		///  ,      
		///  
		/// </summary>
		public TwoGrid()
		{
			InitializeComponent();
		}

		/// <summary>
		/// ,        <see cref=""/>   
		///    
		/// </summary>
		/// <param name="htArgs">  <see cref="Hashtable">,   </param>
		/// <remarks>
		/// 	<para>     :</para>
		/// 	<list type="bullet">
		/// 		<item>cln_id - id </item>
		/// 		<item>ac_id - id  </item>
		/// 		<item>sub_id - id </item>
		/// 	</list>
		/// </remarks>
		public TwoGrid(Hashtable htArgs) : base(htArgs)
		{
			InitializeComponent();

			m_htMasterParam = new Hashtable();

			m_htDetailParam = new Hashtable();

			m_bInit = ReadDictionary();

			if (m_bMasterAll)
				m_htMasterParam.Add("all", null);

			if (m_bDetailAll)
				m_htDetailParam.Add("all", null);


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TwoGrid));
			this.m_grbParam = new System.Windows.Forms.GroupBox();
			this.m_chkChange = new System.Windows.Forms.CheckBox();
			this.m_grdMaster = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_grdDetail = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_cmDetail = new System.Windows.Forms.ContextMenu();
			this.m_miInsertDetail = new System.Windows.Forms.MenuItem();
			this.m_miEditDetail = new System.Windows.Forms.MenuItem();
			this.m_miDeleteDetail = new System.Windows.Forms.MenuItem();
			this.m_gil = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_splTop = new System.Windows.Forms.Splitter();
			this.m_pnlDetail = new System.Windows.Forms.Panel();
			this.m_tbDetail = new System.Windows.Forms.ToolBar();
			this.m_tbbInsertDetail = new System.Windows.Forms.ToolBarButton();
			this.m_tbbEditDetail = new System.Windows.Forms.ToolBarButton();
			this.m_tbbDeleteDetail = new System.Windows.Forms.ToolBarButton();
			this.m_actInsertDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actEditDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actDeleteDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_grbParam.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdDetail)).BeginInit();
			this.m_pnlDetail.SuspendLayout();
			this.SuspendLayout();
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			// 
			// m_alMain
			// 
			this.m_alMain.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																				 this.m_actInsertDetail,
																				 this.m_actEditDetail,
																				 this.m_actDeleteDetail});
			// 
			// m_tbMain
			// 
			this.m_tbMain.Name = "m_tbMain";
			this.m_tbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tbMain.Size")));
			// 
			// m_actInsert
			// 
			this.m_actInsert.Execute += new System.EventHandler(this.m_actMasterInsert_Execute);
			// 
			// m_actEdit
			// 
			this.m_actEdit.Execute += new System.EventHandler(this.m_actMasterEdit_Execute);
			// 
			// m_actDelete
			// 
			this.m_actDelete.Execute += new System.EventHandler(this.m_actMasterDelete_Execute);
			// 
			// m_grbParam
			// 
			this.m_grbParam.AccessibleDescription = resources.GetString("m_grbParam.AccessibleDescription");
			this.m_grbParam.AccessibleName = resources.GetString("m_grbParam.AccessibleName");
			this.m_grbParam.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grbParam.Anchor")));
			this.m_grbParam.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grbParam.BackgroundImage")));
			this.m_grbParam.Controls.Add(this.m_chkChange);
			this.m_grbParam.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grbParam.Dock")));
			this.m_grbParam.Enabled = ((bool)(resources.GetObject("m_grbParam.Enabled")));
			this.m_grbParam.Font = ((System.Drawing.Font)(resources.GetObject("m_grbParam.Font")));
			this.m_grbParam.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grbParam.ImeMode")));
			this.m_grbParam.Location = ((System.Drawing.Point)(resources.GetObject("m_grbParam.Location")));
			this.m_grbParam.Name = "m_grbParam";
			this.m_grbParam.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grbParam.RightToLeft")));
			this.m_grbParam.Size = ((System.Drawing.Size)(resources.GetObject("m_grbParam.Size")));
			this.m_grbParam.TabIndex = ((int)(resources.GetObject("m_grbParam.TabIndex")));
			this.m_grbParam.TabStop = false;
			this.m_grbParam.Text = resources.GetString("m_grbParam.Text");
			this.m_grbParam.Visible = ((bool)(resources.GetObject("m_grbParam.Visible")));
			// 
			// m_chkChange
			// 
			this.m_chkChange.AccessibleDescription = resources.GetString("m_chkChange.AccessibleDescription");
			this.m_chkChange.AccessibleName = resources.GetString("m_chkChange.AccessibleName");
			this.m_chkChange.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_chkChange.Anchor")));
			this.m_chkChange.Appearance = ((System.Windows.Forms.Appearance)(resources.GetObject("m_chkChange.Appearance")));
			this.m_chkChange.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_chkChange.BackgroundImage")));
			this.m_chkChange.CheckAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.CheckAlign")));
			this.m_chkChange.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_chkChange.Dock")));
			this.m_chkChange.Enabled = ((bool)(resources.GetObject("m_chkChange.Enabled")));
			this.m_chkChange.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("m_chkChange.FlatStyle")));
			this.m_chkChange.Font = ((System.Drawing.Font)(resources.GetObject("m_chkChange.Font")));
			this.m_chkChange.Image = ((System.Drawing.Image)(resources.GetObject("m_chkChange.Image")));
			this.m_chkChange.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.ImageAlign")));
			this.m_chkChange.ImageIndex = ((int)(resources.GetObject("m_chkChange.ImageIndex")));
			this.m_chkChange.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_chkChange.ImeMode")));
			this.m_chkChange.Location = ((System.Drawing.Point)(resources.GetObject("m_chkChange.Location")));
			this.m_chkChange.Name = "m_chkChange";
			this.m_chkChange.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_chkChange.RightToLeft")));
			this.m_chkChange.Size = ((System.Drawing.Size)(resources.GetObject("m_chkChange.Size")));
			this.m_chkChange.TabIndex = ((int)(resources.GetObject("m_chkChange.TabIndex")));
			this.m_chkChange.Text = resources.GetString("m_chkChange.Text");
			this.m_chkChange.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.TextAlign")));
			this.m_chkChange.Visible = ((bool)(resources.GetObject("m_chkChange.Visible")));
			this.m_chkChange.CheckedChanged += new System.EventHandler(this.m_chkChange_CheckedChanged);
			// 
			// m_grdMaster
			// 
			this.m_grdMaster.AccessibleDescription = resources.GetString("m_grdMaster.AccessibleDescription");
			this.m_grdMaster.AccessibleName = resources.GetString("m_grdMaster.AccessibleName");
			this.m_grdMaster.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdMaster.Anchor")));
			this.m_grdMaster.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdMaster.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdMaster.BackgroundImage")));
			this.m_grdMaster.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdMaster.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.CaptionFont")));
			this.m_grdMaster.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdMaster.CaptionText = resources.GetString("m_grdMaster.CaptionText");
			this.m_grdMaster.ContextMenu = this.m_cmMain;
			this.m_grdMaster.DataMember = "";
			this.m_grdMaster.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdMaster.Dock")));
			this.m_grdMaster.Enabled = ((bool)(resources.GetObject("m_grdMaster.Enabled")));
			this.m_grdMaster.Font = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.Font")));
			this.m_grdMaster.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdMaster.HighlightRow = true;
			this.m_grdMaster.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdMaster.ImeMode")));
			this.m_grdMaster.Location = ((System.Drawing.Point)(resources.GetObject("m_grdMaster.Location")));
			this.m_grdMaster.Name = "m_grdMaster";
			this.m_grdMaster.ReadOnly = true;
			this.m_grdMaster.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdMaster.RightToLeft")));
			this.m_grdMaster.Size = ((System.Drawing.Size)(resources.GetObject("m_grdMaster.Size")));
			this.m_grdMaster.TabIndex = ((int)(resources.GetObject("m_grdMaster.TabIndex")));
			this.m_grdMaster.Visible = ((bool)(resources.GetObject("m_grdMaster.Visible")));
			this.m_grdMaster.CurrentCellChanged += new System.EventHandler(this.m_grdMaster_CurrentCellChanged);
			// 
			// m_grdDetail
			// 
			this.m_grdDetail.AccessibleDescription = resources.GetString("m_grdDetail.AccessibleDescription");
			this.m_grdDetail.AccessibleName = resources.GetString("m_grdDetail.AccessibleName");
			this.m_grdDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdDetail.Anchor")));
			this.m_grdDetail.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdDetail.BackgroundImage")));
			this.m_grdDetail.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdDetail.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdDetail.CaptionFont")));
			this.m_grdDetail.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdDetail.CaptionText = resources.GetString("m_grdDetail.CaptionText");
			this.m_grdDetail.ContextMenu = this.m_cmDetail;
			this.m_grdDetail.DataMember = "";
			this.m_grdDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdDetail.Dock")));
			this.m_grdDetail.Enabled = ((bool)(resources.GetObject("m_grdDetail.Enabled")));
			this.m_grdDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_grdDetail.Font")));
			this.m_grdDetail.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdDetail.HighlightRow = true;
			this.m_grdDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdDetail.ImeMode")));
			this.m_grdDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_grdDetail.Location")));
			this.m_grdDetail.Name = "m_grdDetail";
			this.m_grdDetail.ReadOnly = true;
			this.m_grdDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdDetail.RightToLeft")));
			this.m_grdDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_grdDetail.Size")));
			this.m_grdDetail.TabIndex = ((int)(resources.GetObject("m_grdDetail.TabIndex")));
			this.m_grdDetail.Visible = ((bool)(resources.GetObject("m_grdDetail.Visible")));
			// 
			// m_cmDetail
			// 
			this.m_cmDetail.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.m_miInsertDetail,
																					   this.m_miEditDetail,
																					   this.m_miDeleteDetail});
			this.m_cmDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmDetail.RightToLeft")));
			// 
			// m_miInsertDetail
			// 
			this.m_alMain.SetAction(this.m_miInsertDetail, this.m_actInsertDetail);
			this.m_miInsertDetail.Enabled = ((bool)(resources.GetObject("m_miInsertDetail.Enabled")));
			this.m_miInsertDetail.Index = 0;
			this.m_miInsertDetail.MergeOrder = 32;
			this.m_miInsertDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miInsertDetail.Shortcut")));
			this.m_miInsertDetail.ShowShortcut = ((bool)(resources.GetObject("m_miInsertDetail.ShowShortcut")));
			this.m_miInsertDetail.Text = resources.GetString("m_miInsertDetail.Text");
			this.m_miInsertDetail.Visible = ((bool)(resources.GetObject("m_miInsertDetail.Visible")));
			// 
			// m_miEditDetail
			// 
			this.m_alMain.SetAction(this.m_miEditDetail, this.m_actEditDetail);
			this.m_miEditDetail.Enabled = ((bool)(resources.GetObject("m_miEditDetail.Enabled")));
			this.m_miEditDetail.Index = 1;
			this.m_miEditDetail.MergeOrder = 33;
			this.m_miEditDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miEditDetail.Shortcut")));
			this.m_miEditDetail.ShowShortcut = ((bool)(resources.GetObject("m_miEditDetail.ShowShortcut")));
			this.m_miEditDetail.Text = resources.GetString("m_miEditDetail.Text");
			this.m_miEditDetail.Visible = ((bool)(resources.GetObject("m_miEditDetail.Visible")));
			// 
			// m_miDeleteDetail
			// 
			this.m_alMain.SetAction(this.m_miDeleteDetail, this.m_actDeleteDetail);
			this.m_miDeleteDetail.Enabled = ((bool)(resources.GetObject("m_miDeleteDetail.Enabled")));
			this.m_miDeleteDetail.Index = 2;
			this.m_miDeleteDetail.MergeOrder = 31;
			this.m_miDeleteDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDeleteDetail.Shortcut")));
			this.m_miDeleteDetail.ShowShortcut = ((bool)(resources.GetObject("m_miDeleteDetail.ShowShortcut")));
			this.m_miDeleteDetail.Text = resources.GetString("m_miDeleteDetail.Text");
			this.m_miDeleteDetail.Visible = ((bool)(resources.GetObject("m_miDeleteDetail.Visible")));
			// 
			// m_gil
			// 
			this.m_gil.ImageList = this.SoftelImageList;
			this.m_gil.Parent = this;
			// 
			// m_splTop
			// 
			this.m_splTop.AccessibleDescription = resources.GetString("m_splTop.AccessibleDescription");
			this.m_splTop.AccessibleName = resources.GetString("m_splTop.AccessibleName");
			this.m_splTop.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splTop.Anchor")));
			this.m_splTop.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splTop.BackgroundImage")));
			this.m_splTop.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splTop.Dock")));
			this.m_splTop.Enabled = ((bool)(resources.GetObject("m_splTop.Enabled")));
			this.m_splTop.Font = ((System.Drawing.Font)(resources.GetObject("m_splTop.Font")));
			this.m_splTop.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splTop.ImeMode")));
			this.m_splTop.Location = ((System.Drawing.Point)(resources.GetObject("m_splTop.Location")));
			this.m_splTop.MinExtra = ((int)(resources.GetObject("m_splTop.MinExtra")));
			this.m_splTop.MinSize = ((int)(resources.GetObject("m_splTop.MinSize")));
			this.m_splTop.Name = "m_splTop";
			this.m_splTop.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splTop.RightToLeft")));
			this.m_splTop.Size = ((System.Drawing.Size)(resources.GetObject("m_splTop.Size")));
			this.m_splTop.TabIndex = ((int)(resources.GetObject("m_splTop.TabIndex")));
			this.m_splTop.TabStop = false;
			this.m_splTop.Visible = ((bool)(resources.GetObject("m_splTop.Visible")));
			// 
			// m_pnlDetail
			// 
			this.m_pnlDetail.AccessibleDescription = resources.GetString("m_pnlDetail.AccessibleDescription");
			this.m_pnlDetail.AccessibleName = resources.GetString("m_pnlDetail.AccessibleName");
			this.m_pnlDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlDetail.Anchor")));
			this.m_pnlDetail.AutoScroll = ((bool)(resources.GetObject("m_pnlDetail.AutoScroll")));
			this.m_pnlDetail.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlDetail.AutoScrollMargin")));
			this.m_pnlDetail.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlDetail.AutoScrollMinSize")));
			this.m_pnlDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlDetail.BackgroundImage")));
			this.m_pnlDetail.Controls.Add(this.m_grdDetail);
			this.m_pnlDetail.Controls.Add(this.m_tbDetail);
			this.m_pnlDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlDetail.Dock")));
			this.m_pnlDetail.Enabled = ((bool)(resources.GetObject("m_pnlDetail.Enabled")));
			this.m_pnlDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlDetail.Font")));
			this.m_pnlDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlDetail.ImeMode")));
			this.m_pnlDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlDetail.Location")));
			this.m_pnlDetail.Name = "m_pnlDetail";
			this.m_pnlDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlDetail.RightToLeft")));
			this.m_pnlDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlDetail.Size")));
			this.m_pnlDetail.TabIndex = ((int)(resources.GetObject("m_pnlDetail.TabIndex")));
			this.m_pnlDetail.Text = resources.GetString("m_pnlDetail.Text");
			this.m_pnlDetail.Visible = ((bool)(resources.GetObject("m_pnlDetail.Visible")));
			// 
			// m_tbDetail
			// 
			this.m_tbDetail.AccessibleDescription = resources.GetString("m_tbDetail.AccessibleDescription");
			this.m_tbDetail.AccessibleName = resources.GetString("m_tbDetail.AccessibleName");
			this.m_tbDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tbDetail.Anchor")));
			this.m_tbDetail.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("m_tbDetail.Appearance")));
			this.m_tbDetail.AutoSize = ((bool)(resources.GetObject("m_tbDetail.AutoSize")));
			this.m_tbDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tbDetail.BackgroundImage")));
			this.m_tbDetail.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						  this.m_tbbInsertDetail,
																						  this.m_tbbEditDetail,
																						  this.m_tbbDeleteDetail});
			this.m_tbDetail.ButtonSize = ((System.Drawing.Size)(resources.GetObject("m_tbDetail.ButtonSize")));
			this.m_tbDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tbDetail.Dock")));
			this.m_tbDetail.DropDownArrows = ((bool)(resources.GetObject("m_tbDetail.DropDownArrows")));
			this.m_tbDetail.Enabled = ((bool)(resources.GetObject("m_tbDetail.Enabled")));
			this.m_tbDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_tbDetail.Font")));
			this.m_tbDetail.ImageList = this.SoftelImageList;
			this.m_tbDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tbDetail.ImeMode")));
			this.m_tbDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_tbDetail.Location")));
			this.m_tbDetail.Name = "m_tbDetail";
			this.m_tbDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tbDetail.RightToLeft")));
			this.m_tbDetail.ShowToolTips = ((bool)(resources.GetObject("m_tbDetail.ShowToolTips")));
			this.m_tbDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_tbDetail.Size")));
			this.m_tbDetail.TabIndex = ((int)(resources.GetObject("m_tbDetail.TabIndex")));
			this.m_tbDetail.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("m_tbDetail.TextAlign")));
			this.m_tbDetail.Visible = ((bool)(resources.GetObject("m_tbDetail.Visible")));
			this.m_tbDetail.Wrappable = ((bool)(resources.GetObject("m_tbDetail.Wrappable")));
			// 
			// m_tbbInsertDetail
			// 
			this.m_alMain.SetAction(this.m_tbbInsertDetail, this.m_actInsertDetail);
			this.m_tbbInsertDetail.Enabled = ((bool)(resources.GetObject("m_tbbInsertDetail.Enabled")));
			this.m_tbbInsertDetail.ImageIndex = ((int)(resources.GetObject("m_tbbInsertDetail.ImageIndex")));
			this.m_tbbInsertDetail.Tag = "1";
			this.m_tbbInsertDetail.Text = resources.GetString("m_tbbInsertDetail.Text");
			this.m_tbbInsertDetail.ToolTipText = resources.GetString("m_tbbInsertDetail.ToolTipText");
			this.m_tbbInsertDetail.Visible = ((bool)(resources.GetObject("m_tbbInsertDetail.Visible")));
			// 
			// m_tbbEditDetail
			// 
			this.m_alMain.SetAction(this.m_tbbEditDetail, this.m_actEditDetail);
			this.m_tbbEditDetail.Enabled = ((bool)(resources.GetObject("m_tbbEditDetail.Enabled")));
			this.m_tbbEditDetail.ImageIndex = ((int)(resources.GetObject("m_tbbEditDetail.ImageIndex")));
			this.m_tbbEditDetail.Tag = "2";
			this.m_tbbEditDetail.Text = resources.GetString("m_tbbEditDetail.Text");
			this.m_tbbEditDetail.ToolTipText = resources.GetString("m_tbbEditDetail.ToolTipText");
			this.m_tbbEditDetail.Visible = ((bool)(resources.GetObject("m_tbbEditDetail.Visible")));
			// 
			// m_tbbDeleteDetail
			// 
			this.m_alMain.SetAction(this.m_tbbDeleteDetail, this.m_actDeleteDetail);
			this.m_tbbDeleteDetail.Enabled = ((bool)(resources.GetObject("m_tbbDeleteDetail.Enabled")));
			this.m_tbbDeleteDetail.ImageIndex = ((int)(resources.GetObject("m_tbbDeleteDetail.ImageIndex")));
			this.m_tbbDeleteDetail.Tag = "3";
			this.m_tbbDeleteDetail.Text = resources.GetString("m_tbbDeleteDetail.Text");
			this.m_tbbDeleteDetail.ToolTipText = resources.GetString("m_tbbDeleteDetail.ToolTipText");
			this.m_tbbDeleteDetail.Visible = ((bool)(resources.GetObject("m_tbbDeleteDetail.Visible")));
			// 
			// m_actInsertDetail
			// 
			this.m_actInsertDetail.Checked = false;
			this.m_actInsertDetail.Enabled = true;
			this.m_actInsertDetail.Hint = resources.GetString("m_actInsertDetail.Hint");
			this.m_actInsertDetail.ImageIndex = ((int)(resources.GetObject("m_actInsertDetail.ImageIndex")));
			this.m_actInsertDetail.MergeOrder = 32;
			this.m_actInsertDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actInsertDetail.Tag = null;
			this.m_actInsertDetail.Text = resources.GetString("m_actInsertDetail.Text");
			this.m_actInsertDetail.Visible = true;
			this.m_actInsertDetail.Execute += new System.EventHandler(this.m_actInsertDetail_Execute);
			// 
			// m_actEditDetail
			// 
			this.m_actEditDetail.Checked = false;
			this.m_actEditDetail.Enabled = true;
			this.m_actEditDetail.Hint = resources.GetString("m_actEditDetail.Hint");
			this.m_actEditDetail.ImageIndex = ((int)(resources.GetObject("m_actEditDetail.ImageIndex")));
			this.m_actEditDetail.MergeOrder = 33;
			this.m_actEditDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actEditDetail.Tag = null;
			this.m_actEditDetail.Text = resources.GetString("m_actEditDetail.Text");
			this.m_actEditDetail.Visible = true;
			this.m_actEditDetail.Execute += new System.EventHandler(this.m_actEditDetail_Execute);
			// 
			// m_actDeleteDetail
			// 
			this.m_actDeleteDetail.Checked = false;
			this.m_actDeleteDetail.Enabled = true;
			this.m_actDeleteDetail.Hint = resources.GetString("m_actDeleteDetail.Hint");
			this.m_actDeleteDetail.ImageIndex = ((int)(resources.GetObject("m_actDeleteDetail.ImageIndex")));
			this.m_actDeleteDetail.MergeOrder = 31;
			this.m_actDeleteDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDeleteDetail.Tag = null;
			this.m_actDeleteDetail.Text = resources.GetString("m_actDeleteDetail.Text");
			this.m_actDeleteDetail.Visible = true;
			this.m_actDeleteDetail.Execute += new System.EventHandler(this.m_actDeleteDetail_Execute);
			// 
			// TwoGrid
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.Controls.Add(this.m_pnlDetail);
			this.Controls.Add(this.m_splTop);
			this.Controls.Add(this.m_grdMaster);
			this.Controls.Add(this.m_grbParam);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Name = "TwoGrid";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.Size = ((System.Drawing.Size)(resources.GetObject("$this.Size")));
			this.Load += new System.EventHandler(this.TwoGridForm_Load);
			this.Controls.SetChildIndex(this.m_tbMain, 0);
			this.Controls.SetChildIndex(this.m_grbParam, 0);
			this.Controls.SetChildIndex(this.m_grdMaster, 0);
			this.Controls.SetChildIndex(this.m_splTop, 0);
			this.Controls.SetChildIndex(this.m_pnlDetail, 0);
			this.m_grbParam.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdDetail)).EndInit();
			this.m_pnlDetail.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		///     "",  
		/// </summary>
		/// <summary>
		///     "",  
		/// </summary>
		public override void Reload()
		{
			if (!m_bInit)
				return;

			if (m_bControlFieldMaster)
			{
				this.AddFieldFromHash(m_htMasterParam);
			}

			if (m_bControlFieldDetail)
			{
				this.AddFieldFromHash(m_htDetailParam);
			}


			//int iConnectionValue;
			if (m_bMasterAll)
				m_htMasterParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
			FillDetail(m_strTuningMaster, m_grdMaster, ref m_dtTuningMaster);

			if(m_bReadOnlyMaster)
			{
				m_actDelete.Visible = false;
				m_actInsert.Visible = false;
				m_actEdit.Visible = false;
			}
			DataRow dr;

			if (m_dtMaster.Rows.Count == 0)
				dr = null;
			else
				dr = m_dtMaster.Rows[0];

			AddFieldFromRow(m_htDetailParam, dr, m_strConnectField);

			if (m_bDetailAll)
				m_htDetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			if (m_strGetDetail != "" && m_strGetDetail != null)
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
			if (m_strTuningDetail != "")
				FillDetail(m_strTuningDetail, m_grdDetail, ref m_dtTuningDetail);
			if(m_bReadOnlyDetail)
			{
				m_actDeleteDetail.Visible = false;
				m_actInsertDetail.Visible = false;
				m_actEditDetail.Visible = false;
			}

		}


		/// <summary>
		///     
		/// </summary>
		/// <param name="sender">,  </param>
		/// <param name="e"> </param>
		private void TwoGridForm_Load(object sender, EventArgs e)
		{
//			Reload();
		}

		/// <summary>
		///    
		/// </summary>
		/// <returns></returns>
		private bool ReadDictionary()
		{
			m_strTuningMaster = this.Tuning;
			using (Command cmdElement = new Command())
			{
				if (m_strTuningMaster != null)
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningMaster;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					if (dtElement.Rows.Count != 0 && m_strTuningMaster != "")
					{
						m_strTuningDetail = dtElement.Rows[0]["tuning_detail"].ToString();
						m_strConnectField = dtElement.Rows[0]["connect_field"].ToString();
						m_strGetMaster = dtElement.Rows[0]["get"].ToString();
						m_strDeleteMaster = dtElement.Rows[0]["del"].ToString();
						m_strKeyFieldMaster = dtElement.Rows[0]["key_field"].ToString();

						if (dtElement.Rows[0]["history_field"] != DBNull.Value)
							m_bMasterAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
						else
							m_bMasterAll = false;


						m_grdMaster.CaptionText = dtElement.Rows[0]["desk"].ToString();

						if (dtElement.Rows[0]["control_field"] != DBNull.Value)
							m_bControlFieldMaster = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
						else
							m_bControlFieldMaster = false;

						
						if(dtElement.Rows[0]["read_only"] != DBNull.Value)
							m_bReadOnlyMaster = Convert.ToBoolean(dtElement.Rows[0]["read_only"]);
						else
							m_bReadOnlyMaster = false;

					}


				}
				else
					return false;
			}
			using (Command cmdElement = new Command())
			{
				if (m_strTuningDetail != null)
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningDetail;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					if (dtElement.Rows.Count != 0 && m_strTuningDetail != "")
					{
						m_strGetDetail = dtElement.Rows[0]["get"].ToString();
						m_strDeleteDetail = dtElement.Rows[0]["del"].ToString();
						m_strKeyFieldDetail = dtElement.Rows[0]["key_field"].ToString();

						if (dtElement.Rows[0]["history_field"] != DBNull.Value)
							m_bDetailAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
						else
							m_bDetailAll = false;


						m_grdDetail.CaptionText = dtElement.Rows[0]["desk"].ToString();

						if (dtElement.Rows[0]["control_field"] != DBNull.Value)
							m_bControlFieldDetail = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
						else
							m_bControlFieldDetail = false;
						if(dtElement.Rows[0]["read_only"] != DBNull.Value)
							m_bReadOnlyDetail = Convert.ToBoolean(dtElement.Rows[0]["read_only"]);
						else
							m_bReadOnlyDetail = false;
					}
				}
				else
					return false;
			}

			if (!m_bDetailAll && !m_bMasterAll)
				m_grbParam.Visible = false;


			return true;

		}

		private void m_grdMaster_CurrentCellChanged(object sender, EventArgs e)
		{
			AddFieldFromRow(m_htDetailParam, m_grdMaster.CurrentRow, m_strConnectField);

			if (m_bDetailAll)
				m_htDetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);


		}


		private void m_actMasterInsert_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdMaster, null, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());
				AddFieldFromRow(m_htDetailParam, m_grdMaster.CurrentRow, m_strConnectField);
			}

		}

		private void m_actMasterEdit_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdMaster, m_strKeyFieldMaster, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());

			}

		}

		private void m_actMasterDelete_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDeleteMaster, m_strKeyFieldMaster, m_grdMaster))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);

			}


		}

		private void m_chkChange_CheckedChanged(object sender, EventArgs e)
		{
			Reload();
		}

		private void m_actDeleteDetail_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDeleteDetail, m_strKeyFieldDetail, m_grdDetail))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);

			}
		}

		private void m_actInsertDetail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdDetail, null, ref m_dtTuningDetail, m_htDetailParam, out iIndex))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
				m_grdDetail.SelectRow(m_strKeyFieldDetail, iIndex.ToString());
			}

		}

		private void m_actEditDetail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdDetail, m_strKeyFieldDetail, ref m_dtTuningDetail, m_htDetailParam, out iIndex))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
				m_grdDetail.SelectRow(m_strKeyFieldDetail, iIndex.ToString());
			}
		}

/*
		private void m_tbDetail_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
		{
			if (Convert.ToInt32(e.Button.Tag)==1)
			{
				int iIndex;
				if(Operation(OperationType.Insert,m_grdDetail,null,ref m_dtTuningDetail,m_htDetailParam,out iIndex))
				{
					//FillInside(m_strGetDetail,m_grdDetail,m_htDetailParam,ref m_dtDetail,m_actEditDetail,m_actDeleteDetail);
					m_grdDetail.SelectRow(m_strKeyFieldDetail,iIndex.ToString());
				}

			}

			if (Convert.ToInt32(e.Button.Tag)==2)
			{
				int iIndex;
				if(Operation(OperationType.Edit,m_grdDetail,m_strKeyFieldDetail,ref m_dtTuningDetail,m_htDetailParam,out iIndex))
				{
				//	FillInside(m_strGetDetail,m_grdDetail,m_htDetailParam,ref m_dtDetail,m_actEditDetail,m_actDeleteDetail);
					m_grdDetail.SelectRow(m_strKeyFieldDetail,iIndex.ToString());
				}


			}
			if (Convert.ToInt32(e.Button.Tag)==3)
			{
				if(Delete(m_strDeleteDetail,m_strKeyFieldDetail,m_grdDetail))
				{
					//FillInside(m_strGetDetail,m_grdDetail,m_htDetailParam,ref m_dtDetail,m_actEditDetail,m_actDeleteDetail);
				
				}

			}
		}
		
	*/


	}
}
/********************* SniipSoftel *****************
 *
 *    $History: TwoGrid.cs $
 *   
 *   *****************  Version 10  *****************
 *   User: Gavrilov     Date: 29.05.07   Time: 18:26
 *   Updated in $/Net/Common/ClientControl/MultiGrid
 *   
 *   *****************  Version 9  *****************
 *   User: Gavrilov     Date: 10.04.07   Time: 18:48
 *   Updated in $/Net/Common/ClientControl/MultiGrid
 *   
 *   *****************  Version 8  *****************
 *   User: Serg_ch      Date: 26.03.07   Time: 20:42
 *   Updated in $/Net/Common/ClientControl/MultiGrid
 *   
 *   *****************  Version 6  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 5  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 4  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *
 ********************* SniipSoftel *****************/
