/********************* SniipSoftel *****************
 *
 *   $Author: Gavrilov $
 *   $Revision: 58 $
 *   $Date: 21.05.07 17:52 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Design;
using System.Globalization;
using System.Security.Permissions;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Text.RegularExpressions;
using MessageBox = Softel.Windows.Forms.MsgBox;
//using Softel.Common;

namespace Softel.Windows.Forms
{
    /// <summary>
    ///       <see cref="System.Windows.Forms.PropertyGrid"/>
    /// </summary>
    internal class NamespaceDoc
    {
    }

    /// <summary>
    ///    
    /// </summary>
    /// <remarks>
    ///       
    /// </remarks>
    public enum ParamsType
    {
        Int = 0,
        Float,
        String,
        Image,
        Data,
        File,
        Folder,
        List,
        Font,
        Boolean,
        DateTime,
        DateTimeStart,
        DateTimeEnd,
        Time,
        CustomForm,
        MultiLine,
        Date
    }

    /// <summary>
    ///  
    /// </summary>
    [Serializable]
    public class Param
    {
        public event EventHandler OnNewItem;

        /// <summary>
        ///  
        /// </summary>
        private ArrayList m_alAttributes;

        /// <summary>
        ///  
        /// </summary>
        private string m_strCategory;

        /// <summary>
        ///  
        /// </summary>
        private string m_strDescription;

        /// <summary>
        ///     
        /// </summary>
        private string m_strEditor;

        /// <summary>
        ///  
        /// </summary>
        private string m_strCaption;

        /// <summary>
        ///  
        /// </summary>
        private string m_strName;

        /// <summary>
        ///  
        /// </summary>
        private string m_strType;

        private ParamsType m_ptType;

        /// <summary>
        /// ,      
        /// </summary>
        private string m_strTypeConverter;

        /// <summary>
        ///   
        /// </summary>
        private object m_objDefaultValue;

        /// <summary>
        ///   
        /// </summary>
        private ArrayList m_alArrayList;

        private bool m_bListType;

        /// <summary>
        ///     Data
        /// </summary>
        private DataTable m_dtTable;

        /// <summary>
        ///   ,          
        /// </summary>
        private string m_strStoredProc;

        /// <summary>
        ///        
        /// </summary>
        private string m_strInsertStoredProc;

        /// <summary>
        ///         
        /// </summary>
        private int m_iInsertParamType;

        /// <summary>
        ///     
        /// </summary>
        private string m_strInsField;

        /// <summary>
        ///     
        /// </summary>
        private string m_strUpdField;

        /// <summary>
        ///     Data
        /// </summary>
        private string m_strDataKey;

        /// <summary>
        ///    Data
        /// </summary>
        private string m_strDataValue;

        /// <summary>
        ///      File
        /// </summary>
        private string m_strFileFilter;

        /// <summary>
        ///      File  Folder
        /// </summary>
        private string m_strInitialFolder;
		/// <summary>
		/// 
		/// </summary>
		private string m_strMask;


        /// <summary>
        /// ,     
        /// </summary>
        private bool m_bReadOnly;

        /// <summary>
        /// ,     
        /// </summary>
        private bool m_bVisible;

        /// <summary>
        ///   ,  CustomForm
        /// </summary>
        private ICustomForm m_fCustomForm;

        /// <summary>
        ///       
        /// </summary>
        private bool m_bIsNew = false;

        private bool m_bIsMandatory = false;
        private object m_objMaxValue = null;
        private object m_objMinValue = null;

        /// <summary>
        ///       
        /// </summary>
        /// <param name="strCaption"> </param>
        /// <param name="ptType"> </param>
        public Param(string strCaption, ParamsType ptType) : this(null, strCaption, ptType, null, null, null)
        {
        }

        public Param(string strName, string strCaption, ParamsType ptType)
            : this(strName, strCaption, ptType, null, null, null)
        {
        }

        /// <summary>
        ///     ,   
        /// </summary>
        /// <param name="strCaption"> </param>
        /// <param name="ptType"> </param>
        /// <param name="strCategory"> </param>
        public Param(string strCaption, ParamsType ptType, string strCategory)
            : this(null, strCaption, ptType, strCategory, null, null)
        {
        }

        public Param(string strName, string strCaption, ParamsType ptType, string strCategory)
            : this(strName, strCaption, ptType, strCategory, null, null)
        {
        }

        /// <summary>
        ///     , ,   
        /// </summary>
        /// <param name="strCaption"> </param>
        /// <param name="ptType"> </param>
        /// <param name="strCategory"> </param>
        /// <param name="strDescription"> </param>
        public Param(string strCaption, ParamsType ptType, string strCategory, string strDescription)
            : this(null, strCaption, ptType, strCategory, strDescription, null)
        {
        }

        public Param(string strName, string strCaption, ParamsType ptType, string strCategory, string strDescription)
            : this(strName, strCaption, ptType, strCategory, strDescription, null)
        {
        }

        /// <summary>
        ///     , ,   
        /// </summary>
        /// <param name="strCaption"> </param>
        /// <param name="strType"> </param>
        /// <param name="strCategory"> </param>
        /// <param name="strDescription"> </param>
        public Param(string strCaption, string strType, string strCategory, string strDescription, object objEmpty)
            : this(null, strCaption, strType, strCategory, strDescription, null)
        {
        }

        public Param(
            string strName,
            string strCaption,
            string strType,
            string strCategory,
            string strDescription,
            object objDefaultValue)
        {
            if(strName == null)
                m_strName = strCaption;
            else
                m_strName = strName;
            m_strCaption = strCaption;
            if(m_strCaption.Length == 0)
                m_strCaption = "Invisible Caption";
            m_strCategory = strCategory;
            m_strDescription = strDescription;
            m_objDefaultValue = objDefaultValue;
            m_alAttributes = new ArrayList();
            m_alArrayList = null; //new ArrayList();
            m_dtTable = null; //new DataTable();
            m_strDataKey = "";
            m_strDataValue = "";
            m_strTypeConverter = typeof(ValueValidator).FullName;
            m_strEditor = "";
            m_strFileFilter = "";
            m_strInitialFolder = "";
            m_bReadOnly = false;
            m_bVisible = true;
            m_strType = strType;
            SetDefaultValue();
        }

        public Param(string strCaption, ParamsType ptType, string strCategory, string strDescription, object objDefaultValue)
            : this(null, strCaption, ptType, strCategory, strDescription, objDefaultValue)
        {
        }

        public Param(
            string strName,
            string strCaption,
            ParamsType ptType,
            string strCategory,
            string strDescription,
            object objDefaultValue)
        {
            if(strName == null)
                m_strName = strCaption;
            else
                m_strName = strName;
            m_strCaption = strCaption;
            if(m_strCaption.Length == 0)
                m_strCaption = "Invisible Caption";
            m_strCategory = strCategory;
            m_strDescription = strDescription;
            m_objDefaultValue = objDefaultValue;
            m_alAttributes = new ArrayList();
            m_alArrayList = null; //new ArrayList();
            m_dtTable = null; //new DataTable();
            m_strDataKey = "";
            m_strDataValue = "";
            m_strTypeConverter = typeof(ValueValidator).FullName;
            m_strEditor = "";
            m_strFileFilter = "";
            m_strInitialFolder = "";
            m_bReadOnly = false;
            m_bVisible = true;
            Type = ptType;
            SetDefaultValue();
        }

        private void SetDefaultValue()
        {
            DateTime dtFinal = new DateTime(9999, 12, 31);
            DateTime dtStart = new DateTime(1900, 1, 1);
            if(m_strType.IndexOf("Date") != -1 && !(m_objDefaultValue is DateTime) && !(m_objDefaultValue == (Object) dtFinal) ||
               (m_objDefaultValue == (Object) dtStart))
                m_objDefaultValue = DateTime.Now.Date;
        }

        public void ClearAttribute()
        {
            m_alAttributes.Clear();
        }

        public bool IsNew
        {
            get { return m_bIsNew; }
            set { m_bIsNew = value; }
        }

        public bool IsMandatory
        {
            get { return m_bIsMandatory; }
            set { m_bIsMandatory = value; }
        }
		public string Mask
		{
			get { return m_strMask; }
			set { m_strMask = value; }
		}
        public void NewItem()
        {
            if(OnNewItem != null)
                OnNewItem(this, new EventArgs());
        }

        public bool ListType
        {
            get { return m_bListType; }
            set { m_bListType = value; }
        }

        public string InsertStoredProc
        {
            get { return m_strInsertStoredProc; }
            set { m_strInsertStoredProc = value; }
        }

        public int InsertParamType
        {
            get { return m_iInsertParamType; }
            set { m_iInsertParamType = value; }
        }

        public string InsertField
        {
            get { return m_strInsField; }
            set { m_strInsField = value; }
        }

        public string UpdateField
        {
            get { return m_strUpdField; }
            set { m_strUpdField = value; }
        }

        /// <summary>
        ///     
        /// </summary>
        /// <param name="attInsert"> </param>
        public void AddAttribute(Attribute attInsert)
        {
            m_alAttributes.Add(attInsert);
        }

        /// <summary>
        /// ,        
        /// </summary>
        public bool ReadOnly
        {
            get { return m_bReadOnly; }
            set
            {
                m_bReadOnly = value;
                int iCount = m_alAttributes.Count;
                int iIndex = 0;
                while(iIndex < iCount)
                {
                    object objAtt = m_alAttributes[iIndex++];
                    if(objAtt.Equals(ReadOnlyAttribute.No) || objAtt.Equals(ReadOnlyAttribute.Yes))
                    {
                        m_alAttributes.Remove(objAtt);
                        break;
                    }
                }
                if(m_bReadOnly)
                    AddAttribute(ReadOnlyAttribute.Yes);
                else
                    AddAttribute(ReadOnlyAttribute.No);
                //				bool bIs = false;
                //				for(int iIndex = 0; iIndex < Attributes.Length; iIndex++)
                //				{
                //					if(m_alAttributes[iIndex].Equals(ReadOnlyAttribute.No) || m_attAttributes[iIndex].Equals(ReadOnlyAttribute.Yes))
                //					{
                //						if(m_bReadOnly)
                //							m_attAttributes[iIndex] = ReadOnlyAttribute.Yes;
                //						else
                //							m_attAttributes[iIndex] = ReadOnlyAttribute.No;
                //						bIs = true;
                //						break;
                //					}
                //				}
                //				if(m_bReadOnly && !bIs)
                //					AddAttribute(ReadOnlyAttribute.Yes);
                //				else
                //					AddAttribute(ReadOnlyAttribute.No);
            }
        }

        public bool Visible
        {
            get { return m_bVisible; }
            set
            {
                m_bVisible = value;
                int iCount = m_alAttributes.Count;
                int iIndex = 0;
                while(iIndex < iCount)
                {
                    object objAtt = m_alAttributes[iIndex++];
                    if(objAtt.Equals(BrowsableAttribute.No) || objAtt.Equals(BrowsableAttribute.Yes))
                    {
                        m_alAttributes.Remove(objAtt);
                        break;
                    }
                }
                if(m_bVisible)
                    AddAttribute(BrowsableAttribute.Yes);
                else
                    AddAttribute(BrowsableAttribute.No);
            }
        }

        /// <summary>
        /// ,          File
        /// </summary>
        public string FileFilter
        {
            get { return m_strFileFilter; }
            set { m_strFileFilter = value; }
        }

        /// <summary>
        /// ,       File  Folder
        /// </summary>
        public string InitialeFolder
        {
            get { return m_strInitialFolder; }
            set { m_strInitialFolder = value; }
        }

        /// <summary>
        /// ,     
        /// </summary>
        public Attribute[] Attributes
        {
            get { return (Attribute[]) m_alAttributes.ToArray(typeof(Attribute)); }
            set { m_alAttributes = new ArrayList(value); }
        }

        /// <summary>
        /// ,  ,      
        /// </summary>
        public string Category
        {
            get { return m_strCategory; }
            set { m_strCategory = value; }
        }

        /// <summary>
        /// ,        
        /// </summary>
        public string ConverterTypeName
        {
            get { return m_strTypeConverter; }
            set { m_strTypeConverter = value; }
        }

        /// <summary>
        /// ,    
        /// </summary>
        public object DefaultValue
        {
            get { return m_objDefaultValue; }
            set { m_objDefaultValue = value; }
        }

        /// <summary>
        /// ,     
        /// </summary>
        public string Description
        {
            get { return m_strDescription; }
            set { m_strDescription = value; }
        }

        /// <summary>
        /// ,        
        /// </summary>
        public string EditorTypeName
        {
            get { return m_strEditor; }
            set { m_strEditor = value; }
        }

        /// <summary>
        /// ,   
        /// </summary>
        public string Name
        {
            get { return m_strName; }
            set { m_strName = value; }
        }

        public string Caption
        {
            get { return m_strCaption; }
            set { m_strCaption = value; }
        }

        /// <summary>
        /// ,   
        /// </summary>
        public string TypeName
        {
            get { return m_strType; }
            set { m_strType = value; }
        }

        public ParamsType Type
        {
            get { return m_ptType; }
            set
            {
                m_ptType = value;
                switch(value)
                {
                    case ParamsType.Boolean:
                        m_strType = "System.Boolean";
                        break;
                    case ParamsType.Data:
                        m_strType = "System.String";
                        AddAttribute(new EditorAttribute(typeof(PropertyListEditor), typeof(UITypeEditor)));
                        break;
                    case ParamsType.File:
                        m_strType = "System.String";
                        AddAttribute(new EditorAttribute(typeof(PropertyFileEditor), typeof(UITypeEditor)));
                        break;
                    case ParamsType.Float:
                        m_strType = "System.Double";
                        break;
                    case ParamsType.Folder:
                        m_strType = "System.String";
                        AddAttribute(new EditorAttribute(typeof(PropertyFolderEditor), typeof(UITypeEditor)));
                        break;
                    case ParamsType.Font:
                        m_strType = typeof(Font).AssemblyQualifiedName;
                        break;
                    case ParamsType.Image:
                        m_strType = typeof(Image).AssemblyQualifiedName;
                        break;
                    case ParamsType.Int:
                        m_strType = "System.Decimal";
                        break;
                    case ParamsType.List:
                        m_strType = "System.String";
                        AddAttribute(new EditorAttribute(typeof(PropertyListEditor), typeof(UITypeEditor)));
                        break;
                    case ParamsType.String:
                        m_strType = "System.String";
                        break;
                    case ParamsType.DateTime:
                    case ParamsType.DateTimeStart:
                    case ParamsType.DateTimeEnd:
                    case ParamsType.Date:
                        m_strType = "System.DateTime";
                        break;
                    case ParamsType.Time:
                        m_strType = "System.DateTime";
                        AddAttribute(new EditorAttribute(typeof(PropertyTimeEditor), typeof(UITypeEditor)));
                        break;
                    case ParamsType.CustomForm:
                        m_strType = "System.String";
                        AddAttribute(new EditorAttribute(typeof(PropertyCustomFormEditor), typeof(UITypeEditor)));
                        break;
                    case ParamsType.MultiLine:
                        m_strType = "System.String[]";
                        AddAttribute(new EditorAttribute(typeof(PropertyMultiEditTextEditor), typeof(UITypeEditor)));
                        break;
                }
            }
        }

        /// <summary>
        /// ,        
        /// </summary>
        public ArrayList List
        {
            get { return m_alArrayList; }
            set { m_alArrayList = value; }
        }

        /// <summary>
        /// ,       Data
        /// </summary>
        public DataTable Table
        {
            get { return m_dtTable; }
            set
            {
                m_dtTable = value;
                if(m_strDataKey != "")
                    m_dtTable.PrimaryKey = new DataColumn[] {m_dtTable.Columns[m_strDataKey]};
            }
        }

        public string StoredProc
        {
            get { return m_strStoredProc; }
            set { m_strStoredProc = value; }
        }

        /// <summary>
        /// ,       Data
        /// </summary>
        public string DataKey
        {
            get { return m_strDataKey; }
            set
            {
                m_strDataKey = value;
                if(m_dtTable != null)
                    m_dtTable.PrimaryKey = new DataColumn[] {m_dtTable.Columns[m_strDataKey]};
            }
        }

        /// <summary>
        /// ,        Data
        /// </summary>
        public string DataValue
        {
            get { return m_strDataValue; }
            set { m_strDataValue = value; }
        }

        /// <summary>
        /// ,      CustomForm
        /// </summary>
        public ICustomForm CustomForm
        {
            get { return m_fCustomForm; }
            set { m_fCustomForm = value; }
        }

        public object GetDefaultValue(ParamsType type, object DefValue)
        {
            object result = null;

            switch(type)
            {
                case ParamsType.Data:
                {
                    int iCount = m_dtTable.Rows.Count;
                    int iIndex = 0;
                    while(iIndex < iCount)
                    {
                        DataRow drCurrent = m_dtTable.Rows[iIndex++];
                        if(drCurrent[m_strDataKey].ToString() == DefValue.ToString())
                        {
                            result = drCurrent[m_strDataKey];
                            break;
                        }
                    }
                    break;
                }
                case ParamsType.List:
                    if(DefValue is int)
                        result = m_alArrayList[Convert.ToInt32(DefValue)];
                    break;
                default:
                    result = DefValue;
                    break;
            }
            return result;
        }

        public object MaxValue
        {
            get { return m_objMaxValue; }
            set { m_objMaxValue = value; }
        }

        public object MinValue
        {
            get { return m_objMinValue; }
            set { m_objMinValue = value; }
        }
    }

    /// <summary>
    ///       
    /// </summary>
    public class ParamEventArgs : EventArgs
    {
        /// <summary>
        /// -
        /// </summary>
        private Param m_objProperty;

        /// <summary>
        ///  
        /// </summary>
        private object m_objValue;

        private object m_objPreviousValue;

        /// <summary>
        ///      Data
        /// </summary>
        private object m_objDataKey;

        /// <summary>
        ///         List
        /// </summary>
        private int m_iIndex;

        /// <summary>
        ///     
        /// </summary>
        /// <param name="objProperty">-</param>
        public ParamEventArgs(Param objProperty)
        {
            m_objProperty = objProperty;
        }

        /// <summary>
        ///     
        /// </summary>
        /// <param name="objProperty">-</param>
        /// <param name="objValue"> </param>
        public ParamEventArgs(Param objProperty, object objValue) : this(objProperty)
        {
            m_objValue = objValue;
        }

        /// <summary>
        /// ,  -
        /// </summary>
        public Param Property
        {
            get { return m_objProperty; }
        }

        /// <summary>
        /// ,  
        /// </summary>
        public object Value
        {
            get { return m_objValue; }
            set { m_objValue = value; }
        }

        public object PreviousValue
        {
            get { return m_objPreviousValue; }
            set { m_objPreviousValue = value; }
        }

        /// <summary>
        /// ,       Data
        /// </summary>
        public object DataKey
        {
            get { return m_objDataKey; }
            set { m_objDataKey = value; }
        }

        /// <summary>
        /// ,       List
        /// </summary>
        public int Index
        {
            get { return m_iIndex; }
            set { m_iIndex = value; }
        }
    }

    /// <summary>
    ///   ,     <see cref="ParamEventArgs"/>
    /// </summary>
    public delegate void ParamEventHandler(object sender, ParamEventArgs e);

    #region ParamCollection class definition

    /// <summary>
    /// ,   
    /// </summary>
    [Serializable]
    public class ParamCollection : IList
    {
        /// <summary>
        ///    
        /// </summary>
        private ArrayList m_alInner;

        /// <summary>
        ///    
        /// </summary>
        public ParamCollection()
        {
            m_alInner = new ArrayList();
        }

        /// <summary>
        /// ,     
        /// </summary>
        public int Count
        {
            get { return m_alInner.Count; }
        }

        /// <summary>
        ///  
        /// </summary>
        public bool IsFixedSize
        {
            get { return false; }
        }

        /// <summary>
        ///  
        /// </summary>
        public bool IsReadOnly
        {
            get { return false; }
        }

        /// <summary>
        ///  
        /// </summary>
        public bool IsSynchronized
        {
            get { return false; }
        }

        /// <summary>
        ///  
        /// </summary>
        object ICollection.SyncRoot
        {
            get { return null; }
        }

        /// <summary>
        /// ,     
        /// </summary>
        public Param this[int iIndex]
        {
            get { return (Param) m_alInner[iIndex]; }
            set { m_alInner[iIndex] = value; }
        }

        /// <summary>
        /// ,     
        /// </summary>
        public Param this[string strParamName]
        {
            get
            {
//				int iIndex = m_alInner.IndexOf(strParamName);
                int iCount = m_alInner.Count;
                int iIndex = 0;
                while(iIndex < iCount)
                {
                    Param parCurrent = (Param) m_alInner[iIndex++];
                    if(parCurrent.Name == strParamName)
                        return parCurrent;
                }
                return null; //(Param)m_alInner[iIndex]; 
            } //			set 
//			{ 
////				int iIndex = m_alInner.IndexOf(strParamName);
//				foreach(Param parCurrent in m_alInner)
//					if(parCurrent.Name == strParamName)
//					{
//						parCurrent = value;
//						break;
//					}
////				m_alInner[iIndex] = value; 
//			}
        }

        /// <summary>
        ///     
        /// </summary>
        /// <param name="value">  <see cref="Param"/></param>
        /// <returns>  </returns>
        public int Add(Param value)
        {
            int iIndex = m_alInner.Add(value);

            return iIndex;
        }

        /// <summary>
        ///      
        /// </summary>
        /// <param name="objArray"> </param>
        public void AddRange(Param[] objArray)
        {
            m_alInner.AddRange(objArray);
        }

        /// <summary>
        ///   
        /// </summary>
        public void Clear()
        {
            m_alInner.Clear();
        }

        /// <summary>
        /// ,      
        /// </summary>
        /// <param name="objItem">  <see cref="Param"/></param>
        /// <returns>true,     ,  false</returns>
        public bool Contains(Param objItem)
        {
            return m_alInner.Contains(objItem);
        }

        /// <summary>
        /// ,      
        /// </summary>
        /// <param name="strName"> </param>
        /// <returns>true,     ,  false</returns>
        public bool Contains(string strName)
        {
            int iCount = m_alInner.Count;
            int iIndex = 0;
            while(iIndex < iCount)
            {
                Param objSpec = (Param) m_alInner[iIndex++];
                if(objSpec.Name == strName)
                    return true;
            }

            return false;
        }

        /// <summary>
        ///   
        /// </summary>
        /// <param name="objArray">   </param>
        public void CopyTo(Param[] objArray)
        {
            m_alInner.CopyTo(objArray);
        }

        /// <summary>
        ///   
        /// </summary>
        /// <param name="objArray"> </param>
        /// <param name="iIndex">   </param>
        public void CopyTo(Param[] objArray, int iIndex)
        {
            m_alInner.CopyTo(objArray, iIndex);
        }

        /// <summary>
        ///  ,       
        /// </summary>
        /// <returns> <see cref="IEnumerator"/>  </returns>
        /// <remarks>
        /// </remarks>
        public IEnumerator GetEnumerator()
        {
            return m_alInner.GetEnumerator();
        }

        public int IndexOf(Param value)
        {
            return m_alInner.IndexOf(value);
        }

        public int IndexOf(string strName)
        {
            int iCount = m_alInner.Count;
            int iIndex = 0;
            while(iIndex < iCount)
            {
                Param objSpec = (Param) m_alInner[iIndex++];
                if(objSpec.Name == strName)
                    return iIndex - 1;
            }

            return -1;
        }

        public Param ItemOf(string strName)
        {
            int iIndex = IndexOf(strName);
            return (Param) m_alInner[iIndex];
        }

        public void Insert(int iIndex, Param objValue)
        {
            m_alInner.Insert(iIndex, objValue);
        }

        public void Remove(Param objSpec)
        {
            m_alInner.Remove(objSpec);
        }

        public void Remove(string strName)
        {
            int iRemoveIndex = -1;
            int iCount = Count;
            int iIndex = 0;
            while(iIndex < iCount)
            {
                Param parCur = this[iIndex++];
                if(parCur.Name == strName)
                {
                    iRemoveIndex = IndexOf(parCur);
                    break;
                }
            }
            RemoveAt(iRemoveIndex);
        }

        public void RemoveAt(int iIndex)
        {
            m_alInner.RemoveAt(iIndex);
        }

        public Param[] ToArray()
        {
            return (Param[]) m_alInner.ToArray(typeof(Param));
        }

        #region Explicit interface implementations for ICollection and IList

        void ICollection.CopyTo(Array aArray, int iIndex)
        {
            CopyTo((Param[]) aArray, iIndex);
        }

        int IList.Add(object objValue)
        {
            return Add((Param) objValue);
        }

        bool IList.Contains(object objValue)
        {
            return Contains((Param) objValue);
        }

        object IList.this[int iIndex]
        {
            get { return this[iIndex]; }
            set { (this)[iIndex] = (Param) value; }
        }

        int IList.IndexOf(object objValue)
        {
            return IndexOf((Param) objValue);
        }

        void IList.Insert(int iIndex, object objValue)
        {
            Insert(iIndex, (Param) objValue);
        }

        void IList.Remove(object objValue)
        {
            Remove((Param) objValue);
        }

        #endregion
    }

    #endregion

    [Serializable]
    public class ParamBag : ICustomTypeDescriptor
    {
        #region ParamDescriptor class definition

        public class ParamDescriptor : PropertyDescriptor
        {
            private ParamBag m_objBag;
            private Param m_objSpec;
            private Hashtable m_htValues;

            public ParamDescriptor(Param objSpec, ParamBag objBag, string strName, Attribute[] attAttrs)
                : base(strName, attAttrs)
            {
                m_objBag = objBag;
                m_objSpec = objSpec;
                m_htValues = new Hashtable();
            }

            public override Type ComponentType
            {
                get { return m_objSpec.GetType(); }
            }

            public override bool IsReadOnly
            {
                get { return (Attributes.Matches(ReadOnlyAttribute.Yes)); }
            }

            public override Type PropertyType
            {
                get { return Type.GetType(m_objSpec.TypeName); }
            }

            public override bool CanResetValue(object objComponent)
            {
                if(m_objSpec.DefaultValue == null)
                    return false;
                else
                    return !GetValue(objComponent).Equals(m_objSpec.DefaultValue);
            }

            public override object GetValue(object objComponent)
            {
                if(!m_htValues.ContainsKey(m_objSpec))
                {
                    m_htValues[m_objSpec] = m_objSpec.DefaultValue;

                    switch(m_objSpec.Type)
                    {
                        case ParamsType.Data:
                        {
                            int iCount = m_objSpec.Table.Rows.Count;
                            int iIndex = 0;
                            while(iIndex < iCount)
                            {
                                DataRow drCurrent = m_objSpec.Table.Rows[iIndex++];
                                if(drCurrent[m_objSpec.DataKey].ToString() == m_objSpec.DefaultValue.ToString())
                                {
                                    m_htValues[m_objSpec] = drCurrent[m_objSpec.DataValue];
                                    break;
                                }
                            }
                            break;
                        }
                        case ParamsType.List:
                            if(m_objSpec.DefaultValue is int)
                                m_htValues[m_objSpec] = m_objSpec.List[Convert.ToInt32(m_objSpec.DefaultValue)];
                            break;
                    }
                }
                ParamEventArgs evSpec = new ParamEventArgs(m_objSpec, m_htValues[m_objSpec]);
                PropertyBag.OnGetValue(evSpec);
                return evSpec.Value;
            }

            public override void ResetValue(object objComponent)
            {
                switch(m_objSpec.Type)
                {
                    case ParamsType.Data:
                    {
                        object objValue = null;
                        int iCount = m_objSpec.Table.Rows.Count;
                        int iIndex = 0;
                        while(iIndex < iCount)
                        {
                            DataRow drCurrent = m_objSpec.Table.Rows[iIndex++];
                            if(drCurrent[m_objSpec.DataKey] == m_objSpec.DefaultValue)
                            {
                                objValue = drCurrent[m_objSpec.DataValue];
                                break;
                            }
                        }
                        SetValue(objComponent, objValue);
                        break;
                    }
                    default:
                        SetValue(objComponent, m_objSpec.DefaultValue);
                        break;
                }
            }

            public override void SetValue(object objComponent, object objValue)
            {
                ParamEventArgs evSpec;
                if(objValue is ParamEventArgs)
                    evSpec = (ParamEventArgs) objValue;
                else
                    evSpec = new ParamEventArgs(m_objSpec, objValue);
                if(m_objSpec.DataKey != null && m_objSpec.DataKey != "")
                {
                    int iCount = m_objSpec.Table.Rows.Count;
                    int iIndex = 0;
                    while(iIndex < iCount)
                    {
                        DataRow drCur = m_objSpec.Table.Rows[iIndex++];
                        if(drCur[m_objSpec.DataValue] == m_htValues[m_objSpec])
                        {
                            evSpec.PreviousValue = drCur[m_objSpec.DataKey];
                            break;
                        }
                    }
                }
                else if(m_objSpec.List != null && m_objSpec.List.Count != 0)
                {
                    if(m_objSpec.ListType)
                        evSpec.PreviousValue = m_objSpec.List.Contains(m_htValues[m_objSpec]);
                    else
                        evSpec.PreviousValue = m_htValues[m_objSpec];
                }
                else
                    evSpec.PreviousValue = m_htValues[m_objSpec];
                m_htValues[m_objSpec] = evSpec.Value;
                PropertyBag.OnSetValue(evSpec);
                if(m_objSpec.DataKey != null && m_objSpec.DataKey != "" && evSpec.DataKey != null)
                    m_htValues[m_objSpec] = m_objSpec.Table.Rows.Find(evSpec.DataKey)[m_objSpec.DataValue];
//				else if(m_objSpec.List != null)
//				{
//					if(m_objSpec.ListType)
//						evSpec.PreviousValue = m_objSpec.List.Contains(m_htValues[m_objSpec]);
//					else
//						evSpec.PreviousValue = m_htValues[m_objSpec];
//				}
//				else
//					evSpec.PreviousValue = m_htValues[m_objSpec];
            }

            public override bool ShouldSerializeValue(object objComponent)
            {
                object objValue = GetValue(objComponent);

                if(m_objSpec.DefaultValue == null && objValue == null)
                    return false;
                else
                    return !objValue.Equals(m_objSpec.DefaultValue);
            }

            public Param Parent
            {
                get { return m_objSpec; }
            }

            public Param Current
            {
                get { return m_objSpec; }
            }

        	public ParamBag PropertyBag
        	{
        		get { return m_objBag; }
        	}
        }

        #endregion

//		private string			m_strDefaultProperty;
        private ParamCollection m_objParams;

        public ParamBag()
        {
//			m_strDefaultProperty	= null;
            m_objParams = new ParamCollection();
        }

//		public string DefaultProperty
//		{
//			get { return m_strDefaultProperty; }
//			set { m_strDefaultProperty = value; }
//		}
        public ParamCollection Params
        {
            get { return m_objParams; }
            set { m_objParams = value; }
        }

        public event ParamEventHandler GetValue;
        public event ParamEventHandler SetValue;
        public event ParamEventHandler LimitMinValue;
        public event ParamEventHandler LimitMaxValue;

        protected virtual void OnGetValue(ParamEventArgs e)
        {
            if(GetValue != null)
            {
                GetValue(this, e);

                if(e.Property.TypeName == "System.DateTime")
                {
                    DateTime dtCurrent = new DateTime(9999, 12, 31);
                    if((DateTime) e.Value == dtCurrent)
                        e.Value = new DateTime(9998, 12, 31);
                }
                if(e.Property.Type == ParamsType.DateTimeEnd)
                {
                    DateTime dtValue = (DateTime) e.Value;
                    e.Value = new DateTime(dtValue.Year, dtValue.Month, dtValue.Day, 23, 59, 59);
                    if(SetValue != null)
                        SetValue(this, e);
                }
            }
        }

        protected virtual void OnSetValue(ParamEventArgs e)
        {
            bool bMax = e.Property.MaxValue != null;
            bool bMin = e.Property.MinValue != null;
            if(bMin && bMax && !e.Property.MaxValue.Equals(e.Property.MinValue))
            {
                switch(e.Property.TypeName)
                {
                    case "System.DateTime":
                        if(Convert.ToDateTime(e.Value) < Convert.ToDateTime(e.Property.MinValue))
                        {
                            if(LimitMinValue != null)
                                LimitMinValue(this, e);
                            e.Value = Convert.ToDateTime(e.Property.MinValue);
                        }
                        if(Convert.ToDateTime(e.Value) > Convert.ToDateTime(e.Property.MaxValue))
                        {
                            if(LimitMaxValue != null)
                                LimitMaxValue(this, e);
                            e.Value = Convert.ToDateTime(e.Property.MaxValue);
                        }

                        DateTime dtCurrent = new DateTime(9998, 12, 31);
                        if((DateTime) e.Value == dtCurrent)
                            e.Value = new DateTime(9999, 12, 31);

                        break;
                    case "System.Decimal":
                        try
                        {
                            if(Convert.ToDecimal(e.Value) < Convert.ToDecimal(e.Property.MinValue))
                            {
                                if(LimitMinValue != null)
                                    LimitMinValue(this, e);
                                e.Value = Convert.ToDecimal(e.Property.MinValue);
                            }
                            if(Convert.ToDecimal(e.Value) > Convert.ToDecimal(e.Property.MaxValue))
                            {
                                if(LimitMaxValue != null)
                                    LimitMaxValue(this, e);
                                e.Value = Convert.ToDecimal(e.Property.MaxValue);
                            }
                        }
                        catch
                        {
                            e.Value = e.Property.DefaultValue;
                        }
                        break;
                    case "int":
                    case "integer":
                        try
                        {
                            if(Convert.ToInt32(e.Value) < Convert.ToInt32(e.Property.MinValue))
                            {
                                if(LimitMinValue != null)
                                    LimitMinValue(this, e);
                                e.Value = Convert.ToInt32(e.Property.MinValue);
                            }
                            if(Convert.ToInt32(e.Value) > Convert.ToInt32(e.Property.MaxValue))
                            {
                                if(LimitMaxValue != null)
                                    LimitMaxValue(this, e);
                                e.Value = Convert.ToInt32(e.Property.MaxValue);
                            }
                        }
                        catch
                        {
                            e.Value = e.Property.DefaultValue;
                        }
                        break;
                    case "System.Double":
                    case "double":
                        try
                        {
                            if(Convert.ToDouble(e.Value) < Convert.ToDouble(e.Property.MinValue))
                            {
                                if(LimitMinValue != null)
                                    LimitMinValue(this, e);
                                e.Value = Convert.ToDouble(e.Property.MinValue);
                            }
                            if(Convert.ToDouble(e.Value) > Convert.ToDouble(e.Property.MaxValue))
                            {
                                if(LimitMaxValue != null)
                                    LimitMaxValue(this, e);
                                e.Value = Convert.ToDouble(e.Property.MaxValue);
                            }
                        }
                        catch
                        {
                            e.Value = e.Property.DefaultValue;
                        }
                        break;
                    case "System.Float":
                    case "float":
                        if((float) e.Value < (float) e.Property.MinValue)
                        {
                            if(LimitMinValue != null)
                                LimitMinValue(this, e);
                            e.Value = e.Property.MinValue;
                        }
                        if((float) e.Value > (float) e.Property.MaxValue)
                        {
                            if(LimitMaxValue != null)
                                LimitMaxValue(this, e);
                            e.Value = e.Property.MaxValue;
                        }
                        break;
                }
            }
            bool bMandatory = false;
            if(e.Property.IsMandatory)
            {
                if(e.Property.DataKey != null && e.Property.DataKey != "")
                {
                    if(e.DataKey == null)
                        bMandatory = true;
                }
                else if(e.Property.List != null && e.Property.List.Count != 0)
                {
                    if(e.Property.ListType && e.Index == -1)
                        bMandatory = true;
                    else if(!e.Property.ListType && (e.Value == null || ((string) e.Value) == ""))
                        bMandatory = true;
                }
                else if(e.Value == DBNull.Value || e.Value == null || (e.Value != null && e.Value.ToString() == ""))
                    bMandatory = true;
            }
            if(bMandatory)
            {
                MessageBox.Show(
                    ResourceControl.String49, ResourceControl.String50, MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                if(e.Property.DataKey != null && e.Property.DataKey != "")
                    e.DataKey = e.PreviousValue;
                else if(e.Property.List != null && e.Property.List.Count != 0)
                {
                    if(e.Property.ListType)
                        e.Index = (int) e.PreviousValue;
                    else
                        e.Value = e.PreviousValue;
                }
                else
                    e.Value = e.PreviousValue;
            }
            if(SetValue != null)
                SetValue(this, e);
        }

        #region ICustomTypeDescriptor explicit interface definitions

        AttributeCollection ICustomTypeDescriptor.GetAttributes()
        {
            return TypeDescriptor.GetAttributes(this, true);
        }

        string ICustomTypeDescriptor.GetClassName()
        {
            return TypeDescriptor.GetClassName(this, true);
        }

        string ICustomTypeDescriptor.GetComponentName()
        {
            return TypeDescriptor.GetComponentName(this, true);
        }

        TypeConverter ICustomTypeDescriptor.GetConverter()
        {
            return TypeDescriptor.GetConverter(this, true);
        }

        EventDescriptor ICustomTypeDescriptor.GetDefaultEvent()
        {
            return TypeDescriptor.GetDefaultEvent(this, true);
        }

        PropertyDescriptor ICustomTypeDescriptor.GetDefaultProperty()
        {
            Param objParam = null;
//			if(m_strDefaultProperty != null)
//			{
//				int iIndex = m_objParams.IndexOf(m_strDefaultProperty);
//				objParam = m_objParams[iIndex];
//			}

            if(objParam != null)
                return new ParamDescriptor(objParam, this, objParam.Caption, null);
            else
                return null;
        }

        object ICustomTypeDescriptor.GetEditor(Type EditorBaseType)
        {
            return TypeDescriptor.GetEditor(this, EditorBaseType, true);
        }

        EventDescriptorCollection ICustomTypeDescriptor.GetEvents()
        {
            return TypeDescriptor.GetEvents(this, true);
        }

        EventDescriptorCollection ICustomTypeDescriptor.GetEvents(Attribute[] attAttributes)
        {
            return TypeDescriptor.GetEvents(this, attAttributes, true);
        }

        PropertyDescriptorCollection ICustomTypeDescriptor.GetProperties()
        {
            return ((ICustomTypeDescriptor) this).GetProperties(new Attribute[0]);
        }

        PropertyDescriptorCollection ICustomTypeDescriptor.GetProperties(Attribute[] attAttributes)
        {
            ArrayList alProps = new ArrayList();

            int iCount = m_objParams.Count;
            int iIndex = 0;
            while(iIndex < iCount)
            {
                Param objProperty = m_objParams[iIndex++];
                ArrayList alAttrs = new ArrayList();

                if(objProperty.Category != null)
                    alAttrs.Add(new CategoryAttribute(objProperty.Category));

                if(objProperty.Description != null)
                    alAttrs.Add(new DescriptionAttribute(objProperty.Description));

                if(objProperty.EditorTypeName != null)
                    alAttrs.Add(new EditorAttribute(objProperty.EditorTypeName, typeof(UITypeEditor)));

                if(objProperty.ConverterTypeName != null && objProperty.ConverterTypeName.Length != 0)
                    alAttrs.Add(new TypeConverterAttribute(objProperty.ConverterTypeName));

                if(objProperty.Attributes != null)
                    alAttrs.AddRange(objProperty.Attributes);

                Attribute[] attrArray = (Attribute[]) alAttrs.ToArray(typeof(Attribute));

                ParamDescriptor pd = new ParamDescriptor(objProperty, this, objProperty.Caption, attrArray);
                alProps.Add(pd);
            }
            PropertyDescriptor[] propArray = (PropertyDescriptor[]) alProps.ToArray(typeof(PropertyDescriptor));
            return new PropertyDescriptorCollection(propArray);
        }

        object ICustomTypeDescriptor.GetPropertyOwner(PropertyDescriptor pd)
        {
            return this;
        }

        #endregion
    }

    public class ValueValidator : TypeConverter
    {
        private bool m_bOnce = true;

        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
//			bool bRes = base.CanConvertFrom (context, sourceType);
            return true;
        }

        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
        {
            object objRes = null;
            Param parValue = null;
            if(m_bOnce)
            {
                parValue = ((ParamBag.ParamDescriptor) context.PropertyDescriptor).Current;
                m_bOnce = false;
                try
                {
                    switch(parValue.Type)
                    {
                        case ParamsType.Data:
                        {
                            bool bExists = false;
                            int iCount = parValue.Table.Rows.Count;
                            int iIndex = 0;
                            while(iIndex < iCount)
                            {
                                DataRow drCurrent = parValue.Table.Rows[iIndex++];
                                if(drCurrent[parValue.DataValue] == value)
                                {
                                    bExists = true;
                                    objRes = value;
                                    break;
                                }
                            }
                            if(!bExists)
                            {
                                if(value.ToString().Length != 0)
                                {
                                    MessageBox.Show(
                                        ResourceControl.String51,
                                        ResourceControl.String52,
                                        MessageBoxButtons.OK,
                                        MessageBoxIcon.Asterisk);
                                }
                                else
                                    objRes = DBNull.Value;
                            }

                            break;
                        }
                        case ParamsType.List:
                        {
                            bool bExists = false;
                            int iCount = parValue.List.Count;
                            int iIndex = 0;
                            while(iIndex < iCount)
                            {
                                object objCurrent = parValue.List[iIndex++];
                                if(objCurrent == value)
                                {
                                    bExists = true;
                                    objRes = value;
                                    break;
                                }
                            }
                            if(!bExists)
                            {
                                MessageBox.Show(
                                    ResourceControl.String53,
                                    ResourceControl.String52,
                                    MessageBoxButtons.OK,
                                    MessageBoxIcon.Asterisk);
                            }
                            break;
                        }
                        case ParamsType.Time:
                        {
                            try
                            {
                                objRes = Convert.ToDateTime(value).ToString("hh:mm:ss");
                            }
                            catch
                            {
                                MessageBox.Show(
                                    ResourceControl.String54,
                                    ResourceControl.String52,
                                    MessageBoxButtons.OK,
                                    MessageBoxIcon.Asterisk);
                            }
                            break;
                        }
						
                        case ParamsType.MultiLine:
                        {
                            objRes = value.ToString().Replace("\r\n", " ");
                            break;
                        }
                        default:
                        {
                            switch(context.PropertyDescriptor.PropertyType.FullName)
                            {
                                case "System.Boolean":
                                {
                                    try
                                    {
                                        //objRes = Convert.ToBoolean(value);
                                        if(((string) value) /*.ToLower()*/== ResourceControl.String27)
                                            objRes = true;
                                        if(((string) value) /*.ToLower()*/== ResourceControl.String28)
                                            objRes = false;
                                    }
                                    catch
                                    {
                                        MessageBox.Show(
                                            ResourceControl.String51,
                                            ResourceControl.String52,
                                            MessageBoxButtons.OK,
                                            MessageBoxIcon.Asterisk);
                                    }
                                }
                                    break;
                                case "System.Decimal":
                                    if(value is string)
                                    {
                                        string strDelimiter = culture.NumberFormat.CurrencyDecimalSeparator;
                                        string strValue = value.ToString();
                                        strValue = strValue.Replace(".", strDelimiter);
                                        try
                                        {
                                            if(strValue.Length != 0)
                                                objRes = Convert.ToDecimal(strValue);
                                            else
                                                objRes = null;
                                        }
                                        catch
                                        {
                                            MessageBox.Show(
                                                ResourceControl.String53,
                                                ResourceControl.String52,
                                                MessageBoxButtons.OK,
                                                MessageBoxIcon.Asterisk);
                                        }
                                    }
                                    break;
                                case "System.Double":
                                    if(value is string)
                                    {
                                        string strDelimiter = culture.NumberFormat.CurrencyDecimalSeparator;
                                        string strValue = value.ToString();
                                        strValue = strValue.Replace(".", strDelimiter);
                                        try
                                        {
                                            if(strValue.Length != 0)
                                                objRes = Convert.ToDouble(strValue);
                                            else
                                                objRes = null;
                                        }
                                        catch
                                        {
                                            MessageBox.Show(
                                                ResourceControl.String53,
                                                ResourceControl.String52,
                                                MessageBoxButtons.OK,
                                                MessageBoxIcon.Asterisk);
                                        }
                                    }
                                    break;
								case "System.Single":
									if(value is string)
									{
										string strDelimiter = culture.NumberFormat.CurrencyDecimalSeparator;
										string strValue = value.ToString();
										strValue = strValue.Replace(".", strDelimiter);
										try
										{
											if(strValue.Length != 0)
												objRes = Convert.ToSingle(strValue);
											else
												objRes = null;
										}
										catch
										{
											MessageBox.Show(
												ResourceControl.String53,
												ResourceControl.String52,
												MessageBoxButtons.OK,
												MessageBoxIcon.Asterisk);
										}
									}
									break;
								case "System.DateTime":
                                    try
                                    {
                                        objRes = DateTime.Parse(value.ToString());
                                        //DateTime dtCurrent= new DateTime(9998,12,31);
                                        //if((DateTime)objRes==dtCurrent)
                                        //	objRes=new DateTime(9999,12,31);
                                    }
                                    catch
                                    {
                                        MessageBox.Show(
                                            ResourceControl.String54,
                                            ResourceControl.String52,
                                            MessageBoxButtons.OK,
                                            MessageBoxIcon.Asterisk);
                                    }
                                    break;
								case "System.Byte":
									try
									{
										objRes = Convert.ToByte(value);
									}
									catch
									{
										MessageBox.Show(
											ResourceControl.String53,
											ResourceControl.String52,
											MessageBoxButtons.OK,
											MessageBoxIcon.Asterisk);
									}
									break;
								case "System.Int16":
									try
									{
										objRes = Convert.ToInt16(value);
									}
									catch
									{
										MessageBox.Show(
											ResourceControl.String53,
											ResourceControl.String52,
											MessageBoxButtons.OK,
											MessageBoxIcon.Asterisk);
									}
									break;
								case "System.Int32":
                                    try
                                    {
                                        objRes = Convert.ToInt32(value);
                                    }
                                    catch
                                    {
                                        MessageBox.Show(
                                            ResourceControl.String53,
                                            ResourceControl.String52,
                                            MessageBoxButtons.OK,
                                            MessageBoxIcon.Asterisk);
                                    }
                                    break;
								case "System.Int64":
                                    try
                                    {
                                        objRes = Convert.ToInt64(value);
                                    }
                                    catch
                                    {
                                        MessageBox.Show(
                                            ResourceControl.String53,
                                            ResourceControl.String52,
                                            MessageBoxButtons.OK,
                                            MessageBoxIcon.Asterisk);
                                    }
                                    break;
                                case "System.String":
									if(parValue.Mask!=null && parValue.Mask!=""  && value.ToString().Trim()!="")
									{
								
										Regex regex=new Regex(parValue.Mask);
										if(!regex.IsMatch(value.ToString()))
										{
											MessageBox.Show(
												ResourceControl.String59,
												ResourceControl.String52,
												MessageBoxButtons.OK,
												MessageBoxIcon.Asterisk);
										}
										else
											objRes = value;
										
								
									}
									else
										objRes = value;
                                    break;
                                case "System.String[]":
                                    objRes = value;
                                    break;
                                default:
                                    objRes = base.ConvertFrom(context, culture, value);
									if(objRes == null)
										objRes = value;
                                    break;
                            }
                            break;
                        }
                    }
                }
                catch
                {
					objRes = value;
				}
                m_bOnce = true;
            }
            if(context.PropertyDescriptor.PropertyType.FullName != "System.Decimal")
            {
                if(objRes == null)
                    objRes = context.PropertyDescriptor.GetValue(parValue);
            }

            return objRes;
        }

        public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
        {
//			bool bRes =  base.CanConvertTo (context, destinationType);
            return true;
        }

        public override object ConvertTo(
            ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
        {
            object objRes = null;
            Param parValue = null;

            if(context != null)
            {
                parValue = ((ParamBag.ParamDescriptor) context.PropertyDescriptor).Current;

                switch(context.PropertyDescriptor.PropertyType.FullName)
                {
                    case "System.DateTime":
                        try
                        {
                            if(parValue.Type == ParamsType.Date)
                                objRes = ((DateTime) value).ToString("dd.MM.yyyy");
                            else if(parValue.Type == ParamsType.Time)
                                objRes = ((DateTime) value).ToString("HH:mm:ss");
                            else
                                objRes = ((DateTime) value).ToString("dd.MM.yyyy HH:mm:ss");
//							else if(parValue.Type == ParamsType.DateTimeStart)
//							{
//								DateTime dtValue = (DateTime) value;
////								DateTime dtStartValue = new DateTime(dtValue.Year, dtValue.Month, dtValue.Day, 0, 0, 0);
////								objRes = dtStartValue.ToString("dd.MM.yyyy HH:mm:ss");
//								objRes = dtValue.ToString("dd.MM.yyyy HH:mm:ss");
//								value = dtValue;
//							}
//							else if(parValue.Type == ParamsType.DateTimeEnd)
//							{
//								DateTime dtValue = (DateTime) value;
//								DateTime dtEndValue = new DateTime(dtValue.Year, dtValue.Month, dtValue.Day, 23, 59, 59);
//								objRes = dtEndValue.ToString("dd.MM.yyyy HH:mm:ss");
////								objRes = dtValue.ToString("dd.MM.yyyy HH:mm:ss");
//								value = dtEndValue;
//							}
                        }
                        catch
                        {
                        }
                        break;
                    case "System.Boolean":
                        try
                        {
                            objRes = ((bool) value) ? ResourceControl.String27 : ResourceControl.String28;
                        }
                        catch
                        {
                        }
                        break;
                    case "System.String[]":
                        try
                        {
                            objRes = value.ToString().Replace("\r\n", " ");
                        }
                        catch
                        {
                        }
                        break;
                    default:
                        if(value is ICustomValue)
                            objRes = ((ICustomValue) value).Caption;
                        else
                            objRes = base.ConvertTo(context, culture, value, destinationType);
                        break;
                }
            }
            if(objRes == null)
            {
                try
                {
                    objRes = Convert.ChangeType(value, destinationType);
                }
                catch
                {
                }
            }
            return objRes;
        }

        public override object CreateInstance(ITypeDescriptorContext context, IDictionary propertyValues)
        {
            object bRes = base.CreateInstance(context, propertyValues);
            return bRes;
        }

        public override bool Equals(object obj)
        {
            bool bRes = base.Equals(obj);
            return bRes;
        }

        public override bool GetCreateInstanceSupported(ITypeDescriptorContext context)
        {
            bool bRes = base.GetCreateInstanceSupported(context);
            return bRes;
        }

        public override int GetHashCode()
        {
            int bRes = base.GetHashCode();
            return bRes;
        }

        public override PropertyDescriptorCollection GetProperties(
            ITypeDescriptorContext context, object value, Attribute[] attributes)
        {
            PropertyDescriptorCollection bRes = base.GetProperties(context, value, attributes);
            return bRes;
        }

        public override bool GetPropertiesSupported(ITypeDescriptorContext context)
        {
            bool bRes = base.GetPropertiesSupported(context);
            return bRes;
        }

        public override StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
        {
            StandardValuesCollection bRes = base.GetStandardValues(context);
            if(context.PropertyDescriptor.PropertyType.FullName == "System.Boolean")
                bRes = new StandardValuesCollection(new bool[] {true, false});
            return bRes;
        }

        public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
        {
            bool bRes = base.GetStandardValuesExclusive(context);
            return bRes;
        }

        public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
        {
            bool bRes = base.GetStandardValuesSupported(context);
            switch(context.PropertyDescriptor.PropertyType.FullName)
            {
                case "System.Boolean":
                    return true;
                    //break;
                default:
                    return bRes;
            }
        }

        public override bool IsValid(ITypeDescriptorContext context, object value)
        {
            bool bRes = base.IsValid(context, value);
            return bRes;
        }
    }

    public class ParamTable : ParamBag
    {
        private Hashtable propValues;

        public ParamTable()
        {
            propValues = new Hashtable();
        }

        public object this[string strKey]
        {
            get { return propValues[strKey]; }
            set
            {
                base.OnSetValue(new ParamEventArgs(Params.ItemOf(strKey), value));
                propValues[strKey] = value;
            }
        }

        protected override void OnGetValue(ParamEventArgs e)
        {
            e.Value = propValues[e.Property.Name];
            base.OnGetValue(e);
        }

        protected override void OnSetValue(ParamEventArgs e)
        {
            propValues[e.Property.Name] = e.Value;
            base.OnSetValue(e);
        }
    }

    #region    

    /// <summary>
    ///    
    /// </summary>
    public class PropertyConverter : ExpandableObjectConverter
    {
    }

    #endregion

    #region     Time

    public class PropertyTimeEditor : UITypeEditor
    {
        /// <summary>
        ///      
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.DropDown;
        }

        /// <summary>
        /// ,   
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            IWindowsFormsEditorService edSvc =
                (IWindowsFormsEditorService) provider.GetService(typeof(IWindowsFormsEditorService));

//			ParamBag.ParamDescriptor	lpdCurrent = null;
//
//			if(context.PropertyDescriptor.GetType().Equals(typeof(ParamBag.ParamDescriptor)))
//				lpdCurrent = (ParamBag.ParamDescriptor)context.PropertyDescriptor;

            if(value == null)
                value = "";
            DateTimePicker dtpEditor = new DateTimePicker();

            //dtpEditor.CustomFormat="hh:mm:ss";
            dtpEditor.Format = DateTimePickerFormat.Time;

            dtpEditor.ShowUpDown = true;

            dtpEditor.Value = (DateTime) value;

            edSvc.DropDownControl(dtpEditor);

            return dtpEditor.Value;
        }

        /// <summary>
        ///   -    
        ///     
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return false;
        }
    }

    #endregion

    #region     

    public class PropertyListEditor : UITypeEditor
    {
        /// <summary>
        ///      
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.DropDown;
        }

        /// <summary>
        /// ,   
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            IWindowsFormsEditorService edSvc =
                (IWindowsFormsEditorService) provider.GetService(typeof(IWindowsFormsEditorService));
            ParamBag.ParamDescriptor lpdCurrent = null;

            if(context.PropertyDescriptor.GetType().Equals(typeof(ParamBag.ParamDescriptor)))
                lpdCurrent = (ParamBag.ParamDescriptor) context.PropertyDescriptor;

            PropertyList objEditor = null;
            Hashtable htDataKey = null;
            if(lpdCurrent.Parent.List != null)
            {
                objEditor = new PropertyList(edSvc, lpdCurrent.Parent);
                objEditor.Items.Clear();
                int iCount = lpdCurrent.Parent.List.Count;
                int iIndex = 0;
                while(iIndex < iCount)
                {
                    object arrCurrent = lpdCurrent.Parent.List[iIndex++];
                    objEditor.Items.Add(Convert.ToString(arrCurrent));
                }
            }
            else if(lpdCurrent.Parent.Table != null)
            {
                objEditor = new PropertyList(edSvc, lpdCurrent.Parent);
                htDataKey = new Hashtable();
                objEditor.Items.Clear();
                int iCount = lpdCurrent.Parent.Table.Rows.Count;
                int iIndex = 0;
                while(iIndex < iCount)
                {
                    DataRow drCurrent = lpdCurrent.Parent.Table.Rows[iIndex++];
                    object objCurrent = drCurrent[lpdCurrent.Parent.DataValue];
                    int iInIndex = objEditor.Items.Add(Convert.ToString(objCurrent));
                    htDataKey[iInIndex] = drCurrent[lpdCurrent.Parent.DataKey];
                }
            }
            objEditor.SelectedItem = value;
            //   ,   
            edSvc.DropDownControl(objEditor);
            ParamEventArgs evSpec = new ParamEventArgs(lpdCurrent.Parent, objEditor.SelectedItem);
            if(htDataKey != null)
                evSpec.DataKey = htDataKey[objEditor.SelectedIndex];
            evSpec.Index = objEditor.SelectedIndex;

            return evSpec;
        }

        /// <summary>
        ///   -    
        ///     
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return false;
        }
    }

    #endregion

    #region     

    public class PropertyFileEditor : UITypeEditor
    {
        /// <summary>
        ///      
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }

        /// <summary>
        /// ,   
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
//			IWindowsFormsEditorService	edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
            ParamBag.ParamDescriptor lpdCurrent = null;

            if(context.PropertyDescriptor.GetType().Equals(typeof(ParamBag.ParamDescriptor)))
                lpdCurrent = (ParamBag.ParamDescriptor) context.PropertyDescriptor;

            if(value == null)
                value = "";
            OpenFileDlg dlgOpenFile = new OpenFileDlg();
            if(value.ToString().Length != 0)
                dlgOpenFile.InitialDirectory = value.ToString();
            else if(lpdCurrent != null)
                dlgOpenFile.InitialDirectory = lpdCurrent.Parent.InitialeFolder;

            if(lpdCurrent != null)
                dlgOpenFile.Filter = lpdCurrent.Parent.FileFilter;
            if(dlgOpenFile.ShowDialog() == DialogResult.OK)
                value = dlgOpenFile.FileName;

            return value;
        }

        /// <summary>
        ///   -    
        ///     
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return false;
        }
    }

    #endregion

    #region      

    public class PropertyCustomFormEditor : UITypeEditor
    {
        /// <summary>
        ///      
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;/*UITypeEditorEditStyle.DropDown;*/
        }

        /// <summary>
        /// ,   
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
//			IWindowsFormsEditorService	edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
            ParamBag.ParamDescriptor lpdCurrent = null;

            if(context.PropertyDescriptor.GetType().Equals(typeof(ParamBag.ParamDescriptor)))
                lpdCurrent = (ParamBag.ParamDescriptor) context.PropertyDescriptor;

            if(value == null)
                value = "";
            lpdCurrent.Parent.CustomForm.StartPosition = FormStartPosition.CenterScreen;

           // if(lpdCurrent.Parent.CustomForm.ShowDialog() == DialogResult.OK)
			if(lpdCurrent.Parent.CustomForm.Execute() == DialogResult.OK)
                value = lpdCurrent.Parent.CustomForm.EditValue;
//			else
//				value = "";

            /*
			OpenFileDialog dlgOpenFile = new OpenFileDialog();
			if(value.ToString().Length != 0)
				dlgOpenFile.InitialDirectory = value.ToString();
			else
				if(lpdCurrent != null)
				dlgOpenFile.InitialDirectory = lpdCurrent.Parent.InitialeFolder;

			if(lpdCurrent != null)
				dlgOpenFile.Filter = lpdCurrent.Parent.FileFilter;
			if(dlgOpenFile.ShowDialog() == DialogResult.OK)
				value = dlgOpenFile.FileName;

			*/

            return value;
        }

        /// <summary>
        ///   -    
        ///     
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return false;
        }
    }

    #endregion

    #region   

    public class PropertyMultiEditTextEditor : UITypeEditor
    {
        /// <summary>
        ///      
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }

        /// <summary>
        /// ,   
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            //			IWindowsFormsEditorService	edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
            ParamBag.ParamDescriptor lpdCurrent = null;

            if(context.PropertyDescriptor.GetType().Equals(typeof(ParamBag.ParamDescriptor)))
                lpdCurrent = (ParamBag.ParamDescriptor) context.PropertyDescriptor;

            if(value == null)
                value = "";
            MultiLineEditor frmMultiLineEditor = new MultiLineEditor();

            frmMultiLineEditor.EditorValue = Convert.ToString(value);
            frmMultiLineEditor.EditorCaption = lpdCurrent.DisplayName;

            if(frmMultiLineEditor.ShowDialog() == DialogResult.OK)
                value = frmMultiLineEditor.EditorValue;

            return value;
        }

        /// <summary>
        ///   -    
        ///     
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return false;
        }
    }

    #endregion

    #region     

    [Serializable]
    public class PropertyFolderEditor : UITypeEditor
    {
        /// <summary>
        ///      
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }

        /// <summary>
        /// ,   
        ///  
        /// </summary>
        /// <param name="context"></param>
        /// <param name="provider"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
//			IWindowsFormsEditorService	edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
//			ParamBag.ParamDescriptor	lpdCurrent = null;

//			if(context.PropertyDescriptor.GetType().Equals(typeof(ParamBag.ParamDescriptor)))
//				lpdCurrent = (ParamBag.ParamDescriptor)context.PropertyDescriptor;

            if(value == null)
                value = "";
            FolderBrowserDialog dlgOpenFolder = new FolderBrowserDialog();
            dlgOpenFolder.SelectedPath = value.ToString();
            if(dlgOpenFolder.ShowDialog() == DialogResult.OK)
                value = dlgOpenFolder.SelectedPath;

            return value;
        }

        /// <summary>
        ///   -    
        ///     
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [PermissionSet(SecurityAction.Demand, Name="FullTrust")]
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return false;
        }
    }

    #endregion

    #region     

    public class PropertyList : Panel
    {
        private ListBox m_lbList;
        private Label m_lblNew;
        private IWindowsFormsEditorService m_evSpec;
        private Param m_parParam;

        public PropertyList(IWindowsFormsEditorService evSpec, Param parParam)
        {
            m_parParam = parParam;
            m_evSpec = evSpec;
            m_lbList = new ListBox();
            m_lbList.BorderStyle = BorderStyle.None;
            m_lbList.SelectedValueChanged += new EventHandler(PropertyList_SelectedValueChanged);
//			m_lbList.Left = 0;
//			m_lbList.Width = this.ClientRectangle.Width + 10;
            m_lbList.Top = 0;
//			m_lbList.Height = this.ClientRectangle.Height;
            m_lbList.Dock = DockStyle.Bottom;
            m_lbList.IntegralHeight = false;
            Controls.Add(m_lbList);
            if(m_parParam.IsNew)
            {
                m_lbList.Top = 20;
                m_lbList.Height = ClientRectangle.Height - 20;

                m_lblNew = new Label();
                m_lblNew.Left = 0;
                m_lblNew.Top = 0;
                m_lblNew.Height = 18;
                m_lblNew.Width = ClientRectangle.Width + 10;
                m_lblNew.Text = ResourceControl.String55;
                m_lblNew.TextAlign = ContentAlignment.MiddleCenter;
                m_lblNew.Click += new EventHandler(m_lblNew_Click);
                Controls.Add(m_lblNew);

                Paint += new PaintEventHandler(PropertyList_Paint);
            }
            Init();
        }

        private void Init()
        {
            BackColor = SystemColors.Window;
        }

        private void PropertyList_SelectedValueChanged(object sender, EventArgs e)
        {
            m_evSpec.CloseDropDown();
        }

        public ListBox.ObjectCollection Items
        {
            get { return m_lbList.Items; }
        }

        public object SelectedItem
        {
            get { return m_lbList.SelectedItem; }
            set { m_lbList.SelectedItem = value; }
        }

        public int SelectedIndex
        {
            get { return m_lbList.SelectedIndex; }
        }

        private void m_lblNew_Click(object sender, EventArgs e)
        {
            m_evSpec.CloseDropDown();
            m_parParam.NewItem();
        }

        private void PropertyList_Paint(object sender, PaintEventArgs e)
        {
            if(m_parParam.IsNew)
            {
                Pen penLine = new Pen(Color.Black);
                e.Graphics.DrawLine(penLine, 0, 19, ClientRectangle.Width + 10, 19);
            }
        }
    }

    #endregion

    #region   CustomForms

    public interface ICustomValue
    {
        string Caption { get; set; }
    }

    public class ICustomForm : Form

    {
        private ParamsDialogCollection m_objParamsDialogCollection;

        public ICustomForm() : base()
        {
        }

        public virtual ICustomValue EditValue
        {
            get { return null; }
            set { }
        }
		public virtual DialogResult Execute()
		{
			return ShowDialog();
		}
        public ParamsDialogCollection ParamsDialogs
        {
            get { return m_objParamsDialogCollection; }
            set { m_objParamsDialogCollection = value; }
        }
    }

    #endregion
}
/********************* SniipSoftel *****************
 *
 *    $History: PropertyBag.cs $
 *   
 *   *****************  Version 58  *****************
 *   User: Gavrilov     Date: 21.05.07   Time: 17:52
 *   Updated in $/Net/Common/ClientControl/PropertyGrid
 *   
 *   *****************  Version 57  *****************
 *   User: Serg_ch      Date: 11.04.07   Time: 16:57
 *   Updated in $/Net/Common/ClientControl/PropertyGrid
 *   
 *   *****************  Version 56  *****************
 *   User: Serg_ch      Date: 26.03.07   Time: 20:42
 *   Updated in $/Net/Common/ClientControl/PropertyGrid
 *   
 *   *****************  Version 55  *****************
 *   User: Serg_ch      Date: 23.03.07   Time: 11:12
 *   Updated in $/Net/Common/ClientControl/PropertyGrid
 *   
 *   *****************  Version 53  *****************
 *   User: Gavrilov     Date: 31.01.07   Time: 12:53
 *   Updated in $/Net/Common/SoftelControl/PropertyGrid
 *   
 *   *****************  Version 52  *****************
 *   User: Autobuild    Date: 26.01.07   Time: 23:15
 *   Updated in $/Net/Common/SoftelControl/PROPERTYGRID
 *
 ********************* SniipSoftel *****************/
