/********************* SniipSoftel *****************
 *
 *   $Author: Gavrilov $
 *   $Revision: 36 $
 *   $Date: 9.04.07 11:37 $
 *
 ********************* SniipSoftel *****************/
///////////////////////////////////////////////////////////////////////////////
// filename		= SoftelWizard.cs
// domainname	= SOFTEL-GAV
// username		= gavrilov
// fullusername = gavrilov
// projectname	= SoftelWizard
// curdate		= 10.04.2006
///////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Reflection;
using System.Threading;
using System.Windows.Forms;
using FirebirdSql.Data.Firebird;
using Softel.Common;
using Softel.MiddleTier.Client;
using Convert = System.Convert;

namespace Softel.Windows.Forms
{
	/// <summary>
	/// ,         
	/// </summary>
	public class SoftelWizard : Content
	{
		public event SoftelWizardEventHandler OnPressNext;
		public event SoftelWizardDataEventHandler OnAddParamsDialog;


		private Panel m_pnlHeader;
		private Panel m_pnlBottom;
		private Panel m_pnlBody;
		private System.Windows.Forms.Button m_btnCancel;
		private System.Windows.Forms.Button m_btnNext;
		private System.Windows.Forms.Button m_btnPrevious;
		private ParamsDialogCollection m_colParamsDialog;
		private int m_iCount;
		private int m_iNextAction = -1;
		private string m_strErrorMessage;
		private string m_strSuccessMessage;
		private string m_strInsertProcedure;
		private string m_strCaption;
		private int m_iMaxCount;
		private string m_strMessage;
		private string m_strWizardType;
		private System.Windows.Forms.TextBox m_txtHeader;
		private Hashtable m_htHeaders;
		private Hashtable m_htReferenceField;
		private Hashtable m_htStoredProcedure;
		private Hashtable m_htInitialParamsCount;
		private ParamsDialog m_pdParams;
		private ParamsDialog m_pdChangedParams;
		private Hashtable m_htPageId;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private Container components = null;

		/// <summary>
		///   
		/// </summary>
		public SoftelWizard()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="strWizardType"> Wizard</param>
		public SoftelWizard(string strWizardType)
		{
			m_strWizardType = strWizardType;
			InitializeComponent();
		}

		/// <summary>
///    ParamsDialogCollection
/// </summary>
		public ParamsDialogCollection WizardRezult

		{
			get { return m_colParamsDialog; }
		}

		/// <summary>
///  -1     ;    
/// </summary>
		public int NextAction
		{
			get { return m_iNextAction; }
			set { m_iNextAction = value; }
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SoftelWizard));
			this.m_pnlHeader = new System.Windows.Forms.Panel();
			this.m_txtHeader = new System.Windows.Forms.TextBox();
			this.m_pnlBottom = new System.Windows.Forms.Panel();
			this.m_btnPrevious = new System.Windows.Forms.Button();
			this.m_btnNext = new System.Windows.Forms.Button();
			this.m_btnCancel = new System.Windows.Forms.Button();
			this.m_pnlBody = new System.Windows.Forms.Panel();
			this.m_pnlHeader.SuspendLayout();
			this.m_pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// m_pnlHeader
			// 
			this.m_pnlHeader.AccessibleDescription = resources.GetString("m_pnlHeader.AccessibleDescription");
			this.m_pnlHeader.AccessibleName = resources.GetString("m_pnlHeader.AccessibleName");
			this.m_pnlHeader.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlHeader.Anchor")));
			this.m_pnlHeader.AutoScroll = ((bool)(resources.GetObject("m_pnlHeader.AutoScroll")));
			this.m_pnlHeader.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlHeader.AutoScrollMargin")));
			this.m_pnlHeader.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlHeader.AutoScrollMinSize")));
			this.m_pnlHeader.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlHeader.BackgroundImage")));
			this.m_pnlHeader.Controls.Add(this.m_txtHeader);
			this.m_pnlHeader.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlHeader.Dock")));
			this.m_pnlHeader.Enabled = ((bool)(resources.GetObject("m_pnlHeader.Enabled")));
			this.m_pnlHeader.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlHeader.Font")));
			this.m_pnlHeader.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlHeader.ImeMode")));
			this.m_pnlHeader.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlHeader.Location")));
			this.m_pnlHeader.Name = "m_pnlHeader";
			this.m_pnlHeader.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlHeader.RightToLeft")));
			this.m_pnlHeader.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlHeader.Size")));
			this.m_pnlHeader.TabIndex = ((int)(resources.GetObject("m_pnlHeader.TabIndex")));
			this.m_pnlHeader.Text = resources.GetString("m_pnlHeader.Text");
			this.m_pnlHeader.Visible = ((bool)(resources.GetObject("m_pnlHeader.Visible")));
			// 
			// m_txtHeader
			// 
			this.m_txtHeader.AccessibleDescription = resources.GetString("m_txtHeader.AccessibleDescription");
			this.m_txtHeader.AccessibleName = resources.GetString("m_txtHeader.AccessibleName");
			this.m_txtHeader.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_txtHeader.Anchor")));
			this.m_txtHeader.AutoSize = ((bool)(resources.GetObject("m_txtHeader.AutoSize")));
			this.m_txtHeader.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_txtHeader.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_txtHeader.BackgroundImage")));
			this.m_txtHeader.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_txtHeader.Dock")));
			this.m_txtHeader.Enabled = ((bool)(resources.GetObject("m_txtHeader.Enabled")));
			this.m_txtHeader.Font = ((System.Drawing.Font)(resources.GetObject("m_txtHeader.Font")));
			this.m_txtHeader.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_txtHeader.ImeMode")));
			this.m_txtHeader.Location = ((System.Drawing.Point)(resources.GetObject("m_txtHeader.Location")));
			this.m_txtHeader.MaxLength = ((int)(resources.GetObject("m_txtHeader.MaxLength")));
			this.m_txtHeader.Multiline = ((bool)(resources.GetObject("m_txtHeader.Multiline")));
			this.m_txtHeader.Name = "m_txtHeader";
			this.m_txtHeader.PasswordChar = ((char)(resources.GetObject("m_txtHeader.PasswordChar")));
			this.m_txtHeader.ReadOnly = true;
			this.m_txtHeader.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_txtHeader.RightToLeft")));
			this.m_txtHeader.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("m_txtHeader.ScrollBars")));
			this.m_txtHeader.Size = ((System.Drawing.Size)(resources.GetObject("m_txtHeader.Size")));
			this.m_txtHeader.TabIndex = ((int)(resources.GetObject("m_txtHeader.TabIndex")));
			this.m_txtHeader.Text = resources.GetString("m_txtHeader.Text");
			this.m_txtHeader.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("m_txtHeader.TextAlign")));
			this.m_txtHeader.Visible = ((bool)(resources.GetObject("m_txtHeader.Visible")));
			this.m_txtHeader.WordWrap = ((bool)(resources.GetObject("m_txtHeader.WordWrap")));
			// 
			// m_pnlBottom
			// 
			this.m_pnlBottom.AccessibleDescription = resources.GetString("m_pnlBottom.AccessibleDescription");
			this.m_pnlBottom.AccessibleName = resources.GetString("m_pnlBottom.AccessibleName");
			this.m_pnlBottom.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlBottom.Anchor")));
			this.m_pnlBottom.AutoScroll = ((bool)(resources.GetObject("m_pnlBottom.AutoScroll")));
			this.m_pnlBottom.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlBottom.AutoScrollMargin")));
			this.m_pnlBottom.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlBottom.AutoScrollMinSize")));
			this.m_pnlBottom.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlBottom.BackgroundImage")));
			this.m_pnlBottom.Controls.Add(this.m_btnPrevious);
			this.m_pnlBottom.Controls.Add(this.m_btnNext);
			this.m_pnlBottom.Controls.Add(this.m_btnCancel);
			this.m_pnlBottom.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlBottom.Dock")));
			this.m_pnlBottom.Enabled = ((bool)(resources.GetObject("m_pnlBottom.Enabled")));
			this.m_pnlBottom.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlBottom.Font")));
			this.m_pnlBottom.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlBottom.ImeMode")));
			this.m_pnlBottom.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlBottom.Location")));
			this.m_pnlBottom.Name = "m_pnlBottom";
			this.m_pnlBottom.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlBottom.RightToLeft")));
			this.m_pnlBottom.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlBottom.Size")));
			this.m_pnlBottom.TabIndex = ((int)(resources.GetObject("m_pnlBottom.TabIndex")));
			this.m_pnlBottom.Text = resources.GetString("m_pnlBottom.Text");
			this.m_pnlBottom.Visible = ((bool)(resources.GetObject("m_pnlBottom.Visible")));
			// 
			// m_btnPrevious
			// 
			this.m_btnPrevious.AccessibleDescription = resources.GetString("m_btnPrevious.AccessibleDescription");
			this.m_btnPrevious.AccessibleName = resources.GetString("m_btnPrevious.AccessibleName");
			this.m_btnPrevious.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_btnPrevious.Anchor")));
			this.m_btnPrevious.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_btnPrevious.BackgroundImage")));
			this.m_btnPrevious.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_btnPrevious.Dock")));
			this.m_btnPrevious.Enabled = ((bool)(resources.GetObject("m_btnPrevious.Enabled")));
			this.m_btnPrevious.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("m_btnPrevious.FlatStyle")));
			this.m_btnPrevious.Font = ((System.Drawing.Font)(resources.GetObject("m_btnPrevious.Font")));
			this.m_btnPrevious.Image = ((System.Drawing.Image)(resources.GetObject("m_btnPrevious.Image")));
			this.m_btnPrevious.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_btnPrevious.ImageAlign")));
			this.m_btnPrevious.ImageIndex = ((int)(resources.GetObject("m_btnPrevious.ImageIndex")));
			this.m_btnPrevious.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_btnPrevious.ImeMode")));
			this.m_btnPrevious.Location = ((System.Drawing.Point)(resources.GetObject("m_btnPrevious.Location")));
			this.m_btnPrevious.Name = "m_btnPrevious";
			this.m_btnPrevious.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_btnPrevious.RightToLeft")));
			this.m_btnPrevious.Size = ((System.Drawing.Size)(resources.GetObject("m_btnPrevious.Size")));
			this.m_btnPrevious.TabIndex = ((int)(resources.GetObject("m_btnPrevious.TabIndex")));
			this.m_btnPrevious.Text = resources.GetString("m_btnPrevious.Text");
			this.m_btnPrevious.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_btnPrevious.TextAlign")));
			this.m_btnPrevious.Visible = ((bool)(resources.GetObject("m_btnPrevious.Visible")));
			this.m_btnPrevious.Click += new System.EventHandler(this.m_btnPrevious_Click);
			// 
			// m_btnNext
			// 
			this.m_btnNext.AccessibleDescription = resources.GetString("m_btnNext.AccessibleDescription");
			this.m_btnNext.AccessibleName = resources.GetString("m_btnNext.AccessibleName");
			this.m_btnNext.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_btnNext.Anchor")));
			this.m_btnNext.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_btnNext.BackgroundImage")));
			this.m_btnNext.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_btnNext.Dock")));
			this.m_btnNext.Enabled = ((bool)(resources.GetObject("m_btnNext.Enabled")));
			this.m_btnNext.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("m_btnNext.FlatStyle")));
			this.m_btnNext.Font = ((System.Drawing.Font)(resources.GetObject("m_btnNext.Font")));
			this.m_btnNext.Image = ((System.Drawing.Image)(resources.GetObject("m_btnNext.Image")));
			this.m_btnNext.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_btnNext.ImageAlign")));
			this.m_btnNext.ImageIndex = ((int)(resources.GetObject("m_btnNext.ImageIndex")));
			this.m_btnNext.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_btnNext.ImeMode")));
			this.m_btnNext.Location = ((System.Drawing.Point)(resources.GetObject("m_btnNext.Location")));
			this.m_btnNext.Name = "m_btnNext";
			this.m_btnNext.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_btnNext.RightToLeft")));
			this.m_btnNext.Size = ((System.Drawing.Size)(resources.GetObject("m_btnNext.Size")));
			this.m_btnNext.TabIndex = ((int)(resources.GetObject("m_btnNext.TabIndex")));
			this.m_btnNext.Text = resources.GetString("m_btnNext.Text");
			this.m_btnNext.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_btnNext.TextAlign")));
			this.m_btnNext.Visible = ((bool)(resources.GetObject("m_btnNext.Visible")));
			this.m_btnNext.Click += new System.EventHandler(this.m_btnNext_Click);
			// 
			// m_btnCancel
			// 
			this.m_btnCancel.AccessibleDescription = resources.GetString("m_btnCancel.AccessibleDescription");
			this.m_btnCancel.AccessibleName = resources.GetString("m_btnCancel.AccessibleName");
			this.m_btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_btnCancel.Anchor")));
			this.m_btnCancel.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_btnCancel.BackgroundImage")));
			this.m_btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.m_btnCancel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_btnCancel.Dock")));
			this.m_btnCancel.Enabled = ((bool)(resources.GetObject("m_btnCancel.Enabled")));
			this.m_btnCancel.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("m_btnCancel.FlatStyle")));
			this.m_btnCancel.Font = ((System.Drawing.Font)(resources.GetObject("m_btnCancel.Font")));
			this.m_btnCancel.Image = ((System.Drawing.Image)(resources.GetObject("m_btnCancel.Image")));
			this.m_btnCancel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_btnCancel.ImageAlign")));
			this.m_btnCancel.ImageIndex = ((int)(resources.GetObject("m_btnCancel.ImageIndex")));
			this.m_btnCancel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_btnCancel.ImeMode")));
			this.m_btnCancel.Location = ((System.Drawing.Point)(resources.GetObject("m_btnCancel.Location")));
			this.m_btnCancel.Name = "m_btnCancel";
			this.m_btnCancel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_btnCancel.RightToLeft")));
			this.m_btnCancel.Size = ((System.Drawing.Size)(resources.GetObject("m_btnCancel.Size")));
			this.m_btnCancel.TabIndex = ((int)(resources.GetObject("m_btnCancel.TabIndex")));
			this.m_btnCancel.Text = resources.GetString("m_btnCancel.Text");
			this.m_btnCancel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_btnCancel.TextAlign")));
			this.m_btnCancel.Visible = ((bool)(resources.GetObject("m_btnCancel.Visible")));
			this.m_btnCancel.Click += new System.EventHandler(this.m_btnCancel_Click);
			// 
			// m_pnlBody
			// 
			this.m_pnlBody.AccessibleDescription = resources.GetString("m_pnlBody.AccessibleDescription");
			this.m_pnlBody.AccessibleName = resources.GetString("m_pnlBody.AccessibleName");
			this.m_pnlBody.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlBody.Anchor")));
			this.m_pnlBody.AutoScroll = ((bool)(resources.GetObject("m_pnlBody.AutoScroll")));
			this.m_pnlBody.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlBody.AutoScrollMargin")));
			this.m_pnlBody.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlBody.AutoScrollMinSize")));
			this.m_pnlBody.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlBody.BackgroundImage")));
			this.m_pnlBody.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlBody.Dock")));
			this.m_pnlBody.Enabled = ((bool)(resources.GetObject("m_pnlBody.Enabled")));
			this.m_pnlBody.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlBody.Font")));
			this.m_pnlBody.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlBody.ImeMode")));
			this.m_pnlBody.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlBody.Location")));
			this.m_pnlBody.Name = "m_pnlBody";
			this.m_pnlBody.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlBody.RightToLeft")));
			this.m_pnlBody.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlBody.Size")));
			this.m_pnlBody.TabIndex = ((int)(resources.GetObject("m_pnlBody.TabIndex")));
			this.m_pnlBody.Text = resources.GetString("m_pnlBody.Text");
			this.m_pnlBody.Visible = ((bool)(resources.GetObject("m_pnlBody.Visible")));
			// 
			// SoftelWizard
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.m_pnlBody);
			this.Controls.Add(this.m_pnlBottom);
			this.Controls.Add(this.m_pnlHeader);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "SoftelWizard";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.TabText = resources.GetString("$this.TabText");
			this.Text = resources.GetString("$this.Text");
			this.ToolTipText = resources.GetString("$this.ToolTipText");
			this.Load += new System.EventHandler(this.SoftelWizard_Load);
			this.m_pnlHeader.ResumeLayout(false);
			this.m_pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
///  
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
		private void SoftelWizard_Load(object sender, EventArgs e)
		{
			m_iCount = 0;
			m_colParamsDialog = new ParamsDialogCollection();
			m_htHeaders = new Hashtable();
			m_htPageId = new Hashtable();
			m_htReferenceField = new Hashtable();
			m_htStoredProcedure = new Hashtable();
			m_htInitialParamsCount = new Hashtable();

			GetWizardType(m_strWizardType);
			
			SetParamsDialog();
			m_btnPrevious.Enabled = false;
		}

		/// <summary>
///  
/// </summary>
		private void InsertData()
		{
			try
			{
				Command cProc = new Command();
				cProc.CommandName = m_strInsertProcedure;
				for (int i = 0; i < m_iMaxCount; i++)
				{
					foreach (string strKey in m_colParamsDialog[i].InsertValue.Keys)
					{
						if (m_colParamsDialog[i].Params[strKey.Substring(1)].Type == ParamsType.CustomForm)
						{
							string strValue = ((ICustomValue) m_colParamsDialog[i].Value[strKey.Substring(1)]).Caption.ToString();
							cProc.InputParams[strKey] = strValue;
						}
						else
						{
							if (m_colParamsDialog[i].InsertValue[strKey] != null && m_colParamsDialog[i].InsertValue[strKey] != DBNull.Value)
								cProc.InputParams[strKey] = m_colParamsDialog[i].InsertValue[strKey];
							else
								cProc.InputParams[strKey] = DBNull.Value;
						}

					}
				}
				cProc.InputParams["timeout"]=60000;
				string strOutput = new string(' ', 255);
				cProc.OutputParams["@outputparam"] = strOutput;  

				Object objReturnCode = cProc.Execute(true);
				int iRet = 0;									
				if (objReturnCode != null)
				{
					iRet = Convert.ToInt32(objReturnCode);

					if (iRet == 0)
					{
						NextAction = Convert.ToInt32(cProc.OutputParams["@outputparam"]); 
						m_strMessage = m_strSuccessMessage + cProc.OutputParams["@outputparam"].ToString(); 
					}
					else
						m_strMessage = m_strErrorMessage + ": " + cProc.OutputParams["@outputparam"].ToString();  
				}
				else
					m_strMessage = ResourceControl.String56;
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message.ToString() + " Error occured while trying to execute " + m_strInsertProcedure
					+ "; See file SoftelWizard.cs"); /* Added for debug purpose by VPanf */
			}
		}

		/// <summary>
///     next
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
		private void m_btnNext_Click(object sender, EventArgs e)
		{
			m_pdParams.RestoreDefault = false;
			if (m_iCount < m_iMaxCount)
			{
				m_colParamsDialog[m_iCount] = m_pdParams;
				for (int i = 0; i < m_iMaxCount; i++)
				{
					m_colParamsDialog[i].ParamsDialogs = m_colParamsDialog;
				}

			}
			//if(m_htReferenceField[m_iCount.ToString()]!=null)
			//	m_iCount++;
			m_iCount++;
			if (m_iCount == m_iMaxCount + 1)
			{
				if (OnPressNext != null)
				{
					SoftelWizardArg objSoftelWizardArg = new SoftelWizardArg();
					objSoftelWizardArg.ParDialogCollection = m_colParamsDialog;
					objSoftelWizardArg.MaxCount = m_iMaxCount;
					SoftelWizardArg objResSoftelWizardArg = OnPressNext(this, objSoftelWizardArg);
					m_strMessage = objResSoftelWizardArg.Message;
					NextAction = objResSoftelWizardArg.Result;
				}
				else
					InsertData();

			}
			if (m_iCount == m_iMaxCount + 2)
			{
				return;
			}

			if (m_iCount == m_iMaxCount + 1)
			{
				m_btnNext.DialogResult = DialogResult.OK;
				m_btnPrevious.Enabled = false;
				m_btnCancel.Enabled = false;
				m_btnNext.Text = ResourceControl.String57;
				m_btnNext.Refresh();


			}
			else
			{
				m_btnNext.DialogResult = DialogResult.None;


			}
			if (m_iCount >= 1 && m_iCount != m_iMaxCount + 1)
			{
				m_btnPrevious.Enabled = true;
				m_btnPrevious.Refresh();

			}
			SetParamsDialog();
			m_btnPrevious.Enabled = false;

		}

		/// <summary>
///     previous
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
		private void m_btnPrevious_Click(object sender, EventArgs e)
		{
			m_pdParams.RestoreDefault = false;
			if (m_iCount < m_iMaxCount)
				m_colParamsDialog[m_iCount] = m_pdParams;

			//if(m_htReferenceField[m_iCount.ToString()]!=null)
			//	m_iCount--;
			m_iCount--;


			m_btnNext.Text = ResourceControl.String58;
			m_btnNext.DialogResult = DialogResult.None;
			if (m_iCount == 0)
				m_btnPrevious.Enabled = false;

			SetParamsDialog();
		}

		/// <summary>
///     Cancel
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
		private void m_btnCancel_Click(object sender, EventArgs e)
		{
		}

		/// <summary>
///    Wizard
/// </summary>
/// <param name="strWizardType"></param>
		private void GetWizardType(string strWizardType)
		{
			Command cmdParams = new Command();
			cmdParams.CommandName = "UIGetWizardType";
			cmdParams.InputParams["@wizard_type"] = strWizardType;
			cmdParams.Execute(true);
			DataTable dtTable = cmdParams.DataSet.Tables[0];
			m_strCaption = dtTable.Rows[0]["Caption"].ToString();
			this.Text = m_strCaption;
			m_strInsertProcedure = dtTable.Rows[0]["InsertProcedure"].ToString();
			m_strErrorMessage = dtTable.Rows[0]["ErrorMessage"].ToString();
			m_strSuccessMessage = dtTable.Rows[0]["SuccessMessage"].ToString();
			int iWizardType = Convert.ToInt32(dtTable.Rows[0]["wizard_id"]);
			GetWizardSteps(iWizardType);

		}

		/// <summary>
///   
/// </summary>
/// <param name="iWizardId">id Wizarda</param>
		private void GetWizardSteps(int iWizardId)
		{
			Command cmdParams = new Command();
			cmdParams.CommandName = "UIGetWizardPage";
			cmdParams.InputParams["@wizard_id"] = iWizardId;
			cmdParams.Execute(true);
			DataTable dtParams = cmdParams.DataSet.Tables[0];

			int iCount = 0;
			m_iMaxCount = 0;

			foreach (DataRow dr in dtParams.Rows)
			{
				int iType = Convert.ToInt32(dr["type"]);
				int iPageId = Convert.ToInt32(dr["page_id"]);
				m_htHeaders.Add(iCount.ToString(), dr["caption"].ToString());
				m_htPageId.Add(iCount.ToString(), iPageId.ToString());

				if (iType == 1)
				{
					GetParams(iPageId);
					m_iMaxCount++;
				}
				if (dr["relation_field"] != DBNull.Value && dr["relation_field"].ToString() != "")
				{
					m_htReferenceField.Add(iCount.ToString(), dr["relation_field"].ToString());

				}
				if (dr["StoredProcedure"] != DBNull.Value && dr["StoredProcedure"].ToString() != "")
				{
					m_htStoredProcedure.Add(iCount.ToString(), dr["StoredProcedure"].ToString());

				}

				if (iType == 3)
				{
					GetParams(iPageId);
				}
				iCount++;
			}


		}

// <summary>
		///    ParamsDialog
/// </summary>
		public bool ChangeParamsDialog(string strField, int iValue,int iPageId)
		{
			return ChangeParamsDialog(strField, iValue, null, false,iPageId);
		}

		/// <summary>
///    ParamsDialog
/// </summary>
		public bool ChangeParamsDialog(string strField, int iValue, string strStoredProcedure, bool bDataPrevious,int iPageid)
		{
			Command cmdParams = new Command();
			bool bMandatory = false;
			if (strStoredProcedure == null)
			{
				cmdParams.CommandName = "UIGetWizardChangedParams";
				cmdParams.InputParams["@field"] = strField;
				cmdParams.InputParams["@value"] = iValue;
				cmdParams.InputParams["@page_id"] = iPageid;

			}
			else
			{
				cmdParams.CommandName = strStoredProcedure;
				cmdParams.InputParams["@" + strField] = iValue;

			}


			cmdParams.Execute(true);

			/*
			for( int i=0;i <pdParams.Params.Count;++i)
			{
				if(pdParams.Params[i].Type==ParamsType.CustomForm)
				{
					if(pdParams.Params[i].CustomForm!=null)
						pdParams.Params[i].CustomForm.Close();
					pdParams.Params[i].CustomForm	=new SearchNumber();
				}
				

			}
			*/

			int iCount = Convert.ToInt32(m_htInitialParamsCount[m_iCount.ToString()]);

			while (m_pdParams.Params.Count > iCount)
			{
				for (int i = iCount; i < m_pdParams.Params.Count; ++i)
				{
					//String strName=m_pdParams.Params[i].Name;
					//m_pdParams.Params.Remove(strName);
					m_pdParams.Params.RemoveAt(i);
				}
			}
			foreach (DataRow dr in cmdParams.DataSet.Tables[0].Rows)
			{
				if (m_pdParams.Params[dr["field"].ToString()] != null)
					m_pdParams.Params.Remove(dr["field"].ToString());
				string strCustomType=null;;
				if(strStoredProcedure==null)
				{
					 strCustomType = dr["data_type"].ToString();
				}
					Softel.Windows.Forms.ParamsType objParamsType;
					if(strCustomType == "CustomForm")
						objParamsType=ParamsType.CustomForm;
					else
						objParamsType=ParamsType.String;
				Param objParam = new Param(dr["field"].ToString(), dr["caption"].ToString(), objParamsType, dr["category"].ToString());
				
				objParam.InsertField = dr["ins_proc_param"].ToString();
				if(dr.Table.Columns.Contains("must_be_filled"))
				{
					string strMustBeFilled = dr["must_be_filled"].ToString();
					if(strMustBeFilled =="True")
					{
						objParam.IsMandatory = true;
						bMandatory = true;
					}
				}
				try
				{
					if (strCustomType == "CustomForm" && dr["CustomForm"] != DBNull.Value)
					{
						int iInCount,iInIndex;
						string strAssemblyName = dr["CustomForm"].ToString();
						int iInd1 = strAssemblyName.LastIndexOf(".");
						string strMethod = strAssemblyName.Substring(iInd1 + 1);
						FbConnection fbConnection = (FbConnection) Thread.GetData(Thread.GetNamedDataSlot("FbConnection"));
						Assembly asCustomForm = m_pdParams.LoadAssembly(fbConnection, strAssemblyName, "iv");
						Type[] typeCustom = asCustomForm.GetTypes();
						iInCount = typeCustom.Length;
						iInIndex = 0;
						while(iInIndex < iInCount)
						{
							Type t = typeCustom[iInIndex++];
							string strCurMethod = t.ToString();
							int iInd2 = strCurMethod.LastIndexOf(".");
							string strTempMethod = strCurMethod.Substring(iInd2 + 1);
							if (strTempMethod == strMethod)
							{
								objParam.CustomForm = (ICustomForm) t.InvokeMember(strMethod, BindingFlags.CreateInstance, null, null, null);

								break;
							}
						}
					}
				}
				catch
				{
				}

				m_pdParams.Params.Add(objParam);
				if(strCustomType == "CustomForm")
					m_pdParams.ParamsDialogs=m_colParamsDialog;
				
				


			}

			if (!bDataPrevious)
			{
				m_pdParams.PropertyGrid.Parent = m_pdParams;
				m_pdParams.RestoreDefault = true;
				m_pdParams.PropertyGrid.Parent = m_pnlBody;
				m_pdParams.RestoreDefault = false;
			}

			return bMandatory;
		}

		/// <summary>
///   ParamsDialog
/// </summary>
/// <param name="iWizardStep"></param>
		private void GetParams(int iWizardStep)
		{
			Command cmdParams = new Command();
			cmdParams.CommandName = "UIGetWizardStepParams";

			cmdParams.InputParams["@page_id"] = iWizardStep;

			cmdParams.Execute(true);
			DataTable dtData = new DataTable("Table");
			DataTable dtTuning;
			if (OnAddParamsDialog != null)
			{
				dtTuning = OnAddParamsDialog(this, cmdParams.DataSet.Tables[0]);
			}
			else
				dtTuning = cmdParams.DataSet.Tables[0];
			int iCount = 0;
			foreach (DataRow dr in cmdParams.DataSet.Tables[0].Rows)
			{
				dtData.Columns.Add(dr["field"].ToString());
				iCount++;

			}
			ParamsDialog pdParams = new ParamsDialog(dtData, cmdParams.DataSet.Tables[0]);
			pdParams.PropertyGrid.PropertyValueChanged += new PropertyValueChangedEventHandler(PropertyGrid_PropertyValueChanged);
			//pdDepartment.OnSetValue
			pdParams.OnSetValue += new ParamsDialogEventHandler(pdParams_OnSetValue);
			/*
			for( int i=0;i <pdParams.Params.Count;++i)
			{
				if(pdParams.Params[i].Type==ParamsType.CustomForm)
				{
					if(pdParams.Params[i].CustomForm!=null)
						pdParams.Params[i].CustomForm.Close();
					pdParams.Params[i].CustomForm	=new SearchNumber();
				}
				

			}
			*/
			m_colParamsDialog.Add(pdParams);
			m_htInitialParamsCount[m_iMaxCount.ToString()] = iCount;
		}

		/// <summary>
///    
/// </summary>
/// <param name="s"></param>
/// <param name="e"></param>
		private void PropertyGrid_PropertyValueChanged(object s, PropertyValueChangedEventArgs e)
		{
			if (m_btnNext.Enabled == false && CheckMandatory())
				m_btnNext.Enabled = true;


		}

		/// <summary>
///       
/// </summary>
/// <returns> -true- ;false- </returns>
		private bool CheckMandatory()
		{
			bool bNext = true;
			for (int i = 0; i < m_pdParams.Params.Count; i++)
			{
				if (m_pdParams.Params[i].IsMandatory && 
					(m_pdParams.Value[m_pdParams.Params[i].Name] == DBNull.Value || m_pdParams.Value[m_pdParams.Params[i].Name] == null))
				{
					bNext = false;
					break;

				}

			}
			return bNext;
		}

		/// <summary>
///  ParamsDialog
/// </summary>
		private void SetParamsDialog()
		{
			Boolean bMandatory = false;
			if (m_iCount < m_iMaxCount)
			{
				m_pdParams = m_colParamsDialog[m_iCount];
				if (m_htReferenceField[m_iCount.ToString()] != null)

				{
					string strReferencedField = m_htReferenceField[m_iCount.ToString()].ToString();

					for (int i = 0; i < m_iCount; i++)
						for (int j = 0; j < m_colParamsDialog[i].Params.Count; j++)
						{
							String strKey = m_colParamsDialog[i].Params[j].Name;
							if (strReferencedField == strKey && m_colParamsDialog[i].Value[strKey] != DBNull.Value)
							{
								int iValue = Convert.ToInt32(m_colParamsDialog[i].Value[strKey]);
								String strStoredProcedure;
								if(m_htStoredProcedure[m_iCount.ToString()]!= null)
									strStoredProcedure= m_htStoredProcedure[m_iCount.ToString()].ToString();
								else
									strStoredProcedure=null;
								int iPageid=System.Convert.ToInt32(m_htPageId[m_iCount.ToString()]);
								bMandatory=ChangeParamsDialog(strReferencedField, iValue, strStoredProcedure, true,iPageid);
								break;
							}

						}
				}
				m_pdParams.PropertyGrid.ToolbarVisible = false;


				m_pdParams.PropertyGrid.Dock = DockStyle.Top;

				m_pdParams.PropertyGrid.Parent = m_pnlBody;
				if (m_pnlBody.Controls.Count > 1)
					m_pnlBody.Controls.RemoveAt(0);
				if (m_pnlBody.Controls.Count > 1)
					m_pnlBody.Controls.RemoveAt(0);

				m_btnNext.Enabled = CheckMandatory();
				if(bMandatory)
					m_btnNext.Enabled = false;

				m_pdParams.PropertyGrid.Show();

			}
			else if (m_iCount == m_iMaxCount)
			{
				System.Windows.Forms.TextBox txtCommon = new TextBox();
				txtCommon.Multiline = true;
				txtCommon.ScrollBars = ScrollBars.Both;
				txtCommon.ReadOnly = true;
				String strText = "";
				for (int i = 0; i < m_iMaxCount; i++)
				{
					for (int j = 0; j < m_colParamsDialog[i].Params.Count; j++)

					{
						String strKey = m_colParamsDialog[i].Params[j].Name;
						String strCaption = m_colParamsDialog[i].Params[strKey].Caption.ToString();
						String strValue = "";
						if (m_colParamsDialog[i].Value[strKey] != DBNull.Value && m_colParamsDialog[i].Value[strKey] != null)
							if (m_colParamsDialog[i].Params[j].List != null || m_colParamsDialog[i].Params[j].DataValue != ""
								&& m_colParamsDialog[i].Params[j].DataValue != m_colParamsDialog[i].Params[j].DataKey)
							{
								int iIndex = Convert.ToInt32(m_colParamsDialog[i].Value[strKey].ToString());
								if (m_colParamsDialog[i].Params[j].List != null)
									strValue = m_colParamsDialog[i].Params[j].List[iIndex].ToString();
								else
								{
									foreach (DataRow dr in m_colParamsDialog[i].Params[j].Table.Rows)
										if (dr[m_colParamsDialog[i].Params[j].DataKey].ToString() == iIndex.ToString())
										{
											strValue = dr[m_colParamsDialog[i].Params[j].DataValue].ToString();
											break;
										}
								}
							}
							else if (m_colParamsDialog[i].Params[j].TypeName == "System.DateTime")
								strValue = Convert.ToDateTime(m_colParamsDialog[i].Value[strKey]).ToString("dd.MM.yyyy");
							else if (m_colParamsDialog[i].Params[j].Type == ParamsType.CustomForm)

								strValue = ((ICustomValue) m_colParamsDialog[i].Value[strKey]).Caption.ToString();
							else
								strValue = m_colParamsDialog[i].Value[strKey].ToString();
						else
							strValue = "";
						strText = strText + "\r\n" + strCaption + ":" + strValue;
					}
					strText = strText + "\r\n";
				}
				txtCommon.Text = strText;
				txtCommon.Parent = m_pnlBody;
				txtCommon.ReadOnly = true;

				if (m_pnlBody.Controls.Count > 1)
					m_pnlBody.Controls.RemoveAt(0);
				txtCommon.Dock = DockStyle.Fill;
				txtCommon.Show();


			}
			else
			{
				System.Windows.Forms.TextBox txtCommon = new TextBox();
				txtCommon.Text = m_strMessage + " \r\n" + " \r\n" + " \r\n";
				txtCommon.Multiline = true;


				txtCommon.Parent = m_pnlBody;
				if (m_pnlBody.Controls.Count > 1)
					m_pnlBody.Controls.RemoveAt(0);

				if (NextAction > 0)
				{
					txtCommon.Dock = DockStyle.Top;
					m_pdParams = m_colParamsDialog[m_colParamsDialog.Count - 1];
					m_pdParams.PropertyGrid.ToolbarVisible = false;
					m_pdParams.PropertyGrid.Dock = DockStyle.Fill;
					m_pdParams.PropertyGrid.Parent = m_pnlBody;
					m_pdParams.PropertyGrid.Show();


				}
				else
					txtCommon.Dock = DockStyle.Fill;
				txtCommon.Show();

			}
			this.m_txtHeader.Text = m_htHeaders[m_iCount.ToString()].ToString();

		}

		private ParamEventArgs pdParams_OnSetValue(ParamsDialog pdSender, ParamEventArgs parValue)
		{
			string strReferenceField = null;
			string strStoredProcedure = null;
			if (m_htReferenceField[m_iCount.ToString()] != null)
				strReferenceField = m_htReferenceField[m_iCount.ToString()].ToString();

			if (strReferenceField != null)
			{
				if (parValue.Property.Name == strReferenceField)
				{
					int iValue = Convert.ToInt32(parValue.DataKey);
					if (m_htStoredProcedure[m_iCount.ToString()] != null)
						strStoredProcedure = m_htStoredProcedure[m_iCount.ToString()].ToString();
					
					int iPageid=System.Convert.ToInt32(m_htPageId[m_iCount.ToString()]);
					ChangeParamsDialog(strReferenceField, iValue, strStoredProcedure, false,iPageid);
				}

			}


			if (m_btnNext.Enabled == false && CheckMandatory())
				m_btnNext.Enabled = true;

			return parValue;
		}
	}

	/// <summary>
///     SoftelWizard
/// </summary>
	public class SoftelWizardArg
	{
		private ParamsDialogCollection m_objParamsCollection;
		private string m_strMessage;
		private int iMaxCount;
		private int iResult;

		public ParamsDialogCollection ParDialogCollection
		{
			set { m_objParamsCollection = value; }
			get { return m_objParamsCollection; }

		}

		public String Message
		{
			set { m_strMessage = value; }
			get { return m_strMessage; }

		}

		public int MaxCount
		{
			set { iMaxCount = value; }
			get { return iMaxCount; }

		}

		public int Result
		{
			set { iResult = value; }
			get { return iResult; }

		}


	}

	/// <summary>
///   ParamsDialog
/// </summary>
	[Serializable]
	public class ParamsDialogCollection : IList
	{
		/// <summary>
		///    
		/// </summary>
		private ArrayList m_alInner;

		/// <summary>
		///    
		/// </summary>
		public ParamsDialogCollection()
		{
			m_alInner = new ArrayList();
		}

		/// <summary>
		/// ,     
		/// </summary>
		public int Count
		{
			get { return m_alInner.Count; }
		}

		/// <summary>
		///  
		/// </summary>
		public bool IsFixedSize
		{
			get { return false; }
		}

		/// <summary>
		///  
		/// </summary>
		public bool IsReadOnly
		{
			get { return false; }
		}

		/// <summary>
		///  
		/// </summary>
		public bool IsSynchronized
		{
			get { return false; }
		}

		/// <summary>
		///  
		/// </summary>
		object ICollection.SyncRoot
		{
			get { return null; }
		}

		/// <summary>
		/// ,     
		/// </summary>
		public ParamsDialog this[int iIndex]
		{
			get
			{
				return
					(ParamsDialog) m_alInner[iIndex];
			}
			set { m_alInner[iIndex] = value; }
		}

		/// <summary>
		/// ,     
		/// </summary>
		/// <summary>
		///     
		/// </summary>
		/// <param name="value">  <see cref="Param"/></param>
		/// <returns>  </returns>
		public int Add(ParamsDialog value)
		{
			int iIndex = m_alInner.Add(value);

			return iIndex;
		}

		/// <summary>
		///      
		/// </summary>
		/// <param name="objArray"> </param>
		public void AddRange(ParamsDialog[] objArray)
		{
			m_alInner.AddRange(objArray);
		}

		/// <summary>
		///   
		/// </summary>
		public void Clear()
		{
			m_alInner.Clear();
		}

		/// <summary>
		/// ,      
		/// </summary>
		/// <param name="objItem">  <see cref="Param"/></param>
		/// <returns>true,     ,  false</returns>
		public bool Contains(ParamsDialog objItem)
		{
			return m_alInner.Contains(objItem);
		}

		/// <summary>
		/// ,      
		/// </summary>
		/// <param name="strName"> </param>
		/// <returns>true,     ,  false</returns>
		public bool Contains(string strName)
		{
			foreach (ParamsDialog objSpec in m_alInner)
				if (objSpec.Name == strName)
					return true;

			return false;
		}

		/// <summary>
		///   
		/// </summary>
		/// <param name="objArray">   </param>
		public void CopyTo(ParamsDialog[] objArray)
		{
			m_alInner.CopyTo(objArray);
		}

		/// <summary>
		///   
		/// </summary>
		/// <param name="objArray"> </param>
		/// <param name="iIndex">   </param>
		public void CopyTo(ParamsDialog[] objArray, int iIndex)
		{
			m_alInner.CopyTo(objArray, iIndex);
		}

		/// <summary>
		///  ,       
		/// </summary>
		/// <returns> <see cref="IEnumerator"/>  </returns>
		/// <remarks>
		/// </remarks>
		public IEnumerator GetEnumerator()
		{
			return m_alInner.GetEnumerator();
		}

		public int IndexOf(ParamsDialog value)
		{
			return m_alInner.IndexOf(value);
		}

		public int IndexOf(string strName)
		{
			int iIndex = 0;

			foreach (ParamsDialog objSpec in m_alInner)
			{
				if (objSpec.Name == strName)
					return iIndex;

				iIndex++;
			}

			return -1;
		}

		public ParamsDialog ItemOf(string strName)
		{
			int iIndex = this.IndexOf(strName);
			return (ParamsDialog) m_alInner[iIndex];
		}

		public void Insert(int iIndex, ParamsDialog objValue)
		{
			m_alInner.Insert(iIndex, objValue);
		}

		public void Remove(ParamsDialog objSpec)
		{
			m_alInner.Remove(objSpec);
		}

		public void Remove(string strName)
		{
			int iIndex = -1;
			foreach (ParamsDialog parCur in this)
			{
				if (parCur.Name == strName)
				{
					iIndex = IndexOf(parCur);
					break;
				}
			}
			RemoveAt(iIndex);
		}

		public void RemoveAt(int iIndex)
		{
			m_alInner.RemoveAt(iIndex);
		}

		public ParamsDialog[] ToArray()
		{
			return (ParamsDialog[]) m_alInner.ToArray(typeof (ParamsDialog));
		}

		#region Explicit interface implementations for ICollection and IList

		void ICollection.CopyTo(Array aArray, int iIndex)
		{
			CopyTo((ParamsDialog[]) aArray, iIndex);
		}

		int IList.Add(object objValue)
		{
			return Add((ParamsDialog) objValue);
		}

		bool IList.Contains(object objValue)
		{
			return Contains((ParamsDialog) objValue);
		}

		object IList.this[int iIndex]
		{
			get { return this[iIndex]; }
			set { (this)[iIndex] = (ParamsDialog) value; }
		}

		int IList.IndexOf(object objValue)
		{
			return IndexOf((ParamsDialog) objValue);
		}

		void IList.Insert(int iIndex, object objValue)
		{
			Insert(iIndex, (ParamsDialog) objValue);
		}

		void IList.Remove(object objValue)
		{
			Remove((ParamsDialog) objValue);
		}

		#endregion
	}
	/// <summary>
	///   
	/// </summary>
	public delegate DataTable SoftelWizardDataEventHandler(SoftelWizard pdSender, DataTable arg);

	public delegate SoftelWizardArg SoftelWizardEventHandler(SoftelWizard pdSender, SoftelWizardArg arg);

	/// <summary>
	///   Wizarda
	/// </summary>
	public enum WizardStepType
	{
		Initial = 0,
		Main = 1,
		Total = 2,
		Finish = 3
	}

}
/********************* SniipSoftel *****************
 *
 *    $History: SoftelWizard.cs $
 *   
 *   *****************  Version 36  *****************
 *   User: Gavrilov     Date: 9.04.07    Time: 11:37
 *   Updated in $/Net/Common/ClientControl/SoftelWizard
 *   
 *   *****************  Version 35  *****************
 *   User: Serg_ch      Date: 26.03.07   Time: 18:05
 *   Updated in $/Net/Common/ClientControl/SoftelWizard
 *   
 *   *****************  Version 33  *****************
 *   User: Serg_ch      Date: 29.01.07   Time: 15:44
 *   Updated in $/Net/Common/SoftelControl/SoftelWizard
 *   
 *   *****************  Version 32  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/SoftelWizard
 *   
 *   *****************  Version 31  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/SoftelWizard
 *   
 *   *****************  Version 30  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/SoftelWizard
 *
 ********************* SniipSoftel *****************/
