/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 58 $
 *   $Date: 13.08.07 16:12 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Softel.Common;
using Softel.MiddleTier.Client;
using Softel.Windows.Forms;
using Softel.Windows.Forms.Interface;
using Convert=System.Convert;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Application.BaseContent
{
	/// <summary>
	/// Summary description for BaseContent.
	/// </summary>
	public class BaseContent : Content, ITreeBaseForm
	{
		private ToolBar m_tbTop;
		private Panel m_pnlMain;
		private IContainer components;
		public Hashtable htParams;
		private DataTable m_dtDesk;
		private DataTable m_dtTuning;
		private ActionList m_alActions;
		private Action m_actSave;
		private Action m_actCancel;
		private ToolBarButton m_tbSave;
		private ToolBarButton m_tbCancel;
		private ImageList SoftelImageList;
		private GlobalImageList m_giImages;
		private ParamsDialog m_pdParams;
		public IDockManager m_dmMain;
		public string Caption;
		public int iKind = 0;

		private RichTextBox m_edtMemo;
		private Exchange m_exBottom = new Exchange();
		private string strDelProc = "";
		private string strInsProc = "";
		private string[] strDelProcParams;
		private string[] strInsProcParams;
		private ParamsDialog m_pdMain;
		private ITreeBaseForm itUni;
		private Panel m_pnlLeft = null;

		private const int iMemo = 1;
		private ToolBarButton m_btReload;
		private Action m_actReload;
		private const int iExchange = 2;
		private ToolBarButton m_tbbSeparator;
		private BaseGrid m_frmWindow = null;
		private CollapsiblePanelBar m_cpbMain;
		private Splitter splitter1;
		private CollapsiblePanel m_cpMain;
		private CollapsiblePanel m_cpFilter;
		private EventHandler m_evtMemo;
		private SingleGrid sgExchange;
		private SingleGrid m_frmWindowEx;

		public BaseContent()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			m_evtMemo = new EventHandler(edtTextChg);
			m_exBottom.AfterChangeSelected+=new EventHandlerSS(m_exBottom_AfterChangeSelected);
				
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if(disposing)
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		public Hashtable GetInitParams()
		{
			return htParams;
		}

		public void InitParams(Hashtable htArgs)
		{
			if(htArgs == null)
			{
				m_actReload.Enabled = false;
			}
			else
			{
				m_actReload.Enabled = true;
			}
			htParams = htArgs;
			if(m_pnlMain.Controls.Count > 0)
			{
				switch(Convert.ToInt32(htParams["TypeInterface"].ToString()))
				{
					case 2:
						((SingleGrid) m_pnlMain.Controls[0]).InitializeForm(GetHash(htParams));
						((SingleGrid) m_pnlMain.Controls[0]).Reload();
						break;
					case 3:
						((TwoGrid) m_pnlMain.Controls[0]).InitializeForm(GetHash(htParams));
						((TwoGrid) m_pnlMain.Controls[0]).Reload();
						break;
					case 4:
						((ThreeGrid) m_pnlMain.Controls[0]).InitializeForm(GetHash(htParams));
						((ThreeGrid) m_pnlMain.Controls[0]).Reload();
						break;
					case 5:
						((FourGrid) m_pnlMain.Controls[0]).InitializeForm(GetHash(htParams));
						((FourGrid) m_pnlMain.Controls[0]).Reload();
						break;
					case 6:
						((ThreeGridHor) m_pnlMain.Controls[0]).InitializeForm(GetHash(htParams));
						((ThreeGridHor) m_pnlMain.Controls[0]).Reload();
						break;
				}
			}
		}

		public void GetParams()
		{
			m_tbTop.Visible = true;
			m_actReload.Visible = true;
			//m_actSave.Enabled=true;
			//m_actCancel.Enabled=true;
			Command cmdDesk = new Command();
			cmdDesk.CommandName = htParams["SP_PG"].ToString();
			string[] Fields = htParams["Field_PG"].ToString().Split('|');
			string[] Pars = htParams["Params_PG"].ToString().Split('|');
			long iCount = Fields.LongLength;
			int iIndex = 0;
			if(!(htParams["Field_PG"].ToString() == DBNull.Value.ToString() || htParams["Field_PG"].ToString() == ""))
			{
				while(iIndex < iCount)
				{
					cmdDesk.InputParams["@" + Fields[iIndex].ToString()] = htParams[Pars[iIndex]];
					iIndex += 1;
				}
			}
			cmdDesk.Execute(true);
			m_dtDesk = cmdDesk.DataSet.Tables[0];

			Command cmdTuning = new Command();
			cmdTuning.CommandName = htParams["SP_Tuning"].ToString();
			Fields = htParams["Field_Tuning"].ToString().Split('|');
			Pars = htParams["Params_Tuning"].ToString().Split('|');
			iCount = Fields.LongLength;
			iIndex = 0;
			while(iIndex < iCount)
			{
				cmdTuning.InputParams["@" + Fields[iIndex].ToString()] = Pars[iIndex];
				iIndex += 1;
			}
			cmdTuning.Execute(true);
			m_dtTuning = cmdTuning.DataSet.Tables[0];

			m_pdParams = new ParamsDialog(m_dtDesk, m_dtTuning);
			m_pdParams.PropertyGrid.ToolbarVisible = false;
			m_pdParams.PropertyGrid.Dock = DockStyle.Fill;
			m_pdParams.PropertyGrid.Parent = m_pnlMain;
			if(m_pnlMain.Controls.Count > 1)
			{
				m_pnlMain.Controls.RemoveAt(0);
			}
			m_pdParams.PropertyGrid.Show();
			m_pdParams.PropertyGrid.PropertyValueChanged += new PropertyValueChangedEventHandler(PropertyGrid_PropertyValueChanged);
		}

		private void PropertyGrid_PropertyValueChanged(object s, PropertyValueChangedEventArgs e)
		{
			ParamsChanged(true);
		}

		private void ParamsChanged(bool bParamsChanged)
		{
			m_actSave.Enabled = bParamsChanged;
			m_actCancel.Enabled = bParamsChanged;
			iKind = 0;
			if(!bParamsChanged)
			{
				switch(Convert.ToInt32(htParams["TypeInterface"].ToString()))
				{
					case 1:
						//params dialog
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetParams();
						break;
					case 2:
						//single form loading...
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetFormSingle();
						break;
					case 3:
						//two grid loading...
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetForm2nd();
						break;
					case 4:
						//three grid loading...
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetForm3rd();
						break;
					case 5:
						//four grid loading...
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetForm4th();
						break;
					case 6:
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetThreeGridHor();
						break;
					case 7:
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetMemo();
						break;
					case 9:
						m_pnlMain.Visible = false;
						m_cpbMain.Visible = true;
						GetOneGrP();
						break;
					case 10:
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetTwoGrP();
						break;
					case 11:
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						GetThreeGrP();
						break;
					case 12:
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						m_actSave.Enabled = true;
						m_actCancel.Enabled = true;
						GetExchangeGrid(0);
						break;
					case 15:
						m_pnlMain.Visible = true;
						m_cpbMain.Visible = false;
						m_actSave.Enabled = true;
						m_actCancel.Enabled = true;
						GetExchangeGrid(1);
						break;
				}
			}
		}

		private Param CreateParam(string strName, string strCaption, string strType, Hashtable htArgs)
		{
			ParamsType ptTyp = new ParamsType();
			object DefVal = new object();
			switch(strType)
			{
				case "Date":
					ptTyp = ParamsType.DateTime;
					DefVal = DateTime.Today;
					break;
				case "Time":
					ptTyp = ParamsType.Time;
					DefVal = DateTime.Today;
					break;
				case "DateTime":
					ptTyp = ParamsType.DateTime;
					DefVal = DateTime.Today;
					break;
				case "DateTimeStart":
					ptTyp = ParamsType.DateTime;
					DefVal = DateTime.Today;
					break;
				case "DateTimeEnd":
					ptTyp = ParamsType.DateTime;
					DefVal = DateTime.Now;
					break;
				case "Int":
					ptTyp = ParamsType.Int;
					DefVal = 0;
					break;
				case "Boolean":
					ptTyp = ParamsType.Boolean;
					DefVal = false;
					break;
				case "Float":
					ptTyp = ParamsType.Float;
					DefVal = 0.0;
					break;
				case "Data":
					ptTyp = ParamsType.Data;
					break;
				case "String":
					ptTyp = ParamsType.String;
					DefVal = "";
					break;
				case "Image":
					ptTyp = ParamsType.Image;
					break;
			}
			htArgs[strName] = DefVal;
			Param parCr = new Param(strName, strCaption, ptTyp, ResourceControl.String1, strCaption, DefVal);
			return parCr;
		}

		private void CreateParamsDialog(Hashtable htArgs, Panel pnlLeft)
		{
			m_pdMain = new ParamsDialog();

			string[] strNames = htArgs["ParamName"].ToString().Split('|');
			string[] strCaptions = htArgs["ParamCaption"].ToString().Split('|');
			string[] strTypes = htArgs["ParamType"].ToString().Split('|');

			for(int i = 0; i < strNames.LongLength; i++)
			{
				Param parAdded = CreateParam(strNames[i], strCaptions[i], strTypes[i], htArgs);
				htArgs[strNames[i]] = "";
				m_pdMain.Params.Add(parAdded);
			}

			m_pdMain.Text = ResourceControl.String2;
			m_pdMain.PropertyGrid.PropertySort = PropertySort.Categorized;
			m_pdMain.PropertyGrid.Parent = pnlLeft;
//			pnlLeft.Width = 350;
			m_pdMain.PropertyGrid.ToolbarVisible = false;
			m_pdMain.PropertyGrid.HelpVisible = false;
			m_pdMain.PropertyGrid.Dock = DockStyle.Fill;
			if(pnlLeft.Controls.Count > 1)
			{
				pnlLeft.Controls.RemoveAt(0);
			}

			ParamsDialogEventHandler hndlChd = new ParamsDialogEventHandler(ParamChanged);
			m_pdMain.OnAfterSetValue += hndlChd;
		}

		private void SetPosition(Hashtable htParams)
		{
			if(m_pnlLeft == null)
			{
				m_pnlLeft = new Panel();
//				m_pnlLeft.Parent = m_pnlMain;
//				m_splDivider = new Splitter();
//				m_splDivider.Parent = m_pnlMain;
//				if(htParams["TopLeft"].Equals(true))
//				{
//					m_pnlLeft.Dock = DockStyle.Top;
//					m_splDivider.Dock = DockStyle.Top;
//					m_pnlLeft.Height = 100;
//					splDivider.Top = m_pnlLeft.Top + m_pnlLeft.Height + 2;
//				}
//				else
//				{
				m_pnlLeft.Dock = DockStyle.Fill;
//					m_pnlLeft.Width = 150;
//					splDivider.Left = m_pnlLeft.Left + m_pnlLeft.Width + 2;
//					m_splDivider.Dock = DockStyle.Left;
//				}
//				m_splDivider.BringToFront();
			}
			CreateParamsDialog(htParams, m_pnlLeft);
			m_pnlLeft.Parent = m_cpFilter;
//			CreateParamsDialog(htParams, m_cpMain);
		}

		private void GetOneGrP()
		{
			m_tbTop.Visible = false;
			m_pnlMain.Visible = false;
			m_cpbMain.Visible = true;
			if(m_pdMain != null)
			{
				ChangeGridByFilter(m_pdMain);
			}
			else
			{
				m_cpbMain.BorderStyle = BorderStyle.None;
				GetFormSingle();
				m_frmWindow.Parent = m_cpMain;
				SetPosition(htParams);
				ChangeGridByFilter(m_pdMain);
//				itUni.Reload();
			}
		}

		private void GetTwoGrP()
		{
			m_tbTop.Visible = false;
			m_pnlMain.Visible = false;
			m_cpbMain.Visible = true;
			if(m_pdMain != null)
			{
				ChangeGridByFilter(m_pdMain);
			}
			else
			{
				m_cpbMain.BorderStyle = BorderStyle.None;
				m_tbTop.Visible = true;
				GetForm2nd();
				m_frmWindow.Parent = m_cpMain;
				SetPosition(htParams);
				ChangeGridByFilter(m_pdMain);
			}
		}

		private void GetThreeGrP()
		{
			m_tbTop.Visible = true;
			GetForm3rd();
			SetPosition(htParams);
		}

		private void ChangeGridByFilter(ParamsDialog pdThat)
		{
			Hashtable hshCurrent = new Hashtable();
			string[] strParams = htParams["Field_PG"].ToString().Split('|');
			for(int i = 0; i < strParams.Length; i++)

			{
				string strCurrent = strParams[i];
				if(pdThat.Value[strCurrent] != null)
				{
					htParams[pdThat.Params[strCurrent]] = pdThat.Value[strCurrent];
					hshCurrent[strCurrent] = pdThat.Value[strCurrent];
				}
				else
				{
					hshCurrent[strCurrent] = htParams[strCurrent];
				}
			}
			itUni.InitParams(hshCurrent);
//			itUni.Reload();
		}

		private ParamEventArgs ParamChanged(ParamsDialog pdThat, ParamEventArgs peaArgs)
		{
			/*
			Hashtable hshCurrent=new Hashtable();
			string[] strParams=htParams["Field_PG"].ToString().Split('|');
			for (int i=0;i < strParams.Length;i++)

			
			{
				string strCurrent=strParams[i];
				if(pdThat.Value[strCurrent] != null)
				{
					htParams[pdThat.Params[strCurrent]] = pdThat.Value[strCurrent];
					hshCurrent[strCurrent] = pdThat.Value[strCurrent];
				}
				else
					hshCurrent[strCurrent]=htParams[strCurrent];
				
			}
			itUni.InitParams(hshCurrent);
			itUni.Reload();
			*/
			ChangeGridByFilter(pdThat);
			return peaArgs;
		}
	
		
		private void UpdExch(int iCnst)
		{
			m_tbTop.Visible = true;
			m_exBottom.AvailableValueMember = htParams["ParamName"].ToString();
			m_exBottom.AvailableDisplayMember = htParams["Field_PG"].ToString();
			m_exBottom.SelectedValueMember = htParams["ParamName"].ToString();
			m_exBottom.SelectedDisplayMember = htParams["Field_Tuning"].ToString();

			Command cProc = new Command();
			cProc.CommandName = htParams["SP_PG"].ToString();
			cProc.InputParams["@" + htParams["Params_PG"]] = iCnst;
			cProc.Execute(true);
			if(cProc.DataSet.Tables != null)
			{
				m_exBottom.AvailableData = cProc.DataSet.Tables[0];
			}

			cProc = new Command();
			cProc.CommandName = htParams["SP_Tuning"].ToString();
			cProc.InputParams["@" + htParams["Params_Tuning"]] = iCnst;
			cProc.Execute(true);
			if(cProc.DataSet.Tables != null)
			{
				m_exBottom.SelectedData = cProc.DataSet.Tables[0];
			}
		}
		private void GetExchangeGrid(int iCnst)
		{
				
				
			m_tbTop.Visible = true;
			m_exBottom.AvailableValueMember = htParams["ParamName"].ToString();
			m_exBottom.AvailableDisplayMember = htParams["Field_PG"].ToString();
			m_exBottom.SelectedValueMember = htParams["ParamName"].ToString();
			m_exBottom.SelectedDisplayMember = htParams["Field_Tuning"].ToString();

			Command cProc = new Command();
			cProc.CommandName = htParams["SP_PG"].ToString();
			string strParTun = htParams["Params_Tuning"].ToString();
			if(iCnst==0)
				cProc.InputParams["@" + htParams["Params_PG"]] = iCnst;
			else
				cProc.InputParams["@" + htParams["Params_Tuning"]] = htParams[strParTun];
			cProc.Execute(true);
			if(cProc.DataSet.Tables != null)
			{
				m_exBottom.AvailableData = cProc.DataSet.Tables[0];
			}

			cProc = new Command();
			
				cProc.CommandName = htParams["SP_Tuning"].ToString();
			if(iCnst==0)
				cProc.InputParams["@" + htParams["Params_PG"]] = iCnst;
			else
				cProc.InputParams["@" + htParams["Params_Tuning"]] = htParams[strParTun];
			cProc.Execute(true);
			if(cProc.DataSet.Tables != null)
			{
				m_exBottom.SelectedData = cProc.DataSet.Tables[0];
			}

			m_exBottom.Dock = DockStyle.Bottom;
			if(iCnst==0)
			{
				m_frmWindowEx = new SingleGrid(GetHash(htParams));
				m_frmWindowEx.CurrentRowChanged+=new EventHandler(m_frmWindowEx_CurrentRowChanged);

				m_frmWindowEx.Tuning = htParams["tuning"].ToString();
				m_frmWindowEx.Reload();
				m_frmWindowEx.Tag = Tag;
				m_frmWindowEx.Parent = m_pnlMain;
				m_frmWindowEx.Dock = DockStyle.Fill;
				sgExchange = m_frmWindowEx;
			}
			else
				m_exBottom.Dock = DockStyle.Fill;
			m_exBottom.Parent = m_pnlMain;
			

			iKind = iExchange;
			strDelProc = htParams["Del_Proc"].ToString();
			strInsProc = htParams["Ins_Proc"].ToString();
			strDelProcParams = htParams["Del_Params"].ToString().Split('|');
			strInsProcParams = htParams["Ins_Params"].ToString().Split('|');
			m_actSave.Enabled = false;
			if(iCnst == 0 && m_frmWindowEx.CurrentItem != null)
				UpdExch(Convert.ToInt32(m_frmWindowEx.CurrentItem[strParTun].ToString()));
		}

		private Hashtable GetHash(Hashtable htArgs)
		{
			Hashtable htResult = new Hashtable();
			htResult["tuning"] = htArgs["tuning"];
			if(htArgs["GridParams"].ToString() != DBNull.Value.ToString() && htArgs["GridParams"].ToString() != "")
			{
				string[] strFields = htArgs["GridParams"].ToString().Split('|');
				int iCount = strFields.Length;
				int iIndex = 0;
				while(iIndex < iCount)
				{
					string strG = strFields[iIndex++];
					if(strG.Split('=').Length > 2)
					{
						string[] strField = strG.Split('=');
						htResult[strField[0]] = strField[1];

					}
					else
						htResult[strG] = htArgs[strG];
				}
			}

			return htResult;
		}

		private void GetFormSingle()
		{
			//SingleGrid
			if(m_frmWindow == null)
			{
				m_frmWindow = new SingleGrid(GetHash(htParams));
			
					
				//m_frmWindow.OnGridRefresh += new Softel.Windows.Forms.BaseGrid.EventHandlerRefresh(m_frmWindow_OnGridRefresh);
			}
			else
			{
				m_frmWindow.InitializeForm(GetHash(htParams));
			}

			m_frmWindow.Tuning = htParams["tuning"].ToString();

			m_frmWindow.Reload();
			m_frmWindow.Tag = Tag;
			m_frmWindow.Parent = m_pnlMain;
			m_frmWindow.Dock = DockStyle.Fill;
			m_tbTop.Visible = false;
			itUni = m_frmWindow;
		}

		private void GetForm2nd()
		{
			//TwoGrid
			if(m_frmWindow == null)
			{
				m_frmWindow = new TwoGrid(GetHash(htParams));
			
					
				//m_frmWindow.OnGridRefresh += new Softel.Windows.Forms.BaseGrid.EventHandlerRefresh(m_frmWindow_OnGridRefresh);
			}
			else
			{
				m_frmWindow.InitializeForm(GetHash(htParams));
			}
			//TwoGrid frmWindow = new TwoGrid(GetHash(htParams));
			m_frmWindow.Tuning = htParams["tuning"].ToString();
			m_frmWindow.Reload();
			m_frmWindow.Tag = Tag;
			m_frmWindow.Parent = m_pnlMain;
			m_frmWindow.Dock = DockStyle.Fill;
			m_tbTop.Visible = false;
			itUni = m_frmWindow;
		}

		private void GetForm3rd()
		{
			ThreeGrid frmWindow = new ThreeGrid(GetHash(htParams));
			frmWindow.Tuning = htParams["tuning"].ToString();
			frmWindow.Reload();
			frmWindow.Tag = Tag;
			frmWindow.Parent = m_pnlMain;
			frmWindow.Dock = DockStyle.Fill;
			m_tbTop.Visible = false;
			itUni = frmWindow;
		}

		private void GetForm4th()
		{
			FourGrid frmWindow = new FourGrid(GetHash(htParams));
			frmWindow.Tuning = htParams["tuning"].ToString();
			frmWindow.Reload();
			frmWindow.Tag = Tag;
			frmWindow.Parent = m_pnlMain;
			frmWindow.Dock = DockStyle.Fill;
			m_tbTop.Visible = false;
		}

		private void GetThreeGridHor()
		{
			ThreeGridHor frmWindow = new ThreeGridHor(GetHash(htParams));
			frmWindow.Tuning = htParams["tuning"].ToString();
			frmWindow.Reload();
			frmWindow.Tag = Tag;
			frmWindow.Parent = m_pnlMain;
			frmWindow.Dock = DockStyle.Fill;
			m_tbTop.Visible = false;
		}

		private void GetMemo()
		{
			m_tbTop.Visible = true;
			if(m_edtMemo != null)
			{
				m_edtMemo.TextChanged -= m_evtMemo;
				m_edtMemo.Text = "";
			}
			else
			{
				m_edtMemo = new RichTextBox();
			}

			Command cProc = new Command();
			cProc.CommandName = htParams["SP_PG"].ToString();
			string[] Pars = htParams["Params_PG"].ToString().Split('|');
			if(Pars.LongLength > 0)
			{
				int iCount = Pars.Length;
				int iIndex = 0;
				while(iIndex < iCount)
				{
					string strPar = Pars[iIndex++];
					cProc.InputParams["@" + strPar] = htParams[strPar];
				}
			}
			cProc.Execute(true);
			m_edtMemo.Dock = DockStyle.Fill;
			DataTable dtEx = cProc.DataSet.Tables[0];

			if(dtEx.Rows.Count > 0)
			{
				m_edtMemo.Text = dtEx.Rows[0][htParams["Field_PG"].ToString()].ToString();
			}

			m_edtMemo.Parent = m_pnlMain;
			iKind = iMemo;
			m_edtMemo.TextChanged += m_evtMemo;
		}

		private void edtTextChg(object sender, EventArgs e)
		{
			m_actSave.Enabled = true;
			m_actCancel.Enabled = true;
		}

		private void UpdDesk()
		{
			if(iKind == iExchange)
			{
				//???????????????????????????????????????????
				object[] Dels = m_exBottom.DataChangeDel;
				object[] Inss = m_exBottom.DataChangeIns;
				string strParTun = htParams["Params_Tuning"].ToString();
				Command cmdProc = new Command();
				cmdProc.CommandName = strInsProc;
				int iMax = Inss.Length;
				int iCurr = 0;
				while (iCurr < iMax)
				{
					string strPar1;
					string strPar2;
					cmdProc.InputParams.Clear();
					cmdProc.OutputParams.Clear();
					if(strParTun==strInsProcParams[0])
					{
						strPar1 = strInsProcParams[0];
						strPar2 = strInsProcParams[1];
					}
					else
					{
						strPar2 = strInsProcParams[0];
						strPar1 = strInsProcParams[1];
						
					}
					if(m_frmWindowEx!=null)
						cmdProc.InputParams["@"+strPar1] = m_frmWindowEx.CurrentItem[strParTun];
					else
						cmdProc.InputParams["@"+strPar1] = htParams[strParTun];
					cmdProc.InputParams["@"+strPar2] = Inss[iCurr].ToString();
					cmdProc.Execute(true);
					iCurr += 1;
				}
				cmdProc.CommandName = strDelProc;
				iMax = Dels.Length;
				iCurr = 0;
				while (iCurr < iMax)
				{
					string strPar1;
					string strPar2;
					cmdProc.InputParams.Clear();
					cmdProc.OutputParams.Clear();
					if(strParTun==strInsProcParams[0])
					{
						strPar1 = strInsProcParams[0];
						strPar2 = strInsProcParams[1];
					}
					else
					{
						strPar2 = strInsProcParams[0];
						strPar1 = strInsProcParams[1];
						
					}
					if(m_frmWindowEx!=null)
						cmdProc.InputParams["@"+strPar1] = m_frmWindowEx.CurrentItem[strParTun];
					else
						cmdProc.InputParams["@"+strPar1] = htParams[strParTun];
					cmdProc.InputParams["@"+strPar2] = Dels[iCurr].ToString();
					cmdProc.Execute(true);
					iCurr += 1;
				}
				m_actSave.Enabled = false;
				return;
				//???????????????????????????????????????????
			}
			if(iKind != iMemo)
			{
				Command cmdProc = new Command();
				cmdProc.CommandName = m_pdParams.UpdateStoredProc;
				cmdProc.InputParams = m_pdParams.UpdateTable;
				string[] Pars = htParams["Params_PG"].ToString().Split('|');
				if(Pars.LongLength > 0)
				{
					int iCount = Pars.Length;
					int iIndex = 0;
					while(iIndex < iCount)
					{
						string strPar = Pars[iIndex++];
						cmdProc.InputParams["@" + strPar] = htParams[strPar];
					}
				}
				cmdProc.Execute(true);
			}
			else
			{
				htParams[htParams["Field_PG"]] = m_edtMemo.Text;
				Command cmdProc = new Command();
				cmdProc.CommandName = htParams["SP_Tuning"].ToString();
				string[] Pars = htParams["Params_Tuning"].ToString().Split('|');
				if(Pars.LongLength > 0)
				{
					int iCount = Pars.Length;
					int iIndex = 0;
					while(iIndex < iCount)
					{
						string strPar = Pars[iIndex++];
						cmdProc.InputParams["@" + strPar] = htParams[strPar];
					}
				}
				cmdProc.Execute(true);
				m_actSave.Enabled = false;
				m_actCancel.Enabled = false;
			}
		}

		protected void Cancel()
		{
			ParamsChanged(false);
		}

		protected void Save()
		{
			UpdDesk();
			if (iKind != iExchange)
				ParamsChanged(false);
		}

		public void Reload()
		{
			ParamsChanged(false);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(BaseContent));
			this.m_tbTop = new System.Windows.Forms.ToolBar();
			this.m_tbSave = new System.Windows.Forms.ToolBarButton();
			this.m_tbCancel = new System.Windows.Forms.ToolBarButton();
			this.m_tbbSeparator = new System.Windows.Forms.ToolBarButton();
			this.m_btReload = new System.Windows.Forms.ToolBarButton();
			this.SoftelImageList = new System.Windows.Forms.ImageList(this.components);
			this.m_pnlMain = new System.Windows.Forms.Panel();
			this.m_alActions = new Softel.Windows.Forms.ActionList(this.components);
			this.m_actSave = new Softel.Windows.Forms.Action(this.components);
			this.m_actCancel = new Softel.Windows.Forms.Action(this.components);
			this.m_actReload = new Softel.Windows.Forms.Action(this.components);
			this.m_giImages = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_cpbMain = new Softel.Windows.Forms.CollapsiblePanelBar();
			this.m_cpMain = new Softel.Windows.Forms.CollapsiblePanel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.m_cpFilter = new Softel.Windows.Forms.CollapsiblePanel();
			((System.ComponentModel.ISupportInitialize)(this.m_cpbMain)).BeginInit();
			this.m_cpbMain.SuspendLayout();
			this.SuspendLayout();
			// 
			// m_tbTop
			// 
			this.m_tbTop.AccessibleDescription = resources.GetString("m_tbTop.AccessibleDescription");
			this.m_tbTop.AccessibleName = resources.GetString("m_tbTop.AccessibleName");
			this.m_tbTop.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tbTop.Anchor")));
			this.m_tbTop.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("m_tbTop.Appearance")));
			this.m_tbTop.AutoSize = ((bool)(resources.GetObject("m_tbTop.AutoSize")));
			this.m_tbTop.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tbTop.BackgroundImage")));
			this.m_tbTop.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.m_tbSave,
																					   this.m_tbCancel,
																					   this.m_tbbSeparator,
																					   this.m_btReload});
			this.m_tbTop.ButtonSize = ((System.Drawing.Size)(resources.GetObject("m_tbTop.ButtonSize")));
			this.m_tbTop.Divider = false;
			this.m_tbTop.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tbTop.Dock")));
			this.m_tbTop.DropDownArrows = ((bool)(resources.GetObject("m_tbTop.DropDownArrows")));
			this.m_tbTop.Enabled = ((bool)(resources.GetObject("m_tbTop.Enabled")));
			this.m_tbTop.Font = ((System.Drawing.Font)(resources.GetObject("m_tbTop.Font")));
			this.m_tbTop.ImageList = this.SoftelImageList;
			this.m_tbTop.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tbTop.ImeMode")));
			this.m_tbTop.Location = ((System.Drawing.Point)(resources.GetObject("m_tbTop.Location")));
			this.m_tbTop.Name = "m_tbTop";
			this.m_tbTop.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tbTop.RightToLeft")));
			this.m_tbTop.ShowToolTips = ((bool)(resources.GetObject("m_tbTop.ShowToolTips")));
			this.m_tbTop.Size = ((System.Drawing.Size)(resources.GetObject("m_tbTop.Size")));
			this.m_tbTop.TabIndex = ((int)(resources.GetObject("m_tbTop.TabIndex")));
			this.m_tbTop.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("m_tbTop.TextAlign")));
			this.m_tbTop.Visible = ((bool)(resources.GetObject("m_tbTop.Visible")));
			this.m_tbTop.Wrappable = ((bool)(resources.GetObject("m_tbTop.Wrappable")));
			// 
			// m_tbSave
			// 
			this.m_alActions.SetAction(this.m_tbSave, this.m_actSave);
			this.m_tbSave.Enabled = ((bool)(resources.GetObject("m_tbSave.Enabled")));
			this.m_tbSave.ImageIndex = ((int)(resources.GetObject("m_tbSave.ImageIndex")));
			this.m_tbSave.Text = resources.GetString("m_tbSave.Text");
			this.m_tbSave.ToolTipText = resources.GetString("m_tbSave.ToolTipText");
			this.m_tbSave.Visible = ((bool)(resources.GetObject("m_tbSave.Visible")));
			// 
			// m_tbCancel
			// 
			this.m_alActions.SetAction(this.m_tbCancel, this.m_actCancel);
			this.m_tbCancel.Enabled = ((bool)(resources.GetObject("m_tbCancel.Enabled")));
			this.m_tbCancel.ImageIndex = ((int)(resources.GetObject("m_tbCancel.ImageIndex")));
			this.m_tbCancel.Text = resources.GetString("m_tbCancel.Text");
			this.m_tbCancel.ToolTipText = resources.GetString("m_tbCancel.ToolTipText");
			this.m_tbCancel.Visible = ((bool)(resources.GetObject("m_tbCancel.Visible")));
			// 
			// m_tbbSeparator
			// 
			this.m_tbbSeparator.Enabled = ((bool)(resources.GetObject("m_tbbSeparator.Enabled")));
			this.m_tbbSeparator.ImageIndex = ((int)(resources.GetObject("m_tbbSeparator.ImageIndex")));
			this.m_tbbSeparator.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			this.m_tbbSeparator.Text = resources.GetString("m_tbbSeparator.Text");
			this.m_tbbSeparator.ToolTipText = resources.GetString("m_tbbSeparator.ToolTipText");
			this.m_tbbSeparator.Visible = ((bool)(resources.GetObject("m_tbbSeparator.Visible")));
			// 
			// m_btReload
			// 
			this.m_alActions.SetAction(this.m_btReload, this.m_actReload);
			this.m_btReload.Enabled = ((bool)(resources.GetObject("m_btReload.Enabled")));
			this.m_btReload.ImageIndex = ((int)(resources.GetObject("m_btReload.ImageIndex")));
			this.m_btReload.Text = resources.GetString("m_btReload.Text");
			this.m_btReload.ToolTipText = resources.GetString("m_btReload.ToolTipText");
			this.m_btReload.Visible = ((bool)(resources.GetObject("m_btReload.Visible")));
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageSize = ((System.Drawing.Size)(resources.GetObject("SoftelImageList.ImageSize")));
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			this.SoftelImageList.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// m_pnlMain
			// 
			this.m_pnlMain.AccessibleDescription = resources.GetString("m_pnlMain.AccessibleDescription");
			this.m_pnlMain.AccessibleName = resources.GetString("m_pnlMain.AccessibleName");
			this.m_pnlMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlMain.Anchor")));
			this.m_pnlMain.AutoScroll = ((bool)(resources.GetObject("m_pnlMain.AutoScroll")));
			this.m_pnlMain.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlMain.AutoScrollMargin")));
			this.m_pnlMain.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlMain.AutoScrollMinSize")));
			this.m_pnlMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlMain.BackgroundImage")));
			this.m_pnlMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlMain.Dock")));
			this.m_pnlMain.Enabled = ((bool)(resources.GetObject("m_pnlMain.Enabled")));
			this.m_pnlMain.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlMain.Font")));
			this.m_pnlMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlMain.ImeMode")));
			this.m_pnlMain.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlMain.Location")));
			this.m_pnlMain.Name = "m_pnlMain";
			this.m_pnlMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlMain.RightToLeft")));
			this.m_pnlMain.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlMain.Size")));
			this.m_pnlMain.TabIndex = ((int)(resources.GetObject("m_pnlMain.TabIndex")));
			this.m_pnlMain.Text = resources.GetString("m_pnlMain.Text");
			this.m_pnlMain.Visible = ((bool)(resources.GetObject("m_pnlMain.Visible")));
			// 
			// m_alActions
			// 
			this.m_alActions.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																					this.m_actSave,
																					this.m_actCancel,
																					this.m_actReload});
			this.m_alActions.ImageList = this.SoftelImageList;
			this.m_alActions.ShowTextOnToolBar = false;
			this.m_alActions.Tag = null;
			// 
			// m_actSave
			// 
			this.m_actSave.Checked = false;
			this.m_actSave.Enabled = false;
			this.m_actSave.Hint = resources.GetString("m_actSave.Hint");
			this.m_actSave.ImageIndex = ((int)(resources.GetObject("m_actSave.ImageIndex")));
			this.m_actSave.MergeOrder = 12;
			this.m_actSave.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actSave.Tag = null;
			this.m_actSave.Text = resources.GetString("m_actSave.Text");
			this.m_actSave.Visible = true;
			this.m_actSave.Execute += new System.EventHandler(this.m_actSave_Execute);
			// 
			// m_actCancel
			// 
			this.m_actCancel.Checked = false;
			this.m_actCancel.Enabled = false;
			this.m_actCancel.Hint = resources.GetString("m_actCancel.Hint");
			this.m_actCancel.ImageIndex = ((int)(resources.GetObject("m_actCancel.ImageIndex")));
			this.m_actCancel.MergeOrder = 13;
			this.m_actCancel.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actCancel.Tag = null;
			this.m_actCancel.Text = resources.GetString("m_actCancel.Text");
			this.m_actCancel.Visible = true;
			this.m_actCancel.Execute += new System.EventHandler(this.m_actCancel_Execute);
			// 
			// m_actReload
			// 
			this.m_actReload.Checked = false;
			this.m_actReload.Enabled = false;
			this.m_actReload.Hint = resources.GetString("m_actReload.Hint");
			this.m_actReload.ImageIndex = ((int)(resources.GetObject("m_actReload.ImageIndex")));
			this.m_actReload.MergeOrder = 21;
			this.m_actReload.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actReload.Tag = null;
			this.m_actReload.Text = resources.GetString("m_actReload.Text");
			this.m_actReload.Visible = true;
			this.m_actReload.Execute += new System.EventHandler(this.m_actReload_Execute);
			// 
			// m_giImages
			// 
			this.m_giImages.ImageList = this.SoftelImageList;
			this.m_giImages.Parent = this;
			// 
			// m_cpbMain
			// 
			this.m_cpbMain.AccessibleDescription = resources.GetString("m_cpbMain.AccessibleDescription");
			this.m_cpbMain.AccessibleName = resources.GetString("m_cpbMain.AccessibleName");
			this.m_cpbMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_cpbMain.Anchor")));
			this.m_cpbMain.AutoScroll = ((bool)(resources.GetObject("m_cpbMain.AutoScroll")));
			this.m_cpbMain.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_cpbMain.AutoScrollMargin")));
			this.m_cpbMain.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_cpbMain.AutoScrollMinSize")));
			this.m_cpbMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_cpbMain.BackgroundImage")));
			this.m_cpbMain.Border = 8;
			this.m_cpbMain.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.m_cpbMain.Controls.Add(this.m_cpMain);
			this.m_cpbMain.Controls.Add(this.splitter1);
			this.m_cpbMain.Controls.Add(this.m_cpFilter);
			this.m_cpbMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_cpbMain.Dock")));
			this.m_cpbMain.Enabled = ((bool)(resources.GetObject("m_cpbMain.Enabled")));
			this.m_cpbMain.Font = ((System.Drawing.Font)(resources.GetObject("m_cpbMain.Font")));
			this.m_cpbMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_cpbMain.ImeMode")));
			this.m_cpbMain.Location = ((System.Drawing.Point)(resources.GetObject("m_cpbMain.Location")));
			this.m_cpbMain.Name = "m_cpbMain";
			this.m_cpbMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cpbMain.RightToLeft")));
			this.m_cpbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_cpbMain.Size")));
			this.m_cpbMain.Spacing = 8;
			this.m_cpbMain.TabIndex = ((int)(resources.GetObject("m_cpbMain.TabIndex")));
			this.m_cpbMain.Text = resources.GetString("m_cpbMain.Text");
			this.m_cpbMain.Visible = ((bool)(resources.GetObject("m_cpbMain.Visible")));
			// 
			// m_cpMain
			// 
			this.m_cpMain.AccessibleDescription = resources.GetString("m_cpMain.AccessibleDescription");
			this.m_cpMain.AccessibleName = resources.GetString("m_cpMain.AccessibleName");
			this.m_cpMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_cpMain.Anchor")));
			this.m_cpMain.AutoScroll = ((bool)(resources.GetObject("m_cpMain.AutoScroll")));
			this.m_cpMain.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_cpMain.AutoScrollMargin")));
			this.m_cpMain.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_cpMain.AutoScrollMinSize")));
			this.m_cpMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_cpMain.BackgroundImage")));
			this.m_cpMain.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.m_cpMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_cpMain.Dock")));
			this.m_cpMain.Enabled = ((bool)(resources.GetObject("m_cpMain.Enabled")));
			this.m_cpMain.Font = ((System.Drawing.Font)(resources.GetObject("m_cpMain.Font")));
			this.m_cpMain.Image = null;
			this.m_cpMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_cpMain.ImeMode")));
			this.m_cpMain.Location = ((System.Drawing.Point)(resources.GetObject("m_cpMain.Location")));
			this.m_cpMain.Name = "m_cpMain";
			this.m_cpMain.PanelState = Softel.Windows.Forms.PanelState.Expanded;
			this.m_cpMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cpMain.RightToLeft")));
			this.m_cpMain.Size = ((System.Drawing.Size)(resources.GetObject("m_cpMain.Size")));
			this.m_cpMain.TabIndex = ((int)(resources.GetObject("m_cpMain.TabIndex")));
			this.m_cpMain.Text = resources.GetString("m_cpMain.Text");
			this.m_cpMain.TitleAngleGradient = 90F;
			this.m_cpMain.TitleBorderStyle = System.Windows.Forms.BorderStyle.None;
			this.m_cpMain.TitleDarkColor = System.Drawing.SystemColors.ControlDark;
			this.m_cpMain.TitleFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.m_cpMain.TitleFontColour = System.Drawing.SystemColors.ControlText;
			this.m_cpMain.TitleLightColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_cpMain.TitleText = "";
			this.m_cpMain.Visible = ((bool)(resources.GetObject("m_cpMain.Visible")));
			// 
			// splitter1
			// 
			this.splitter1.AccessibleDescription = resources.GetString("splitter1.AccessibleDescription");
			this.splitter1.AccessibleName = resources.GetString("splitter1.AccessibleName");
			this.splitter1.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("splitter1.Anchor")));
			this.splitter1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("splitter1.BackgroundImage")));
			this.splitter1.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("splitter1.Dock")));
			this.splitter1.Enabled = ((bool)(resources.GetObject("splitter1.Enabled")));
			this.splitter1.Font = ((System.Drawing.Font)(resources.GetObject("splitter1.Font")));
			this.splitter1.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("splitter1.ImeMode")));
			this.splitter1.Location = ((System.Drawing.Point)(resources.GetObject("splitter1.Location")));
			this.splitter1.MinExtra = ((int)(resources.GetObject("splitter1.MinExtra")));
			this.splitter1.MinSize = ((int)(resources.GetObject("splitter1.MinSize")));
			this.splitter1.Name = "splitter1";
			this.splitter1.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("splitter1.RightToLeft")));
			this.splitter1.Size = ((System.Drawing.Size)(resources.GetObject("splitter1.Size")));
			this.splitter1.TabIndex = ((int)(resources.GetObject("splitter1.TabIndex")));
			this.splitter1.TabStop = false;
			this.splitter1.Visible = ((bool)(resources.GetObject("splitter1.Visible")));
			// 
			// m_cpFilter
			// 
			this.m_cpFilter.AccessibleDescription = resources.GetString("m_cpFilter.AccessibleDescription");
			this.m_cpFilter.AccessibleName = resources.GetString("m_cpFilter.AccessibleName");
			this.m_cpFilter.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_cpFilter.Anchor")));
			this.m_cpFilter.AutoScroll = ((bool)(resources.GetObject("m_cpFilter.AutoScroll")));
			this.m_cpFilter.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_cpFilter.AutoScrollMargin")));
			this.m_cpFilter.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_cpFilter.AutoScrollMinSize")));
			this.m_cpFilter.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_cpFilter.BackgroundImage")));
			this.m_cpFilter.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.m_cpFilter.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_cpFilter.Dock")));
			this.m_cpFilter.Enabled = ((bool)(resources.GetObject("m_cpFilter.Enabled")));
			this.m_cpFilter.Font = ((System.Drawing.Font)(resources.GetObject("m_cpFilter.Font")));
			this.m_cpFilter.Image = null;
			this.m_cpFilter.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_cpFilter.ImeMode")));
			this.m_cpFilter.Location = ((System.Drawing.Point)(resources.GetObject("m_cpFilter.Location")));
			this.m_cpFilter.Name = "m_cpFilter";
			this.m_cpFilter.PanelState = Softel.Windows.Forms.PanelState.Expanded;
			this.m_cpFilter.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cpFilter.RightToLeft")));
			this.m_cpFilter.Size = ((System.Drawing.Size)(resources.GetObject("m_cpFilter.Size")));
			this.m_cpFilter.TabIndex = ((int)(resources.GetObject("m_cpFilter.TabIndex")));
			this.m_cpFilter.Text = resources.GetString("m_cpFilter.Text");
			this.m_cpFilter.TitleAngleGradient = 90F;
			this.m_cpFilter.TitleBorderStyle = System.Windows.Forms.BorderStyle.None;
			this.m_cpFilter.TitleDarkColor = System.Drawing.SystemColors.ControlDark;
			this.m_cpFilter.TitleFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.m_cpFilter.TitleFontColour = System.Drawing.SystemColors.ControlText;
			this.m_cpFilter.TitleLightColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_cpFilter.TitleText = "";
			this.m_cpFilter.Visible = ((bool)(resources.GetObject("m_cpFilter.Visible")));
			// 
			// BaseContent
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.m_cpbMain);
			this.Controls.Add(this.m_pnlMain);
			this.Controls.Add(this.m_tbTop);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "BaseContent";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.TabText = resources.GetString("$this.TabText");
			this.Text = resources.GetString("$this.Text");
			this.ToolTipText = resources.GetString("$this.ToolTipText");
			((System.ComponentModel.ISupportInitialize)(this.m_cpbMain)).EndInit();
			this.m_cpbMain.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		private void m_actSave_Execute(object sender, EventArgs e)
		{
			Save();
		}

		private void m_actCancel_Execute(object sender, EventArgs e)
		{
			Cancel();
		}

		private void m_actReload_Execute(object sender, EventArgs e)
		{
			if (iKind != iExchange)
			{
				ParamsChanged(false);
			}
			else
			{
				string strParTun = htParams["Params_Tuning"].ToString();
				if(m_frmWindowEx != null && m_frmWindowEx.CurrentItem != null)
					UpdExch(Convert.ToInt32(m_frmWindowEx.CurrentItem[strParTun].ToString()));
				else if(htParams.ContainsKey(strParTun))
					UpdExch(Convert.ToInt32(htParams[strParTun].ToString()));
				else
					MessageBox.Show(ResourceControl.String62, ResourceControl.String63, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		public void Clear()
		{
			m_actSave.Enabled = false;
			m_actCancel.Enabled = false;
			m_actReload.Enabled = false;
			m_pnlMain.Controls.Clear();
			m_pnlMain.Visible = false;
			m_cpbMain.Visible = false;
			m_tbTop.Visible = false;
			if(m_pdMain != null)
			{
				m_pdMain.PropertyGrid.Parent.Controls.Clear();
				m_pdMain = null;
			}
		}

		//private Hashtable m_frmWindow_OnGridRefresh()
		//{
			//ParamsChanged(false);
			//return null;
		//}

		private void m_exBottom_AfterChangeSelected(bool bIsChange)
		{
			m_actSave.Enabled = true;
		}

	

		private void m_frmWindowEx_CurrentRowChanged(object sender, EventArgs e)
		{
			string strParTun = htParams["Params_Tuning"].ToString();
			if(m_frmWindowEx!=null)
				UpdExch(Convert.ToInt32(m_frmWindowEx.CurrentItem[strParTun].ToString()));

		}
	}
}
/********************* SniipSoftel *****************
 *
 *    $History: BaseContent.cs $
 *   
 *   *****************  Version 58  *****************
 *   User: Serg_ch      Date: 13.08.07   Time: 16:12
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 57  *****************
 *   User: Serg_ch      Date: 23.07.07   Time: 20:09
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 56  *****************
 *   User: Gavrilov     Date: 30.05.07   Time: 18:37
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 55  *****************
 *   User: Gavrilov     Date: 29.05.07   Time: 18:27
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 53  *****************
 *   User: Serg_ch      Date: 26.03.07   Time: 20:42
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 51  *****************
 *   User: Serg_ch      Date: 1.03.07    Time: 18:09
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 50  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 49  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 48  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *
 ********************* SniipSoftel *****************/
