/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 103 $
 *   $Date: 17.05.07 12:38 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Reflection;
using System.Windows.Forms;
using FirebirdSql.Data.Firebird;
using Softel.Application.BaseContent;
using Softel.Common;
using Softel.MiddleTier.Client;
using Softel.Windows.Forms.Interface;
using Convert=System.Convert;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Windows.Forms
{
	/// <summary>
	///   -  ::       
	/// .
	/// </summary>
	/// <example>
	/// 	<para>Hashtable htParams = new Hashtable;</para>
	/// 	<para>DockManager m_dmMain = new DockManager;</para>
	/// 	<para>int iTreeID = 3;</para>
	/// 	<para>BaseTree btExample = new BaseTree()</para>
	/// 	<para>btExample.Init(iTreeID, htParams, m_dmMain);</para>
	/// </example>
	public class BaseTree : UserControl
	{
		public event BaseTreeDataEventHandler OnProcessTreeNode;

		/// <summary>
		/// , 
		///    .     
		///      ::   .
		/// </summary>
		private const string STR_Top_node = "$top_node";

		/// <summary>
		///  ,    ,   
		/// .
		/// </summary>
		private const string STR_Top_node_rec = "$top_node_rec";

		/// <summary>,  .</summary>
		private TreeView m_tvMain;

		/// <summary>
		///  -      
		/// </summary>
		private Hashtable m_htNodeTransit;

		/// <summary>
		///  -     
		/// </summary>
		private Hashtable m_htNodeUpdate = new Hashtable();

		///
		private Hashtable m_htNodeOwn = new Hashtable();

		/// <summary>Selected item of the tree.</summary>
		private TreeNode m_tnSelected;

		private IContainer components;

		/// <summary>   .</summary>
		private DataTable m_dtTreeList;

		/// <summary>   .</summary>
		private TreeNode m_tnTop;

		/// <summary>-...</summary>
		private IDockManager m_dmMain;

		//		private Assembly m_asmPanel;
		private ImageList SoftelImageList;

		/// <summary>
		///  .      ,  
		/// .
		/// </summary>
		private ContextMenu m_cmPopUp;

		/*
				private GlobalImageList m_ilImages;
		*/

		/// <summary>, ,     .</summary>
		private bool m_bDontCreate;

		//		private int m_iNewLevel1;
		//		private int m_iNewLevel2;
		/// <summary>.</summary>
		private MenuItem m_miAdd;

		/// <summary>.</summary>
		private MenuItem m_miDelete;

		/// <summary>   .</summary>
		private int m_iTreeID;

		/// <summary>  .</summary>
		private int m_iNewLevel;

		//		private string m_strText;
		/// <summary> .</summary>
		private string m_strMasterName;

		/// <summary> .</summary>
		private Hashtable m_htArgs = new Hashtable();

		/// <summary>   .</summary>
		private CancelEventHandler cehQuit;
		private GlobalImageList m_gilMain;

		/// <summary>    image_id.</summary>
		public int GetImgIndex(DataRow drItem)
		{
			int iImgIndex = 3;
			try
			{
				if(!drItem["image_id"].Equals(null))
					iImgIndex = Convert.ToInt32(drItem["image_id"].ToString());
			}
			catch
			{
				iImgIndex = 3;
			}
			return iImgIndex;
		}

		public Hashtable Args
		{
			get { return m_htArgs; }
		}

		/// <summary>   .</summary>
		public int GetImg2Index(DataRow drItem)
		{
			int iImgIndex = 3;
			try
			{
				if(!drItem["desk"].Equals(null))
					iImgIndex = Convert.ToInt32(drItem["desk"].ToString());
			}
			catch
			{
				iImgIndex = 3;
			}
			return iImgIndex;
		}

		/// <summary> .</summary>
		public void InitParams(string MasterName)
		{
			m_strMasterName = MasterName;
		}

		/// <summary> .</summary>
		public void InitTree(int iTreeID, Hashtable htParams, IDockManager dmGlbl, Hashtable htNodeParams)

		{
			m_dmMain = dmGlbl;
			InitTree(iTreeID, htParams, htNodeParams);
		}

		/// <summary> .</summary>
		public void InitTree(int iTreeID, Hashtable htParams, IDockManager dmGlbl)

		{
			m_dmMain = dmGlbl;
			InitTree(iTreeID, htParams);
		}

		/// <summary> .</summary>
		public void InitTree(int iTreeID, Hashtable htParams)
		{
			Hashtable htNodeParams = null;
			InitTree(iTreeID, htParams, htNodeParams);
		}

		/// <summary> .</summary>
		public void InitTree(int iTreeID, Hashtable htParams, Hashtable htNodeParams)
		{
			m_iTreeID = iTreeID;
			m_htNodeTransit = htNodeParams;

			m_htArgs = htParams;
			m_bDontCreate = false;
			m_dtTreeList = GetFormsList.GetTree(iTreeID.ToString());
			NodeData ndTag = new NodeData();
			m_tvMain.Nodes.Clear();
			string strTopNode = "root";
			int iImgIndex = -1;
			Hashtable htAdPars = new Hashtable();
			//Searching top element	
			try
			{
				int i = 0;
				while(i <= m_dtTreeList.Rows.Count)
				{
					DataRow drItem = m_dtTreeList.Rows[i];
					if(drItem["desk"].ToString() == STR_Top_node)
					{
						if(drItem["SP"].ToString() != "" && drItem["SP"].ToString() != DBNull.Value.ToString())
						{
							Command cProc = new Command();
							cProc.CommandName = drItem["SP"].ToString();
							string[] strParams = drItem["Params"].ToString().Split('|');
							if(drItem["Params"].ToString() != DBNull.Value.ToString() && drItem["Params"].ToString() != "")
							{
								int iCount = strParams.Length;
								int iIndex = 0;
								while(iIndex < iCount)
								{
									string sParam = strParams[iIndex++];
									cProc.InputParams["@" + sParam] = htParams[sParam];
								}
							}
							cProc.Execute(true);
							DataTable dtRes = cProc.DataSet.Tables[0];
							if(dtRes.Rows.Count != 0)
							{
								DataRow drSub = dtRes.Rows[0];
								strTopNode = drSub[drItem["Field"].ToString()].ToString();
								htAdPars = ExtractParams(drItem, htParams);
								htAdPars["NoRefresh"] = true;
								iImgIndex = GetImgIndex(drItem);
								break;
							}
							else
							{
								m_tnSelected = null;
								UpdateAllWindows();
								return;
							}
						}
						else
						{
							strTopNode = drItem["caption"].ToString();
							iImgIndex = GetImgIndex(drItem);
							htAdPars = ExtractParams(drItem, htParams);
							break;
						}
					}
					else if(drItem["desk"].ToString() == STR_Top_node_rec)
					{
						strTopNode = drItem["caption"].ToString();
						htAdPars = ExtractParams(drItem, htParams);
						m_bDontCreate = true;
						break;
					}
					i += 1;
				}
			}
			catch
			{
				MessageBox.Show(ResourceControl.String3);
			}
			//Searching top element
			m_tvMain.BeginUpdate();

			if(m_bDontCreate)
				AddParamNodes(m_tvMain, htParams);
			else
			{
				m_tnTop = m_tvMain.Nodes.Add(strTopNode);
				ndTag.Params = htAdPars;
				m_tnTop.Tag = ndTag;
				m_tnTop.ImageIndex = iImgIndex;
				m_tnTop.SelectedImageIndex = iImgIndex;
				//m_tnTop.EnsureVisible();
				FastTransit(m_tnTop);
				AddParamNodes(m_tnTop, htParams);
			}

			m_tvMain.EndUpdate();
		}

		/// <summary>    .</summary>
		private void FastTransit(TreeNode tnCurrentNode)
		{
			if(m_htNodeOwn[tnCurrentNode.Text] == null)
				m_htNodeOwn.Add(tnCurrentNode.Text, "");

			if(m_htNodeTransit == null)
				return;
			//if (((NodeData) tnCurrentNode.Tag).Params.Count > 10)
			//	return;
			Boolean bFound = true;
			foreach(DictionaryEntry objEntry in  m_htNodeTransit)
			{
				if(((NodeData) tnCurrentNode.Tag).Params[objEntry.Key] == null)
				{
					bFound = false;
					break;
				}
				if(objEntry.Value.ToString() != ((NodeData) tnCurrentNode.Tag).Params[objEntry.Key].ToString())
				{
					bFound = false;
					break;
				}
			}
			if(bFound)
			{
				tnCurrentNode.Expand();
				m_htNodeTransit = null;
				tnCurrentNode.EnsureVisible();
				m_tvMain.SelectedNode = tnCurrentNode;
				m_tnSelected = m_tvMain.SelectedNode;
				//UpdateAllWindows();
			}
		}

		public BaseTree()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			this.m_gilMain = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_gilMain.ImageList = this.SoftelImageList;
			this.m_gilMain.Parent = this;

			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if(disposing)
			{
				if(components != null)
					components.Dispose();
			}
			base.Dispose(disposing);
		}

		private void TreeMainForm_Load(object sender, EventArgs e)
		{
			cehQuit = new CancelEventHandler(Quit);
			ParentForm.Closing += cehQuit;
		}

		/// <summary> .</summary>
		public void Quit(object sender, CancelEventArgs e)
		{
			if(m_tvMain.Nodes.Count != 0)
				CloseAllWindows(m_tvMain.Nodes[0]);
			if(ParentForm != null)
				ParentForm.Closing -= cehQuit;
		}

		/// <summary>  .</summary>
		public string[] SplitFields(string strSource)
		{
			return strSource.Split('|');
		}

		/// <summary>    .</summary>
		public Hashtable ReturnSplits(string strSource, Hashtable htSource)
		{
			string[] strParams = SplitFields(strSource);
			int iCount = strParams.Length;
			int iIndex = 0;
			Hashtable htReturn = new Hashtable();
			while(iIndex < iCount)
			{
				string strParam = strParams[iIndex++];
				htReturn["@" + strParam] = htSource[strParam];
			}
			return htReturn;
		}

		/// <summary>   .</summary>
		public void GroupItems(int iInCount, int iIn2Count, Hashtable htValues, int iIndex, string strNumvalue, TreeNode tnNeu)
		{
			int iInIndex = 0;
			NodeData objNodeData = new NodeData();
			TreeNode tnKid;

			while(iInIndex < iInCount)
			{
				DataRow drSSItem = m_dtTreeList.Rows[iIndex++];
				//if this item has parent declared in SP it will be added to it
				if(drSSItem["parent_node_id"].ToString() == strNumvalue)
				{
					tnKid = new TreeNode();
					tnKid.Text = drSSItem["caption"].ToString();
					tnKid.ImageIndex = GetImgIndex(drSSItem);
					tnKid.SelectedImageIndex = GetImgIndex(drSSItem);
					objNodeData.AssemblyName = drSSItem["assembly_name"].ToString();
					objNodeData.ClassName = drSSItem["class_name"].ToString();
					objNodeData.Params = ExtractParams(drSSItem, htValues);
					if(drSSItem["SP"].ToString() != "")
						objNodeData.Params["NoRefresh"] = true;
					tnKid.Tag = objNodeData;
					tnNeu.Nodes.Add(tnKid);
					FastTransit(tnKid);
					iIn2Count = m_dtTreeList.Rows.Count;
					//Like in Previous type, but subitems
					GroupItems(iIn2Count, iIn2Count, htValues, iIndex, strNumvalue, tnNeu);
					//Recursive sending this procedure
					if(drSSItem["SP"].ToString() != "")
					{
						AddToTree(
							tnKid,
							drSSItem["field"].ToString(),
							drSSItem["SP"].ToString(),
							drSSItem["Params"].ToString(),
							htValues,
							drSSItem["node_id"].ToString(),
							GetImg2Index(drSSItem),
							drSSItem["assembly_name"].ToString(),
							drSSItem["class_name"].ToString(),
							drSSItem["TypeInterface"]);
					}
				}
			}
		}

		/// <summary>   .</summary>
		/// <param name="tnTps">Node-Parent</param>
		/// <param name="strSP">Stored Procedure</param>
		/// <param name="strParametrs">SP Params</param>
		/// <param name="htValues">SP Values</param>
		/// <param name="str_numvalue">Parent_ID</param>
		/// <param name="iImgIndex">Icon Image</param>
		private void AddToTree(
			TreeNode tnTps,
			string strField,
			string strSP,
			string strParametrs,
			Hashtable htValues,
			string str_numvalue,
			int iImgIndex,
			string strAssemblyName,
			string strClassName,
			object iTypeInterface)
		{
			NodeData objNodeData = new NodeData();
			string[] strParams = strParametrs.Split('|');
			string[] strFields = strField.Split('|');
			TreeNode tnNeu, tnKid, tnKid2;
			DataTable dtResult,dtResultSPNext;
			Command cProc = new Command();
			cProc.CommandName = strSP;
			int iCount = 0;
			int iIndex = 0;
			//Split Params
			if(strParametrs != DBNull.Value.ToString() && strParametrs != "")
			{
				iCount = strParams.Length;
				iIndex = 0;
				while(iIndex < iCount)
				{
					string strParam = strParams[iIndex++];
					string[] strPar = strParam.Split('=');
					if(strPar.Length==1)
						cProc.InputParams["@" + strParam] = htValues[strParam];
					else
                        cProc.InputParams["@" + strPar[0]] = strPar[1];
				}
			}
			cProc.Execute(true);
			dtResult = cProc.DataSet.Tables[0];
			//Prepare to built tree
			//iCount = strParams.Length;
			iCount = dtResult.Rows.Count;
			iIndex = 0;
			int iInCount = 0;
			int iInIndex = 0;
			int iIn2Count = 0;
			int iIn2Index = 0;
			//Built tree using SP DataSet
			while(iIndex < iCount)
			{
				Hashtable htCopyValues = new Hashtable(htValues);
				DataRow drSubItem = dtResult.Rows[iIndex++];
				//Getting DataRow and creating new Node
				tnNeu = new TreeNode();
				tnNeu.Text = drSubItem[strFields[0]].ToString();
				tnNeu.ImageIndex = iImgIndex;
				tnNeu.SelectedImageIndex = GetImgIndex(drSubItem);
				iInCount = strFields.Length;
				iInIndex = 0;
				//Split Fields
				while(iInIndex < iInCount)
				{
					string strEvF = strFields[iInIndex++];
					if(strEvF != "")
						htCopyValues[strEvF] = drSubItem[strEvF];
				}
				htCopyValues["Wizard"] = ((NodeData) tnTps.Tag).Params["Wizard"];
				htCopyValues["WizardFields"] = ((NodeData) tnTps.Tag).Params["WizardFields"];
				NodeData ndTag = new NodeData();
				if(iTypeInterface != DBNull.Value && (int) iTypeInterface == 14)
				{
					htCopyValues["TypeInterface"] = 8;
					ndTag.AssemblyName = strAssemblyName;
					ndTag.ClassName = strClassName;
				}

				ndTag.Params = htCopyValues;
				tnNeu.Tag = ndTag;
				tnTps.Nodes.Add(tnNeu);
				//Ensure Visiblity
				FastTransit(tnNeu);
				/*
				if(m_strMasterName != DBNull.Value.ToString() && m_strMasterName != null && m_strMasterName != "")
				{
					if(htCopyValues.ContainsKey(m_strMasterName) && htCopyValues[m_strMasterName].ToString() == m_iNewLevel.ToString())
						tnNeu.EnsureVisible();
				}
				*/
				iInCount = m_dtTreeList.Rows.Count;
				iInIndex = 0;
				//Watch all items in DataTable of "TreeNode" to add those items to "tnNeu" (each 
				//group to this item)
				while(iInIndex < iInCount)
				{
					DataRow drSSItem = m_dtTreeList.Rows[iInIndex++];
					//if this item has parent declared in SP it will be added to it
					if(drSSItem["parent_node_id"].ToString() == str_numvalue)
					{
						tnKid = new TreeNode();
						tnKid.Text = drSSItem["caption"].ToString();
						tnKid.ImageIndex = GetImgIndex(drSSItem);
						tnKid.SelectedImageIndex = GetImgIndex(drSSItem);
						objNodeData.AssemblyName = drSSItem["assembly_name"].ToString();
						objNodeData.ClassName = drSSItem["class_name"].ToString();
						objNodeData.Params = ExtractParams(drSSItem, htCopyValues);
						if(drSSItem["SP"].ToString() != "")
							objNodeData.Params["NoRefresh"] = true;
						tnKid.Tag = objNodeData;
						tnNeu.Nodes.Add(tnKid);
						FastTransit(tnKid);
						iIn2Count = m_dtTreeList.Rows.Count;
						iIn2Index = 0;
						//Like in Previous type, but subitems
						String strSP2=drSSItem["SP"].ToString();
						String strSP3=drSSItem["SP_Next"].ToString();
						if(strSP2==null || strSP2=="")
						{
							if(strSP3 != "")
							
								AddNodesByCondition(drSSItem["SP_Next_Params"].ToString(), strSP3, objNodeData, tnKid,
								                    htCopyValues);
								

							


							else
							{
								while(iIn2Index < iIn2Count)
								{
									DataRow drAdItem = m_dtTreeList.Rows[iIn2Index++];
							
									if(drAdItem["parent_node_id"].ToString() == drSSItem["node_id"].ToString())
							
										//   (drSSItem["Class_name"].ToString() != ""))
									{
										tnKid2 = new TreeNode();
										tnKid2.Text = drAdItem["caption"].ToString();
										objNodeData.AssemblyName = (drAdItem["assembly_name"].ToString());
										objNodeData.ClassName = drAdItem["Class_name"].ToString();
										objNodeData.Params = ExtractParams(drAdItem, htCopyValues);
										tnKid2.Tag = objNodeData;
										tnKid2.ImageIndex = GetImgIndex(drAdItem);
										tnKid2.SelectedImageIndex = GetImgIndex(drAdItem);
										tnKid.Nodes.Add(tnKid2);
										FastTransit(tnKid2);
										//Recursive sending this procedure
										if(drAdItem["SP"].ToString() != "")
										{
											AddToTree(
												tnKid2,
												drAdItem["field"].ToString(),
												drAdItem["SP"].ToString(),
												drAdItem["Params"].ToString(),
												htCopyValues,
												drAdItem["node_id"].ToString(),
												GetImg2Index(drAdItem),
												objNodeData.AssemblyName,
												objNodeData.ClassName,
												0);
										}
									}
								}
							}
							//Recursive sending this procedure
							if(drSSItem["SP"].ToString() != "")
							{
								AddToTree(
									tnKid,
									drSSItem["field"].ToString(),
									drSSItem["SP"].ToString(),
									drSSItem["Params"].ToString(),
									htCopyValues,
									drSSItem["node_id"].ToString(),
									GetImg2Index(drSSItem),
									strAssemblyName,
									strClassName,
									0);
							}
						}
					}
				}
			}
		}

		/// <summary>    .</summary>
		private Hashtable ExtractParams(DataRow drItem, Hashtable htWas)
		{
			Hashtable htArguments = new Hashtable();
			try
			{
				htArguments["node_id"] = drItem["node_id"];
				htArguments["SP_PG"] = drItem["SP_PG"];
				htArguments["Field_PG"] = drItem["Field_PG"];
				htArguments["Params_PG"] = drItem["Params_PG"];
				htArguments["SP_Tuning"] = drItem["SP_Tuning"];
				htArguments["Field_Tuning"] = drItem["Field_Tuning"];
				htArguments["Params_Tuning"] = drItem["Params_Tuning"];
				htArguments["tuning"] = drItem["GridTuning"];
				htArguments["TypeInterface"] = drItem["TypeInterface"];
				htArguments["GridParams"] = drItem["GridParams"];
				htArguments["ParamName"] = drItem["ParamName"];
				htArguments["ParamCaption"] = drItem["Paramcaption"];
				htArguments["ParamType"] = drItem["ParamType"];
				htArguments["GridStyleSP"] = drItem["GridStyleSP"];
				htArguments["GridStyleParam"] = drItem["GridStyleParam"];
				htArguments["Wizard"] = drItem["Wizard"];
				htArguments["WizardFields"] = drItem["WizardFields"];
				htArguments["TopLeft"] = drItem["TopLeft"];
				htArguments["Ins_Proc"] = drItem["Ins_Proc"];
				htArguments["Ins_Params"] = drItem["Ins_Params"];
				htArguments["Del_Proc"] = drItem["Del_Proc"];
				htArguments["Del_Params"] = drItem["Del_Params"];
				if(!drItem["billing_type_id"].Equals(DBNull.Value) && !drItem["billing_type_id"].Equals(""))
					htArguments["billing_type"] = drItem["billing_type_id"];
				else
					htArguments["billing_type"] = 0;
				foreach(string strItem in htWas.Keys)
				{
					if(strItem != "Wizard" && strItem != "WizardFields")
						htArguments[strItem] = htWas[strItem];
				}
			}
			catch
			{
				MessageBox.Show(ResourceControl.String4);
			}
			return htArguments;
		}

		//Adding ParamNodes to top element
		/// <summary> .</summary>
		private void AddParamNodes(TreeNode tnParam, Hashtable htParams)
		{
			TreeNode tnNew, tnKid2;
			NodeData objNodeData = new NodeData();
			int iInCount = 0;
			int iInIndex = 0;
			int iCount = m_dtTreeList.Rows.Count;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				DataRow drItem = m_dtTreeList.Rows[iIndex++];
				String strTest=drItem["caption"].ToString();
				if(drItem["parent_node_id"].Equals(0) && !drItem["desk"].Equals(STR_Top_node))
				{
					tnNew = new TreeNode();
					tnNew.Text = drItem["caption"].ToString();
					objNodeData.AssemblyName = (drItem["assembly_name"].ToString());
					objNodeData.ClassName = drItem["class_name"].ToString();
					objNodeData.Params = ExtractParams(drItem, htParams);
					if(drItem["SP"].ToString() != "")
						objNodeData.Params["NoRefresh"] = true;
					tnNew.Tag = objNodeData;
					tnNew.ImageIndex = GetImgIndex(drItem);
					tnNew.SelectedImageIndex = GetImgIndex(drItem);
					tnParam.Nodes.Add(tnNew);
					FastTransit(tnNew);
					if(drItem["SP"].ToString() != "")
					{
						AddToTree(
							tnNew,
							drItem["field"].ToString(),
							drItem["SP"].ToString(),
							drItem["Params"].ToString(),
							htParams,
							drItem["node_id"].ToString(),
							GetImg2Index(drItem),
							drItem["assembly_name"].ToString(),
							drItem["class_name"].ToString(),
							drItem["TypeInterface"]);
					}
					else
					{
						iInCount = m_dtTreeList.Rows.Count;
						iInIndex = 0;
						while(iInIndex < iInCount)
						{
							DataRow drAdItem = m_dtTreeList.Rows[iInIndex++];

							if(drAdItem["parent_node_id"].ToString() == drItem["node_id"].ToString())
							{
								tnKid2 = new TreeNode();
								tnKid2.Text = drAdItem["caption"].ToString();
								tnKid2.ImageIndex = GetImgIndex(drAdItem);
								tnKid2.SelectedImageIndex = GetImgIndex(drAdItem);
								objNodeData.Params = ExtractParams(drAdItem, htParams);
								objNodeData.AssemblyName = (drAdItem["assembly_name"].ToString());
								objNodeData.ClassName = drAdItem["class_name"].ToString();
								tnKid2.Tag = objNodeData;
								tnNew.Nodes.Add(tnKid2);
								FastTransit(tnKid2);
							}
						}
					}
				}
			}
		}

		//Adding ParamNodes to TreeView, but not to TreeNode
		/// <summary> .</summary>
		private void AddParamNodes(TreeView tnParam, Hashtable htParams)
		{
			TreeNode tnNew, tnKid2;
			NodeData objNodeData = new NodeData();
			int iInCount = 0;
			int iInIndex = 0;
			int iCount = m_dtTreeList.Rows.Count;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				DataRow drItem = m_dtTreeList.Rows[iIndex++];
				String strTest=drItem["caption"].ToString();
				if(drItem["parent_node_id"].Equals(0) && !drItem["desk"].Equals(STR_Top_node))
				{
					tnNew = new TreeNode();
					tnNew.Text = drItem["caption"].ToString();
					objNodeData.AssemblyName = (drItem["assembly_name"].ToString());
					objNodeData.ClassName = drItem["class_name"].ToString();
					objNodeData.Params = ExtractParams(drItem, htParams);
					if(drItem["SP"].ToString() != "")
						objNodeData.Params["NoRefresh"] = true;
					tnNew.Tag = objNodeData;
					tnNew.ImageIndex = GetImgIndex(drItem);
					tnNew.SelectedImageIndex = GetImgIndex(drItem);
					tnParam.Nodes.Add(tnNew);
					FastTransit(tnNew);
					if(drItem["SP"].ToString() != "")
					{
						AddToTree(
							tnNew,
							drItem["field"].ToString(),
							drItem["SP"].ToString(),
							drItem["Params"].ToString(),
							htParams,
							drItem["node_id"].ToString(),
							GetImg2Index(drItem),
							drItem["assembly_name"].ToString(),
							drItem["class_name"].ToString(),
							drItem["TypeInterface"]);
					}
					else
					{
						iInCount = m_dtTreeList.Rows.Count;
						iInIndex = 0;
						while(iInIndex < iInCount)
						{
							DataRow drAdItem = m_dtTreeList.Rows[iInIndex++];
							if(drAdItem["parent_node_id"].ToString() == drItem["node_id"].ToString())
							{
								tnKid2 = new TreeNode();
								tnKid2.Text = drAdItem["caption"].ToString();
								tnKid2.ImageIndex = GetImgIndex(drAdItem);
								tnKid2.SelectedImageIndex = GetImgIndex(drAdItem);
								objNodeData.AssemblyName = (drAdItem["assembly_name"].ToString());
								objNodeData.ClassName = drAdItem["class_name"].ToString();
								objNodeData.Params = ExtractParams(drAdItem, htParams);
								tnKid2.Tag = objNodeData;
								tnNew.Nodes.Add(tnKid2);
								FastTransit(tnKid2);
							}
						}
					}
				}
			}
		}
	private void AddNodesByCondition(string strNextParams , string strSPNext,NodeData objNodeData,TreeNode tnKid,
		Hashtable htCopyValues)
	{
		Command cProcNext = new Command();
								
		if(strNextParams != "")
		{
			string[] strParams=strNextParams.ToString().Split('|');
			int iCount = strParams.Length;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				string strParam = strParams[iIndex++];
				cProcNext.InputParams["@" + strParam] = objNodeData.Params[strParam];
			}
		}
		cProcNext.CommandName = strSPNext;
		cProcNext.Execute(true);
		DataTable dtResultSPNext = cProcNext.DataSet.Tables[0];
		int iIn2Count = dtResultSPNext.Rows.Count;
		int iIn2Index = 0;
		while(iIn2Index < iIn2Count)
		{
			DataRow drAdItem = dtResultSPNext.Rows[iIn2Index++];
			TreeNode tnKid2 = new TreeNode();
			tnKid2.Text = drAdItem["caption"].ToString();
			objNodeData.AssemblyName = (drAdItem["assembly_name"].ToString());
			objNodeData.ClassName = drAdItem["Class_name"].ToString();
			objNodeData.Params = ExtractParams(drAdItem, htCopyValues);
			tnKid2.Tag = objNodeData;
			tnKid2.ImageIndex = GetImgIndex(drAdItem);
			tnKid2.SelectedImageIndex = GetImgIndex(drAdItem);
			tnKid.Nodes.Add(tnKid2);
			FastTransit(tnKid2);
			//Recursive sending this procedure
			if(drAdItem["SP"].ToString() != "")
			{
				AddToTree(
					tnKid2,
					drAdItem["field"].ToString(),
					drAdItem["SP"].ToString(),
					drAdItem["Params"].ToString(),
					htCopyValues,
					drAdItem["node_id"].ToString(),
					GetImg2Index(drAdItem),
					objNodeData.AssemblyName,
					objNodeData.ClassName,
					0);
			}
		}
	}
		/// <summary> .</summary>
		public static DataTable GetList(string list_filter)
		{
			DataTable dtResult;
			Command cProc = new Command();
			cProc.CommandName = "GetSubsystemsAssemblies";
			cProc.InputParams["@relation"] = list_filter;
			cProc.Execute(true);
			dtResult = cProc.DataSet.Tables[0];
			return dtResult;
		}

		#region Component Designer generated code

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(BaseTree));
			this.m_tvMain = new System.Windows.Forms.TreeView();
			this.SoftelImageList = new System.Windows.Forms.ImageList(this.components);
			this.m_cmPopUp = new System.Windows.Forms.ContextMenu();
			this.m_miAdd = new System.Windows.Forms.MenuItem();
			this.m_miDelete = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// m_tvMain
			// 
			this.m_tvMain.AccessibleDescription = resources.GetString("m_tvMain.AccessibleDescription");
			this.m_tvMain.AccessibleName = resources.GetString("m_tvMain.AccessibleName");
			this.m_tvMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tvMain.Anchor")));
			this.m_tvMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tvMain.BackgroundImage")));
			this.m_tvMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tvMain.Dock")));
			this.m_tvMain.Enabled = ((bool)(resources.GetObject("m_tvMain.Enabled")));
			this.m_tvMain.Font = ((System.Drawing.Font)(resources.GetObject("m_tvMain.Font")));
			this.m_tvMain.FullRowSelect = true;
			this.m_tvMain.HideSelection = false;
			this.m_tvMain.HotTracking = true;
			this.m_tvMain.ImageIndex = ((int)(resources.GetObject("m_tvMain.ImageIndex")));
			this.m_tvMain.ImageList = this.SoftelImageList;
			this.m_tvMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tvMain.ImeMode")));
			this.m_tvMain.Indent = ((int)(resources.GetObject("m_tvMain.Indent")));
			this.m_tvMain.ItemHeight = ((int)(resources.GetObject("m_tvMain.ItemHeight")));
			this.m_tvMain.Location = ((System.Drawing.Point)(resources.GetObject("m_tvMain.Location")));
			this.m_tvMain.Name = "m_tvMain";
			this.m_tvMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tvMain.RightToLeft")));
			this.m_tvMain.SelectedImageIndex = ((int)(resources.GetObject("m_tvMain.SelectedImageIndex")));
			this.m_tvMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tvMain.Size")));
			this.m_tvMain.TabIndex = ((int)(resources.GetObject("m_tvMain.TabIndex")));
			this.m_tvMain.Text = resources.GetString("m_tvMain.Text");
			this.m_tvMain.Visible = ((bool)(resources.GetObject("m_tvMain.Visible")));
			this.m_tvMain.MouseDown += new System.Windows.Forms.MouseEventHandler(this.m_tvMain_MouseDown);
			this.m_tvMain.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.m_tvMain_AfterSelect);
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageSize = ((System.Drawing.Size)(resources.GetObject("SoftelImageList.ImageSize")));
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			this.SoftelImageList.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// m_cmPopUp
			// 
			this.m_cmPopUp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.m_miAdd,
																					  this.m_miDelete});
			this.m_cmPopUp.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmPopUp.RightToLeft")));
			// 
			// m_miAdd
			// 
			this.m_miAdd.Enabled = ((bool)(resources.GetObject("m_miAdd.Enabled")));
			this.m_miAdd.Index = 0;
			this.m_miAdd.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miAdd.Shortcut")));
			this.m_miAdd.ShowShortcut = ((bool)(resources.GetObject("m_miAdd.ShowShortcut")));
			this.m_miAdd.Text = resources.GetString("m_miAdd.Text");
			this.m_miAdd.Visible = ((bool)(resources.GetObject("m_miAdd.Visible")));
			this.m_miAdd.Click += new System.EventHandler(this.AddNewItem);
			// 
			// m_miDelete
			// 
			this.m_miDelete.Enabled = ((bool)(resources.GetObject("m_miDelete.Enabled")));
			this.m_miDelete.Index = 1;
			this.m_miDelete.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDelete.Shortcut")));
			this.m_miDelete.ShowShortcut = ((bool)(resources.GetObject("m_miDelete.ShowShortcut")));
			this.m_miDelete.Text = resources.GetString("m_miDelete.Text");
			this.m_miDelete.Visible = ((bool)(resources.GetObject("m_miDelete.Visible")));
			// 
			// BaseTree
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.Controls.Add(this.m_tvMain);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Name = "BaseTree";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.Size = ((System.Drawing.Size)(resources.GetObject("$this.Size")));
			this.Load += new System.EventHandler(this.TreeMainForm_Load);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>    .</summary>
		private void m_tvMain_AfterSelect(object sender, TreeViewEventArgs e)
		{
//			m_tnSelected = e.Node;
//			if(e.Node.Tag != null)
//			{
//				NodeData objTag = (NodeData) e.Node.Tag;
//				OpenWindow(objTag);
//				if(!objTag.Params.ContainsKey("NoRefresh"))
//					UpdateAllWindows();
//			}
		}

		/// <summary>      .</summary>
		private void CloseAllWindows(TreeNode tnDelNode)
		{
			if(tnDelNode == null)
				return;
			if(tnDelNode.Nodes == null || tnDelNode.Nodes.Count == 0)
				return;
			TreeNode tnCurrent = new TreeNode();
			int iMaxX = m_dmMain.Contents.Count;
			if(iMaxX == 0)
				return;
			int iIndX = 0;
			int iMax = tnDelNode.Nodes.Count;
			int iInd = 0;
			while(iInd < iMax)
			{
				tnCurrent = tnDelNode.Nodes[iInd];
				iIndX = 0;
				iMaxX = m_dmMain.Contents.Count;
				if(iMaxX == 0)
					return;
				while(iIndX < iMaxX)
				{
					if(m_dmMain.Contents[iIndX].TabText == tnCurrent.Text)
					{
						m_dmMain.Contents[iIndX].Close();
						break;
					}
					iIndX += 1;
				}
				CloseAllWindows(tnCurrent);
				iInd += 1;
			}
		}

		/// <summary>        .</summary>
		public void UpdateAllWindows()
		{
			TreeNode tnCurrent;
			tnCurrent = m_tnSelected;

			m_htNodeUpdate.Clear();
			int iMaxX = m_dmMain.Contents.Count;
			int iIndX = 0;
			iIndX = 0;
			while(iIndX < iMaxX)
			{
				if(m_dmMain.Contents[iIndX] is ITreeBaseForm)
				{
					if(m_htNodeOwn[m_dmMain.Contents[iIndX].TabText] != null)
					{
						if(tnCurrent == null)
						{
							if(m_dmMain.Contents[iIndX] is BaseContent)
								((BaseContent) m_dmMain.Contents[iIndX]).Clear();
							else
							{
								((ITreeBaseForm) m_dmMain.Contents[iIndX]).InitParams(null);
								((ITreeBaseForm) m_dmMain.Contents[iIndX]).Reload();
							}
						}
						else
							m_htNodeUpdate[m_dmMain.Contents[iIndX].TabText] = m_dmMain.Contents[iIndX];
					}
				}

				iIndX += 1;
			}
			if(tnCurrent == null)
				return;

			if(tnCurrent.Nodes == null || tnCurrent.Nodes.Count == 0)
				return;

			UpdateAllWindows(tnCurrent);
		}

		/// <summary>     .</summary>
		public void UpdateAllWindows(TreeNode tnSelected)
		{
			if(tnSelected.Nodes == null || tnSelected.Nodes.Count == 0 || m_htNodeUpdate.Keys.Count == 0)
				return;
			TreeNode tnCurrent = new TreeNode();
			int iMax = tnSelected.Nodes.Count;
			int iInd = 0;
			int iIndex = 0;
			int iCount = 0;
			ArrayList alRemove = new ArrayList();
			Hashtable htParams = new Hashtable();

			while(iInd < iMax)
			{
				tnCurrent = tnSelected.Nodes[iInd];
				htParams = ((NodeData) tnCurrent.Tag).Params;
				alRemove.Clear();
				foreach(DictionaryEntry deContent in m_htNodeUpdate)
				{
					if(deContent.Key.ToString() == tnCurrent.Text)
					{
						Content frmContent = (Content) deContent.Value;
						frmContent.Tag = tnCurrent.Tag;
						if(htParams.ContainsKey("NoRefresh"))
							((ITreeBaseForm) frmContent).InitParams(null);
						else
							((ITreeBaseForm) frmContent).InitParams(htParams);
						((ITreeBaseForm) frmContent).Reload();
						frmContent.Refresh();
						alRemove.Add(tnCurrent.Text);
						break;
					}
				}
				iCount = alRemove.Count;
				while(iIndex < iCount)
					m_htNodeUpdate.Remove(alRemove[iIndex++]);

				UpdateAllWindows(tnCurrent);
				iInd += 1;
			}
		}

		/// <summary>     .</summary>
		private void OpenWindow(NodeData objNodeData)
		{
			if(objNodeData.Params.ContainsKey("TypeInterface"))
			{
				if(objNodeData.Params["TypeInterface"].ToString() != "" &&
				   objNodeData.Params["TypeInterface"].ToString() != DBNull.Value.ToString())
				{
					Hashtable htParams = new Hashtable();
					htParams = objNodeData.Params;
					IDockContent frmDockPanel = null;
					bool bExist = false;
					try
					{
						int iInCount = 0;
						int iInIndex = 0;
						int iCount = m_dmMain.Contents.Count;
						int iIndex = 0;
						while(iIndex < iCount)
						{
							IDockContent frmCurrent = m_dmMain.Contents[iIndex];
							if(ExistsContent(frmCurrent, htParams))
							{
								frmDockPanel = frmCurrent;
								bExist = true;
								break;
							} // if
							iIndex++;
						}
						if(!bExist)
						{
							if(htParams["TypeInterface"].Equals(8) || htParams["TypeInterface"].Equals(16))
							{
								if(objNodeData.AssemblyName != "" && objNodeData.ClassName != "")
								{
									try
									{
										Assembly asmPanel;
//#if TEST_ASSEMBLY
										asmPanel = Assembly.Load(objNodeData.AssemblyName);
//#else
//										FbConnection fbConnection = (FbConnection) Thread.GetData(Thread.GetNamedDataSlot("FbConnection"));
//										asmPanel = LoadAssembly(fbConnection, objNodeData.AssemblyName, "iv");
//#endif
										if(asmPanel != null)
										{
											Type[] typeAsm = asmPanel.GetTypes();
											iInCount = typeAsm.Length;
											iInIndex = 0;
											while(iInIndex < iInCount)
											{
												Type t = typeAsm[iInIndex++];

												if(t.ToString() == objNodeData.ClassName)
												{
													ITreeBaseForm objDockPanel =
														(ITreeBaseForm) t.InvokeMember(objNodeData.ClassName, BindingFlags.CreateInstance, null, null, null);
													objDockPanel.InitParams(htParams);
//													objDockPanel.Reload();
													if(htParams["TypeInterface"].Equals(8))
													{
														frmDockPanel = (Content) objDockPanel;
														frmDockPanel.Tag = objNodeData;
														frmDockPanel.TabText = m_tnSelected.Text;
														frmDockPanel.Text = m_tnSelected.Text;
														frmDockPanel.Show(m_dmMain);
													}
												}
											}
										}
									}
									catch(Exception excTree)
									{
//										Logger.Instance.Message(LogEventTypes.Error, 0, excTree.ToString());
										MessageBox.Show(
											ResourceControl.String5, ResourceControl.Error1, MessageBoxButtons.OK, MessageBoxIcon.Error, excTree.ToString());
									}
								}
							}
//							else if (htParams["TypeInterface"].Equals(9))
//							{
//								try
//								{
//									BaseGridParam frmWind = new
//										BaseGridParam();
//									frmWind.InitParams(htParams);
//									frmWind.Reload();
//									frmWind.Text = m_tnSelected.Text;
//									frmWind.TabText = m_tnSelected.Text;
//									frmWind.Tag = objNodeData;
//									frmWind.Show(m_dmMain);
//								}
//								catch
//								{
//									MessageBox.Show("Internal system error!");
//								}
//							}
							else
							{
								try
								{
									if(!htParams["TypeInterface"].Equals(14))
									{
										BaseContent frmWindow = new BaseContent();
										frmWindow.Tag = objNodeData;
										frmWindow.m_dmMain = m_dmMain;
										frmWindow.Caption = m_tnSelected.Text;
										frmWindow.Text = m_tnSelected.Text;
										frmWindow.TabText = m_tnSelected.Text;

										frmWindow.InitParams(htParams);
										frmWindow.Reload();
										frmWindow.Show(m_dmMain);
									}
								}
								catch(Exception excReload)
								{
									MessageBox.Show(
										ResourceControl.String6, ResourceControl.Error1, MessageBoxButtons.OK, MessageBoxIcon.Error, excReload.ToString());
								}
							}
						}
						else if(frmDockPanel.Tag != null)
						{
							if(m_dmMain.ActiveDocumentPane.Contents.Contains(frmDockPanel))
							{
								if(!frmDockPanel.IsFloat)
									m_dmMain.ActiveDocumentPane.ActiveContent = frmDockPanel;
								else
									frmDockPanel.Activate();
							}
						} // else
					} // try
					catch(Exception excReload)
					{
						MessageBox.Show(
							ResourceControl.String7, ResourceControl.Error1, MessageBoxButtons.OK, MessageBoxIcon.Error, excReload.ToString());
					} // catch (Exception)
				}
			}
		}

/*
		/// <summary> .</summary>
		private Assembly LoadAssembly(FbConnection fbConnection, string strAsmName, string culture)
		{
			Assembly objAssembly = null;
			Assembly[] asmsDomain = AppDomain.CurrentDomain.GetAssemblies();
			int iCount = asmsDomain.Length;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				Assembly objCurrentAssembly = asmsDomain[iIndex++];

				if(strAsmName == objCurrentAssembly.FullName)
				{
					objAssembly = objCurrentAssembly;
					break;
				}
			}
			if(objAssembly == null)
			{
				SSP sspAsm = new SSP();
				sspAsm.DatabaseType = AdoDbType.FireBird;
				sspAsm.Connection = fbConnection;
				sspAsm.ParamsRange["@ASMNAME"] = strAsmName;
				sspAsm.ParamsRange["@CULTURE"] = culture;
				sspAsm.ParamsRange["@VERSION"] = null;
				sspAsm.Execute("asm_getAsm");
				if(sspAsm.DataSet != null && sspAsm.DataSet.Tables.Count > 0 && sspAsm.DataSet.Tables[0].Rows.Count > 0)
				{
					if(sspAsm.DataSet.Tables[0].Rows[0]["Data"] != DBNull.Value)
						objAssembly = AppDomain.CurrentDomain.Load((byte[]) sspAsm.DataSet.Tables[0].Rows[0]["Data"]);
				}
			}
			return objAssembly;
		}
*/

		/// <summary> -        .</summary>
		private bool ExistsContent(IDockContent frmCurrent, Hashtable htArgs)
		{
			if(frmCurrent.TabText == m_tnSelected.Text)
			{
				NodeData ndFrm = new NodeData();
				Hashtable htAtForm = ((ITreeBaseForm) frmCurrent).GetInitParams();

				bool bReload = true;
				foreach(object objKey in  htArgs.Keys)
				{
					string strKey = Convert.ToString(objKey);
					if(htAtForm == null)
						bReload = false;
					else if(htAtForm[strKey] == null)
						bReload = false;
					else if(htAtForm[strKey] != htArgs[strKey])
						bReload = false;
				}

				bReload = !bReload;

				//bReload = (htArgs != htAtForm);
				if(bReload)
				{
					((ITreeBaseForm) frmCurrent).InitParams(htArgs);
					//Make reload if it is not grid
					if(Convert.ToInt32(htArgs["TypeInterface"].ToString()) > 0 || Convert.ToInt32(htArgs["TypeInterface"].ToString()) > 6)
						((ITreeBaseForm) frmCurrent).Reload();
					//Update params in current Form
					ndFrm.Params = htArgs;
					frmCurrent.Tag = ndFrm;
				}
				return true;
			}
			return false;
		}

		/// <summary>  .</summary>
		private void m_tvMain_MouseDown(object sender, MouseEventArgs e)
		{
			m_tnSelected = m_tvMain.GetNodeAt(e.X, e.Y);
			if(m_tnSelected != null && m_tnSelected.Tag != null)
			{
				m_tvMain.SelectedNode = m_tnSelected;
				NodeData objTag = (NodeData) m_tnSelected.Tag;
				if(e.Button == MouseButtons.Left)
				{
					if(objTag.Params.ContainsKey("TypeInterface") && objTag.Params["TypeInterface"].ToString() != DBNull.Value.ToString())
						OpenWindow(objTag);

//					m_tnSelected = e.Node;
//					if(e.Node.Tag != null)
//					{
//						NodeData objTag = (NodeData) e.Node.Tag;
//					OpenWindow(objTag);
					if(!objTag.Params.ContainsKey("NoRefresh"))
						UpdateAllWindows();
//					}
				}
				if(OnProcessTreeNode != null)
					OnProcessTreeNode(this, objTag);
			}
			else
			{
				NodeData objTag = new NodeData();
				if(OnProcessTreeNode != null)
					OnProcessTreeNode(this, objTag);
			}
		}

		/// <summary>   .</summary>
		private void AddNewItem(object sender, EventArgs e)
		{
			try
			{
				string strIndex = ((NodeData) m_tnSelected.Tag).Params["WizardFields"].ToString();
				m_strMasterName = strIndex;
				m_iNewLevel = Convert.ToInt32(((NodeData) m_tnSelected.Tag).Params[strIndex].ToString());
			}
			catch
			{
			}
			string strWizard;
			if(m_tvMain.Nodes.Count == 0)
				strWizard = m_strMasterName;
			else
				strWizard = ((NodeData) m_tnSelected.Tag).Params["Wizard"].ToString();

			using(SoftelWizard frmAccountWizard = new SoftelWizard(strWizard))
			{
				frmAccountWizard.OnAddParamsDialog += new SoftelWizardDataEventHandler(Wizard_OnAddParamsDialog);
				frmAccountWizard.Text += m_iNewLevel.ToString();
				frmAccountWizard.ShowDialog();
				//int iNewClient=frmAccountWizard.NextAction;
				if(frmAccountWizard.NextAction != -1)
					InitTree(m_iTreeID, m_htArgs);
			}
		}

		/// <summary>  .</summary>
		private DataTable Wizard_OnAddParamsDialog(SoftelWizard pdSender, DataTable arg)
		{
			int iCount = arg.Rows.Count;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				DataRow dr = arg.Rows[iIndex++];
				if(dr["field"] != DBNull.Value && dr["field"].ToString() == m_strMasterName)
					dr["defaultvalue"] = m_iNewLevel;
			}
			return arg;
		}

		/// <summary>  .</summary>
		public TreeNodeCollection Nodes
		{
			get { return m_tvMain.Nodes; }
		}

		/// <summary> .</summary>
		public TreeView TreeViewMain
		{
			get { return m_tvMain; }
		}

		public TreeNode SelectedNode
		{
			get { return m_tnSelected; }
		}
	}

	public delegate NodeData BaseTreeDataEventHandler(BaseTree pdSender, NodeData arg);

	/// <summary>     .</summary>
	public struct NodeData
	{
		/// <summary> .</summary>
		private string m_strAssemblyName;

		/// <summary> .</summary>
		private string m_strClassName;

		/// <summary>.</summary>
		private Hashtable m_htParams;

		/// <summary> .</summary>
		public string AssemblyName
		{
			get { return m_strAssemblyName; }
			set { m_strAssemblyName = value; }
		}

		/// <summary> .</summary>
		public string ClassName
		{
			get { return m_strClassName; }
			set { m_strClassName = value; }
		}

		/// <summary>.</summary>
		public Hashtable Params
		{
			get { return m_htParams; }
			set { m_htParams = value; }
		}
	}

	/// <summary>
	/// ,        
	/// .
	/// </summary>
	public interface ITreeBaseForm
	{
		void InitParams(Hashtable htParams);
		void Reload();
		Hashtable GetInitParams();
	}
}

/********************* SniipSoftel *****************
 *
 *    $History: BaseTree.cs $
 *   
 *   *****************  Version 103  *****************
 *   User: Serg_ch      Date: 17.05.07   Time: 12:38
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 101  *****************
 *   User: Gavrilov     Date: 13.04.07   Time: 17:45
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 100  *****************
 *   User: Gavrilov     Date: 2.04.07    Time: 12:46
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 99  *****************
 *   User: Gavrilov     Date: 30.03.07   Time: 15:44
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 98  *****************
 *   User: Gavrilov     Date: 30.03.07   Time: 12:38
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 97  *****************
 *   User: Gavrilov     Date: 29.03.07   Time: 18:38
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 96  *****************
 *   User: Serg_ch      Date: 26.03.07   Time: 20:42
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 95  *****************
 *   User: Gavrilov     Date: 26.03.07   Time: 13:09
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 94  *****************
 *   User: Serg_ch      Date: 23.03.07   Time: 11:12
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 93  *****************
 *   User: Serg_ch      Date: 2.03.07    Time: 19:05
 *   Updated in $/Net/Common/ClientControl/BaseTree
 *   
 *   *****************  Version 91  *****************
 *   User: Serg_ch      Date: 2.03.07    Time: 13:42
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 90  *****************
 *   User: Serg_ch      Date: 1.03.07    Time: 18:09
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 89  *****************
 *   User: Gavrilov     Date: 5.02.07    Time: 11:47
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 88  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 87  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 86  *****************
 *   User: Gavrilov     Date: 16.01.07   Time: 11:43
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 85  *****************
 *   User: Serg_ch      Date: 20.12.06   Time: 16:26
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *   
 *   *****************  Version 84  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/BaseTree
 *
 ********************* SniipSoftel *****************/