/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 34 $
 *   $Date: 24.01.07 14:46 $
 *
 ********************* SniipSoftel *****************/
/// Project: SoftelControl, File: ClientsBaseForm.cs</p>
/// Namespace: Softel.Windows.Forms.ClientsBaseForm, Class: ClientsBaseForm</p>
/// Code lines: 295</p>
/// Creation date: 28.12.2005 17:58</p>
/// Last modified: 17.03.2006 12:06</p>

#region Using directives

using System;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

#endregion

namespace Softel.Windows.Forms.ClientsBaseForm
{
	/// <summary>
	/// Summary description for ClientsBaseForm.
	/// </summary>
	public class ClientsBaseForm : Content, ITreeBaseForm
	{
		private IContainer components;

		private int m_iClnId, m_iAcId, m_iSubId, m_iCompanyId;
		private string m_strRoute;
		private BillingTypes m_objBillingType;
		protected ImageList SoftelImageList;
		private GlobalImageList m_gilMain;
		protected Action m_actSave;
		protected Action m_actCancel;
		protected ActionList m_alMain;
		protected ToolBar m_tbMain;
		private ToolBarButton m_tbbSave;
		private ToolBarButton m_tbbCancel;
		private ToolBarButton m_tbbSepEnd;
		private ToolBarButton m_tbbRefresh;
		protected Action m_actRefresh;
		protected Hashtable m_htArgs;

		/// <summary>
		///  
		/// </summary>
		public ClientsBaseForm()
		{
			InitializeComponent();
		} // ClientsBaseForm(htArgs)
		/// <summary>
		///  
		/// </summary>
		public ClientsBaseForm(Hashtable htArgs)
		{
			InitializeComponent();
			m_htArgs = htArgs;
			InitializeForm(htArgs);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ClientsBaseForm));
			this.SoftelImageList = new System.Windows.Forms.ImageList(this.components);
			this.m_gilMain = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_alMain = new Softel.Windows.Forms.ActionList(this.components);
			this.m_actSave = new Softel.Windows.Forms.Action(this.components);
			this.m_actCancel = new Softel.Windows.Forms.Action(this.components);
			this.m_actRefresh = new Softel.Windows.Forms.Action(this.components);
			this.m_tbbSave = new System.Windows.Forms.ToolBarButton();
			this.m_tbbCancel = new System.Windows.Forms.ToolBarButton();
			this.m_tbbRefresh = new System.Windows.Forms.ToolBarButton();
			this.m_tbMain = new System.Windows.Forms.ToolBar();
			this.m_tbbSepEnd = new System.Windows.Forms.ToolBarButton();
			this.SuspendLayout();
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageSize = ((System.Drawing.Size)(resources.GetObject("SoftelImageList.ImageSize")));
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			this.SoftelImageList.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// m_gilMain
			// 
			this.m_gilMain.ImageList = this.SoftelImageList;
			this.m_gilMain.Parent = this;
			// 
			// m_alMain
			// 
			this.m_alMain.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																				 this.m_actSave,
																				 this.m_actCancel,
																				 this.m_actRefresh});
			this.m_alMain.ImageList = this.SoftelImageList;
			this.m_alMain.ShowTextOnToolBar = false;
			this.m_alMain.Tag = null;
			// 
			// m_actSave
			// 
			this.m_actSave.Checked = false;
			this.m_actSave.Enabled = true;
			this.m_actSave.Hint = resources.GetString("m_actSave.Hint");
			this.m_actSave.ImageIndex = ((int)(resources.GetObject("m_actSave.ImageIndex")));
			this.m_actSave.MergeOrder = 12;
			this.m_actSave.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actSave.Tag = null;
			this.m_actSave.Text = resources.GetString("m_actSave.Text");
			this.m_actSave.Visible = true;
			this.m_actSave.Execute += new System.EventHandler(this.m_actSave_Execute);
			// 
			// m_actCancel
			// 
			this.m_actCancel.Checked = false;
			this.m_actCancel.Enabled = true;
			this.m_actCancel.Hint = resources.GetString("m_actCancel.Hint");
			this.m_actCancel.ImageIndex = ((int)(resources.GetObject("m_actCancel.ImageIndex")));
			this.m_actCancel.MergeOrder = 13;
			this.m_actCancel.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actCancel.Tag = null;
			this.m_actCancel.Text = resources.GetString("m_actCancel.Text");
			this.m_actCancel.Visible = true;
			this.m_actCancel.Execute += new System.EventHandler(this.m_actCancel_Execute);
			// 
			// m_actRefresh
			// 
			this.m_actRefresh.Checked = false;
			this.m_actRefresh.Enabled = true;
			this.m_actRefresh.Hint = resources.GetString("m_actRefresh.Hint");
			this.m_actRefresh.ImageIndex = ((int)(resources.GetObject("m_actRefresh.ImageIndex")));
			this.m_actRefresh.MergeOrder = 21;
			this.m_actRefresh.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actRefresh.Tag = null;
			this.m_actRefresh.Text = resources.GetString("m_actRefresh.Text");
			this.m_actRefresh.Visible = true;
			this.m_actRefresh.Execute += new System.EventHandler(this.m_actRefresh_Execute);
			// 
			// m_tbbSave
			// 
			this.m_alMain.SetAction(this.m_tbbSave, this.m_actSave);
			this.m_tbbSave.Enabled = ((bool)(resources.GetObject("m_tbbSave.Enabled")));
			this.m_tbbSave.ImageIndex = ((int)(resources.GetObject("m_tbbSave.ImageIndex")));
			this.m_tbbSave.Text = resources.GetString("m_tbbSave.Text");
			this.m_tbbSave.ToolTipText = resources.GetString("m_tbbSave.ToolTipText");
			this.m_tbbSave.Visible = ((bool)(resources.GetObject("m_tbbSave.Visible")));
			// 
			// m_tbbCancel
			// 
			this.m_alMain.SetAction(this.m_tbbCancel, this.m_actCancel);
			this.m_tbbCancel.Enabled = ((bool)(resources.GetObject("m_tbbCancel.Enabled")));
			this.m_tbbCancel.ImageIndex = ((int)(resources.GetObject("m_tbbCancel.ImageIndex")));
			this.m_tbbCancel.Text = resources.GetString("m_tbbCancel.Text");
			this.m_tbbCancel.ToolTipText = resources.GetString("m_tbbCancel.ToolTipText");
			this.m_tbbCancel.Visible = ((bool)(resources.GetObject("m_tbbCancel.Visible")));
			// 
			// m_tbbRefresh
			// 
			this.m_alMain.SetAction(this.m_tbbRefresh, this.m_actRefresh);
			this.m_tbbRefresh.Enabled = ((bool)(resources.GetObject("m_tbbRefresh.Enabled")));
			this.m_tbbRefresh.ImageIndex = ((int)(resources.GetObject("m_tbbRefresh.ImageIndex")));
			this.m_tbbRefresh.Text = resources.GetString("m_tbbRefresh.Text");
			this.m_tbbRefresh.ToolTipText = resources.GetString("m_tbbRefresh.ToolTipText");
			this.m_tbbRefresh.Visible = ((bool)(resources.GetObject("m_tbbRefresh.Visible")));
			// 
			// m_tbMain
			// 
			this.m_tbMain.AccessibleDescription = resources.GetString("m_tbMain.AccessibleDescription");
			this.m_tbMain.AccessibleName = resources.GetString("m_tbMain.AccessibleName");
			this.m_tbMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tbMain.Anchor")));
			this.m_tbMain.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("m_tbMain.Appearance")));
			this.m_tbMain.AutoSize = ((bool)(resources.GetObject("m_tbMain.AutoSize")));
			this.m_tbMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tbMain.BackgroundImage")));
			this.m_tbMain.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.m_tbbSave,
																						this.m_tbbCancel,
																						this.m_tbbSepEnd,
																						this.m_tbbRefresh});
			this.m_tbMain.ButtonSize = ((System.Drawing.Size)(resources.GetObject("m_tbMain.ButtonSize")));
			this.m_tbMain.Divider = false;
			this.m_tbMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tbMain.Dock")));
			this.m_tbMain.DropDownArrows = ((bool)(resources.GetObject("m_tbMain.DropDownArrows")));
			this.m_tbMain.Enabled = ((bool)(resources.GetObject("m_tbMain.Enabled")));
			this.m_tbMain.Font = ((System.Drawing.Font)(resources.GetObject("m_tbMain.Font")));
			this.m_tbMain.ImageList = this.SoftelImageList;
			this.m_tbMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tbMain.ImeMode")));
			this.m_tbMain.Location = ((System.Drawing.Point)(resources.GetObject("m_tbMain.Location")));
			this.m_tbMain.Name = "m_tbMain";
			this.m_tbMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tbMain.RightToLeft")));
			this.m_tbMain.ShowToolTips = ((bool)(resources.GetObject("m_tbMain.ShowToolTips")));
			this.m_tbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tbMain.Size")));
			this.m_tbMain.TabIndex = ((int)(resources.GetObject("m_tbMain.TabIndex")));
			this.m_tbMain.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("m_tbMain.TextAlign")));
			this.m_tbMain.Visible = ((bool)(resources.GetObject("m_tbMain.Visible")));
			this.m_tbMain.Wrappable = ((bool)(resources.GetObject("m_tbMain.Wrappable")));
			// 
			// m_tbbSepEnd
			// 
			this.m_tbbSepEnd.Enabled = ((bool)(resources.GetObject("m_tbbSepEnd.Enabled")));
			this.m_tbbSepEnd.ImageIndex = ((int)(resources.GetObject("m_tbbSepEnd.ImageIndex")));
			this.m_tbbSepEnd.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			this.m_tbbSepEnd.Text = resources.GetString("m_tbbSepEnd.Text");
			this.m_tbbSepEnd.ToolTipText = resources.GetString("m_tbbSepEnd.ToolTipText");
			this.m_tbbSepEnd.Visible = ((bool)(resources.GetObject("m_tbbSepEnd.Visible")));
			// 
			// ClientsBaseForm
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.m_tbMain);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "ClientsBaseForm";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.TabText = resources.GetString("$this.TabText");
			this.Text = resources.GetString("$this.Text");
			this.ToolTipText = resources.GetString("$this.ToolTipText");
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		/// ,      ""
		/// </summary>
		protected virtual void Save()
		{
		}

		/// <summary>
		/// ,      ""
		/// </summary>
		protected virtual void Cancel()
		{
			Reload();
			EnableButtons(false);
		}

		public Hashtable GetInitParams()
		{
			return m_htArgs;
		}
		public void InitParams(Hashtable htParams)
		{
			m_htArgs = htParams;
			InitializeForm(htParams);
		}

		/// <summary>
		/// ,      ""
		/// </summary>
		public virtual void Reload()
		{
			EnableButtons(false);
		}

		/// <summary>
		/// ,       
		/// </summary>
		protected virtual void EnableButtons(bool bEnable)
		{
			m_actSave.Enabled = bEnable;
			m_actCancel.Enabled = bEnable;
		}

		/// <summary>
		/// ,       
		/// </summary>
		protected virtual void VisibleButtons(bool bVisible)
		{
			m_actSave.Visible = bVisible;
			m_actCancel.Visible = bVisible;
			m_actRefresh.Visible = bVisible;
			m_tbbSepEnd.Visible = bVisible;
		}

		/// <summary>
		///  
		/// </summary>
		/// <param name="htArgs"> <seealso cref="Hashtable"/>   </param>
		public void InitializeForm(Hashtable htArgs)
		{
			m_htArgs = htArgs;
			if(htArgs != null)
			{
				if (htArgs.ContainsKey("ac_id"))
					m_iAcId = Convert.ToInt32(htArgs["ac_id"]);
				if (htArgs.ContainsKey("sub_id"))
					m_iSubId = Convert.ToInt32(htArgs["sub_id"]);
				if (htArgs.ContainsKey("cln_id"))
					m_iClnId = Convert.ToInt32(htArgs["cln_id"]);
				if (htArgs.ContainsKey("billing_type"))
					m_objBillingType = (BillingTypes) htArgs["billing_type"];
				if (htArgs.ContainsKey("company_id"))
					m_iCompanyId = Convert.ToInt32(htArgs["company_id"]);
			}

//			Reload();
		}

		/// <summary>
		///     ""
		/// </summary>
		/// <param name="sender">  </param>
		/// <param name="e"> </param>
		private void m_actSave_Execute(object sender, EventArgs e)
		{
			Save();
		}

		/// <summary>
		///     ""
		/// </summary>
		/// <param name="sender">  </param>
		/// <param name="e"> </param>
		private void m_actRefresh_Execute(object sender, EventArgs e)
		{
			Reload();
		}

		/// <summary>
		///     ""
		/// </summary>
		/// <param name="sender">  </param>
		/// <param name="e"> </param>
		private void m_actCancel_Execute(object sender, EventArgs e)
		{
			Cancel();
		}

		/// <summary>
		/// ,   
		/// </summary>
		public int ClnId
		{
			get { return m_iClnId; }
			set { m_iClnId = value; }
		}

		/// <summary>
		/// ,   
		/// </summary>
		public int CompanyId
		{
			get { return m_iCompanyId; }
			set { m_iCompanyId = value; }
		}

		/// <summary>
		/// ,   
		/// </summary>
		public int AcId
		{
			get { return m_iAcId; }
			set { m_iAcId = value; }
		}

		/// <summary>
		/// ,   
		/// </summary>
		public int SubId
		{
			get { return m_iSubId; }
			set { m_iSubId = value; }
		}

		public BillingTypes BillingType
		{
			get { return m_objBillingType; }
			set { m_objBillingType = value; }
		}

		public string Route
		{
			get { return m_strRoute; }
			set { m_strRoute = value; }
		}
	}

	public enum BillingTypes
	{
		PH = 1,
		IP = 2,
		PRIH = 3,
		RASH = 4
	}
}
/********************* SniipSoftel *****************
 *
 *    $History: ClientsBaseForm.cs $
 *   
 *   *****************  Version 34  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/ClientsBaseForm
 *   
 *   *****************  Version 33  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/ClientsBaseForm
 *
 ********************* SniipSoftel *****************/
