/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 11 $
 *   $Date: 6.03.07 14:17 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Drawing;
using System.Windows.Forms;
using Softel.Windows.Forms.CuteGridColumns;

namespace Softel.Windows.Forms
{
	/// <summary>
	/// Summary description for CuteGridBoolColumn.
	/// </summary>
	public class CuteGridBoolColumn : DataGridBoolColumn
	{
		private Bitmap m_imgTrue;
		private GlobalImageList m_gilMain;

		public CuteGridBoolColumn()
		{
			Initialize();
		}
		private void Initialize()
		{
			try
			{
				m_gilMain = new GlobalImageList();
				m_imgTrue = (Bitmap)m_gilMain.ImageList.Images[12];
				m_imgTrue.MakeTransparent(Color.Fuchsia);
			}
			catch(Exception excInit)
			{
				
			}
		}

		protected override void Paint(Graphics g, Rectangle bounds, CurrencyManager source, int rowNum, Brush backBrush, Brush foreBrush, bool alignToRight)
		{
			//base.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight);
			//return;

			try
			{
				CuteGridPaintCellEventArgs e
					= new CuteGridPaintCellEventArgs(g, bounds, source, this, rowNum, GetColumnValueAtRow(source, rowNum),
					                                 backBrush, foreBrush, alignToRight);
				if (!this.ReadOnly)
				{
					((CuteSoftelGrid) this.DataGridTableStyle.DataGrid).OnCellPaint(e);
				}

				if (!e.CustomPaint && this.ReadOnly)
				{
					if (this.DataGridTableStyle.DataGrid.IsSelected(rowNum))
					{
						backBrush = e.SelectionBackBrush;
						foreBrush = e.SelectionForeBrush;
					}
					else
					{
						backBrush = e.BackBrush;
						foreBrush = e.ForeBrush;
					}
					g.FillRectangle(backBrush, bounds);
					object objValue = GetColumnValueAtRow(source, rowNum);
					if (objValue != null && bool.Parse(objValue.ToString()))
					{
						Rectangle rectTrue = bounds;
						double dPrir = bounds.Height/(double) m_imgTrue.Height;
						rectTrue.Height = (int) (m_imgTrue.Height*dPrir);
						rectTrue.Width = (int) (m_imgTrue.Width*dPrir);
						rectTrue.X = rectTrue.Left + bounds.Width/2 - rectTrue.Width/2;
						g.DrawImage(m_imgTrue, rectTrue);
//						Pen pLine = new Pen(foreBrush, 3);
//						float dX = bounds.Left + bounds.Width / 2;
//						float dY = bounds.Top + bounds.Height / 2;
//						g.DrawLine(pLine, dX - 5, dY - 1, dX, dY + 5);
//						g.DrawLine(pLine, dX, dY + 5, dX + 5, dY - 8);
					}
//					base.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight);
				}
				else
					base.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight);

			}
			catch (Exception)
			{
				//base.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight);
			}

		}

		protected override void Edit(CurrencyManager source, int rowNum, Rectangle bounds, bool readOnly, string instantText, bool cellIsVisible)
		{
			if (!readOnly)
				base.Edit(source, rowNum, bounds, readOnly, instantText, cellIsVisible);

		}
	}
}
/********************* SniipSoftel *****************
 *
 *    $History: CuteGridBoolColumn.cs $
 *   
 *   *****************  Version 11  *****************
 *   User: Serg_ch      Date: 6.03.07    Time: 14:17
 *   Updated in $/Net/Common/ClientControl/CuteSoftelGrid/CuteGridColumns
 *   
 *   *****************  Version 10  *****************
 *   User: Serg_ch      Date: 2.03.07    Time: 19:02
 *   Updated in $/Net/Common/ClientControl/CuteSoftelGrid/CuteGridColumns
 *   
 *   *****************  Version 8  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/CuteSoftelGrid/CuteGridColumns
 *
 ********************* SniipSoftel *****************/
