/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 43 $
 *   $Date: 15.03.07 20:01 $
 *
 ********************* SniipSoftel *****************/
/// Project: SoftelControl, File: ClientsBaseForm.cs</p>
/// Namespace: Softel.Windows.Forms.ClientsBaseForm, Class: ClientsBaseForm</p>
/// Code lines: 295</p>
/// Creation date: 28.12.2005 17:58</p>
/// Last modified: 17.03.2006 12:06</p>

#region Using directives

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Softel.Common;
using Softel.MiddleTier.Client;
using Softel.Windows.Forms.ClientsBaseForm;
using Softel.Windows.Forms.CuteTableStyles;
using Convert = System.Convert;

#endregion

namespace Softel.Windows.Forms
{
	/// <summary>
	/// Summary description for ClientsBaseForm.
	/// </summary>
	public class DictionaryBaseForm : Content
	{
		private IContainer components;


		private BillingTypes m_objBillingType;
		protected ImageList SoftelImageList;
		private GlobalImageList m_gilMain;
		protected ActionList m_alMain;
		protected ToolBar m_tbMain;
		private ToolBarButton m_tbbSepEnd;
		protected Action m_actInsert;
		protected Action m_actEdit;
		protected Action m_actDelete;
		protected ToolBarButton m_tbbInsert;
		protected ToolBarButton m_tbbEdit;
		protected ToolBarButton m_tbbDelete;
		private Action m_actRefresh;
		private ToolBarButton m_tbbRefresh;
		public ContextMenu m_cmMain;
		private MenuItem m_miInsMain;
		private MenuItem m_miEditMaim;
		private MenuItem m_miDelMain;
		protected Hashtable m_htArgs;
		private string m_strTuning;

		/// <summary>
		///  
		/// </summary>
		public DictionaryBaseForm()
		{
			InitializeComponent();
		} // ClientsBaseForm(htArgs)
		/// <summary>
		///  
		/// </summary>
		public DictionaryBaseForm(Hashtable htArgs)
		{
			InitializeComponent();

			InitializeForm(htArgs);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DictionaryBaseForm));
			this.SoftelImageList = new System.Windows.Forms.ImageList(this.components);
			this.m_gilMain = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_alMain = new Softel.Windows.Forms.ActionList(this.components);
			this.m_actInsert = new Softel.Windows.Forms.Action(this.components);
			this.m_actEdit = new Softel.Windows.Forms.Action(this.components);
			this.m_actDelete = new Softel.Windows.Forms.Action(this.components);
			this.m_actRefresh = new Softel.Windows.Forms.Action(this.components);
			this.m_tbbInsert = new System.Windows.Forms.ToolBarButton();
			this.m_tbbEdit = new System.Windows.Forms.ToolBarButton();
			this.m_tbbDelete = new System.Windows.Forms.ToolBarButton();
			this.m_tbbRefresh = new System.Windows.Forms.ToolBarButton();
			this.m_miInsMain = new System.Windows.Forms.MenuItem();
			this.m_miEditMaim = new System.Windows.Forms.MenuItem();
			this.m_miDelMain = new System.Windows.Forms.MenuItem();
			this.m_tbMain = new System.Windows.Forms.ToolBar();
			this.m_tbbSepEnd = new System.Windows.Forms.ToolBarButton();
			this.m_cmMain = new System.Windows.Forms.ContextMenu();
			this.SuspendLayout();
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageSize = ((System.Drawing.Size)(resources.GetObject("SoftelImageList.ImageSize")));
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			this.SoftelImageList.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// m_gilMain
			// 
			this.m_gilMain.ImageList = this.SoftelImageList;
			this.m_gilMain.Parent = this;
			// 
			// m_alMain
			// 
			this.m_alMain.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																				 this.m_actInsert,
																				 this.m_actEdit,
																				 this.m_actDelete,
																				 this.m_actRefresh});
			this.m_alMain.ImageList = this.SoftelImageList;
			this.m_alMain.ShowTextOnToolBar = false;
			this.m_alMain.Tag = null;
			// 
			// m_actInsert
			// 
			this.m_actInsert.Checked = false;
			this.m_actInsert.Enabled = true;
			this.m_actInsert.Hint = resources.GetString("m_actInsert.Hint");
			this.m_actInsert.ImageIndex = ((int)(resources.GetObject("m_actInsert.ImageIndex")));
			this.m_actInsert.MergeOrder = 32;
			this.m_actInsert.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actInsert.Tag = null;
			this.m_actInsert.Text = resources.GetString("m_actInsert.Text");
			this.m_actInsert.Visible = true;
			// 
			// m_actEdit
			// 
			this.m_actEdit.Checked = false;
			this.m_actEdit.Enabled = true;
			this.m_actEdit.Hint = resources.GetString("m_actEdit.Hint");
			this.m_actEdit.ImageIndex = ((int)(resources.GetObject("m_actEdit.ImageIndex")));
			this.m_actEdit.MergeOrder = 33;
			this.m_actEdit.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actEdit.Tag = null;
			this.m_actEdit.Text = resources.GetString("m_actEdit.Text");
			this.m_actEdit.Visible = true;
			// 
			// m_actDelete
			// 
			this.m_actDelete.Checked = false;
			this.m_actDelete.Enabled = true;
			this.m_actDelete.Hint = resources.GetString("m_actDelete.Hint");
			this.m_actDelete.ImageIndex = ((int)(resources.GetObject("m_actDelete.ImageIndex")));
			this.m_actDelete.MergeOrder = 31;
			this.m_actDelete.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDelete.Tag = null;
			this.m_actDelete.Text = resources.GetString("m_actDelete.Text");
			this.m_actDelete.Visible = true;
			// 
			// m_actRefresh
			// 
			this.m_actRefresh.Checked = false;
			this.m_actRefresh.Enabled = true;
			this.m_actRefresh.Hint = resources.GetString("m_actRefresh.Hint");
			this.m_actRefresh.ImageIndex = ((int)(resources.GetObject("m_actRefresh.ImageIndex")));
			this.m_actRefresh.MergeOrder = 21;
			this.m_actRefresh.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actRefresh.Tag = null;
			this.m_actRefresh.Text = resources.GetString("m_actRefresh.Text");
			this.m_actRefresh.Visible = true;
			this.m_actRefresh.Execute += new System.EventHandler(this.m_actRefresh_Execute);
			// 
			// m_tbbInsert
			// 
			this.m_alMain.SetAction(this.m_tbbInsert, this.m_actInsert);
			this.m_tbbInsert.Enabled = ((bool)(resources.GetObject("m_tbbInsert.Enabled")));
			this.m_tbbInsert.ImageIndex = ((int)(resources.GetObject("m_tbbInsert.ImageIndex")));
			this.m_tbbInsert.Text = resources.GetString("m_tbbInsert.Text");
			this.m_tbbInsert.ToolTipText = resources.GetString("m_tbbInsert.ToolTipText");
			this.m_tbbInsert.Visible = ((bool)(resources.GetObject("m_tbbInsert.Visible")));
			// 
			// m_tbbEdit
			// 
			this.m_alMain.SetAction(this.m_tbbEdit, this.m_actEdit);
			this.m_tbbEdit.Enabled = ((bool)(resources.GetObject("m_tbbEdit.Enabled")));
			this.m_tbbEdit.ImageIndex = ((int)(resources.GetObject("m_tbbEdit.ImageIndex")));
			this.m_tbbEdit.Text = resources.GetString("m_tbbEdit.Text");
			this.m_tbbEdit.ToolTipText = resources.GetString("m_tbbEdit.ToolTipText");
			this.m_tbbEdit.Visible = ((bool)(resources.GetObject("m_tbbEdit.Visible")));
			// 
			// m_tbbDelete
			// 
			this.m_alMain.SetAction(this.m_tbbDelete, this.m_actDelete);
			this.m_tbbDelete.Enabled = ((bool)(resources.GetObject("m_tbbDelete.Enabled")));
			this.m_tbbDelete.ImageIndex = ((int)(resources.GetObject("m_tbbDelete.ImageIndex")));
			this.m_tbbDelete.Text = resources.GetString("m_tbbDelete.Text");
			this.m_tbbDelete.ToolTipText = resources.GetString("m_tbbDelete.ToolTipText");
			this.m_tbbDelete.Visible = ((bool)(resources.GetObject("m_tbbDelete.Visible")));
			// 
			// m_tbbRefresh
			// 
			this.m_alMain.SetAction(this.m_tbbRefresh, this.m_actRefresh);
			this.m_tbbRefresh.Enabled = ((bool)(resources.GetObject("m_tbbRefresh.Enabled")));
			this.m_tbbRefresh.ImageIndex = ((int)(resources.GetObject("m_tbbRefresh.ImageIndex")));
			this.m_tbbRefresh.Text = resources.GetString("m_tbbRefresh.Text");
			this.m_tbbRefresh.ToolTipText = resources.GetString("m_tbbRefresh.ToolTipText");
			this.m_tbbRefresh.Visible = ((bool)(resources.GetObject("m_tbbRefresh.Visible")));
			// 
			// m_miInsMain
			// 
			this.m_alMain.SetAction(this.m_miInsMain, this.m_actInsert);
			this.m_miInsMain.Enabled = ((bool)(resources.GetObject("m_miInsMain.Enabled")));
			this.m_miInsMain.Index = 0;
			this.m_miInsMain.MergeOrder = 32;
			this.m_miInsMain.MergeType = System.Windows.Forms.MenuMerge.MergeItems;
			this.m_miInsMain.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miInsMain.Shortcut")));
			this.m_miInsMain.ShowShortcut = ((bool)(resources.GetObject("m_miInsMain.ShowShortcut")));
			this.m_miInsMain.Text = resources.GetString("m_miInsMain.Text");
			this.m_miInsMain.Visible = ((bool)(resources.GetObject("m_miInsMain.Visible")));
			// 
			// m_miEditMaim
			// 
			this.m_alMain.SetAction(this.m_miEditMaim, this.m_actEdit);
			this.m_miEditMaim.Enabled = ((bool)(resources.GetObject("m_miEditMaim.Enabled")));
			this.m_miEditMaim.Index = 1;
			this.m_miEditMaim.MergeOrder = 33;
			this.m_miEditMaim.MergeType = System.Windows.Forms.MenuMerge.MergeItems;
			this.m_miEditMaim.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miEditMaim.Shortcut")));
			this.m_miEditMaim.ShowShortcut = ((bool)(resources.GetObject("m_miEditMaim.ShowShortcut")));
			this.m_miEditMaim.Text = resources.GetString("m_miEditMaim.Text");
			this.m_miEditMaim.Visible = ((bool)(resources.GetObject("m_miEditMaim.Visible")));
			// 
			// m_miDelMain
			// 
			this.m_alMain.SetAction(this.m_miDelMain, this.m_actDelete);
			this.m_miDelMain.Enabled = ((bool)(resources.GetObject("m_miDelMain.Enabled")));
			this.m_miDelMain.Index = 2;
			this.m_miDelMain.MergeOrder = 31;
			this.m_miDelMain.MergeType = System.Windows.Forms.MenuMerge.MergeItems;
			this.m_miDelMain.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDelMain.Shortcut")));
			this.m_miDelMain.ShowShortcut = ((bool)(resources.GetObject("m_miDelMain.ShowShortcut")));
			this.m_miDelMain.Text = resources.GetString("m_miDelMain.Text");
			this.m_miDelMain.Visible = ((bool)(resources.GetObject("m_miDelMain.Visible")));
			// 
			// m_tbMain
			// 
			this.m_tbMain.AccessibleDescription = resources.GetString("m_tbMain.AccessibleDescription");
			this.m_tbMain.AccessibleName = resources.GetString("m_tbMain.AccessibleName");
			this.m_tbMain.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tbMain.Anchor")));
			this.m_tbMain.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("m_tbMain.Appearance")));
			this.m_tbMain.AutoSize = ((bool)(resources.GetObject("m_tbMain.AutoSize")));
			this.m_tbMain.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tbMain.BackgroundImage")));
			this.m_tbMain.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.m_tbbInsert,
																						this.m_tbbEdit,
																						this.m_tbbDelete,
																						this.m_tbbRefresh});
			this.m_tbMain.ButtonSize = ((System.Drawing.Size)(resources.GetObject("m_tbMain.ButtonSize")));
			this.m_tbMain.Divider = false;
			this.m_tbMain.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tbMain.Dock")));
			this.m_tbMain.DropDownArrows = ((bool)(resources.GetObject("m_tbMain.DropDownArrows")));
			this.m_tbMain.Enabled = ((bool)(resources.GetObject("m_tbMain.Enabled")));
			this.m_tbMain.Font = ((System.Drawing.Font)(resources.GetObject("m_tbMain.Font")));
			this.m_tbMain.ImageList = this.SoftelImageList;
			this.m_tbMain.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tbMain.ImeMode")));
			this.m_tbMain.Location = ((System.Drawing.Point)(resources.GetObject("m_tbMain.Location")));
			this.m_tbMain.Name = "m_tbMain";
			this.m_tbMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tbMain.RightToLeft")));
			this.m_tbMain.ShowToolTips = ((bool)(resources.GetObject("m_tbMain.ShowToolTips")));
			this.m_tbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tbMain.Size")));
			this.m_tbMain.TabIndex = ((int)(resources.GetObject("m_tbMain.TabIndex")));
			this.m_tbMain.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("m_tbMain.TextAlign")));
			this.m_tbMain.Visible = ((bool)(resources.GetObject("m_tbMain.Visible")));
			this.m_tbMain.Wrappable = ((bool)(resources.GetObject("m_tbMain.Wrappable")));
			// 
			// m_tbbSepEnd
			// 
			this.m_tbbSepEnd.Enabled = ((bool)(resources.GetObject("m_tbbSepEnd.Enabled")));
			this.m_tbbSepEnd.ImageIndex = ((int)(resources.GetObject("m_tbbSepEnd.ImageIndex")));
			this.m_tbbSepEnd.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			this.m_tbbSepEnd.Text = resources.GetString("m_tbbSepEnd.Text");
			this.m_tbbSepEnd.ToolTipText = resources.GetString("m_tbbSepEnd.ToolTipText");
			this.m_tbbSepEnd.Visible = ((bool)(resources.GetObject("m_tbbSepEnd.Visible")));
			// 
			// m_cmMain
			// 
			this.m_cmMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.m_miInsMain,
																					 this.m_miEditMaim,
																					 this.m_miDelMain});
			this.m_cmMain.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmMain.RightToLeft")));
			// 
			// DictionaryBaseForm
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.m_tbMain);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "DictionaryBaseForm";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.TabText = resources.GetString("$this.TabText");
			this.Text = resources.GetString("$this.Text");
			this.ToolTipText = resources.GetString("$this.ToolTipText");
			this.ResumeLayout(false);

		}

		#endregion

		public virtual void Reload()
		{
		}

		/// <summary>
		/// ,       
		/// </summary>
		protected virtual void EnableButtons(bool bEnable)
		{
		}

		/// <summary>
		/// ,       
		/// </summary>
		protected virtual void VisibleButtons(bool bVisible)
		{
		}

		/// <summary>
		///  
		/// </summary>
		/// <param name="htArgs"> <seealso cref="Hashtable"/>   </param>
		public void InitializeForm(Hashtable htArgs)
		{
			if (htArgs.ContainsKey("billing_type"))
				m_objBillingType = (BillingTypes) htArgs["billing_type"];

			if (htArgs.ContainsKey("tuning"))
				m_strTuning = (string) htArgs["tuning"];
			m_htArgs = htArgs;

			//			Reload();
		}

		protected void AddFieldFromHash(Hashtable htOutput)
		{
			foreach (string strKey in m_htArgs.Keys)
			{
				if (strKey != "tuning" && strKey != "billing_type")
					htOutput[strKey] = m_htArgs[strKey];

			}


		}

		protected void AddFieldFromRow(Hashtable ht, DataRow dr, string strConnectionField)
		{
			string[] strKeys = strConnectionField.Split(';');

			int iCount = strKeys.Length;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				string strKey = strKeys[iIndex++];
				string strDependKey, strMasterKey;
				int iKeyIndex = strKey.IndexOf('/');
				if (iKeyIndex == -1)
				{
					strDependKey = strKey;
					strMasterKey = strKey;
				}
				else
				{
					strDependKey = strKey.Substring(iKeyIndex + 1);
					strMasterKey = strKey.Substring(0, iKeyIndex);
				}

				if (dr == null)
					ht[strDependKey] = 0;
				else
					ht[strDependKey] = dr[strMasterKey];

			}


		}

		protected void FillDetail(string strType, CuteSoftelGrid grdElement, ref DataTable dtElement)
		{
			grdElement.TableStyles.Clear();

			CuteGridTableStylesCollection tsElement = new CuteGridTableStylesCollection();
			tsElement.MappingName = "Table";
			grdElement.TableStyles.Add(tsElement);

			FillDetail(strType, grdElement, tsElement, ref dtElement);

		}

		protected void DisableAction(DataTable dtElement, string strDeleteProcedure, Action actDelete, Action actInsert, Action actUpdate)
		{
			bool bInsAction = false;
			bool bUpdAction = false;

			int iCount = dtElement.Rows.Count;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				DataRow dr = dtElement.Rows[iIndex++];
				if (dr["ins_proc_param"] != DBNull.Value && dr["ins_proc_param"].ToString() != "")
					bInsAction = true;

				if (dr["upd_proc_param"] != DBNull.Value && dr["upd_proc_param"].ToString() != "")
					bUpdAction = true;
			}
			if (!bInsAction)
				actInsert.Visible = false;
			if (!bUpdAction)
				actUpdate.Visible = false;
			if (strDeleteProcedure != null && strDeleteProcedure != "")
				actDelete.Visible = true;
			else
				actDelete.Visible = false;


		}

		protected void FillDetail(string strType, CuteSoftelGrid grdElement, CuteGridTableStylesCollection tsElement, ref DataTable dtElement)

		{
			dtElement = null;

			using (Command cmdElement = new Command())
			{
				tsElement.GridColumnStyles.Clear();

				if (strType != null && strType != "")
				{
					cmdElement.CommandName = "UIGetGridColumns";
					cmdElement.InputParams["@column_type"] = strType;
					cmdElement.InputParams["@dict_name"] = strType;
					cmdElement.Execute(true);
				}

				grdElement.GridTableStyleTable = cmdElement.DataSet.Tables[0];

				grdElement.Text = cmdElement.DataSet.Tables[1].Rows[0]["caption"].ToString();

				if (cmdElement.DataSet.Tables.Count == 3)
					dtElement = cmdElement.DataSet.Tables[2];


				grdElement.ColumnAutoResize();


			}
		}

		/// <summary>
///      
/// </summary>
/// <param name="iOperation"> </param>
/// <param name="grdElement">   </param>
/// <param name="strKey">      (  )</param>
/// <param name="dtElement">  </param>
/// <param name="htKeyValues">Hash table      -</param>
/// <param name="iOutIndex"></param>
/// <returns></returns>
		protected bool Operation(OperationType iOperation, CuteSoftelGrid grdElement, string strKey, ref DataTable dtElement, Hashtable htKeyValues, out int iOutIndex)

		{
			DataTable dtNew = new DataTable();
			Hashtable hshOldUpdateData = new Hashtable();

			bool bRes = false;
			string strOperation = "";

			iOutIndex = -1;
			//   ParamsDialog       
			//     

			int iInCount = 0;
			int iInIndex = 0;
			int iCount = dtElement.Rows.Count;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				DataRow dr = dtElement.Rows[iIndex++];
				bool bExist = false;

				switch (iOperation)
				{
					case OperationType.Insert:
						strOperation = "ins_proc_param";
						break;
					case OperationType.Edit:
						strOperation = "upd_proc_param";
						break;
				}

				if (dr[strOperation] != DBNull.Value && dr[strOperation].ToString().Trim() != "")
					bExist = true;


				if (bExist)
				{
					DataColumn dcCol = new DataColumn(dr["field"].ToString());
					DataTable dtGrid = (DataTable) grdElement.DataSource;
					iInCount = dtGrid.Columns.Count;
					iInIndex = 0;
					while(iInIndex < iInCount)
					{
						DataColumn dcEl = dtGrid.Columns[iInIndex++];
						if (dcEl.ColumnName == dr["grid_field"].ToString())
							dcCol.DataType = dcEl.DataType;

					}
					if (htKeyValues != null && OperationType.Insert == iOperation)
					{
						foreach (string strKeyField in htKeyValues.Keys)
						{
							if (dr["field"].ToString() == strKeyField)
								dr["defaultvalue"] = htKeyValues[strKeyField];

						}
					}


					dtNew.Columns.Add(dcCol);
				}
			}

			if (iOperation == OperationType.Edit)
			{
				DataRow drData;

				drData = dtNew.NewRow();
				iCount = dtElement.Rows.Count;
				iIndex = 0;
				while(iIndex < iCount)
				{
					DataRow dr = dtElement.Rows[iIndex++];
				
					DataTable dtGrid = (DataTable) grdElement.DataSource;
					iInCount = dtGrid.Columns.Count;
					iInIndex = 0;
					while(iInIndex < iInCount)
					{
						DataColumn dcEl = dtGrid.Columns[iInIndex++];
					
						if (dcEl.ColumnName.ToUpper() == dr["grid_field"].ToString().ToUpper() &&
							dr["upd_proc_param"] != DBNull.Value && dr["upd_proc_param"].ToString().Trim() != "")
						{
							if (dr["data_type"].ToString() == "CustomForm")
								dr["defaultvalue"] = grdElement.CurrentRow[dcEl.ColumnName];
							else
								drData[dcEl.ColumnName] = grdElement.CurrentRow[dcEl.ColumnName];

							//      field  upd_proc_param  
							if (dr["field"].ToString() != dr["upd_proc_param"].ToString().Substring(1))
								hshOldUpdateData[dr["field"].ToString()] = grdElement.CurrentRow[dcEl.ColumnName];


							break;

						}
					}
				}


				dtNew.Rows.Add(drData);

				if (strKey.IndexOf(';') == -1 && grdElement.CurrentRow[strKey] != null)
					try
					{
						iOutIndex = Convert.ToInt32(grdElement.CurrentRow[strKey]);
					}
					catch
					{
					}


			}


			ParamsDialogCollection pdCol = new ParamsDialogCollection();

			ParamsDialog pdNew = new ParamsDialog(dtNew, dtElement);
			ParamsDialog pdCopy = pdNew;
			pdCol.Add(pdCopy);
			pdNew.ParamsDialogs = pdCol;
			if (DialogResult.OK == pdNew.ShowDialog())
			{
				using (Command cmdNew = new Command())
				{
					switch (iOperation)
					{
						case OperationType.Edit:
							//       
							//               params_dialog
							cmdNew.CommandName = pdNew.UpdateStoredProc;
							//cmdNew.InputParams = pdNew.UpdateTable;
							foreach (string strKeyIn in pdNew.UpdateTable.Keys)
							{
								if (pdNew.Params[strKeyIn.Substring(1)].Type == ParamsType.CustomForm && pdNew.Value[strKeyIn.Substring(1)] != DBNull.Value)
								{
									if (pdNew.Value[strKeyIn.Substring(1)] is ICustomValue)
									{
										string strValue = ((ICustomValue) pdNew.Value[strKeyIn.Substring(1)]).Caption.ToString();
										cmdNew.InputParams[strKeyIn] = strValue;
									}
									else
										cmdNew.InputParams[strKeyIn] = pdNew.UpdateTable[strKeyIn];
									iCount = dtElement.Rows.Count;
									iIndex = 0;
									while(iIndex < iCount)
									{
										DataRow dr = dtElement.Rows[iIndex++];
										if (strKeyIn == dr["upd_proc_param"].ToString())
											dr["defaultvalue"] = "";
									}


								}
								else
								{
									cmdNew.InputParams[strKeyIn] = pdNew.UpdateTable[strKeyIn];
								}
							}
							string[] strKeyFields = strKey.ToLower().Split(';');
							//  
							iCount = strKeyFields.Length;
							iIndex = 0;
							while(iIndex < iCount)
							{
								string strKeyField = strKeyFields[iIndex++];
								cmdNew.InputParams["@" + strKeyField] = grdElement.CurrentRow[strKeyField];
							}
							//    
							foreach (string strkeyOldData in hshOldUpdateData.Keys)
								cmdNew.InputParams["@" + strkeyOldData] = grdElement.CurrentRow[strkeyOldData];

							break;


						case OperationType.Insert:

							cmdNew.CommandName = pdNew.InsertStoredProc;


							foreach (string strKeyIn in pdNew.InsertValue.Keys)
							{
								if (pdNew.Params[strKeyIn.Substring(1)].Type == ParamsType.CustomForm && pdNew.Value[strKeyIn.Substring(1)] != DBNull.Value)
								{
									if (pdNew.Value[strKeyIn.Substring(1)] is ICustomValue)
									{
										string strValue = ((ICustomValue) pdNew.Value[strKeyIn.Substring(1)]).Caption.ToString();
										cmdNew.InputParams[strKeyIn] = strValue;
									}
									else
										cmdNew.InputParams[strKeyIn] = pdNew.InsertValue[strKeyIn];


								}
								else
								{
									cmdNew.InputParams[strKeyIn] = pdNew.InsertValue[strKeyIn];
								}

							}


							//         params_dialog (connect_field  ontrol_field)

							if (htKeyValues != null)
								foreach (string strKeyField in htKeyValues.Keys)
								{
									bool bExist = false;
									DataTable dtGrid = (DataTable) grdElement.DataSource;
									iCount = dtGrid.Columns.Count;
									iIndex = 0;
									while(iIndex < iCount)
									{
										DataColumn dcEl = dtGrid.Columns[iIndex++];
										if (dcEl.Caption.ToLower() == strKeyField.ToLower())
										{
											bExist = true;
											break;
										}
									}
									if (bExist)
										cmdNew.InputParams["@" + strKeyField] = htKeyValues[strKeyField];

								}

							break;
					}
					//  .
					object objRet = cmdNew.Execute(true);

					bRes = true;

					if (objRet != null)
					{
						if ((int) objRet < 0)
						{
							string strMes;
							if (iOperation == OperationType.Edit)
								strMes = ResourceControl.String8;
							else
								strMes = ResourceControl.String9;
							MessageBox.Show(ResourceControl.String10 + strMes + ResourceControl.String11, strMes + ResourceControl.String12, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
							bRes = false;
						}
						else
							iOutIndex = (int) objRet;
					}


				}
			}
			return bRes;
		}

		protected bool Delete(string strDelete, string strKey, CuteSoftelGrid grdElement)


		{
			bool bRes = false;
			if (DialogResult.OK == MessageBox.Show(ResourceControl.String13, ResourceControl.String14, MessageBoxButtons.OKCancel, MessageBoxIcon.Warning))
			{
				Command cmdDel = new Command();
				cmdDel.CommandName = strDelete;

				string[] strKeyFields = strKey.Split(';');
				int iCount = strKeyFields.Length;
				int iIndex = 0;
				while(iIndex < iCount)
				{
					string strKeyField = strKeyFields[iIndex++];
					cmdDel.InputParams["@" + strKeyField] = grdElement.CurrentRow[strKeyField];
				}


				object objRet = cmdDel.Execute(true);
				if (objRet != null && (int) objRet < 0)
					MessageBox.Show(ResourceControl.String15, ResourceControl.String14, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				else
					bRes = true;

			}
			return bRes;
		}

		protected void FillInside(string strGetProcedure, CuteSoftelGrid grdElement, Hashtable htInputParams, ref DataTable dtTable,
		                          Action actDelete, Action actEdit)

		{
			using (Command cmdElement = new Command())
			{
				cmdElement.CommandName = strGetProcedure;
				foreach (string strKey in  htInputParams.Keys)
				{
					cmdElement.InputParams["@" + strKey] = htInputParams[strKey];
				}
				cmdElement.Execute(true);
				grdElement.DataSource = cmdElement.DataSet.Tables[0];
				dtTable = cmdElement.DataSet.Tables[0];
				//if(grdElement.TableStyles[0].GridColumnStyles.Count > 0)
				//	grdElement.ColumnAutoResize();


				if (cmdElement.DataSet.Tables[0].Rows.Count > 0)
				{
					actEdit.Enabled = true;
					actDelete.Enabled = true;
				}
				else
				{
					actEdit.Enabled = false;
					actDelete.Enabled = false;
				}


			}
			//grdElement.ColumnAutoResize();
		}


		private void m_actRefresh_Execute(object sender, EventArgs e)
		{
			Reload();
		}

		public int InputDataToInt(string m_strField)
		{
			object objFieldValue = InputData[m_strField];
			if (objFieldValue == null)
				return 0;
			else
				try
				{
					return Convert.ToInt32(objFieldValue);
				}
				catch (Exception exc)
				{
				}
			return -1;

		}

		public Hashtable InputData
		{
			get { return m_htArgs; }
		}

		public BillingTypes BillingType
		{
			get { return m_objBillingType; }
			set { m_objBillingType = value; }
		}

		protected enum OperationType
		{
			Insert = 1,
			Edit = 2
		}

		public string Tuning
		{
			get { return m_strTuning; }
			set { m_strTuning = value; }

		}
	}

}
/********************* SniipSoftel *****************
 *
 *    $History: DictionaryBaseForm.cs $
 *   
 *   *****************  Version 43  *****************
 *   User: Serg_ch      Date: 15.03.07   Time: 20:01
 *   Updated in $/Net/Common/ClientControl/DictionaryBaseForm
 *   
 *   *****************  Version 41  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/DictionaryBaseForm
 *   
 *   *****************  Version 40  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/DictionaryBaseForm
 *   
 *   *****************  Version 39  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/DictionaryBaseForm
 *
 ********************* SniipSoftel *****************/
