/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 13 $
 *   $Date: 23.07.07 20:09 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Windows.Forms
{
	/// <summary>
	/// Summary description for SomethingSomewhere1.
	/// </summary>
	public class Exchange : UserControl
	{
		private ButtonXP m_btnDelOne;
		private ButtonXP m_btnDelAll;
		private ButtonXP m_btnInsAll;
		private ButtonXP m_btnInsOne;
		private Label m_lblAvailable;
		private Label m_lblSelect;
		private DataTable m_dtSelected;
		private DataTable m_dtAvailable;
		private ListBox m_lvSelect;
		private ListBox m_lvAvailable;
		private string m_strSelectedDisplayMember;
		private string m_strSelectedValueMember;
		private string m_strAvailableDisplayMember;
		private string m_strAvailableValueMember;
		public event EventHandlerSS AfterChangeSelected;
		private ArrayList m_alInserted;
		private ArrayList m_alDeleted;
		private ArrayList m_alAvailable;
		private ArrayList m_alSelected;
		private CuteSoftelGrid m_grdSelected;
		private DataGridTableStyle m_stlSelected;
		private DataGridTextBoxColumn m_clnMember;
		private DataGridTextBoxColumn m_clnParent;
		private string m_strKeyField;
		private bool m_bReadOnly;

		public string[] m_strInsParams,
			m_strDelParams;

		public string m_strInsProc,
			m_strDelProc;

		public Hashtable m_htParams;

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private Container components = null;

		public Exchange()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			m_alInserted = new ArrayList();
			m_alDeleted = new ArrayList();
			m_alAvailable = new ArrayList();
			m_alSelected = new ArrayList();
			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Component Designer generated code

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Exchange));
			this.m_btnDelOne = new Softel.Windows.Forms.ButtonXP();
			this.m_btnDelAll = new Softel.Windows.Forms.ButtonXP();
			this.m_btnInsAll = new Softel.Windows.Forms.ButtonXP();
			this.m_btnInsOne = new Softel.Windows.Forms.ButtonXP();
			this.m_lblAvailable = new System.Windows.Forms.Label();
			this.m_lblSelect = new System.Windows.Forms.Label();
			this.m_lvSelect = new System.Windows.Forms.ListBox();
			this.m_lvAvailable = new System.Windows.Forms.ListBox();
			this.m_grdSelected = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_stlSelected = new System.Windows.Forms.DataGridTableStyle();
			this.m_clnMember = new System.Windows.Forms.DataGridTextBoxColumn();
			this.m_clnParent = new System.Windows.Forms.DataGridTextBoxColumn();
			((System.ComponentModel.ISupportInitialize)(this.m_grdSelected)).BeginInit();
			this.SuspendLayout();
			// 
			// m_btnDelOne
			// 
			this.m_btnDelOne.AccessibleDescription = resources.GetString("m_btnDelOne.AccessibleDescription");
			this.m_btnDelOne.AccessibleName = resources.GetString("m_btnDelOne.AccessibleName");
			this.m_btnDelOne.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_btnDelOne.Anchor")));
			this.m_btnDelOne.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(212)), ((System.Byte)(208)), ((System.Byte)(200)));
			this.m_btnDelOne.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_btnDelOne.BackgroundImage")));
			this.m_btnDelOne.DefaultScheme = true;
			this.m_btnDelOne.DialogResult = System.Windows.Forms.DialogResult.None;
			this.m_btnDelOne.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_btnDelOne.Dock")));
			this.m_btnDelOne.Enabled = ((bool)(resources.GetObject("m_btnDelOne.Enabled")));
			this.m_btnDelOne.Font = ((System.Drawing.Font)(resources.GetObject("m_btnDelOne.Font")));
			this.m_btnDelOne.Hint = "";
			this.m_btnDelOne.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_btnDelOne.ImeMode")));
			this.m_btnDelOne.Location = ((System.Drawing.Point)(resources.GetObject("m_btnDelOne.Location")));
			this.m_btnDelOne.Name = "m_btnDelOne";
			this.m_btnDelOne.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_btnDelOne.RightToLeft")));
			this.m_btnDelOne.Scheme = Softel.Windows.Forms.ButtonXP.Schemes.Blue;
			this.m_btnDelOne.Size = ((System.Drawing.Size)(resources.GetObject("m_btnDelOne.Size")));
			this.m_btnDelOne.TabIndex = ((int)(resources.GetObject("m_btnDelOne.TabIndex")));
			this.m_btnDelOne.Text = resources.GetString("m_btnDelOne.Text");
			this.m_btnDelOne.Visible = ((bool)(resources.GetObject("m_btnDelOne.Visible")));
			this.m_btnDelOne.Click += new System.EventHandler(this.m_btnDelOne_Click);
			// 
			// m_btnDelAll
			// 
			this.m_btnDelAll.AccessibleDescription = resources.GetString("m_btnDelAll.AccessibleDescription");
			this.m_btnDelAll.AccessibleName = resources.GetString("m_btnDelAll.AccessibleName");
			this.m_btnDelAll.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_btnDelAll.Anchor")));
			this.m_btnDelAll.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(212)), ((System.Byte)(208)), ((System.Byte)(200)));
			this.m_btnDelAll.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_btnDelAll.BackgroundImage")));
			this.m_btnDelAll.DefaultScheme = true;
			this.m_btnDelAll.DialogResult = System.Windows.Forms.DialogResult.None;
			this.m_btnDelAll.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_btnDelAll.Dock")));
			this.m_btnDelAll.Enabled = ((bool)(resources.GetObject("m_btnDelAll.Enabled")));
			this.m_btnDelAll.Font = ((System.Drawing.Font)(resources.GetObject("m_btnDelAll.Font")));
			this.m_btnDelAll.Hint = "";
			this.m_btnDelAll.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_btnDelAll.ImeMode")));
			this.m_btnDelAll.Location = ((System.Drawing.Point)(resources.GetObject("m_btnDelAll.Location")));
			this.m_btnDelAll.Name = "m_btnDelAll";
			this.m_btnDelAll.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_btnDelAll.RightToLeft")));
			this.m_btnDelAll.Scheme = Softel.Windows.Forms.ButtonXP.Schemes.Blue;
			this.m_btnDelAll.Size = ((System.Drawing.Size)(resources.GetObject("m_btnDelAll.Size")));
			this.m_btnDelAll.TabIndex = ((int)(resources.GetObject("m_btnDelAll.TabIndex")));
			this.m_btnDelAll.Text = resources.GetString("m_btnDelAll.Text");
			this.m_btnDelAll.Visible = ((bool)(resources.GetObject("m_btnDelAll.Visible")));
			this.m_btnDelAll.Click += new System.EventHandler(this.m_btnDelAll_Click);
			// 
			// m_btnInsAll
			// 
			this.m_btnInsAll.AccessibleDescription = resources.GetString("m_btnInsAll.AccessibleDescription");
			this.m_btnInsAll.AccessibleName = resources.GetString("m_btnInsAll.AccessibleName");
			this.m_btnInsAll.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_btnInsAll.Anchor")));
			this.m_btnInsAll.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(212)), ((System.Byte)(208)), ((System.Byte)(200)));
			this.m_btnInsAll.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_btnInsAll.BackgroundImage")));
			this.m_btnInsAll.DefaultScheme = true;
			this.m_btnInsAll.DialogResult = System.Windows.Forms.DialogResult.None;
			this.m_btnInsAll.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_btnInsAll.Dock")));
			this.m_btnInsAll.Enabled = ((bool)(resources.GetObject("m_btnInsAll.Enabled")));
			this.m_btnInsAll.Font = ((System.Drawing.Font)(resources.GetObject("m_btnInsAll.Font")));
			this.m_btnInsAll.Hint = "";
			this.m_btnInsAll.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_btnInsAll.ImeMode")));
			this.m_btnInsAll.Location = ((System.Drawing.Point)(resources.GetObject("m_btnInsAll.Location")));
			this.m_btnInsAll.Name = "m_btnInsAll";
			this.m_btnInsAll.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_btnInsAll.RightToLeft")));
			this.m_btnInsAll.Scheme = Softel.Windows.Forms.ButtonXP.Schemes.Blue;
			this.m_btnInsAll.Size = ((System.Drawing.Size)(resources.GetObject("m_btnInsAll.Size")));
			this.m_btnInsAll.TabIndex = ((int)(resources.GetObject("m_btnInsAll.TabIndex")));
			this.m_btnInsAll.Text = resources.GetString("m_btnInsAll.Text");
			this.m_btnInsAll.Visible = ((bool)(resources.GetObject("m_btnInsAll.Visible")));
			this.m_btnInsAll.Click += new System.EventHandler(this.m_btnInsAll_Click);
			// 
			// m_btnInsOne
			// 
			this.m_btnInsOne.AccessibleDescription = resources.GetString("m_btnInsOne.AccessibleDescription");
			this.m_btnInsOne.AccessibleName = resources.GetString("m_btnInsOne.AccessibleName");
			this.m_btnInsOne.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_btnInsOne.Anchor")));
			this.m_btnInsOne.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(212)), ((System.Byte)(208)), ((System.Byte)(200)));
			this.m_btnInsOne.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_btnInsOne.BackgroundImage")));
			this.m_btnInsOne.DefaultScheme = true;
			this.m_btnInsOne.DialogResult = System.Windows.Forms.DialogResult.None;
			this.m_btnInsOne.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_btnInsOne.Dock")));
			this.m_btnInsOne.Enabled = ((bool)(resources.GetObject("m_btnInsOne.Enabled")));
			this.m_btnInsOne.Font = ((System.Drawing.Font)(resources.GetObject("m_btnInsOne.Font")));
			this.m_btnInsOne.Hint = "";
			this.m_btnInsOne.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_btnInsOne.ImeMode")));
			this.m_btnInsOne.Location = ((System.Drawing.Point)(resources.GetObject("m_btnInsOne.Location")));
			this.m_btnInsOne.Name = "m_btnInsOne";
			this.m_btnInsOne.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_btnInsOne.RightToLeft")));
			this.m_btnInsOne.Scheme = Softel.Windows.Forms.ButtonXP.Schemes.Blue;
			this.m_btnInsOne.Size = ((System.Drawing.Size)(resources.GetObject("m_btnInsOne.Size")));
			this.m_btnInsOne.TabIndex = ((int)(resources.GetObject("m_btnInsOne.TabIndex")));
			this.m_btnInsOne.Text = resources.GetString("m_btnInsOne.Text");
			this.m_btnInsOne.Visible = ((bool)(resources.GetObject("m_btnInsOne.Visible")));
			this.m_btnInsOne.Click += new System.EventHandler(this.m_btnInsOne_Click);
			// 
			// m_lblAvailable
			// 
			this.m_lblAvailable.AccessibleDescription = resources.GetString("m_lblAvailable.AccessibleDescription");
			this.m_lblAvailable.AccessibleName = resources.GetString("m_lblAvailable.AccessibleName");
			this.m_lblAvailable.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_lblAvailable.Anchor")));
			this.m_lblAvailable.AutoSize = ((bool)(resources.GetObject("m_lblAvailable.AutoSize")));
			this.m_lblAvailable.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_lblAvailable.Dock")));
			this.m_lblAvailable.Enabled = ((bool)(resources.GetObject("m_lblAvailable.Enabled")));
			this.m_lblAvailable.Font = ((System.Drawing.Font)(resources.GetObject("m_lblAvailable.Font")));
			this.m_lblAvailable.Image = ((System.Drawing.Image)(resources.GetObject("m_lblAvailable.Image")));
			this.m_lblAvailable.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_lblAvailable.ImageAlign")));
			this.m_lblAvailable.ImageIndex = ((int)(resources.GetObject("m_lblAvailable.ImageIndex")));
			this.m_lblAvailable.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_lblAvailable.ImeMode")));
			this.m_lblAvailable.Location = ((System.Drawing.Point)(resources.GetObject("m_lblAvailable.Location")));
			this.m_lblAvailable.Name = "m_lblAvailable";
			this.m_lblAvailable.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_lblAvailable.RightToLeft")));
			this.m_lblAvailable.Size = ((System.Drawing.Size)(resources.GetObject("m_lblAvailable.Size")));
			this.m_lblAvailable.TabIndex = ((int)(resources.GetObject("m_lblAvailable.TabIndex")));
			this.m_lblAvailable.Text = resources.GetString("m_lblAvailable.Text");
			this.m_lblAvailable.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_lblAvailable.TextAlign")));
			this.m_lblAvailable.Visible = ((bool)(resources.GetObject("m_lblAvailable.Visible")));
			// 
			// m_lblSelect
			// 
			this.m_lblSelect.AccessibleDescription = resources.GetString("m_lblSelect.AccessibleDescription");
			this.m_lblSelect.AccessibleName = resources.GetString("m_lblSelect.AccessibleName");
			this.m_lblSelect.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_lblSelect.Anchor")));
			this.m_lblSelect.AutoSize = ((bool)(resources.GetObject("m_lblSelect.AutoSize")));
			this.m_lblSelect.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_lblSelect.Dock")));
			this.m_lblSelect.Enabled = ((bool)(resources.GetObject("m_lblSelect.Enabled")));
			this.m_lblSelect.Font = ((System.Drawing.Font)(resources.GetObject("m_lblSelect.Font")));
			this.m_lblSelect.Image = ((System.Drawing.Image)(resources.GetObject("m_lblSelect.Image")));
			this.m_lblSelect.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_lblSelect.ImageAlign")));
			this.m_lblSelect.ImageIndex = ((int)(resources.GetObject("m_lblSelect.ImageIndex")));
			this.m_lblSelect.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_lblSelect.ImeMode")));
			this.m_lblSelect.Location = ((System.Drawing.Point)(resources.GetObject("m_lblSelect.Location")));
			this.m_lblSelect.Name = "m_lblSelect";
			this.m_lblSelect.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_lblSelect.RightToLeft")));
			this.m_lblSelect.Size = ((System.Drawing.Size)(resources.GetObject("m_lblSelect.Size")));
			this.m_lblSelect.TabIndex = ((int)(resources.GetObject("m_lblSelect.TabIndex")));
			this.m_lblSelect.Text = resources.GetString("m_lblSelect.Text");
			this.m_lblSelect.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_lblSelect.TextAlign")));
			this.m_lblSelect.Visible = ((bool)(resources.GetObject("m_lblSelect.Visible")));
			// 
			// m_lvSelect
			// 
			this.m_lvSelect.AccessibleDescription = resources.GetString("m_lvSelect.AccessibleDescription");
			this.m_lvSelect.AccessibleName = resources.GetString("m_lvSelect.AccessibleName");
			this.m_lvSelect.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_lvSelect.Anchor")));
			this.m_lvSelect.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_lvSelect.BackgroundImage")));
			this.m_lvSelect.ColumnWidth = ((int)(resources.GetObject("m_lvSelect.ColumnWidth")));
			this.m_lvSelect.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_lvSelect.Dock")));
			this.m_lvSelect.Enabled = ((bool)(resources.GetObject("m_lvSelect.Enabled")));
			this.m_lvSelect.Font = ((System.Drawing.Font)(resources.GetObject("m_lvSelect.Font")));
			this.m_lvSelect.HorizontalExtent = ((int)(resources.GetObject("m_lvSelect.HorizontalExtent")));
			this.m_lvSelect.HorizontalScrollbar = ((bool)(resources.GetObject("m_lvSelect.HorizontalScrollbar")));
			this.m_lvSelect.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_lvSelect.ImeMode")));
			this.m_lvSelect.IntegralHeight = ((bool)(resources.GetObject("m_lvSelect.IntegralHeight")));
			this.m_lvSelect.ItemHeight = ((int)(resources.GetObject("m_lvSelect.ItemHeight")));
			this.m_lvSelect.Location = ((System.Drawing.Point)(resources.GetObject("m_lvSelect.Location")));
			this.m_lvSelect.Name = "m_lvSelect";
			this.m_lvSelect.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_lvSelect.RightToLeft")));
			this.m_lvSelect.ScrollAlwaysVisible = ((bool)(resources.GetObject("m_lvSelect.ScrollAlwaysVisible")));
			this.m_lvSelect.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.m_lvSelect.Size = ((System.Drawing.Size)(resources.GetObject("m_lvSelect.Size")));
			this.m_lvSelect.TabIndex = ((int)(resources.GetObject("m_lvSelect.TabIndex")));
			this.m_lvSelect.Visible = ((bool)(resources.GetObject("m_lvSelect.Visible")));
			// 
			// m_lvAvailable
			// 
			this.m_lvAvailable.AccessibleDescription = resources.GetString("m_lvAvailable.AccessibleDescription");
			this.m_lvAvailable.AccessibleName = resources.GetString("m_lvAvailable.AccessibleName");
			this.m_lvAvailable.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_lvAvailable.Anchor")));
			this.m_lvAvailable.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_lvAvailable.BackgroundImage")));
			this.m_lvAvailable.ColumnWidth = ((int)(resources.GetObject("m_lvAvailable.ColumnWidth")));
			this.m_lvAvailable.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_lvAvailable.Dock")));
			this.m_lvAvailable.Enabled = ((bool)(resources.GetObject("m_lvAvailable.Enabled")));
			this.m_lvAvailable.Font = ((System.Drawing.Font)(resources.GetObject("m_lvAvailable.Font")));
			this.m_lvAvailable.HorizontalExtent = ((int)(resources.GetObject("m_lvAvailable.HorizontalExtent")));
			this.m_lvAvailable.HorizontalScrollbar = ((bool)(resources.GetObject("m_lvAvailable.HorizontalScrollbar")));
			this.m_lvAvailable.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_lvAvailable.ImeMode")));
			this.m_lvAvailable.IntegralHeight = ((bool)(resources.GetObject("m_lvAvailable.IntegralHeight")));
			this.m_lvAvailable.ItemHeight = ((int)(resources.GetObject("m_lvAvailable.ItemHeight")));
			this.m_lvAvailable.Location = ((System.Drawing.Point)(resources.GetObject("m_lvAvailable.Location")));
			this.m_lvAvailable.Name = "m_lvAvailable";
			this.m_lvAvailable.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_lvAvailable.RightToLeft")));
			this.m_lvAvailable.ScrollAlwaysVisible = ((bool)(resources.GetObject("m_lvAvailable.ScrollAlwaysVisible")));
			this.m_lvAvailable.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.m_lvAvailable.Size = ((System.Drawing.Size)(resources.GetObject("m_lvAvailable.Size")));
			this.m_lvAvailable.TabIndex = ((int)(resources.GetObject("m_lvAvailable.TabIndex")));
			this.m_lvAvailable.Visible = ((bool)(resources.GetObject("m_lvAvailable.Visible")));
			this.m_lvAvailable.DoubleClick += new System.EventHandler(this.m_btnInsOne_Click);
			// 
			// m_grdSelected
			// 
			this.m_grdSelected.AccessibleDescription = resources.GetString("m_grdSelected.AccessibleDescription");
			this.m_grdSelected.AccessibleName = resources.GetString("m_grdSelected.AccessibleName");
			this.m_grdSelected.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdSelected.Anchor")));
			this.m_grdSelected.BackgroundColor = System.Drawing.SystemColors.Window;
			this.m_grdSelected.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdSelected.BackgroundImage")));
			this.m_grdSelected.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdSelected.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdSelected.CaptionFont")));
			this.m_grdSelected.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdSelected.CaptionText = resources.GetString("m_grdSelected.CaptionText");
			this.m_grdSelected.CaptionVisible = false;
			this.m_grdSelected.ColumnHeadersVisible = false;
			this.m_grdSelected.DataMember = "";
			this.m_grdSelected.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdSelected.Dock")));
			this.m_grdSelected.Enabled = ((bool)(resources.GetObject("m_grdSelected.Enabled")));
			this.m_grdSelected.Font = ((System.Drawing.Font)(resources.GetObject("m_grdSelected.Font")));
			this.m_grdSelected.GridLineColor = System.Drawing.SystemColors.ActiveCaption;
			this.m_grdSelected.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdSelected.HighlightRow = true;
			this.m_grdSelected.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdSelected.ImeMode")));
			this.m_grdSelected.Location = ((System.Drawing.Point)(resources.GetObject("m_grdSelected.Location")));
			this.m_grdSelected.Name = "m_grdSelected";
			this.m_grdSelected.ParentRowsVisible = false;
			this.m_grdSelected.ReadOnly = true;
			this.m_grdSelected.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdSelected.RightToLeft")));
			this.m_grdSelected.RowHeadersVisible = false;
			this.m_grdSelected.RowHeaderWidth = 10;
			this.m_grdSelected.Size = ((System.Drawing.Size)(resources.GetObject("m_grdSelected.Size")));
			this.m_grdSelected.TabIndex = ((int)(resources.GetObject("m_grdSelected.TabIndex")));
			this.m_grdSelected.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
																									  this.m_stlSelected});
			this.m_grdSelected.Visible = ((bool)(resources.GetObject("m_grdSelected.Visible")));
			this.m_grdSelected.DoubleClick += new System.EventHandler(this.m_btnDelOne_Click);
			this.m_grdSelected.CurrentCellChanged += new System.EventHandler(this.m_grdSelected_CurrentCellChanged);
			// 
			// m_stlSelected
			// 
			this.m_stlSelected.ColumnHeadersVisible = false;
			this.m_stlSelected.DataGrid = this.m_grdSelected;
			this.m_stlSelected.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
																											this.m_clnMember,
																											this.m_clnParent});
			this.m_stlSelected.GridLineStyle = System.Windows.Forms.DataGridLineStyle.None;
			this.m_stlSelected.HeaderFont = ((System.Drawing.Font)(resources.GetObject("m_stlSelected.HeaderFont")));
			this.m_stlSelected.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_stlSelected.MappingName = "Table";
			this.m_stlSelected.PreferredColumnWidth = ((int)(resources.GetObject("m_stlSelected.PreferredColumnWidth")));
			this.m_stlSelected.PreferredRowHeight = ((int)(resources.GetObject("m_stlSelected.PreferredRowHeight")));
			this.m_stlSelected.ReadOnly = true;
			this.m_stlSelected.RowHeadersVisible = false;
			this.m_stlSelected.RowHeaderWidth = ((int)(resources.GetObject("m_stlSelected.RowHeaderWidth")));
			// 
			// m_clnMember
			// 
			this.m_clnMember.Alignment = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("m_clnMember.Alignment")));
			this.m_clnMember.Format = "";
			this.m_clnMember.FormatInfo = null;
			this.m_clnMember.HeaderText = resources.GetString("m_clnMember.HeaderText");
			this.m_clnMember.MappingName = resources.GetString("m_clnMember.MappingName");
			this.m_clnMember.NullText = resources.GetString("m_clnMember.NullText");
			this.m_clnMember.ReadOnly = true;
			this.m_clnMember.Width = ((int)(resources.GetObject("m_clnMember.Width")));
			// 
			// m_clnParent
			// 
			this.m_clnParent.Alignment = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("m_clnParent.Alignment")));
			this.m_clnParent.Format = "";
			this.m_clnParent.FormatInfo = null;
			this.m_clnParent.HeaderText = resources.GetString("m_clnParent.HeaderText");
			this.m_clnParent.MappingName = resources.GetString("m_clnParent.MappingName");
			this.m_clnParent.NullText = resources.GetString("m_clnParent.NullText");
			this.m_clnParent.ReadOnly = true;
			this.m_clnParent.Width = ((int)(resources.GetObject("m_clnParent.Width")));
			// 
			// Exchange
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.Controls.Add(this.m_grdSelected);
			this.Controls.Add(this.m_lvAvailable);
			this.Controls.Add(this.m_lvSelect);
			this.Controls.Add(this.m_btnDelOne);
			this.Controls.Add(this.m_btnDelAll);
			this.Controls.Add(this.m_btnInsAll);
			this.Controls.Add(this.m_btnInsOne);
			this.Controls.Add(this.m_lblAvailable);
			this.Controls.Add(this.m_lblSelect);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Name = "Exchange";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.Size = ((System.Drawing.Size)(resources.GetObject("$this.Size")));
			this.SizeChanged += new System.EventHandler(this.SomethingSomewhere_SizeChanged);
			((System.ComponentModel.ISupportInitialize)(this.m_grdSelected)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		private void SomethingSomewhere_SizeChanged(object sender, EventArgs e)
		{
			int iWidth = (Width - 416)/2;
			int iHeight = (Height - 376)/2;

			m_lblSelect.Width = 176 + iWidth;
			m_lblAvailable.Left = 236 + iWidth;
			m_lblAvailable.Width = 176 + iWidth;

			m_lvSelect.Width = 176 + iWidth;
			m_grdSelected.Width = 176 + iWidth;
			m_lvAvailable.Left = 236 + iWidth;
			m_lvAvailable.Width = 176 + iWidth;

			m_btnInsAll.Left = 192 + iWidth;
			m_btnInsOne.Left = 192 + iWidth;
			m_btnDelAll.Left = 192 + iWidth;
			m_btnDelOne.Left = 192 + iWidth;

			m_btnInsAll.Top = 128 + iHeight;
			m_btnInsOne.Top = 96 + iHeight;
			m_btnDelAll.Top = 160 + iHeight;
			m_btnDelOne.Top = 192 + iHeight;
		}

		private void m_btnInsOne_Click(object sender, EventArgs e)
		{
			if (!ReadOnly)
			{
				DataRowView[] drvCopy = new DataRowView[m_lvAvailable.SelectedItems.Count];
				m_lvAvailable.SelectedItems.CopyTo(drvCopy, 0);
				Insert(drvCopy);
			}
		}

		private void m_btnInsAll_Click(object sender, EventArgs e)
		{
			DataRowView[] drvCopy = new DataRowView[m_lvAvailable.Items.Count];
			m_lvAvailable.Items.CopyTo(drvCopy, 0);
			Insert(drvCopy);
		}

		private void Insert(DataRowView[] drvCopy)
		{
			int iCount = drvCopy.Length;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				DataRowView drvChange = drvCopy[iIndex++];
				object objKey = drvChange.Row[m_strSelectedValueMember];
				m_dtSelected.Rows.Add(drvChange.Row.ItemArray);
//				ApplyInsert(m_htParams, m_strInsProc, m_strInsParams);

				if (!m_alInserted.Contains(objKey) && !m_alSelected.Contains(objKey))
					m_alInserted.Add(objKey);
				if (m_alDeleted.Contains(objKey))
					m_alDeleted.Remove(objKey);
				m_dtAvailable.Rows.Remove(drvChange.Row);
			}
			EnabledButton();
			if (AfterChangeSelected != null)
				AfterChangeSelected(!(m_alDeleted.Count == 0 && m_alInserted.Count == 0));
		}

		private void m_btnDelOne_Click(object sender, EventArgs e)
		{
			if (!ReadOnly)
				Delete(new DataRow[] {m_grdSelected.CurrentRow});
		}

		private void m_btnDelAll_Click(object sender, EventArgs e)
		{
			ArrayList alRows;
			if (m_strKeyField != null)
				alRows = new ArrayList(m_dtSelected.Select(string.Format("{0} = ''", m_strKeyField)));
			else
				alRows = new ArrayList(m_dtSelected.Select());
			Delete((DataRow[]) alRows.ToArray(typeof (DataRow)));
		}

//		public void ApplyInsert(Hashtable htParams, string strInsProc, string[] asInsert)
//		{
//			if (strInsProc == "") 
//				return;
//			Command cmdApply = new Command();
//			cmdApply.CommandName = strInsProc;
//
//			for (int i = 0; i < asInsert.LongLength; i++)
//				cmdApply.InputParams[asInsert[i]] = htParams[asInsert[i]];
//			
//			cmdApply.Execute(true);
//		}
//
//		public void ApplyDelete(Hashtable htParams, string strDelProc, string[] asDelete)
//		{
//			if (strDelProc == "") return;
//			Command cmdApply = new Command();
//			cmdApply.CommandName = strDelProc;
//			
//			for (int i = 0; i < asDelete.LongLength; i++)
//				cmdApply.InputParams[asDelete[i]] = htParams[asDelete[i]];
//
//			cmdApply.Execute(true);
//		}

		private void Delete(DataRow[] drcCopy)
		{
			int iCount = drcCopy.Length;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				DataRow drChange = drcCopy[iIndex++];
				if(drChange != null)
				{
					object objKey = drChange[m_strSelectedValueMember];
					m_dtAvailable.Rows.Add(drChange.ItemArray);
					//				ApplyDelete(m_htParams, m_strDelProc, m_strDelParams);
					if (m_alInserted.Contains(objKey))
						m_alInserted.Remove(objKey);
					if (!m_alDeleted.Contains(objKey) && !m_alAvailable.Contains(objKey))
						m_alDeleted.Add(objKey);
					m_dtSelected.Rows.Remove(drChange);
				}
			}
			EnabledButton();

			if (AfterChangeSelected != null)
				AfterChangeSelected(!(m_alDeleted.Count == 0 && m_alInserted.Count == 0));
		}

		public string SelectedLabel
		{
			get { return m_lblSelect.Text; }
			set
			{
				m_lblSelect.Text = string.Format(ResourceControl.String16, value);
//				m_clnMember.HeaderText = value;
			}
		}

		public string AvailableLabel
		{
			get { return m_lblAvailable.Text; }
			set { m_lblAvailable.Text = string.Format(ResourceControl.String17, value); }
		}

		public DataTable SelectedData
		{
			set
			{
				m_dtSelected = value;
				m_alInserted.Clear();
				m_alDeleted.Clear();
				m_clnMember.MappingName = m_strSelectedDisplayMember;
				m_clnParent.MappingName = m_strKeyField;
				m_grdSelected.DataSource = m_dtSelected;
				EnabledButton();
				if (m_dtSelected.Rows.Count > 0)
				{
					if (m_strKeyField != null && m_dtSelected.Rows[0][m_strKeyField].ToString() != "")
						m_btnDelOne.Enabled = false;
					else
						m_btnDelOne.Enabled = true;
				}
				m_alSelected.Clear();
				int iCount = value.Rows.Count;
				int iIndex = 0;
				while(iIndex < iCount)
				{
					DataRow drEx = value.Rows[iIndex++];
					m_alSelected.Add(drEx[m_strSelectedValueMember]);
				}
			}
		}

		public DataTable AvailableData
		{
			set
			{
				m_dtAvailable = value;
				m_lvAvailable.DataSource = value;
				string strDisplay = m_strAvailableDisplayMember;
				string strValue = m_strAvailableValueMember;
				try
				{
					int iIndex1 = m_dtAvailable.Columns.IndexOf(strDisplay);
					if(iIndex1 != -1)
						m_lvAvailable.DisplayMember = m_dtAvailable.Columns[iIndex1].ColumnName;
					else
						m_lvAvailable.DisplayMember = "id";
					iIndex1 = m_dtAvailable.Columns.IndexOf(strValue);
					if(iIndex1 != -1)
						m_lvAvailable.ValueMember = m_dtAvailable.Columns[iIndex1].ColumnName;
					else
						m_lvAvailable.ValueMember = "id";
				}
				catch(Exception excSwitch)
				{
					MessageBox.Show(ResourceControl.String60, ResourceControl.String61, MessageBoxButtons.OK, MessageBoxIcon.Error, excSwitch.ToString());
				}
/*
				if (m_strAvailableDisplayMember == null)
					m_lvAvailable.DisplayMember = "id";
				else
					m_lvAvailable.DisplayMember = m_strAvailableDisplayMember;
				if (m_strAvailableValueMember == null)
					m_lvAvailable.ValueMember = "id";
				else
					m_lvAvailable.ValueMember = m_strAvailableValueMember;
*/
				m_alAvailable.Clear();
				int iCount = value.Rows.Count;
				int iIndex = 0;
				while(iIndex < iCount)
				{
					DataRow drEx = value.Rows[iIndex++];
					m_alAvailable.Add(drEx[m_strAvailableValueMember]);
				}
			}
		}

		public object[] DataChangeIns
		{
			get { return m_alInserted.ToArray(); }
		}

		public object[] DataChangeDel
		{
			get { return m_alDeleted.ToArray(); }
		}

		public string SelectedDisplayMember
		{
			set { m_strSelectedDisplayMember = value; }
		}

		public string SelectedValueMember
		{
			set { m_strSelectedValueMember = value; }
		}

		public string AvailableDisplayMember
		{
			set { m_strAvailableDisplayMember = value; }
		}

		public string AvailableValueMember
		{
			set { m_strAvailableValueMember = value; }
		}

		public string KeyField
		{
			set { m_strKeyField = value; }
		}

		public void Commit()
		{
			int iCount = m_alInserted.Count;
			int iIndex = 0;
			while(iIndex < iCount)
			{
				object objKey = m_alInserted[iIndex++];
				m_alSelected.Add(objKey);
				m_alAvailable.Remove(objKey);
			}
			iCount = m_alDeleted.Count;
			iIndex = 0;
			while(iIndex < iCount)
			{
				object objKey = m_alDeleted[iIndex++];
				m_alSelected.Remove(objKey);
				m_alAvailable.Add(objKey);
			}
			m_alInserted.Clear();
			m_alDeleted.Clear();
		}

		public void Rollback()
		{
			m_alInserted.Clear();
			m_alDeleted.Clear();
		}

		private void m_grdSelected_CurrentCellChanged(object sender, EventArgs e)
		{
			if (m_grdSelected.CurrentRow != null)
			{
				if (m_strKeyField != null && m_grdSelected.CurrentRow[m_strKeyField].ToString() != "")
					m_btnDelOne.Enabled = false;
				else
					m_btnDelOne.Enabled = true;
			}
		}

		public bool ReadOnly
		{
			get { return m_bReadOnly; }
			set
			{
				m_bReadOnly = value;
				if (value)
				{
					m_btnDelOne.Enabled = false;
					m_btnDelAll.Enabled = false;
					m_btnInsOne.Enabled = false;
					m_btnInsAll.Enabled = false;
				}
			}
		}

		private void EnabledButton()
		{
			if (m_dtSelected.Rows.Count == 0)
			{
				m_btnDelOne.Enabled = false;
				m_btnDelAll.Enabled = false;
			}
			else if (m_strKeyField != null && m_dtSelected.Select(string.Format("{0} = ''", m_strKeyField)).Length == 0)
			{
				m_btnDelOne.Enabled = false;
				m_btnDelAll.Enabled = false;
			}
			else
			{
				m_btnDelOne.Enabled = true;
				m_btnDelAll.Enabled = true;
			}

			if (m_dtAvailable.Rows.Count == 0)
			{
				m_btnInsOne.Enabled = false;
				m_btnInsAll.Enabled = false;
			}
			else
			{
				m_btnInsOne.Enabled = true;
				m_btnInsAll.Enabled = true;
			}
		}
	}

	public delegate void EventHandlerSS(bool bIsChange);
}
/********************* SniipSoftel *****************
 *
 *    $History: Exchange.cs $
 *   
 *   *****************  Version 13  *****************
 *   User: Serg_ch      Date: 23.07.07   Time: 20:09
 *   Updated in $/Net/Common/ClientControl/Exchange
 *   
 *   *****************  Version 11  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/Exchange
 *   
 *   *****************  Version 10  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/Exchange
 *
 ********************* SniipSoftel *****************/
