/********************* SniipSoftel *****************
 *
 *   $Author: Autobuild $
 *   $Revision: 3 $
 *   $Date: 19.12.06 23:18 $
 *
 ********************* SniipSoftel *****************/
///////////////////////////////////////////////////////////////////////////////
// filename		= LocalMod.cs
// domainname	= SOFTEL-GAV
// username		= gavrilov
// fullusername = gavrilov
// projectname	= LocalMod
// curdate		= 26.04.2006
///////////////////////////////////////////////////////////////////////////////


using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Softel.MiddleTier.Client;
using Softel.Windows.Forms.CuteTableStyles;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Windows.Forms
{

	public class ExchangeCtrl : UserControl, ITreeBaseForm
	{
		private GroupBox m_grbParam;
		private IContainer components;
		private DataTable m_dtTuningMaster;
		private DataTable m_dtTuningDetail;
		private DataTable m_dtMaster;
		private DataTable m_dtDetail;
		private Hashtable m_htMasterParam;
		private Hashtable m_htDetailParam;
		private GlobalImageList m_gil;
		private Splitter m_splTop;
		private Panel m_pnlDetail;
		private ToolBar m_tbDetail;

		private ContextMenu m_cmDetail;
		private MenuItem m_miInsertDetail;
		private MenuItem m_miEditDetail;
		private MenuItem m_miDeleteDetail;

		private string m_strConnectField;

		private bool m_bControlFieldDetail;
		private bool m_bControlFieldMaster;

		private string m_strGetDetail;
		private string m_strGetMaster;

		private string m_strDeleteDetail;
		private string m_strDeleteMaster;

		private string m_strKeyFieldDetail;
		private string m_strKeyFieldMaster;

		private bool m_bDetailAll;
		private bool m_bMasterAll;


		private string m_strTuningDetail;

		private string m_strTuningMaster;
		private Action m_actInsertDetail;
		private Action m_actEditDetail;
		private Action m_actDeleteDetail;
		private bool m_bInit;
		private System.Windows.Forms.ImageList SoftelImageList;
		private System.Windows.Forms.Label m_lblCaption;
		public Hashtable m_htArgs;
		private System.Windows.Forms.ToolBarButton m_tbbSave;
		private System.Windows.Forms.ToolBarButton m_tbbCancel;
		private System.Windows.Forms.ToolBarButton m_tbbRefresh;
		private string m_strTuning;
		string m_strAvailableValueMember;
		string m_strAvailableDisplayMember;
		string m_strSelectValueMember;
		string m_strSelectDisplayMember;
		string m_strDeleteProcedure;
		string m_strInsertProcedure;
		
		private Softel.Windows.Forms.ActionList m_alMain;
		private Softel.Windows.Forms.Action m_actSave;
		private Softel.Windows.Forms.Action m_actCancel;
		private Softel.Windows.Forms.Action m_actRefresh;
		Exchange m_objExchange;
		


		/// <summary>
		///  ,      
		///  
		/// </summary>
		public ExchangeCtrl()
		{
			InitializeComponent();
	
		}

		/// <summary>
		/// ,        <see cref=""/>   
		///    
		/// </summary>
		/// <param name="htArgs">  <see cref="Hashtable">,   </param>
		/// <remarks>
		/// 	<para>     :</para>
		/// 	<list type="bullet">
		/// 		<item>cln_id - id </item>
		/// 		<item>ac_id - id  </item>
		/// 		<item>sub_id - id </item>
		/// 	</list>
		/// </remarks>
		public ExchangeCtrl(Hashtable htArgs) 
		{
			InitializeComponent();
			if(m_objExchange == null)
			{
				m_objExchange = new Exchange();
				m_objExchange.Parent = this.m_pnlDetail;
				m_objExchange.Dock=DockStyle.Fill;
				
				
			}

			m_htMasterParam = new Hashtable();

			m_htDetailParam = new Hashtable();
			InitParams(htArgs);

			m_bInit = ReadDictionary();

			if (m_bMasterAll)
				m_htMasterParam.Add("all", null);

			if (m_bDetailAll)
				m_htDetailParam.Add("all", null);


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ExchangeCtrl));
			this.m_grbParam = new System.Windows.Forms.GroupBox();
			this.m_lblCaption = new System.Windows.Forms.Label();
			this.m_cmDetail = new System.Windows.Forms.ContextMenu();
			this.m_miInsertDetail = new System.Windows.Forms.MenuItem();
			this.m_miEditDetail = new System.Windows.Forms.MenuItem();
			this.m_miDeleteDetail = new System.Windows.Forms.MenuItem();
			this.SoftelImageList = new System.Windows.Forms.ImageList(this.components);
			this.m_gil = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_splTop = new System.Windows.Forms.Splitter();
			this.m_pnlDetail = new System.Windows.Forms.Panel();
			this.m_tbDetail = new System.Windows.Forms.ToolBar();
			this.m_tbbSave = new System.Windows.Forms.ToolBarButton();
			this.m_tbbCancel = new System.Windows.Forms.ToolBarButton();
			this.m_tbbRefresh = new System.Windows.Forms.ToolBarButton();
			this.m_actInsertDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actEditDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actDeleteDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_alMain = new Softel.Windows.Forms.ActionList(this.components);
			this.m_actSave = new Softel.Windows.Forms.Action(this.components);
			this.m_actCancel = new Softel.Windows.Forms.Action(this.components);
			this.m_actRefresh = new Softel.Windows.Forms.Action(this.components);
			this.m_grbParam.SuspendLayout();
			this.m_pnlDetail.SuspendLayout();
			this.SuspendLayout();
			// 
			// m_grbParam
			// 
			this.m_grbParam.BackColor = System.Drawing.Color.Gainsboro;
			this.m_grbParam.Controls.Add(this.m_lblCaption);
			this.m_grbParam.Dock = System.Windows.Forms.DockStyle.Top;
			this.m_grbParam.Location = new System.Drawing.Point(0, 0);
			this.m_grbParam.Name = "m_grbParam";
			this.m_grbParam.Size = new System.Drawing.Size(544, 32);
			this.m_grbParam.TabIndex = 9;
			this.m_grbParam.TabStop = false;
			// 
			// m_lblCaption
			// 
			this.m_lblCaption.BackColor = System.Drawing.Color.Gainsboro;
			this.m_lblCaption.Dock = System.Windows.Forms.DockStyle.Fill;
			this.m_lblCaption.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.m_lblCaption.Location = new System.Drawing.Point(3, 16);
			this.m_lblCaption.Name = "m_lblCaption";
			this.m_lblCaption.Size = new System.Drawing.Size(538, 13);
			this.m_lblCaption.TabIndex = 0;
			// 
			// m_cmDetail
			// 
			this.m_cmDetail.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.m_miInsertDetail,
																					   this.m_miEditDetail,
																					   this.m_miDeleteDetail});
			// 
			// m_miInsertDetail
			// 
			this.m_miInsertDetail.Index = 0;
			this.m_miInsertDetail.MergeOrder = 32;
			this.m_miInsertDetail.ShowShortcut = false;
			this.m_miInsertDetail.Text = "";
			// 
			// m_miEditDetail
			// 
			this.m_miEditDetail.Index = 1;
			this.m_miEditDetail.MergeOrder = 33;
			this.m_miEditDetail.Text = "";
			// 
			// m_miDeleteDetail
			// 
			this.m_miDeleteDetail.Index = 2;
			this.m_miDeleteDetail.MergeOrder = 31;
			this.m_miDeleteDetail.ShowShortcut = false;
			this.m_miDeleteDetail.Text = "";
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			this.SoftelImageList.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// m_gil
			// 
			this.m_gil.ImageList = this.SoftelImageList;
			this.m_gil.Parent = this;
			// 
			// m_splTop
			// 
			this.m_splTop.Dock = System.Windows.Forms.DockStyle.Top;
			this.m_splTop.Location = new System.Drawing.Point(0, 32);
			this.m_splTop.Name = "m_splTop";
			this.m_splTop.Size = new System.Drawing.Size(544, 3);
			this.m_splTop.TabIndex = 13;
			this.m_splTop.TabStop = false;
			// 
			// m_pnlDetail
			// 
			this.m_pnlDetail.Controls.Add(this.m_tbDetail);
			this.m_pnlDetail.Dock = System.Windows.Forms.DockStyle.Fill;
			this.m_pnlDetail.Location = new System.Drawing.Point(0, 35);
			this.m_pnlDetail.Name = "m_pnlDetail";
			this.m_pnlDetail.Size = new System.Drawing.Size(544, 413);
			this.m_pnlDetail.TabIndex = 14;
			// 
			// m_tbDetail
			// 
			this.m_tbDetail.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.m_tbDetail.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						  this.m_tbbSave,
																						  this.m_tbbCancel,
																						  this.m_tbbRefresh});
			this.m_tbDetail.DropDownArrows = true;
			this.m_tbDetail.ImageList = this.SoftelImageList;
			this.m_tbDetail.Location = new System.Drawing.Point(0, 0);
			this.m_tbDetail.Name = "m_tbDetail";
			this.m_tbDetail.ShowToolTips = true;
			this.m_tbDetail.Size = new System.Drawing.Size(544, 28);
			this.m_tbDetail.TabIndex = 0;
			// 
			// m_tbbSave
			// 
			this.m_alMain.SetAction(this.m_tbbSave, this.m_actSave);
			this.m_tbbSave.ImageIndex = 12;
			this.m_tbbSave.Tag = "1";
			this.m_tbbSave.ToolTipText = "";
			// 
			// m_tbbCancel
			// 
			this.m_alMain.SetAction(this.m_tbbCancel, this.m_actCancel);
			this.m_tbbCancel.ImageIndex = 13;
			this.m_tbbCancel.Tag = "2";
			this.m_tbbCancel.ToolTipText = "";
			// 
			// m_tbbRefresh
			// 
			this.m_alMain.SetAction(this.m_tbbRefresh, this.m_actRefresh);
			this.m_tbbRefresh.ImageIndex = 21;
			this.m_tbbRefresh.Tag = "3";
			this.m_tbbRefresh.ToolTipText = "";
			// 
			// m_actInsertDetail
			// 
			this.m_actInsertDetail.Checked = false;
			this.m_actInsertDetail.Enabled = true;
			this.m_actInsertDetail.Hint = "";
			this.m_actInsertDetail.ImageIndex = 32;
			this.m_actInsertDetail.MergeOrder = 32;
			this.m_actInsertDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actInsertDetail.Tag = null;
			this.m_actInsertDetail.Text = "";
			this.m_actInsertDetail.Visible = true;
			// 
			// m_actEditDetail
			// 
			this.m_actEditDetail.Checked = false;
			this.m_actEditDetail.Enabled = true;
			this.m_actEditDetail.Hint = "";
			this.m_actEditDetail.ImageIndex = 33;
			this.m_actEditDetail.MergeOrder = 33;
			this.m_actEditDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actEditDetail.Tag = null;
			this.m_actEditDetail.Text = "";
			this.m_actEditDetail.Visible = true;
			// 
			// m_actDeleteDetail
			// 
			this.m_actDeleteDetail.Checked = false;
			this.m_actDeleteDetail.Enabled = true;
			this.m_actDeleteDetail.Hint = "";
			this.m_actDeleteDetail.ImageIndex = 31;
			this.m_actDeleteDetail.MergeOrder = 31;
			this.m_actDeleteDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDeleteDetail.Tag = null;
			this.m_actDeleteDetail.Text = "";
			this.m_actDeleteDetail.Visible = true;
			// 
			// m_alMain
			// 
			this.m_alMain.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																				 this.m_actSave,
																				 this.m_actCancel,
																				 this.m_actRefresh});
			this.m_alMain.ImageList = this.SoftelImageList;
			this.m_alMain.ShowTextOnToolBar = false;
			this.m_alMain.Tag = null;
			// 
			// m_actSave
			// 
			this.m_actSave.Checked = false;
			this.m_actSave.Enabled = true;
			this.m_actSave.Hint = "";
			this.m_actSave.ImageIndex = 12;
			this.m_actSave.MergeOrder = 12;
			this.m_actSave.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actSave.Tag = null;
			this.m_actSave.Text = "";
			this.m_actSave.Visible = true;
			this.m_actSave.Execute += new System.EventHandler(this.m_actSave_Execute);
			// 
			// m_actCancel
			// 
			this.m_actCancel.Checked = false;
			this.m_actCancel.Enabled = true;
			this.m_actCancel.Hint = "";
			this.m_actCancel.ImageIndex = 13;
			this.m_actCancel.MergeOrder = 13;
			this.m_actCancel.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actCancel.Tag = null;
			this.m_actCancel.Text = "";
			this.m_actCancel.Visible = true;
			this.m_actCancel.Execute += new System.EventHandler(this.m_actCancel_Execute);
			// 
			// m_actRefresh
			// 
			this.m_actRefresh.Checked = false;
			this.m_actRefresh.Enabled = true;
			this.m_actRefresh.Hint = "";
			this.m_actRefresh.ImageIndex = 21;
			this.m_actRefresh.MergeOrder = 21;
			this.m_actRefresh.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actRefresh.Tag = null;
			this.m_actRefresh.Text = "";
			this.m_actRefresh.Visible = true;
			this.m_actRefresh.Execute += new System.EventHandler(this.m_actRefresh_Execute);
			// 
			// ExchangeCtrl
			// 
			this.Controls.Add(this.m_pnlDetail);
			this.Controls.Add(this.m_splTop);
			this.Controls.Add(this.m_grbParam);
			this.Name = "ExchangeCtrl";
			this.Size = new System.Drawing.Size(544, 448);
			this.Load += new System.EventHandler(this.ExchangeCtrlForm_Load);
			this.m_grbParam.ResumeLayout(false);
			this.m_pnlDetail.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion
		protected void AddFieldFromHash(Hashtable htOutput)
		{
			foreach(string strKey in m_htArgs.Keys)
			{
				if(strKey != "tuning" && strKey != "billing_type")
					htOutput[strKey] = m_htArgs[strKey];
			}
		}
		/// <summary>
		///     "",  
		/// </summary>
		/// <summary>
		///     "",  
		/// </summary>
		public void Reload()
		{
			if (!m_bInit)
				return;
			if (m_bControlFieldMaster)
			{
				this.AddFieldFromHash(m_htMasterParam);
			}

			if (m_bControlFieldDetail)
			{
				this.AddFieldFromHash(m_htDetailParam);
			}
			string strCaption = null;
			FillDetail(m_strTuningDetail, 
				ref m_strAvailableDisplayMember,ref m_strAvailableValueMember,ref m_strInsertProcedure,
				ref strCaption);
			m_objExchange.AvailableLabel = strCaption;
			FillDetail(m_strTuningMaster,
				ref m_strSelectDisplayMember,ref m_strSelectValueMember,
			           ref m_strInsertProcedure,ref strCaption);
			
			m_objExchange.SelectedLabel = strCaption;
			
			m_objExchange.AvailableValueMember = m_strAvailableValueMember;
			m_objExchange.AvailableDisplayMember = m_strAvailableDisplayMember;
			m_objExchange.SelectedValueMember = m_strSelectValueMember;
			m_objExchange.SelectedDisplayMember = m_strSelectDisplayMember;

			Command cProc = new Command();
			cProc.CommandName =this.m_strGetDetail ;
			
			foreach(string strKey in  m_htDetailParam.Keys)
				cProc.InputParams["@" + strKey] = m_htDetailParam[strKey];
			cProc.Execute(true);
			if(cProc.DataSet.Tables != null)
			{
				m_objExchange.AvailableData = cProc.DataSet.Tables[0];
			}

			cProc = new Command();
			cProc.CommandName = this.m_strGetMaster;
			
			foreach(string strKey in  m_htMasterParam.Keys)
				cProc.InputParams["@" + strKey] = m_htMasterParam[strKey];
			cProc.Execute(true);
			if(cProc.DataSet.Tables != null)
			{
				m_objExchange.SelectedData = cProc.DataSet.Tables[0];
			}
			

			


		}


		/// <summary>
		///     
		/// </summary>
		/// <param name="sender">,  </param>
		/// <param name="e"> </param>
		private void ExchangeCtrlForm_Load(object sender, EventArgs e)
		{
			Reload();
		}
		public string Tuning
		{
			get { return m_strTuning; }
			set { m_strTuning = value; }
		}
		protected void FillDetail(string strType,  ref string strDisplayField, 
		                          ref string strSourceField,ref string strInsertCommand,
		                          ref string  strCaption)

		{
			strInsertCommand = "";
			strCaption = "";
			

			using(Command cmdElement = new Command())
			{
				if(strType != null && strType != "")
				{
					cmdElement.CommandName = "UIGetGridColumns";
					cmdElement.InputParams["@column_type"] = strType;
					cmdElement.Execute(true);
				}
				
				DataTable dt =cmdElement.DataSet.Tables[0];
				DataTable dt2;
				if(cmdElement.DataSet.Tables.Count==3)
				{
					dt2 =cmdElement.DataSet.Tables[2];
					if(dt2.Rows[0]["InsertCommand"]!=DBNull.Value)
						strInsertCommand=Convert.ToString(dt2.Rows[0]["InsertCommand"]);
					
					dt2 =cmdElement.DataSet.Tables[1];
					if(dt2.Rows[0]["Caption"]!=DBNull.Value)
						strCaption=Convert.ToString(dt2.Rows[0]["caption"]);
				}
				
				foreach(DataRow drRow in dt.Rows)
				{
					if(drRow["visible"]!=DBNull.Value)
						if(Convert.ToBoolean(drRow["visible"])==true)
							strDisplayField=Convert.ToString(drRow["field"]);
						if(Convert.ToBoolean(drRow["visible"])==false)
							strSourceField=Convert.ToString(drRow["field"]);

						
				}
					

				
			}
		}
		/// <summary>
		///    
		/// </summary>
		/// <returns></returns>
		private bool ReadDictionary()
		{
			m_strTuningMaster = this.Tuning;
			using (Command cmdElement = new Command())
			{
				if (m_strTuningMaster != null)
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningMaster;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					if (dtElement.Rows.Count != 0 && m_strTuningMaster != "")
					{
						m_strTuningDetail = dtElement.Rows[0]["tuning_detail"].ToString();
						m_strConnectField = dtElement.Rows[0]["connect_field"].ToString();
						m_strGetMaster = dtElement.Rows[0]["get"].ToString();
						m_strDeleteMaster = dtElement.Rows[0]["del"].ToString();
						m_strKeyFieldMaster = dtElement.Rows[0]["key_field"].ToString();
						this.m_lblCaption.Text = dtElement.Rows[0]["desk"].ToString();


						if (dtElement.Rows[0]["history_field"] != DBNull.Value)
							m_bMasterAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
						else
							m_bMasterAll = false;


		

						if (dtElement.Rows[0]["control_field"] != DBNull.Value)
							m_bControlFieldMaster = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
						else
							m_bControlFieldMaster = false;

					}


				}
				else
					return false;
			}
			using (Command cmdElement = new Command())
			{
				if (m_strTuningDetail != null)
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningDetail;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					if (dtElement.Rows.Count != 0 && m_strTuningDetail != "")
					{
						m_strGetDetail = dtElement.Rows[0]["get"].ToString();
						m_strDeleteDetail = dtElement.Rows[0]["del"].ToString();
						m_strKeyFieldDetail = dtElement.Rows[0]["key_field"].ToString();

						if (dtElement.Rows[0]["history_field"] != DBNull.Value)
							m_bDetailAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
						else
							m_bDetailAll = false;




						if (dtElement.Rows[0]["control_field"] != DBNull.Value)
							m_bControlFieldDetail = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
						else
							m_bControlFieldDetail = false;
					}
				}
				else
					return false;
			}

			//if (!m_bDetailAll && !m_bMasterAll)
			//	m_grbParam.Visible = false;
			/*
			FillDetail(m_strTuningMaster, ref m_strSelectValueMember,
			           ref m_strSelectDisplayMember);
			FillDetail(m_strTuningDetail, ref m_strAvailableValueMember,
			           ref m_strAvailableDisplayMember);
					   */


			return true;

		}

		




		
		
		public Hashtable GetInitParams()
		{
			return m_htArgs;
		}
		public void InitParams(Hashtable htParams)
		{
			// TODO:  Add BaseGrid.InitParams implementation
			InitializeForm(htParams);
			
		}
		
		/// <summary>
		///  
		/// </summary>
		/// <param name="htArgs"> <seealso cref="Hashtable"/>   </param>
		public void InitializeForm(Hashtable htArgs)
		{
			
			if(htArgs.ContainsKey("tuning"))
				m_strTuning = (string) htArgs["tuning"];
			m_htArgs = htArgs;

			//			Reload();
		}

		private void m_actSave_Execute(object sender, System.EventArgs e)
		{
			object[] objDels = m_objExchange.DataChangeDel;
			Command cmdProc = new Command();
			cmdProc.CommandName = this.m_strDeleteMaster;
			int iMax = objDels.Length;
			int iCurr = 0;
			while (iCurr < iMax)
			{
					
				foreach(string strKey in  m_htMasterParam.Keys)
					cmdProc.InputParams["@" + strKey ] = m_htMasterParam[strKey];
				cmdProc.InputParams["@"+m_strKeyFieldMaster] = objDels[iCurr].ToString();
				cmdProc.Execute(true);
				iCurr += 1;
			}
		
			
			object[] objInss = m_objExchange.DataChangeIns;
			
			//
			
			cmdProc.CommandName = this.m_strInsertProcedure;
			iMax = objInss.Length;
			iCurr = 0;
			while (iCurr < iMax)
			{
				foreach(string strKey in  m_htMasterParam.Keys)
					cmdProc.InputParams["@" + strKey ] = m_htMasterParam[strKey];
				cmdProc.InputParams["@"+m_strKeyFieldMaster] = objInss[iCurr].ToString();
				cmdProc.Execute(true);
				iCurr += 1;
			}
		}

		private void m_actCancel_Execute(object sender, System.EventArgs e)
		{
			this.Reload();
		}

		private void m_actRefresh_Execute(object sender, System.EventArgs e)
		{
			this.Reload();
		}
		
		public Hashtable InputData
		{
			get { return m_htArgs; }
		}
	
		
	


	}
}
/********************* SniipSoftel *****************
 *
 *    $History: ExchangeCtrl.cs $
 *   
 *   *****************  Version 3  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *
 ********************* SniipSoftel *****************/
