/********************* SniipSoftel *****************
 *
 *   $Author: Gavrilov $
 *   $Revision: 8 $
 *   $Date: 14.05.07 19:04 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Softel.MiddleTier.Client;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Windows.Forms
{
	///       
	/// mastergrid -     
	/// detailgrid -     
	/// second detailgrid -     
	/// </summary>
	/// <example>
	///   
	/// 
	/// <code>
	///  Hashtable htArgs = new Hashtable();
	///  htArgs.Add("tuning", "switch")
	///  ThrteeGridForm objGridForm = new ThreeGridForm(htArgs);
	///  objGridForm.ShowDialog();
	///       hashtable - 
	///											  
	///	  1)hash-          tuning.
	///	         ui_type   
	///	   Ui_Dictionary
	///	        ui_dictionary,ui_Params_Type  ui_params, ui_dictionary_realation 
	///	             .
	///	     ui_dictionary,ui_params     
	///   2)hash -        
	///              ui_dictionary  ontrol_field( )=1
	///      ui_dictionary,ui_Params_Type  ui_params   SingleGridForm
	///      ui_dictionary_relation   TwoGridForm
	///   3)        ui_type                
	///             ui_type                
	public class ThreeGrid : BaseGrid
	{
		private GroupBox m_grbParam;
		private CheckBox m_chkChange;
		private IContainer components;
		private DataTable m_dtTuningMaster;
		private DataTable m_dtTuningDetail;
		private DataTable m_dtTuning2Detail;
		private DataTable m_dtMaster;
		private DataTable m_dtDetail;
		private DataTable m_dt2Detail;
		private CuteSoftelGrid m_grdDetail;
		private CuteSoftelGrid m_grdMaster;
		private Hashtable m_htMasterParam;
		private Hashtable m_htDetailParam;
		private Hashtable m_ht2DetailParam;
		private GlobalImageList m_gil;
		private Action m_actInsertDetail;
		private Action m_actEditDetail;
		private Action m_actDeleteDetail;
		private ContextMenu m_cmDetail;
		private MenuItem m_miInsertDetail;
		private MenuItem m_miEditDetail;
		private MenuItem m_miDeleteDetail;

		private string m_strConnectField;
		private string m_strConnectField2;

		private bool m_bControlField2Detail;
		private bool m_bControlFieldDetail;
		private bool m_bControlFieldMaster;

		private string m_strGet2Detail;
		private string m_strGetDetail;
		private string m_strGetMaster;

		private string m_strDelete2Detail;
		private string m_strDeleteDetail;
		private string m_strDeleteMaster;

		private string m_strKeyField2Detail;
		private string m_strKeyFieldDetail;
		private string m_strKeyFieldMaster;

		private bool m_b2DetailAll;
		private bool m_bDetailAll;
		private bool m_bMasterAll;

		private string m_strTuning2Detail;
		private string m_strTuningDetail;


		private Panel m_pnlFill;
		private Panel m_pnlLeft;
		private Splitter m_splLeft;
		private Splitter m_splBottom;
		private Panel m_pnlBottom;
		private ToolBar m_tbDetail;
		private ToolBar m_tbSecondDetail;
		private ToolBarButton m_tbbEditDetail;
		private ToolBarButton m_tbbDeleteDetail;
		private ToolBarButton m_tbbInsertDetail;
		private ToolBarButton m_tbbInsert2Detail;
		private ToolBarButton m_tbbEdit2Detail;
		private ToolBarButton m_tbbDelete2Detail;
		private Action m_actInsert2Detail;
		private Action m_actEdit2Detail;
		private Action m_actDelete2Detail;
		private Panel m_pnlRight;
		private Panel m_pnlTop;
		private CuteSoftelGrid m_grdSecondDetail;
		private ContextMenu m_cmSecondDetail;
		private MenuItem m_miInsert2Detail;
		private MenuItem m_miEdit2Detail;
		private MenuItem m_miDelete2Detail;
		private string m_strTuningMaster;
		private int m_iCount = 0;
		private System.Windows.Forms.Splitter m_splHor;
		private bool m_bInit = false;


		/// <summary>
		///  ,      
		///  
		/// </summary>
		public ThreeGrid()
		{
			InitializeComponent();
		}

		/// <summary>
		/// ,        <see cref="ClientsMainForm"/>   
		///    
		/// </summary>
		/// <param name="htArgs">  <see cref="Hashtable">,   </param>
		/// <remarks>
		/// 	<para>     :</para>
		/// 	<list type="bullet">
		/// 		<item>cln_id - id </item>
		/// 		<item>ac_id - id  </item>
		/// 		<item>sub_id - id </item>
		/// 	</list>
		/// </remarks>
		public ThreeGrid(Hashtable htArgs) : base(htArgs)
		{
			InitializeComponent();

			m_bInit = ReadDictionary();
			if (m_bInit)
			{
				m_htMasterParam = new Hashtable();
				if (m_bMasterAll)
					m_htMasterParam.Add("all", null);


				m_htDetailParam = new Hashtable();
				m_htDetailParam.Add(m_strConnectField, null);
				if (m_bDetailAll)
					m_htDetailParam.Add("all", null);

				m_ht2DetailParam = new Hashtable();
				m_ht2DetailParam.Add(m_strConnectField2, null);
				if (m_b2DetailAll)
					m_ht2DetailParam.Add("all", null);
			}

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ThreeGrid));
			this.m_grbParam = new System.Windows.Forms.GroupBox();
			this.m_chkChange = new System.Windows.Forms.CheckBox();
			this.m_grdMaster = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_grdDetail = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_cmDetail = new System.Windows.Forms.ContextMenu();
			this.m_miInsertDetail = new System.Windows.Forms.MenuItem();
			this.m_miEditDetail = new System.Windows.Forms.MenuItem();
			this.m_miDeleteDetail = new System.Windows.Forms.MenuItem();
			this.m_gil = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_actInsertDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actEditDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actDeleteDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_pnlFill = new System.Windows.Forms.Panel();
			this.m_pnlRight = new System.Windows.Forms.Panel();
			this.m_pnlTop = new System.Windows.Forms.Panel();
			this.m_tbDetail = new System.Windows.Forms.ToolBar();
			this.m_tbbInsertDetail = new System.Windows.Forms.ToolBarButton();
			this.m_tbbEditDetail = new System.Windows.Forms.ToolBarButton();
			this.m_tbbDeleteDetail = new System.Windows.Forms.ToolBarButton();
			this.m_splHor = new System.Windows.Forms.Splitter();
			this.m_pnlBottom = new System.Windows.Forms.Panel();
			this.m_grdSecondDetail = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_cmSecondDetail = new System.Windows.Forms.ContextMenu();
			this.m_miInsert2Detail = new System.Windows.Forms.MenuItem();
			this.m_miEdit2Detail = new System.Windows.Forms.MenuItem();
			this.m_miDelete2Detail = new System.Windows.Forms.MenuItem();
			this.m_tbSecondDetail = new System.Windows.Forms.ToolBar();
			this.m_tbbInsert2Detail = new System.Windows.Forms.ToolBarButton();
			this.m_tbbEdit2Detail = new System.Windows.Forms.ToolBarButton();
			this.m_tbbDelete2Detail = new System.Windows.Forms.ToolBarButton();
			this.m_splLeft = new System.Windows.Forms.Splitter();
			this.m_pnlLeft = new System.Windows.Forms.Panel();
			this.m_splBottom = new System.Windows.Forms.Splitter();
			this.m_actInsert2Detail = new Softel.Windows.Forms.Action(this.components);
			this.m_actEdit2Detail = new Softel.Windows.Forms.Action(this.components);
			this.m_actDelete2Detail = new Softel.Windows.Forms.Action(this.components);
			this.m_grbParam.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdDetail)).BeginInit();
			this.m_pnlFill.SuspendLayout();
			this.m_pnlRight.SuspendLayout();
			this.m_pnlTop.SuspendLayout();
			this.m_pnlBottom.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.m_grdSecondDetail)).BeginInit();
			this.m_pnlLeft.SuspendLayout();
			this.SuspendLayout();
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			// 
			// m_alMain
			// 
			this.m_alMain.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																				 this.m_actInsertDetail,
																				 this.m_actEditDetail,
																				 this.m_actDeleteDetail,
																				 this.m_actInsert2Detail,
																				 this.m_actEdit2Detail,
																				 this.m_actDelete2Detail});
			// 
			// m_tbMain
			// 
			this.m_tbMain.Name = "m_tbMain";
			this.m_tbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tbMain.Size")));
			// 
			// m_actInsert
			// 
			this.m_actInsert.Execute += new System.EventHandler(this.m_actMasterInsert_Execute);
			// 
			// m_actEdit
			// 
			this.m_actEdit.Execute += new System.EventHandler(this.m_actMasterEdit_Execute);
			// 
			// m_actDelete
			// 
			this.m_actDelete.Execute += new System.EventHandler(this.m_actMasterDelete_Execute);
			// 
			// m_grbParam
			// 
			this.m_grbParam.AccessibleDescription = resources.GetString("m_grbParam.AccessibleDescription");
			this.m_grbParam.AccessibleName = resources.GetString("m_grbParam.AccessibleName");
			this.m_grbParam.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grbParam.Anchor")));
			this.m_grbParam.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grbParam.BackgroundImage")));
			this.m_grbParam.Controls.Add(this.m_chkChange);
			this.m_grbParam.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grbParam.Dock")));
			this.m_grbParam.Enabled = ((bool)(resources.GetObject("m_grbParam.Enabled")));
			this.m_grbParam.Font = ((System.Drawing.Font)(resources.GetObject("m_grbParam.Font")));
			this.m_grbParam.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grbParam.ImeMode")));
			this.m_grbParam.Location = ((System.Drawing.Point)(resources.GetObject("m_grbParam.Location")));
			this.m_grbParam.Name = "m_grbParam";
			this.m_grbParam.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grbParam.RightToLeft")));
			this.m_grbParam.Size = ((System.Drawing.Size)(resources.GetObject("m_grbParam.Size")));
			this.m_grbParam.TabIndex = ((int)(resources.GetObject("m_grbParam.TabIndex")));
			this.m_grbParam.TabStop = false;
			this.m_grbParam.Text = resources.GetString("m_grbParam.Text");
			this.m_grbParam.Visible = ((bool)(resources.GetObject("m_grbParam.Visible")));
			// 
			// m_chkChange
			// 
			this.m_chkChange.AccessibleDescription = resources.GetString("m_chkChange.AccessibleDescription");
			this.m_chkChange.AccessibleName = resources.GetString("m_chkChange.AccessibleName");
			this.m_chkChange.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_chkChange.Anchor")));
			this.m_chkChange.Appearance = ((System.Windows.Forms.Appearance)(resources.GetObject("m_chkChange.Appearance")));
			this.m_chkChange.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_chkChange.BackgroundImage")));
			this.m_chkChange.CheckAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.CheckAlign")));
			this.m_chkChange.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_chkChange.Dock")));
			this.m_chkChange.Enabled = ((bool)(resources.GetObject("m_chkChange.Enabled")));
			this.m_chkChange.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("m_chkChange.FlatStyle")));
			this.m_chkChange.Font = ((System.Drawing.Font)(resources.GetObject("m_chkChange.Font")));
			this.m_chkChange.Image = ((System.Drawing.Image)(resources.GetObject("m_chkChange.Image")));
			this.m_chkChange.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.ImageAlign")));
			this.m_chkChange.ImageIndex = ((int)(resources.GetObject("m_chkChange.ImageIndex")));
			this.m_chkChange.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_chkChange.ImeMode")));
			this.m_chkChange.Location = ((System.Drawing.Point)(resources.GetObject("m_chkChange.Location")));
			this.m_chkChange.Name = "m_chkChange";
			this.m_chkChange.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_chkChange.RightToLeft")));
			this.m_chkChange.Size = ((System.Drawing.Size)(resources.GetObject("m_chkChange.Size")));
			this.m_chkChange.TabIndex = ((int)(resources.GetObject("m_chkChange.TabIndex")));
			this.m_chkChange.Text = resources.GetString("m_chkChange.Text");
			this.m_chkChange.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.TextAlign")));
			this.m_chkChange.Visible = ((bool)(resources.GetObject("m_chkChange.Visible")));
			this.m_chkChange.CheckedChanged += new System.EventHandler(this.m_chkChange_CheckedChanged);
			// 
			// m_grdMaster
			// 
			this.m_grdMaster.AccessibleDescription = resources.GetString("m_grdMaster.AccessibleDescription");
			this.m_grdMaster.AccessibleName = resources.GetString("m_grdMaster.AccessibleName");
			this.m_grdMaster.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdMaster.Anchor")));
			this.m_grdMaster.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdMaster.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdMaster.BackgroundImage")));
			this.m_grdMaster.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdMaster.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.CaptionFont")));
			this.m_grdMaster.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdMaster.CaptionText = resources.GetString("m_grdMaster.CaptionText");
			this.m_grdMaster.ContextMenu = this.m_cmMain;
			this.m_grdMaster.DataMember = "";
			this.m_grdMaster.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdMaster.Dock")));
			this.m_grdMaster.Enabled = ((bool)(resources.GetObject("m_grdMaster.Enabled")));
			this.m_grdMaster.Font = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.Font")));
			this.m_grdMaster.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdMaster.HighlightRow = true;
			this.m_grdMaster.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdMaster.ImeMode")));
			this.m_grdMaster.Location = ((System.Drawing.Point)(resources.GetObject("m_grdMaster.Location")));
			this.m_grdMaster.Name = "m_grdMaster";
			this.m_grdMaster.ReadOnly = true;
			this.m_grdMaster.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdMaster.RightToLeft")));
			this.m_grdMaster.Size = ((System.Drawing.Size)(resources.GetObject("m_grdMaster.Size")));
			this.m_grdMaster.TabIndex = ((int)(resources.GetObject("m_grdMaster.TabIndex")));
			this.m_grdMaster.Visible = ((bool)(resources.GetObject("m_grdMaster.Visible")));
			this.m_grdMaster.CurrentCellChanged += new System.EventHandler(this.m_grdMaster_CurrentCellChanged);
			// 
			// m_grdDetail
			// 
			this.m_grdDetail.AccessibleDescription = resources.GetString("m_grdDetail.AccessibleDescription");
			this.m_grdDetail.AccessibleName = resources.GetString("m_grdDetail.AccessibleName");
			this.m_grdDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdDetail.Anchor")));
			this.m_grdDetail.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdDetail.BackgroundImage")));
			this.m_grdDetail.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdDetail.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdDetail.CaptionFont")));
			this.m_grdDetail.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdDetail.CaptionText = resources.GetString("m_grdDetail.CaptionText");
			this.m_grdDetail.ContextMenu = this.m_cmDetail;
			this.m_grdDetail.DataMember = "";
			this.m_grdDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdDetail.Dock")));
			this.m_grdDetail.Enabled = ((bool)(resources.GetObject("m_grdDetail.Enabled")));
			this.m_grdDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_grdDetail.Font")));
			this.m_grdDetail.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdDetail.HighlightRow = true;
			this.m_grdDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdDetail.ImeMode")));
			this.m_grdDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_grdDetail.Location")));
			this.m_grdDetail.Name = "m_grdDetail";
			this.m_grdDetail.ReadOnly = true;
			this.m_grdDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdDetail.RightToLeft")));
			this.m_grdDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_grdDetail.Size")));
			this.m_grdDetail.TabIndex = ((int)(resources.GetObject("m_grdDetail.TabIndex")));
			this.m_grdDetail.Visible = ((bool)(resources.GetObject("m_grdDetail.Visible")));
			// 
			// m_cmDetail
			// 
			this.m_cmDetail.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.m_miInsertDetail,
																					   this.m_miEditDetail,
																					   this.m_miDeleteDetail});
			this.m_cmDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmDetail.RightToLeft")));
			// 
			// m_miInsertDetail
			// 
			this.m_alMain.SetAction(this.m_miInsertDetail, this.m_actInsertDetail);
			this.m_miInsertDetail.Enabled = ((bool)(resources.GetObject("m_miInsertDetail.Enabled")));
			this.m_miInsertDetail.Index = 0;
			this.m_miInsertDetail.MergeOrder = 32;
			this.m_miInsertDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miInsertDetail.Shortcut")));
			this.m_miInsertDetail.ShowShortcut = ((bool)(resources.GetObject("m_miInsertDetail.ShowShortcut")));
			this.m_miInsertDetail.Text = resources.GetString("m_miInsertDetail.Text");
			this.m_miInsertDetail.Visible = ((bool)(resources.GetObject("m_miInsertDetail.Visible")));
			// 
			// m_miEditDetail
			// 
			this.m_alMain.SetAction(this.m_miEditDetail, this.m_actEditDetail);
			this.m_miEditDetail.Enabled = ((bool)(resources.GetObject("m_miEditDetail.Enabled")));
			this.m_miEditDetail.Index = 1;
			this.m_miEditDetail.MergeOrder = 33;
			this.m_miEditDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miEditDetail.Shortcut")));
			this.m_miEditDetail.ShowShortcut = ((bool)(resources.GetObject("m_miEditDetail.ShowShortcut")));
			this.m_miEditDetail.Text = resources.GetString("m_miEditDetail.Text");
			this.m_miEditDetail.Visible = ((bool)(resources.GetObject("m_miEditDetail.Visible")));
			// 
			// m_miDeleteDetail
			// 
			this.m_alMain.SetAction(this.m_miDeleteDetail, this.m_actDeleteDetail);
			this.m_miDeleteDetail.Enabled = ((bool)(resources.GetObject("m_miDeleteDetail.Enabled")));
			this.m_miDeleteDetail.Index = 2;
			this.m_miDeleteDetail.MergeOrder = 31;
			this.m_miDeleteDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDeleteDetail.Shortcut")));
			this.m_miDeleteDetail.ShowShortcut = ((bool)(resources.GetObject("m_miDeleteDetail.ShowShortcut")));
			this.m_miDeleteDetail.Text = resources.GetString("m_miDeleteDetail.Text");
			this.m_miDeleteDetail.Visible = ((bool)(resources.GetObject("m_miDeleteDetail.Visible")));
			// 
			// m_gil
			// 
			this.m_gil.ImageList = this.SoftelImageList;
			this.m_gil.Parent = this;
			// 
			// m_actInsertDetail
			// 
			this.m_actInsertDetail.Checked = false;
			this.m_actInsertDetail.Enabled = true;
			this.m_actInsertDetail.Hint = resources.GetString("m_actInsertDetail.Hint");
			this.m_actInsertDetail.ImageIndex = ((int)(resources.GetObject("m_actInsertDetail.ImageIndex")));
			this.m_actInsertDetail.MergeOrder = 32;
			this.m_actInsertDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actInsertDetail.Tag = null;
			this.m_actInsertDetail.Text = resources.GetString("m_actInsertDetail.Text");
			this.m_actInsertDetail.Visible = true;
			this.m_actInsertDetail.Execute += new System.EventHandler(this.m_actInsertDetail_Execute);
			// 
			// m_actEditDetail
			// 
			this.m_actEditDetail.Checked = false;
			this.m_actEditDetail.Enabled = true;
			this.m_actEditDetail.Hint = resources.GetString("m_actEditDetail.Hint");
			this.m_actEditDetail.ImageIndex = ((int)(resources.GetObject("m_actEditDetail.ImageIndex")));
			this.m_actEditDetail.MergeOrder = 33;
			this.m_actEditDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actEditDetail.Tag = null;
			this.m_actEditDetail.Text = resources.GetString("m_actEditDetail.Text");
			this.m_actEditDetail.Visible = true;
			this.m_actEditDetail.Execute += new System.EventHandler(this.m_actEditDetail_Execute);
			// 
			// m_actDeleteDetail
			// 
			this.m_actDeleteDetail.Checked = false;
			this.m_actDeleteDetail.Enabled = true;
			this.m_actDeleteDetail.Hint = resources.GetString("m_actDeleteDetail.Hint");
			this.m_actDeleteDetail.ImageIndex = ((int)(resources.GetObject("m_actDeleteDetail.ImageIndex")));
			this.m_actDeleteDetail.MergeOrder = 31;
			this.m_actDeleteDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDeleteDetail.Tag = null;
			this.m_actDeleteDetail.Text = resources.GetString("m_actDeleteDetail.Text");
			this.m_actDeleteDetail.Visible = true;
			this.m_actDeleteDetail.Execute += new System.EventHandler(this.m_actDeleteDetail_Execute);
			// 
			// m_pnlFill
			// 
			this.m_pnlFill.AccessibleDescription = resources.GetString("m_pnlFill.AccessibleDescription");
			this.m_pnlFill.AccessibleName = resources.GetString("m_pnlFill.AccessibleName");
			this.m_pnlFill.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlFill.Anchor")));
			this.m_pnlFill.AutoScroll = ((bool)(resources.GetObject("m_pnlFill.AutoScroll")));
			this.m_pnlFill.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlFill.AutoScrollMargin")));
			this.m_pnlFill.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlFill.AutoScrollMinSize")));
			this.m_pnlFill.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlFill.BackgroundImage")));
			this.m_pnlFill.Controls.Add(this.m_pnlRight);
			this.m_pnlFill.Controls.Add(this.m_splLeft);
			this.m_pnlFill.Controls.Add(this.m_pnlLeft);
			this.m_pnlFill.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlFill.Dock")));
			this.m_pnlFill.Enabled = ((bool)(resources.GetObject("m_pnlFill.Enabled")));
			this.m_pnlFill.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlFill.Font")));
			this.m_pnlFill.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlFill.ImeMode")));
			this.m_pnlFill.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlFill.Location")));
			this.m_pnlFill.Name = "m_pnlFill";
			this.m_pnlFill.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlFill.RightToLeft")));
			this.m_pnlFill.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlFill.Size")));
			this.m_pnlFill.TabIndex = ((int)(resources.GetObject("m_pnlFill.TabIndex")));
			this.m_pnlFill.Text = resources.GetString("m_pnlFill.Text");
			this.m_pnlFill.Visible = ((bool)(resources.GetObject("m_pnlFill.Visible")));
			// 
			// m_pnlRight
			// 
			this.m_pnlRight.AccessibleDescription = resources.GetString("m_pnlRight.AccessibleDescription");
			this.m_pnlRight.AccessibleName = resources.GetString("m_pnlRight.AccessibleName");
			this.m_pnlRight.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlRight.Anchor")));
			this.m_pnlRight.AutoScroll = ((bool)(resources.GetObject("m_pnlRight.AutoScroll")));
			this.m_pnlRight.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlRight.AutoScrollMargin")));
			this.m_pnlRight.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlRight.AutoScrollMinSize")));
			this.m_pnlRight.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlRight.BackgroundImage")));
			this.m_pnlRight.Controls.Add(this.m_pnlTop);
			this.m_pnlRight.Controls.Add(this.m_splHor);
			this.m_pnlRight.Controls.Add(this.m_pnlBottom);
			this.m_pnlRight.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlRight.Dock")));
			this.m_pnlRight.Enabled = ((bool)(resources.GetObject("m_pnlRight.Enabled")));
			this.m_pnlRight.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlRight.Font")));
			this.m_pnlRight.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlRight.ImeMode")));
			this.m_pnlRight.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlRight.Location")));
			this.m_pnlRight.Name = "m_pnlRight";
			this.m_pnlRight.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlRight.RightToLeft")));
			this.m_pnlRight.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlRight.Size")));
			this.m_pnlRight.TabIndex = ((int)(resources.GetObject("m_pnlRight.TabIndex")));
			this.m_pnlRight.Text = resources.GetString("m_pnlRight.Text");
			this.m_pnlRight.Visible = ((bool)(resources.GetObject("m_pnlRight.Visible")));
			// 
			// m_pnlTop
			// 
			this.m_pnlTop.AccessibleDescription = resources.GetString("m_pnlTop.AccessibleDescription");
			this.m_pnlTop.AccessibleName = resources.GetString("m_pnlTop.AccessibleName");
			this.m_pnlTop.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlTop.Anchor")));
			this.m_pnlTop.AutoScroll = ((bool)(resources.GetObject("m_pnlTop.AutoScroll")));
			this.m_pnlTop.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlTop.AutoScrollMargin")));
			this.m_pnlTop.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlTop.AutoScrollMinSize")));
			this.m_pnlTop.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlTop.BackgroundImage")));
			this.m_pnlTop.Controls.Add(this.m_grdDetail);
			this.m_pnlTop.Controls.Add(this.m_tbDetail);
			this.m_pnlTop.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlTop.Dock")));
			this.m_pnlTop.Enabled = ((bool)(resources.GetObject("m_pnlTop.Enabled")));
			this.m_pnlTop.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlTop.Font")));
			this.m_pnlTop.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlTop.ImeMode")));
			this.m_pnlTop.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlTop.Location")));
			this.m_pnlTop.Name = "m_pnlTop";
			this.m_pnlTop.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlTop.RightToLeft")));
			this.m_pnlTop.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlTop.Size")));
			this.m_pnlTop.TabIndex = ((int)(resources.GetObject("m_pnlTop.TabIndex")));
			this.m_pnlTop.Text = resources.GetString("m_pnlTop.Text");
			this.m_pnlTop.Visible = ((bool)(resources.GetObject("m_pnlTop.Visible")));
			// 
			// m_tbDetail
			// 
			this.m_tbDetail.AccessibleDescription = resources.GetString("m_tbDetail.AccessibleDescription");
			this.m_tbDetail.AccessibleName = resources.GetString("m_tbDetail.AccessibleName");
			this.m_tbDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tbDetail.Anchor")));
			this.m_tbDetail.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("m_tbDetail.Appearance")));
			this.m_tbDetail.AutoSize = ((bool)(resources.GetObject("m_tbDetail.AutoSize")));
			this.m_tbDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tbDetail.BackgroundImage")));
			this.m_tbDetail.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						  this.m_tbbInsertDetail,
																						  this.m_tbbEditDetail,
																						  this.m_tbbDeleteDetail});
			this.m_tbDetail.ButtonSize = ((System.Drawing.Size)(resources.GetObject("m_tbDetail.ButtonSize")));
			this.m_tbDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tbDetail.Dock")));
			this.m_tbDetail.DropDownArrows = ((bool)(resources.GetObject("m_tbDetail.DropDownArrows")));
			this.m_tbDetail.Enabled = ((bool)(resources.GetObject("m_tbDetail.Enabled")));
			this.m_tbDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_tbDetail.Font")));
			this.m_tbDetail.ImageList = this.SoftelImageList;
			this.m_tbDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tbDetail.ImeMode")));
			this.m_tbDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_tbDetail.Location")));
			this.m_tbDetail.Name = "m_tbDetail";
			this.m_tbDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tbDetail.RightToLeft")));
			this.m_tbDetail.ShowToolTips = ((bool)(resources.GetObject("m_tbDetail.ShowToolTips")));
			this.m_tbDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_tbDetail.Size")));
			this.m_tbDetail.TabIndex = ((int)(resources.GetObject("m_tbDetail.TabIndex")));
			this.m_tbDetail.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("m_tbDetail.TextAlign")));
			this.m_tbDetail.Visible = ((bool)(resources.GetObject("m_tbDetail.Visible")));
			this.m_tbDetail.Wrappable = ((bool)(resources.GetObject("m_tbDetail.Wrappable")));
			// 
			// m_tbbInsertDetail
			// 
			this.m_alMain.SetAction(this.m_tbbInsertDetail, this.m_actInsertDetail);
			this.m_tbbInsertDetail.Enabled = ((bool)(resources.GetObject("m_tbbInsertDetail.Enabled")));
			this.m_tbbInsertDetail.ImageIndex = ((int)(resources.GetObject("m_tbbInsertDetail.ImageIndex")));
			this.m_tbbInsertDetail.Text = resources.GetString("m_tbbInsertDetail.Text");
			this.m_tbbInsertDetail.ToolTipText = resources.GetString("m_tbbInsertDetail.ToolTipText");
			this.m_tbbInsertDetail.Visible = ((bool)(resources.GetObject("m_tbbInsertDetail.Visible")));
			// 
			// m_tbbEditDetail
			// 
			this.m_alMain.SetAction(this.m_tbbEditDetail, this.m_actEditDetail);
			this.m_tbbEditDetail.Enabled = ((bool)(resources.GetObject("m_tbbEditDetail.Enabled")));
			this.m_tbbEditDetail.ImageIndex = ((int)(resources.GetObject("m_tbbEditDetail.ImageIndex")));
			this.m_tbbEditDetail.Text = resources.GetString("m_tbbEditDetail.Text");
			this.m_tbbEditDetail.ToolTipText = resources.GetString("m_tbbEditDetail.ToolTipText");
			this.m_tbbEditDetail.Visible = ((bool)(resources.GetObject("m_tbbEditDetail.Visible")));
			// 
			// m_tbbDeleteDetail
			// 
			this.m_alMain.SetAction(this.m_tbbDeleteDetail, this.m_actDeleteDetail);
			this.m_tbbDeleteDetail.Enabled = ((bool)(resources.GetObject("m_tbbDeleteDetail.Enabled")));
			this.m_tbbDeleteDetail.ImageIndex = ((int)(resources.GetObject("m_tbbDeleteDetail.ImageIndex")));
			this.m_tbbDeleteDetail.Text = resources.GetString("m_tbbDeleteDetail.Text");
			this.m_tbbDeleteDetail.ToolTipText = resources.GetString("m_tbbDeleteDetail.ToolTipText");
			this.m_tbbDeleteDetail.Visible = ((bool)(resources.GetObject("m_tbbDeleteDetail.Visible")));
			// 
			// m_splHor
			// 
			this.m_splHor.AccessibleDescription = resources.GetString("m_splHor.AccessibleDescription");
			this.m_splHor.AccessibleName = resources.GetString("m_splHor.AccessibleName");
			this.m_splHor.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splHor.Anchor")));
			this.m_splHor.BackColor = System.Drawing.SystemColors.Control;
			this.m_splHor.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splHor.BackgroundImage")));
			this.m_splHor.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splHor.Dock")));
			this.m_splHor.Enabled = ((bool)(resources.GetObject("m_splHor.Enabled")));
			this.m_splHor.Font = ((System.Drawing.Font)(resources.GetObject("m_splHor.Font")));
			this.m_splHor.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splHor.ImeMode")));
			this.m_splHor.Location = ((System.Drawing.Point)(resources.GetObject("m_splHor.Location")));
			this.m_splHor.MinExtra = ((int)(resources.GetObject("m_splHor.MinExtra")));
			this.m_splHor.MinSize = ((int)(resources.GetObject("m_splHor.MinSize")));
			this.m_splHor.Name = "m_splHor";
			this.m_splHor.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splHor.RightToLeft")));
			this.m_splHor.Size = ((System.Drawing.Size)(resources.GetObject("m_splHor.Size")));
			this.m_splHor.TabIndex = ((int)(resources.GetObject("m_splHor.TabIndex")));
			this.m_splHor.TabStop = false;
			this.m_splHor.Visible = ((bool)(resources.GetObject("m_splHor.Visible")));
			// 
			// m_pnlBottom
			// 
			this.m_pnlBottom.AccessibleDescription = resources.GetString("m_pnlBottom.AccessibleDescription");
			this.m_pnlBottom.AccessibleName = resources.GetString("m_pnlBottom.AccessibleName");
			this.m_pnlBottom.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlBottom.Anchor")));
			this.m_pnlBottom.AutoScroll = ((bool)(resources.GetObject("m_pnlBottom.AutoScroll")));
			this.m_pnlBottom.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlBottom.AutoScrollMargin")));
			this.m_pnlBottom.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlBottom.AutoScrollMinSize")));
			this.m_pnlBottom.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlBottom.BackgroundImage")));
			this.m_pnlBottom.Controls.Add(this.m_grdSecondDetail);
			this.m_pnlBottom.Controls.Add(this.m_tbSecondDetail);
			this.m_pnlBottom.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlBottom.Dock")));
			this.m_pnlBottom.Enabled = ((bool)(resources.GetObject("m_pnlBottom.Enabled")));
			this.m_pnlBottom.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlBottom.Font")));
			this.m_pnlBottom.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlBottom.ImeMode")));
			this.m_pnlBottom.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlBottom.Location")));
			this.m_pnlBottom.Name = "m_pnlBottom";
			this.m_pnlBottom.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlBottom.RightToLeft")));
			this.m_pnlBottom.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlBottom.Size")));
			this.m_pnlBottom.TabIndex = ((int)(resources.GetObject("m_pnlBottom.TabIndex")));
			this.m_pnlBottom.Text = resources.GetString("m_pnlBottom.Text");
			this.m_pnlBottom.Visible = ((bool)(resources.GetObject("m_pnlBottom.Visible")));
			// 
			// m_grdSecondDetail
			// 
			this.m_grdSecondDetail.AccessibleDescription = resources.GetString("m_grdSecondDetail.AccessibleDescription");
			this.m_grdSecondDetail.AccessibleName = resources.GetString("m_grdSecondDetail.AccessibleName");
			this.m_grdSecondDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdSecondDetail.Anchor")));
			this.m_grdSecondDetail.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdSecondDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdSecondDetail.BackgroundImage")));
			this.m_grdSecondDetail.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdSecondDetail.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdSecondDetail.CaptionFont")));
			this.m_grdSecondDetail.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdSecondDetail.CaptionText = resources.GetString("m_grdSecondDetail.CaptionText");
			this.m_grdSecondDetail.ContextMenu = this.m_cmSecondDetail;
			this.m_grdSecondDetail.DataMember = "";
			this.m_grdSecondDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdSecondDetail.Dock")));
			this.m_grdSecondDetail.Enabled = ((bool)(resources.GetObject("m_grdSecondDetail.Enabled")));
			this.m_grdSecondDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_grdSecondDetail.Font")));
			this.m_grdSecondDetail.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdSecondDetail.HighlightRow = true;
			this.m_grdSecondDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdSecondDetail.ImeMode")));
			this.m_grdSecondDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_grdSecondDetail.Location")));
			this.m_grdSecondDetail.Name = "m_grdSecondDetail";
			this.m_grdSecondDetail.ReadOnly = true;
			this.m_grdSecondDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdSecondDetail.RightToLeft")));
			this.m_grdSecondDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_grdSecondDetail.Size")));
			this.m_grdSecondDetail.TabIndex = ((int)(resources.GetObject("m_grdSecondDetail.TabIndex")));
			this.m_grdSecondDetail.Visible = ((bool)(resources.GetObject("m_grdSecondDetail.Visible")));
			this.m_grdSecondDetail.CurrentCellChanged += new System.EventHandler(this.m_grdSecondDetail_CurrentCellChanged);
			// 
			// m_cmSecondDetail
			// 
			this.m_cmSecondDetail.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.m_miInsert2Detail,
																							 this.m_miEdit2Detail,
																							 this.m_miDelete2Detail});
			this.m_cmSecondDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmSecondDetail.RightToLeft")));
			// 
			// m_miInsert2Detail
			// 
			this.m_alMain.SetAction(this.m_miInsert2Detail, this.m_actInsert2Detail);
			this.m_miInsert2Detail.Enabled = ((bool)(resources.GetObject("m_miInsert2Detail.Enabled")));
			this.m_miInsert2Detail.Index = 0;
			this.m_miInsert2Detail.MergeOrder = 32;
			this.m_miInsert2Detail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miInsert2Detail.Shortcut")));
			this.m_miInsert2Detail.ShowShortcut = ((bool)(resources.GetObject("m_miInsert2Detail.ShowShortcut")));
			this.m_miInsert2Detail.Text = resources.GetString("m_miInsert2Detail.Text");
			this.m_miInsert2Detail.Visible = ((bool)(resources.GetObject("m_miInsert2Detail.Visible")));
			// 
			// m_miEdit2Detail
			// 
			this.m_alMain.SetAction(this.m_miEdit2Detail, this.m_actEdit2Detail);
			this.m_miEdit2Detail.Enabled = ((bool)(resources.GetObject("m_miEdit2Detail.Enabled")));
			this.m_miEdit2Detail.Index = 1;
			this.m_miEdit2Detail.MergeOrder = 33;
			this.m_miEdit2Detail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miEdit2Detail.Shortcut")));
			this.m_miEdit2Detail.ShowShortcut = ((bool)(resources.GetObject("m_miEdit2Detail.ShowShortcut")));
			this.m_miEdit2Detail.Text = resources.GetString("m_miEdit2Detail.Text");
			this.m_miEdit2Detail.Visible = ((bool)(resources.GetObject("m_miEdit2Detail.Visible")));
			// 
			// m_miDelete2Detail
			// 
			this.m_alMain.SetAction(this.m_miDelete2Detail, this.m_actDelete2Detail);
			this.m_miDelete2Detail.Enabled = ((bool)(resources.GetObject("m_miDelete2Detail.Enabled")));
			this.m_miDelete2Detail.Index = 2;
			this.m_miDelete2Detail.MergeOrder = 31;
			this.m_miDelete2Detail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDelete2Detail.Shortcut")));
			this.m_miDelete2Detail.ShowShortcut = ((bool)(resources.GetObject("m_miDelete2Detail.ShowShortcut")));
			this.m_miDelete2Detail.Text = resources.GetString("m_miDelete2Detail.Text");
			this.m_miDelete2Detail.Visible = ((bool)(resources.GetObject("m_miDelete2Detail.Visible")));
			// 
			// m_tbSecondDetail
			// 
			this.m_tbSecondDetail.AccessibleDescription = resources.GetString("m_tbSecondDetail.AccessibleDescription");
			this.m_tbSecondDetail.AccessibleName = resources.GetString("m_tbSecondDetail.AccessibleName");
			this.m_tbSecondDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_tbSecondDetail.Anchor")));
			this.m_tbSecondDetail.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("m_tbSecondDetail.Appearance")));
			this.m_tbSecondDetail.AutoSize = ((bool)(resources.GetObject("m_tbSecondDetail.AutoSize")));
			this.m_tbSecondDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_tbSecondDetail.BackgroundImage")));
			this.m_tbSecondDetail.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																								this.m_tbbInsert2Detail,
																								this.m_tbbEdit2Detail,
																								this.m_tbbDelete2Detail});
			this.m_tbSecondDetail.ButtonSize = ((System.Drawing.Size)(resources.GetObject("m_tbSecondDetail.ButtonSize")));
			this.m_tbSecondDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_tbSecondDetail.Dock")));
			this.m_tbSecondDetail.DropDownArrows = ((bool)(resources.GetObject("m_tbSecondDetail.DropDownArrows")));
			this.m_tbSecondDetail.Enabled = ((bool)(resources.GetObject("m_tbSecondDetail.Enabled")));
			this.m_tbSecondDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_tbSecondDetail.Font")));
			this.m_tbSecondDetail.ImageList = this.SoftelImageList;
			this.m_tbSecondDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_tbSecondDetail.ImeMode")));
			this.m_tbSecondDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_tbSecondDetail.Location")));
			this.m_tbSecondDetail.Name = "m_tbSecondDetail";
			this.m_tbSecondDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_tbSecondDetail.RightToLeft")));
			this.m_tbSecondDetail.ShowToolTips = ((bool)(resources.GetObject("m_tbSecondDetail.ShowToolTips")));
			this.m_tbSecondDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_tbSecondDetail.Size")));
			this.m_tbSecondDetail.TabIndex = ((int)(resources.GetObject("m_tbSecondDetail.TabIndex")));
			this.m_tbSecondDetail.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("m_tbSecondDetail.TextAlign")));
			this.m_tbSecondDetail.Visible = ((bool)(resources.GetObject("m_tbSecondDetail.Visible")));
			this.m_tbSecondDetail.Wrappable = ((bool)(resources.GetObject("m_tbSecondDetail.Wrappable")));
			// 
			// m_tbbInsert2Detail
			// 
			this.m_alMain.SetAction(this.m_tbbInsert2Detail, this.m_actInsert2Detail);
			this.m_tbbInsert2Detail.Enabled = ((bool)(resources.GetObject("m_tbbInsert2Detail.Enabled")));
			this.m_tbbInsert2Detail.ImageIndex = ((int)(resources.GetObject("m_tbbInsert2Detail.ImageIndex")));
			this.m_tbbInsert2Detail.Text = resources.GetString("m_tbbInsert2Detail.Text");
			this.m_tbbInsert2Detail.ToolTipText = resources.GetString("m_tbbInsert2Detail.ToolTipText");
			this.m_tbbInsert2Detail.Visible = ((bool)(resources.GetObject("m_tbbInsert2Detail.Visible")));
			// 
			// m_tbbEdit2Detail
			// 
			this.m_alMain.SetAction(this.m_tbbEdit2Detail, this.m_actEdit2Detail);
			this.m_tbbEdit2Detail.Enabled = ((bool)(resources.GetObject("m_tbbEdit2Detail.Enabled")));
			this.m_tbbEdit2Detail.ImageIndex = ((int)(resources.GetObject("m_tbbEdit2Detail.ImageIndex")));
			this.m_tbbEdit2Detail.Text = resources.GetString("m_tbbEdit2Detail.Text");
			this.m_tbbEdit2Detail.ToolTipText = resources.GetString("m_tbbEdit2Detail.ToolTipText");
			this.m_tbbEdit2Detail.Visible = ((bool)(resources.GetObject("m_tbbEdit2Detail.Visible")));
			// 
			// m_tbbDelete2Detail
			// 
			this.m_alMain.SetAction(this.m_tbbDelete2Detail, this.m_actDelete2Detail);
			this.m_tbbDelete2Detail.Enabled = ((bool)(resources.GetObject("m_tbbDelete2Detail.Enabled")));
			this.m_tbbDelete2Detail.ImageIndex = ((int)(resources.GetObject("m_tbbDelete2Detail.ImageIndex")));
			this.m_tbbDelete2Detail.Text = resources.GetString("m_tbbDelete2Detail.Text");
			this.m_tbbDelete2Detail.ToolTipText = resources.GetString("m_tbbDelete2Detail.ToolTipText");
			this.m_tbbDelete2Detail.Visible = ((bool)(resources.GetObject("m_tbbDelete2Detail.Visible")));
			// 
			// m_splLeft
			// 
			this.m_splLeft.AccessibleDescription = resources.GetString("m_splLeft.AccessibleDescription");
			this.m_splLeft.AccessibleName = resources.GetString("m_splLeft.AccessibleName");
			this.m_splLeft.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splLeft.Anchor")));
			this.m_splLeft.BackColor = System.Drawing.SystemColors.Control;
			this.m_splLeft.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splLeft.BackgroundImage")));
			this.m_splLeft.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splLeft.Dock")));
			this.m_splLeft.Enabled = ((bool)(resources.GetObject("m_splLeft.Enabled")));
			this.m_splLeft.Font = ((System.Drawing.Font)(resources.GetObject("m_splLeft.Font")));
			this.m_splLeft.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splLeft.ImeMode")));
			this.m_splLeft.Location = ((System.Drawing.Point)(resources.GetObject("m_splLeft.Location")));
			this.m_splLeft.MinExtra = ((int)(resources.GetObject("m_splLeft.MinExtra")));
			this.m_splLeft.MinSize = ((int)(resources.GetObject("m_splLeft.MinSize")));
			this.m_splLeft.Name = "m_splLeft";
			this.m_splLeft.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splLeft.RightToLeft")));
			this.m_splLeft.Size = ((System.Drawing.Size)(resources.GetObject("m_splLeft.Size")));
			this.m_splLeft.TabIndex = ((int)(resources.GetObject("m_splLeft.TabIndex")));
			this.m_splLeft.TabStop = false;
			this.m_splLeft.Visible = ((bool)(resources.GetObject("m_splLeft.Visible")));
			// 
			// m_pnlLeft
			// 
			this.m_pnlLeft.AccessibleDescription = resources.GetString("m_pnlLeft.AccessibleDescription");
			this.m_pnlLeft.AccessibleName = resources.GetString("m_pnlLeft.AccessibleName");
			this.m_pnlLeft.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlLeft.Anchor")));
			this.m_pnlLeft.AutoScroll = ((bool)(resources.GetObject("m_pnlLeft.AutoScroll")));
			this.m_pnlLeft.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlLeft.AutoScrollMargin")));
			this.m_pnlLeft.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlLeft.AutoScrollMinSize")));
			this.m_pnlLeft.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlLeft.BackgroundImage")));
			this.m_pnlLeft.Controls.Add(this.m_grdMaster);
			this.m_pnlLeft.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlLeft.Dock")));
			this.m_pnlLeft.Enabled = ((bool)(resources.GetObject("m_pnlLeft.Enabled")));
			this.m_pnlLeft.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlLeft.Font")));
			this.m_pnlLeft.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlLeft.ImeMode")));
			this.m_pnlLeft.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlLeft.Location")));
			this.m_pnlLeft.Name = "m_pnlLeft";
			this.m_pnlLeft.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlLeft.RightToLeft")));
			this.m_pnlLeft.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlLeft.Size")));
			this.m_pnlLeft.TabIndex = ((int)(resources.GetObject("m_pnlLeft.TabIndex")));
			this.m_pnlLeft.Text = resources.GetString("m_pnlLeft.Text");
			this.m_pnlLeft.Visible = ((bool)(resources.GetObject("m_pnlLeft.Visible")));
			// 
			// m_splBottom
			// 
			this.m_splBottom.AccessibleDescription = resources.GetString("m_splBottom.AccessibleDescription");
			this.m_splBottom.AccessibleName = resources.GetString("m_splBottom.AccessibleName");
			this.m_splBottom.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splBottom.Anchor")));
			this.m_splBottom.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splBottom.BackgroundImage")));
			this.m_splBottom.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splBottom.Dock")));
			this.m_splBottom.Enabled = ((bool)(resources.GetObject("m_splBottom.Enabled")));
			this.m_splBottom.Font = ((System.Drawing.Font)(resources.GetObject("m_splBottom.Font")));
			this.m_splBottom.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splBottom.ImeMode")));
			this.m_splBottom.Location = ((System.Drawing.Point)(resources.GetObject("m_splBottom.Location")));
			this.m_splBottom.MinExtra = ((int)(resources.GetObject("m_splBottom.MinExtra")));
			this.m_splBottom.MinSize = ((int)(resources.GetObject("m_splBottom.MinSize")));
			this.m_splBottom.Name = "m_splBottom";
			this.m_splBottom.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splBottom.RightToLeft")));
			this.m_splBottom.Size = ((System.Drawing.Size)(resources.GetObject("m_splBottom.Size")));
			this.m_splBottom.TabIndex = ((int)(resources.GetObject("m_splBottom.TabIndex")));
			this.m_splBottom.TabStop = false;
			this.m_splBottom.Visible = ((bool)(resources.GetObject("m_splBottom.Visible")));
			// 
			// m_actInsert2Detail
			// 
			this.m_actInsert2Detail.Checked = false;
			this.m_actInsert2Detail.Enabled = true;
			this.m_actInsert2Detail.Hint = resources.GetString("m_actInsert2Detail.Hint");
			this.m_actInsert2Detail.ImageIndex = ((int)(resources.GetObject("m_actInsert2Detail.ImageIndex")));
			this.m_actInsert2Detail.MergeOrder = 32;
			this.m_actInsert2Detail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actInsert2Detail.Tag = null;
			this.m_actInsert2Detail.Text = resources.GetString("m_actInsert2Detail.Text");
			this.m_actInsert2Detail.Visible = true;
			this.m_actInsert2Detail.Execute += new System.EventHandler(this.m_actInsert2Detail_Execute);
			// 
			// m_actEdit2Detail
			// 
			this.m_actEdit2Detail.Checked = false;
			this.m_actEdit2Detail.Enabled = true;
			this.m_actEdit2Detail.Hint = resources.GetString("m_actEdit2Detail.Hint");
			this.m_actEdit2Detail.ImageIndex = ((int)(resources.GetObject("m_actEdit2Detail.ImageIndex")));
			this.m_actEdit2Detail.MergeOrder = 33;
			this.m_actEdit2Detail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actEdit2Detail.Tag = null;
			this.m_actEdit2Detail.Text = resources.GetString("m_actEdit2Detail.Text");
			this.m_actEdit2Detail.Visible = true;
			this.m_actEdit2Detail.Execute += new System.EventHandler(this.m_actEdit2Detail_Execute);
			// 
			// m_actDelete2Detail
			// 
			this.m_actDelete2Detail.Checked = false;
			this.m_actDelete2Detail.Enabled = true;
			this.m_actDelete2Detail.Hint = resources.GetString("m_actDelete2Detail.Hint");
			this.m_actDelete2Detail.ImageIndex = ((int)(resources.GetObject("m_actDelete2Detail.ImageIndex")));
			this.m_actDelete2Detail.MergeOrder = 31;
			this.m_actDelete2Detail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDelete2Detail.Tag = null;
			this.m_actDelete2Detail.Text = resources.GetString("m_actDelete2Detail.Text");
			this.m_actDelete2Detail.Visible = true;
			this.m_actDelete2Detail.Execute += new System.EventHandler(this.m_actDelete2Detail_Execute);
			// 
			// ThreeGrid
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.Controls.Add(this.m_pnlFill);
			this.Controls.Add(this.m_grbParam);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Name = "ThreeGrid";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.Size = ((System.Drawing.Size)(resources.GetObject("$this.Size")));
			this.Load += new System.EventHandler(this.ThreeGridForm_Load);
			this.Controls.SetChildIndex(this.m_tbMain, 0);
			this.Controls.SetChildIndex(this.m_grbParam, 0);
			this.Controls.SetChildIndex(this.m_pnlFill, 0);
			this.m_grbParam.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdDetail)).EndInit();
			this.m_pnlFill.ResumeLayout(false);
			this.m_pnlRight.ResumeLayout(false);
			this.m_pnlTop.ResumeLayout(false);
			this.m_pnlBottom.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.m_grdSecondDetail)).EndInit();
			this.m_pnlLeft.ResumeLayout(false);
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		///     "",  
		/// </summary>
		/// <summary>
		///     "",  
		/// </summary>
		public override void Reload()
		{
			if (!m_bInit)
				return;

			if (m_bControlFieldMaster)
				this.AddFieldFromHash(m_htMasterParam);

			if (m_bControlFieldDetail)
				this.AddFieldFromHash(m_htDetailParam);


			if (m_bControlField2Detail)
				this.AddFieldFromHash(m_ht2DetailParam);


			int iConnectionValue;
			int iConnection2Value;

			if (m_bMasterAll)
				m_htMasterParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
			if (m_dtMaster.Rows.Count > 0)
				iConnectionValue = Convert.ToInt32(m_dtMaster.Rows[0][m_strConnectField]);
			else
				iConnectionValue = -1;
			FillDetail(m_strTuningMaster, m_grdMaster, ref m_dtTuningMaster);

			m_htDetailParam[m_strConnectField] = iConnectionValue;
			if (m_bDetailAll)
				m_htDetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
			FillDetail(m_strTuningDetail, m_grdDetail, ref m_dtTuningDetail);

			if (m_dtDetail.Rows.Count > 0)
				iConnection2Value = Convert.ToInt32(m_dtDetail.Rows[0][m_strConnectField2]);
			else
				iConnection2Value = -1;

			if (m_iCount == 1)
				m_ht2DetailParam[m_strConnectField2] = iConnection2Value;
			else
				m_ht2DetailParam[m_strConnectField2] = iConnectionValue;

			if (m_b2DetailAll)
				m_ht2DetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
			FillDetail(m_strTuning2Detail, m_grdSecondDetail, ref m_dtTuning2Detail);


		}


		/// <summary>
		///     
		/// </summary>
		/// <param name="sender">,  </param>
		/// <param name="e"> </param>
		private void ThreeGridForm_Load(object sender, EventArgs e)
		{
			//Reload();
		}

		/// <summary>
		///    
		/// </summary>
		/// <returns></returns>
		private bool ReadDictionary()
		{
			m_strTuningMaster = this.Tuning;
			using (Command cmdElement = new Command())
			{
				if (m_strTuningMaster != null && m_strTuningMaster != "")
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningMaster;
					cmdElement.Execute(true);
					m_iCount = cmdElement.DataSet.Tables[0].Rows.Count;
					if (m_iCount == 0)
						return false;

					DataTable dtElement = cmdElement.DataSet.Tables[0];
					m_strTuningDetail = dtElement.Rows[0]["tuning_detail"].ToString();
					m_strConnectField = dtElement.Rows[0]["connect_field"].ToString();
					m_strGetMaster = dtElement.Rows[0]["get"].ToString();
					m_strDeleteMaster = dtElement.Rows[0]["del"].ToString();
					m_strKeyFieldMaster = dtElement.Rows[0]["key_field"].ToString();

					if (dtElement.Rows[0]["history_field"] != DBNull.Value)
						m_bMasterAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
					else
						m_bMasterAll = false;

					m_grdMaster.CaptionText = dtElement.Rows[0]["desk"].ToString();

					if (dtElement.Rows[0]["control_field"] != DBNull.Value)
						m_bControlFieldMaster = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
					else
						m_bControlFieldMaster = false;


					if (m_iCount == 2)
					{
						m_strTuning2Detail = dtElement.Rows[1]["tuning_detail"].ToString();
						m_strConnectField2 = dtElement.Rows[1]["connect_field"].ToString();
					}


				}
				else
					return false;
			}
			using (Command cmdElement = new Command())
				if (m_strTuningDetail != null && m_strTuningDetail != "")
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningDetail;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					if (m_iCount != 2)
					{
						m_strTuning2Detail = dtElement.Rows[0]["tuning_Detail"].ToString();
						m_strConnectField2 = dtElement.Rows[0]["connect_field"].ToString();
					}
					m_strGetDetail = dtElement.Rows[0]["get"].ToString();
					m_strDeleteDetail = dtElement.Rows[0]["del"].ToString();
					m_strKeyFieldDetail = dtElement.Rows[0]["key_field"].ToString();

					if (dtElement.Rows[0]["history_field"] != DBNull.Value)
						m_bDetailAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
					else
						m_bDetailAll = false;

					m_grdDetail.CaptionText = dtElement.Rows[0]["desk"].ToString();

					if (dtElement.Rows[0]["control_field"] != DBNull.Value)
						m_bControlFieldDetail = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
					else
						m_bControlFieldDetail = false;


				}
				else
					return false;
			using (Command cmdElement = new Command())
				if (m_strTuning2Detail != null)
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuning2Detail;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					m_strGet2Detail = dtElement.Rows[0]["get"].ToString();
					m_strDelete2Detail = dtElement.Rows[0]["del"].ToString();
					m_strKeyField2Detail = dtElement.Rows[0]["key_field"].ToString();

					if (dtElement.Rows[0]["history_field"] != DBNull.Value)
						m_b2DetailAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
					else
						m_b2DetailAll = false;

					m_grdSecondDetail.CaptionText = dtElement.Rows[0]["desk"].ToString();

					if (dtElement.Rows[0]["control_field"] != DBNull.Value)
						m_bControlField2Detail = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
					else
						m_bControlField2Detail = false;


				}
				else
					return false;

			if (!m_bDetailAll && !m_b2DetailAll && !m_bMasterAll)
				m_grbParam.Visible = false;


			return true;

		}

		private void m_grdMaster_CurrentCellChanged(object sender, EventArgs e)
		{
			int iConnectionValue, iConnection2Value;

			iConnectionValue = Convert.ToInt32(m_grdMaster.CurrentRow[m_strConnectField]);

			m_htDetailParam[m_strConnectField] = iConnectionValue;
			if (m_bDetailAll)
				m_htDetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);

			if (m_iCount == 1)
				if (m_dtDetail.Rows.Count > 0)
					iConnection2Value = Convert.ToInt32(m_dtDetail.Rows[0][m_strConnectField2]);
				else
					iConnection2Value = -1;
			else
				iConnection2Value = iConnectionValue;

			m_ht2DetailParam[m_strConnectField2] = iConnection2Value;
			if (m_b2DetailAll)
				m_ht2DetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);


		}


		private void m_actMasterInsert_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdMaster, null, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());
			}

		}

		private void m_actMasterEdit_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdMaster, m_strKeyFieldMaster, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());
			}

		}

		private void m_actMasterDelete_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDeleteMaster, m_strKeyFieldMaster, m_grdMaster))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);

			}


		}

		private void m_chkChange_CheckedChanged(object sender, EventArgs e)
		{
			Reload();
		}

		private void m_actDeleteDetail_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDeleteDetail, m_strKeyFieldDetail, m_grdDetail))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);

			}
		}

		private void m_actInsertDetail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdDetail, null, ref m_dtTuningDetail, m_htDetailParam, out iIndex))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
				m_grdDetail.SelectRow(m_strKeyFieldDetail, iIndex.ToString());
			}

		}

		private void m_actEditDetail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdDetail, m_strKeyFieldDetail, ref m_dtTuningDetail, m_htDetailParam, out iIndex))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
				m_grdDetail.SelectRow(m_strKeyFieldDetail, iIndex.ToString());
			}
		}


		private void m_actDelete2Detail_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDelete2Detail, m_strKeyField2Detail, m_grdSecondDetail))
			{
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);

			}

		}

		private void m_actInsert2Detail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdSecondDetail, null, ref m_dtTuning2Detail, m_ht2DetailParam, out iIndex))
			{
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
				m_grdSecondDetail.SelectRow(m_strKeyField2Detail, iIndex.ToString());
			}

		}

		private void m_actEdit2Detail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdSecondDetail, m_strKeyField2Detail, ref m_dtTuning2Detail, m_ht2DetailParam, out iIndex))
			{
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
				m_grdSecondDetail.SelectRow(m_strKeyField2Detail, iIndex.ToString());
			}

		}

		private void m_grdSecondDetail_CurrentCellChanged(object sender, EventArgs e)
		{
			if (m_iCount == 1)
			{
				int iConnection2Value;

				iConnection2Value = Convert.ToInt32(m_grdSecondDetail.CurrentRow[m_strConnectField2]);

				m_ht2DetailParam[m_strConnectField2] = iConnection2Value;
				if (m_b2DetailAll)
					m_ht2DetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
			}

		}


	}
}
/********************* SniipSoftel *****************
 *
 *    $History: ThreeGrid.cs $
 *   
 *   *****************  Version 8  *****************
 *   User: Gavrilov     Date: 14.05.07   Time: 19:04
 *   Updated in $/Net/Common/ClientControl/MultiGrid
 *   
 *   *****************  Version 6  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 5  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 4  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *
 ********************* SniipSoftel *****************/
