/********************* SniipSoftel *****************
 *
 *   $Author: Gavrilov $
 *   $Revision: 9 $
 *   $Date: 14.05.07 19:05 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Softel.MiddleTier.Client;
using MessageBox = Softel.Windows.Forms.MsgBox;

namespace Softel.Windows.Forms
{
	///         
	/// mastergrid -   
	/// detailgrid -   
	/// second detailgrid -   
	/// </summary>
	/// <example>
	///   
	/// 
	/// <code>
	///  Hashtable htArgs = new Hashtable();
	///  htArgs.Add("tuning", "switch")
	///  ThrteeGridForm objGridForm = new ThreeGridForm(htArgs);
	///  objGridForm.ShowDialog();
	///       hashtable - 
	///											  
	///	  1)hash-          tuning.
	///	         ui_type   
	///	   Ui_Dictionary
	///	        ui_dictionary,ui_Params_Type  ui_params, ui_dictionary_realation 
	///	             .
	///	     ui_dictionary,ui_params     
	///   2)hash -        
	///              ui_dictionary  ontrol_field( )=1
	///      ui_dictionary,ui_Params_Type  ui_params   SingleGridForm
	///      ui_dictionary_relation   TwoGridForm
	///   3)        ui_type                
	///             ui_type                
	public class ThreeGridHor : BaseGrid
	{
		private GroupBox m_grbParam;
		private CheckBox m_chkChange;
		private IContainer components;
		private DataTable m_dtTuningMaster;
		private DataTable m_dtTuningDetail;
		private DataTable m_dtTuning2Detail;
		private DataTable m_dtMaster;
		private DataTable m_dtDetail;
		private DataTable m_dt2Detail;
		private Hashtable m_htMasterParam;
		private Hashtable m_htDetailParam;
		private Hashtable m_ht2DetailParam;
		private GlobalImageList m_gil;
		private Action m_actInsertDetail;
		private Action m_actEditDetail;
		private Action m_actDeleteDetail;
		private ContextMenu m_cmDetail;
		private MenuItem m_miInsertDetail;
		private MenuItem m_miEditDetail;
		private MenuItem m_miDeleteDetail;

		private string m_strConnectField;
		private string m_strConnectField2;

		private bool m_bControlField2Detail;
		private bool m_bControlFieldDetail;
		private bool m_bControlFieldMaster;

		private string m_strGet2Detail;
		private string m_strGetDetail;
		private string m_strGetMaster;

		private string m_strDelete2Detail;
		private string m_strDeleteDetail;
		private string m_strDeleteMaster;

		private string m_strKeyField2Detail;
		private string m_strKeyFieldDetail;
		private string m_strKeyFieldMaster;

		private bool m_b2DetailAll;
		private bool m_bDetailAll;
		private bool m_bMasterAll;

		private string m_strTuning2Detail;
		private string m_strTuningDetail;
		private Splitter m_splBottom;
		private Action m_actInsert2Detail;
		private Action m_actEdit2Detail;
		private Action m_actDelete2Detail;
		private ContextMenu m_cmSecondDetail;
		private MenuItem m_miInsert2Detail;
		private MenuItem m_miEdit2Detail;
		private MenuItem m_miDelete2Detail;
		private string m_strTuningMaster;
		private int m_iCount = 0;
		private Panel m_pnlFill;
		private CuteSoftelGrid m_grdMaster;
		private Splitter m_splMaster;
		private CuteSoftelGrid m_grdSecondDetail;
		private CuteSoftelGrid m_grdDetail;
		private Splitter m_splSecondDetail;
		private bool m_bInit = false;


		/// <summary>
		///  ,      
		///  
		/// </summary>
		public ThreeGridHor()
		{
			InitializeComponent();
		}

		/// <summary>
		/// ,        <see cref=""/>   
		///    
		/// </summary>
		/// <param name="htArgs">  <see cref="Hashtable">,   </param>
		/// <remarks>
		/// 	<para>     :</para>
		/// 	<list type="bullet">
		/// 		<item>cln_id - id </item>
		/// 		<item>ac_id - id  </item>
		/// 		<item>sub_id - id </item>
		/// 	</list>
		/// </remarks>
		public ThreeGridHor(Hashtable htArgs) : base(htArgs)
		{
			InitializeComponent();

			m_bInit = ReadDictionary();
			if (m_bInit)
			{
				m_htMasterParam = new Hashtable();
				if (m_bMasterAll)
					m_htMasterParam.Add("all", null);


				m_htDetailParam = new Hashtable();
				if (m_bDetailAll)
					m_htDetailParam.Add("all", null);

				m_ht2DetailParam = new Hashtable();
				if (m_b2DetailAll)
					m_ht2DetailParam.Add("all", null);
			}

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ThreeGridHor));
			this.m_grbParam = new System.Windows.Forms.GroupBox();
			this.m_chkChange = new System.Windows.Forms.CheckBox();
			this.m_cmDetail = new System.Windows.Forms.ContextMenu();
			this.m_miInsertDetail = new System.Windows.Forms.MenuItem();
			this.m_miEditDetail = new System.Windows.Forms.MenuItem();
			this.m_miDeleteDetail = new System.Windows.Forms.MenuItem();
			this.m_gil = new Softel.Windows.Forms.GlobalImageList(this.components);
			this.m_actInsertDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actEditDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_actDeleteDetail = new Softel.Windows.Forms.Action(this.components);
			this.m_cmSecondDetail = new System.Windows.Forms.ContextMenu();
			this.m_miInsert2Detail = new System.Windows.Forms.MenuItem();
			this.m_miEdit2Detail = new System.Windows.Forms.MenuItem();
			this.m_miDelete2Detail = new System.Windows.Forms.MenuItem();
			this.m_splBottom = new System.Windows.Forms.Splitter();
			this.m_actInsert2Detail = new Softel.Windows.Forms.Action(this.components);
			this.m_actEdit2Detail = new Softel.Windows.Forms.Action(this.components);
			this.m_actDelete2Detail = new Softel.Windows.Forms.Action(this.components);
			this.m_pnlFill = new System.Windows.Forms.Panel();
			this.m_splSecondDetail = new System.Windows.Forms.Splitter();
			this.m_grdDetail = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_grdSecondDetail = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_splMaster = new System.Windows.Forms.Splitter();
			this.m_grdMaster = new Softel.Windows.Forms.CuteSoftelGrid();
			this.m_grbParam.SuspendLayout();
			this.m_pnlFill.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.m_grdDetail)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdSecondDetail)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).BeginInit();
			this.SuspendLayout();
			// 
			// SoftelImageList
			// 
			this.SoftelImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("SoftelImageList.ImageStream")));
			// 
			// m_alMain
			// 
			this.m_alMain.Actions.AddRange(new Softel.Windows.Forms.Action[] {
																				 this.m_actInsertDetail,
																				 this.m_actEditDetail,
																				 this.m_actDeleteDetail,
																				 this.m_actInsert2Detail,
																				 this.m_actEdit2Detail,
																				 this.m_actDelete2Detail});
			// 
			// m_tbMain
			// 
			this.m_tbMain.Name = "m_tbMain";
			this.m_tbMain.Size = ((System.Drawing.Size)(resources.GetObject("m_tbMain.Size")));
			// 
			// m_actInsert
			// 
			this.m_actInsert.Execute += new System.EventHandler(this.m_actMasterInsert_Execute);
			// 
			// m_actEdit
			// 
			this.m_actEdit.Execute += new System.EventHandler(this.m_actMasterEdit_Execute);
			// 
			// m_actDelete
			// 
			this.m_actDelete.Execute += new System.EventHandler(this.m_actMasterDelete_Execute);
			// 
			// m_grbParam
			// 
			this.m_grbParam.AccessibleDescription = resources.GetString("m_grbParam.AccessibleDescription");
			this.m_grbParam.AccessibleName = resources.GetString("m_grbParam.AccessibleName");
			this.m_grbParam.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grbParam.Anchor")));
			this.m_grbParam.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grbParam.BackgroundImage")));
			this.m_grbParam.Controls.Add(this.m_chkChange);
			this.m_grbParam.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grbParam.Dock")));
			this.m_grbParam.Enabled = ((bool)(resources.GetObject("m_grbParam.Enabled")));
			this.m_grbParam.Font = ((System.Drawing.Font)(resources.GetObject("m_grbParam.Font")));
			this.m_grbParam.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grbParam.ImeMode")));
			this.m_grbParam.Location = ((System.Drawing.Point)(resources.GetObject("m_grbParam.Location")));
			this.m_grbParam.Name = "m_grbParam";
			this.m_grbParam.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grbParam.RightToLeft")));
			this.m_grbParam.Size = ((System.Drawing.Size)(resources.GetObject("m_grbParam.Size")));
			this.m_grbParam.TabIndex = ((int)(resources.GetObject("m_grbParam.TabIndex")));
			this.m_grbParam.TabStop = false;
			this.m_grbParam.Text = resources.GetString("m_grbParam.Text");
			this.m_grbParam.Visible = ((bool)(resources.GetObject("m_grbParam.Visible")));
			// 
			// m_chkChange
			// 
			this.m_chkChange.AccessibleDescription = resources.GetString("m_chkChange.AccessibleDescription");
			this.m_chkChange.AccessibleName = resources.GetString("m_chkChange.AccessibleName");
			this.m_chkChange.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_chkChange.Anchor")));
			this.m_chkChange.Appearance = ((System.Windows.Forms.Appearance)(resources.GetObject("m_chkChange.Appearance")));
			this.m_chkChange.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_chkChange.BackgroundImage")));
			this.m_chkChange.CheckAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.CheckAlign")));
			this.m_chkChange.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_chkChange.Dock")));
			this.m_chkChange.Enabled = ((bool)(resources.GetObject("m_chkChange.Enabled")));
			this.m_chkChange.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("m_chkChange.FlatStyle")));
			this.m_chkChange.Font = ((System.Drawing.Font)(resources.GetObject("m_chkChange.Font")));
			this.m_chkChange.Image = ((System.Drawing.Image)(resources.GetObject("m_chkChange.Image")));
			this.m_chkChange.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.ImageAlign")));
			this.m_chkChange.ImageIndex = ((int)(resources.GetObject("m_chkChange.ImageIndex")));
			this.m_chkChange.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_chkChange.ImeMode")));
			this.m_chkChange.Location = ((System.Drawing.Point)(resources.GetObject("m_chkChange.Location")));
			this.m_chkChange.Name = "m_chkChange";
			this.m_chkChange.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_chkChange.RightToLeft")));
			this.m_chkChange.Size = ((System.Drawing.Size)(resources.GetObject("m_chkChange.Size")));
			this.m_chkChange.TabIndex = ((int)(resources.GetObject("m_chkChange.TabIndex")));
			this.m_chkChange.Text = resources.GetString("m_chkChange.Text");
			this.m_chkChange.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("m_chkChange.TextAlign")));
			this.m_chkChange.Visible = ((bool)(resources.GetObject("m_chkChange.Visible")));
			this.m_chkChange.CheckedChanged += new System.EventHandler(this.m_chkChange_CheckedChanged);
			// 
			// m_cmDetail
			// 
			this.m_cmDetail.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.m_miInsertDetail,
																					   this.m_miEditDetail,
																					   this.m_miDeleteDetail});
			this.m_cmDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmDetail.RightToLeft")));
			// 
			// m_miInsertDetail
			// 
			this.m_alMain.SetAction(this.m_miInsertDetail, this.m_actInsertDetail);
			this.m_miInsertDetail.Enabled = ((bool)(resources.GetObject("m_miInsertDetail.Enabled")));
			this.m_miInsertDetail.Index = 0;
			this.m_miInsertDetail.MergeOrder = 32;
			this.m_miInsertDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miInsertDetail.Shortcut")));
			this.m_miInsertDetail.ShowShortcut = ((bool)(resources.GetObject("m_miInsertDetail.ShowShortcut")));
			this.m_miInsertDetail.Text = resources.GetString("m_miInsertDetail.Text");
			this.m_miInsertDetail.Visible = ((bool)(resources.GetObject("m_miInsertDetail.Visible")));
			// 
			// m_miEditDetail
			// 
			this.m_alMain.SetAction(this.m_miEditDetail, this.m_actEditDetail);
			this.m_miEditDetail.Enabled = ((bool)(resources.GetObject("m_miEditDetail.Enabled")));
			this.m_miEditDetail.Index = 1;
			this.m_miEditDetail.MergeOrder = 33;
			this.m_miEditDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miEditDetail.Shortcut")));
			this.m_miEditDetail.ShowShortcut = ((bool)(resources.GetObject("m_miEditDetail.ShowShortcut")));
			this.m_miEditDetail.Text = resources.GetString("m_miEditDetail.Text");
			this.m_miEditDetail.Visible = ((bool)(resources.GetObject("m_miEditDetail.Visible")));
			// 
			// m_miDeleteDetail
			// 
			this.m_alMain.SetAction(this.m_miDeleteDetail, this.m_actDeleteDetail);
			this.m_miDeleteDetail.Enabled = ((bool)(resources.GetObject("m_miDeleteDetail.Enabled")));
			this.m_miDeleteDetail.Index = 2;
			this.m_miDeleteDetail.MergeOrder = 31;
			this.m_miDeleteDetail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDeleteDetail.Shortcut")));
			this.m_miDeleteDetail.ShowShortcut = ((bool)(resources.GetObject("m_miDeleteDetail.ShowShortcut")));
			this.m_miDeleteDetail.Text = resources.GetString("m_miDeleteDetail.Text");
			this.m_miDeleteDetail.Visible = ((bool)(resources.GetObject("m_miDeleteDetail.Visible")));
			// 
			// m_gil
			// 
			this.m_gil.ImageList = this.SoftelImageList;
			this.m_gil.Parent = this;
			// 
			// m_actInsertDetail
			// 
			this.m_actInsertDetail.Checked = false;
			this.m_actInsertDetail.Enabled = true;
			this.m_actInsertDetail.Hint = resources.GetString("m_actInsertDetail.Hint");
			this.m_actInsertDetail.ImageIndex = ((int)(resources.GetObject("m_actInsertDetail.ImageIndex")));
			this.m_actInsertDetail.MergeOrder = 32;
			this.m_actInsertDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actInsertDetail.Tag = null;
			this.m_actInsertDetail.Text = resources.GetString("m_actInsertDetail.Text");
			this.m_actInsertDetail.Visible = true;
			this.m_actInsertDetail.Execute += new System.EventHandler(this.m_actInsertDetail_Execute);
			// 
			// m_actEditDetail
			// 
			this.m_actEditDetail.Checked = false;
			this.m_actEditDetail.Enabled = true;
			this.m_actEditDetail.Hint = resources.GetString("m_actEditDetail.Hint");
			this.m_actEditDetail.ImageIndex = ((int)(resources.GetObject("m_actEditDetail.ImageIndex")));
			this.m_actEditDetail.MergeOrder = 33;
			this.m_actEditDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actEditDetail.Tag = null;
			this.m_actEditDetail.Text = resources.GetString("m_actEditDetail.Text");
			this.m_actEditDetail.Visible = true;
			this.m_actEditDetail.Execute += new System.EventHandler(this.m_actEditDetail_Execute);
			// 
			// m_actDeleteDetail
			// 
			this.m_actDeleteDetail.Checked = false;
			this.m_actDeleteDetail.Enabled = true;
			this.m_actDeleteDetail.Hint = resources.GetString("m_actDeleteDetail.Hint");
			this.m_actDeleteDetail.ImageIndex = ((int)(resources.GetObject("m_actDeleteDetail.ImageIndex")));
			this.m_actDeleteDetail.MergeOrder = 31;
			this.m_actDeleteDetail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDeleteDetail.Tag = null;
			this.m_actDeleteDetail.Text = resources.GetString("m_actDeleteDetail.Text");
			this.m_actDeleteDetail.Visible = true;
			this.m_actDeleteDetail.Execute += new System.EventHandler(this.m_actDeleteDetail_Execute);
			// 
			// m_cmSecondDetail
			// 
			this.m_cmSecondDetail.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.m_miInsert2Detail,
																							 this.m_miEdit2Detail,
																							 this.m_miDelete2Detail});
			this.m_cmSecondDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_cmSecondDetail.RightToLeft")));
			// 
			// m_miInsert2Detail
			// 
			this.m_alMain.SetAction(this.m_miInsert2Detail, this.m_actInsert2Detail);
			this.m_miInsert2Detail.Enabled = ((bool)(resources.GetObject("m_miInsert2Detail.Enabled")));
			this.m_miInsert2Detail.Index = 0;
			this.m_miInsert2Detail.MergeOrder = 32;
			this.m_miInsert2Detail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miInsert2Detail.Shortcut")));
			this.m_miInsert2Detail.ShowShortcut = ((bool)(resources.GetObject("m_miInsert2Detail.ShowShortcut")));
			this.m_miInsert2Detail.Text = resources.GetString("m_miInsert2Detail.Text");
			this.m_miInsert2Detail.Visible = ((bool)(resources.GetObject("m_miInsert2Detail.Visible")));
			// 
			// m_miEdit2Detail
			// 
			this.m_alMain.SetAction(this.m_miEdit2Detail, this.m_actEdit2Detail);
			this.m_miEdit2Detail.Enabled = ((bool)(resources.GetObject("m_miEdit2Detail.Enabled")));
			this.m_miEdit2Detail.Index = 1;
			this.m_miEdit2Detail.MergeOrder = 33;
			this.m_miEdit2Detail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miEdit2Detail.Shortcut")));
			this.m_miEdit2Detail.ShowShortcut = ((bool)(resources.GetObject("m_miEdit2Detail.ShowShortcut")));
			this.m_miEdit2Detail.Text = resources.GetString("m_miEdit2Detail.Text");
			this.m_miEdit2Detail.Visible = ((bool)(resources.GetObject("m_miEdit2Detail.Visible")));
			// 
			// m_miDelete2Detail
			// 
			this.m_alMain.SetAction(this.m_miDelete2Detail, this.m_actDelete2Detail);
			this.m_miDelete2Detail.Enabled = ((bool)(resources.GetObject("m_miDelete2Detail.Enabled")));
			this.m_miDelete2Detail.Index = 2;
			this.m_miDelete2Detail.MergeOrder = 31;
			this.m_miDelete2Detail.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("m_miDelete2Detail.Shortcut")));
			this.m_miDelete2Detail.ShowShortcut = ((bool)(resources.GetObject("m_miDelete2Detail.ShowShortcut")));
			this.m_miDelete2Detail.Text = resources.GetString("m_miDelete2Detail.Text");
			this.m_miDelete2Detail.Visible = ((bool)(resources.GetObject("m_miDelete2Detail.Visible")));
			// 
			// m_splBottom
			// 
			this.m_splBottom.AccessibleDescription = resources.GetString("m_splBottom.AccessibleDescription");
			this.m_splBottom.AccessibleName = resources.GetString("m_splBottom.AccessibleName");
			this.m_splBottom.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splBottom.Anchor")));
			this.m_splBottom.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splBottom.BackgroundImage")));
			this.m_splBottom.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splBottom.Dock")));
			this.m_splBottom.Enabled = ((bool)(resources.GetObject("m_splBottom.Enabled")));
			this.m_splBottom.Font = ((System.Drawing.Font)(resources.GetObject("m_splBottom.Font")));
			this.m_splBottom.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splBottom.ImeMode")));
			this.m_splBottom.Location = ((System.Drawing.Point)(resources.GetObject("m_splBottom.Location")));
			this.m_splBottom.MinExtra = ((int)(resources.GetObject("m_splBottom.MinExtra")));
			this.m_splBottom.MinSize = ((int)(resources.GetObject("m_splBottom.MinSize")));
			this.m_splBottom.Name = "m_splBottom";
			this.m_splBottom.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splBottom.RightToLeft")));
			this.m_splBottom.Size = ((System.Drawing.Size)(resources.GetObject("m_splBottom.Size")));
			this.m_splBottom.TabIndex = ((int)(resources.GetObject("m_splBottom.TabIndex")));
			this.m_splBottom.TabStop = false;
			this.m_splBottom.Visible = ((bool)(resources.GetObject("m_splBottom.Visible")));
			// 
			// m_actInsert2Detail
			// 
			this.m_actInsert2Detail.Checked = false;
			this.m_actInsert2Detail.Enabled = true;
			this.m_actInsert2Detail.Hint = resources.GetString("m_actInsert2Detail.Hint");
			this.m_actInsert2Detail.ImageIndex = ((int)(resources.GetObject("m_actInsert2Detail.ImageIndex")));
			this.m_actInsert2Detail.MergeOrder = 32;
			this.m_actInsert2Detail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actInsert2Detail.Tag = null;
			this.m_actInsert2Detail.Text = resources.GetString("m_actInsert2Detail.Text");
			this.m_actInsert2Detail.Visible = true;
			this.m_actInsert2Detail.Execute += new System.EventHandler(this.m_actInsert2Detail_Execute);
			// 
			// m_actEdit2Detail
			// 
			this.m_actEdit2Detail.Checked = false;
			this.m_actEdit2Detail.Enabled = true;
			this.m_actEdit2Detail.Hint = resources.GetString("m_actEdit2Detail.Hint");
			this.m_actEdit2Detail.ImageIndex = ((int)(resources.GetObject("m_actEdit2Detail.ImageIndex")));
			this.m_actEdit2Detail.MergeOrder = 33;
			this.m_actEdit2Detail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actEdit2Detail.Tag = null;
			this.m_actEdit2Detail.Text = resources.GetString("m_actEdit2Detail.Text");
			this.m_actEdit2Detail.Visible = true;
			this.m_actEdit2Detail.Execute += new System.EventHandler(this.m_actEdit2Detail_Execute);
			// 
			// m_actDelete2Detail
			// 
			this.m_actDelete2Detail.Checked = false;
			this.m_actDelete2Detail.Enabled = true;
			this.m_actDelete2Detail.Hint = resources.GetString("m_actDelete2Detail.Hint");
			this.m_actDelete2Detail.ImageIndex = ((int)(resources.GetObject("m_actDelete2Detail.ImageIndex")));
			this.m_actDelete2Detail.MergeOrder = 31;
			this.m_actDelete2Detail.Shortcut = System.Windows.Forms.Shortcut.None;
			this.m_actDelete2Detail.Tag = null;
			this.m_actDelete2Detail.Text = resources.GetString("m_actDelete2Detail.Text");
			this.m_actDelete2Detail.Visible = true;
			this.m_actDelete2Detail.Execute += new System.EventHandler(this.m_actDelete2Detail_Execute);
			// 
			// m_pnlFill
			// 
			this.m_pnlFill.AccessibleDescription = resources.GetString("m_pnlFill.AccessibleDescription");
			this.m_pnlFill.AccessibleName = resources.GetString("m_pnlFill.AccessibleName");
			this.m_pnlFill.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_pnlFill.Anchor")));
			this.m_pnlFill.AutoScroll = ((bool)(resources.GetObject("m_pnlFill.AutoScroll")));
			this.m_pnlFill.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("m_pnlFill.AutoScrollMargin")));
			this.m_pnlFill.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("m_pnlFill.AutoScrollMinSize")));
			this.m_pnlFill.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_pnlFill.BackgroundImage")));
			this.m_pnlFill.Controls.Add(this.m_splSecondDetail);
			this.m_pnlFill.Controls.Add(this.m_grdDetail);
			this.m_pnlFill.Controls.Add(this.m_grdSecondDetail);
			this.m_pnlFill.Controls.Add(this.m_splMaster);
			this.m_pnlFill.Controls.Add(this.m_grdMaster);
			this.m_pnlFill.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_pnlFill.Dock")));
			this.m_pnlFill.Enabled = ((bool)(resources.GetObject("m_pnlFill.Enabled")));
			this.m_pnlFill.Font = ((System.Drawing.Font)(resources.GetObject("m_pnlFill.Font")));
			this.m_pnlFill.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_pnlFill.ImeMode")));
			this.m_pnlFill.Location = ((System.Drawing.Point)(resources.GetObject("m_pnlFill.Location")));
			this.m_pnlFill.Name = "m_pnlFill";
			this.m_pnlFill.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_pnlFill.RightToLeft")));
			this.m_pnlFill.Size = ((System.Drawing.Size)(resources.GetObject("m_pnlFill.Size")));
			this.m_pnlFill.TabIndex = ((int)(resources.GetObject("m_pnlFill.TabIndex")));
			this.m_pnlFill.Text = resources.GetString("m_pnlFill.Text");
			this.m_pnlFill.Visible = ((bool)(resources.GetObject("m_pnlFill.Visible")));
			// 
			// m_splSecondDetail
			// 
			this.m_splSecondDetail.AccessibleDescription = resources.GetString("m_splSecondDetail.AccessibleDescription");
			this.m_splSecondDetail.AccessibleName = resources.GetString("m_splSecondDetail.AccessibleName");
			this.m_splSecondDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splSecondDetail.Anchor")));
			this.m_splSecondDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splSecondDetail.BackgroundImage")));
			this.m_splSecondDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splSecondDetail.Dock")));
			this.m_splSecondDetail.Enabled = ((bool)(resources.GetObject("m_splSecondDetail.Enabled")));
			this.m_splSecondDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_splSecondDetail.Font")));
			this.m_splSecondDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splSecondDetail.ImeMode")));
			this.m_splSecondDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_splSecondDetail.Location")));
			this.m_splSecondDetail.MinExtra = ((int)(resources.GetObject("m_splSecondDetail.MinExtra")));
			this.m_splSecondDetail.MinSize = ((int)(resources.GetObject("m_splSecondDetail.MinSize")));
			this.m_splSecondDetail.Name = "m_splSecondDetail";
			this.m_splSecondDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splSecondDetail.RightToLeft")));
			this.m_splSecondDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_splSecondDetail.Size")));
			this.m_splSecondDetail.TabIndex = ((int)(resources.GetObject("m_splSecondDetail.TabIndex")));
			this.m_splSecondDetail.TabStop = false;
			this.m_splSecondDetail.Visible = ((bool)(resources.GetObject("m_splSecondDetail.Visible")));
			// 
			// m_grdDetail
			// 
			this.m_grdDetail.AccessibleDescription = resources.GetString("m_grdDetail.AccessibleDescription");
			this.m_grdDetail.AccessibleName = resources.GetString("m_grdDetail.AccessibleName");
			this.m_grdDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdDetail.Anchor")));
			this.m_grdDetail.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdDetail.BackgroundImage")));
			this.m_grdDetail.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdDetail.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdDetail.CaptionFont")));
			this.m_grdDetail.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdDetail.CaptionText = resources.GetString("m_grdDetail.CaptionText");
			this.m_grdDetail.ContextMenu = this.m_cmDetail;
			this.m_grdDetail.DataMember = "";
			this.m_grdDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdDetail.Dock")));
			this.m_grdDetail.Enabled = ((bool)(resources.GetObject("m_grdDetail.Enabled")));
			this.m_grdDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_grdDetail.Font")));
			this.m_grdDetail.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdDetail.HighlightRow = true;
			this.m_grdDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdDetail.ImeMode")));
			this.m_grdDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_grdDetail.Location")));
			this.m_grdDetail.Name = "m_grdDetail";
			this.m_grdDetail.ReadOnly = true;
			this.m_grdDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdDetail.RightToLeft")));
			this.m_grdDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_grdDetail.Size")));
			this.m_grdDetail.TabIndex = ((int)(resources.GetObject("m_grdDetail.TabIndex")));
			this.m_grdDetail.Visible = ((bool)(resources.GetObject("m_grdDetail.Visible")));
			this.m_grdDetail.CurrentCellChanged += new System.EventHandler(this.m_grdDetail_CurrentCellChanged);
			// 
			// m_grdSecondDetail
			// 
			this.m_grdSecondDetail.AccessibleDescription = resources.GetString("m_grdSecondDetail.AccessibleDescription");
			this.m_grdSecondDetail.AccessibleName = resources.GetString("m_grdSecondDetail.AccessibleName");
			this.m_grdSecondDetail.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdSecondDetail.Anchor")));
			this.m_grdSecondDetail.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdSecondDetail.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdSecondDetail.BackgroundImage")));
			this.m_grdSecondDetail.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdSecondDetail.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdSecondDetail.CaptionFont")));
			this.m_grdSecondDetail.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdSecondDetail.CaptionText = resources.GetString("m_grdSecondDetail.CaptionText");
			this.m_grdSecondDetail.ContextMenu = this.m_cmSecondDetail;
			this.m_grdSecondDetail.DataMember = "";
			this.m_grdSecondDetail.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdSecondDetail.Dock")));
			this.m_grdSecondDetail.Enabled = ((bool)(resources.GetObject("m_grdSecondDetail.Enabled")));
			this.m_grdSecondDetail.Font = ((System.Drawing.Font)(resources.GetObject("m_grdSecondDetail.Font")));
			this.m_grdSecondDetail.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdSecondDetail.HighlightRow = true;
			this.m_grdSecondDetail.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdSecondDetail.ImeMode")));
			this.m_grdSecondDetail.Location = ((System.Drawing.Point)(resources.GetObject("m_grdSecondDetail.Location")));
			this.m_grdSecondDetail.Name = "m_grdSecondDetail";
			this.m_grdSecondDetail.ReadOnly = true;
			this.m_grdSecondDetail.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdSecondDetail.RightToLeft")));
			this.m_grdSecondDetail.Size = ((System.Drawing.Size)(resources.GetObject("m_grdSecondDetail.Size")));
			this.m_grdSecondDetail.TabIndex = ((int)(resources.GetObject("m_grdSecondDetail.TabIndex")));
			this.m_grdSecondDetail.Visible = ((bool)(resources.GetObject("m_grdSecondDetail.Visible")));
			// 
			// m_splMaster
			// 
			this.m_splMaster.AccessibleDescription = resources.GetString("m_splMaster.AccessibleDescription");
			this.m_splMaster.AccessibleName = resources.GetString("m_splMaster.AccessibleName");
			this.m_splMaster.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_splMaster.Anchor")));
			this.m_splMaster.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_splMaster.BackgroundImage")));
			this.m_splMaster.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_splMaster.Dock")));
			this.m_splMaster.Enabled = ((bool)(resources.GetObject("m_splMaster.Enabled")));
			this.m_splMaster.Font = ((System.Drawing.Font)(resources.GetObject("m_splMaster.Font")));
			this.m_splMaster.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_splMaster.ImeMode")));
			this.m_splMaster.Location = ((System.Drawing.Point)(resources.GetObject("m_splMaster.Location")));
			this.m_splMaster.MinExtra = ((int)(resources.GetObject("m_splMaster.MinExtra")));
			this.m_splMaster.MinSize = ((int)(resources.GetObject("m_splMaster.MinSize")));
			this.m_splMaster.Name = "m_splMaster";
			this.m_splMaster.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_splMaster.RightToLeft")));
			this.m_splMaster.Size = ((System.Drawing.Size)(resources.GetObject("m_splMaster.Size")));
			this.m_splMaster.TabIndex = ((int)(resources.GetObject("m_splMaster.TabIndex")));
			this.m_splMaster.TabStop = false;
			this.m_splMaster.Visible = ((bool)(resources.GetObject("m_splMaster.Visible")));
			// 
			// m_grdMaster
			// 
			this.m_grdMaster.AccessibleDescription = resources.GetString("m_grdMaster.AccessibleDescription");
			this.m_grdMaster.AccessibleName = resources.GetString("m_grdMaster.AccessibleName");
			this.m_grdMaster.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("m_grdMaster.Anchor")));
			this.m_grdMaster.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.m_grdMaster.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("m_grdMaster.BackgroundImage")));
			this.m_grdMaster.CaptionBackColor = System.Drawing.Color.Gainsboro;
			this.m_grdMaster.CaptionFont = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.CaptionFont")));
			this.m_grdMaster.CaptionForeColor = System.Drawing.Color.Black;
			this.m_grdMaster.CaptionText = resources.GetString("m_grdMaster.CaptionText");
			this.m_grdMaster.ContextMenu = this.m_cmMain;
			this.m_grdMaster.DataMember = "";
			this.m_grdMaster.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("m_grdMaster.Dock")));
			this.m_grdMaster.Enabled = ((bool)(resources.GetObject("m_grdMaster.Enabled")));
			this.m_grdMaster.Font = ((System.Drawing.Font)(resources.GetObject("m_grdMaster.Font")));
			this.m_grdMaster.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_grdMaster.HighlightRow = true;
			this.m_grdMaster.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("m_grdMaster.ImeMode")));
			this.m_grdMaster.Location = ((System.Drawing.Point)(resources.GetObject("m_grdMaster.Location")));
			this.m_grdMaster.Name = "m_grdMaster";
			this.m_grdMaster.ReadOnly = true;
			this.m_grdMaster.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("m_grdMaster.RightToLeft")));
			this.m_grdMaster.Size = ((System.Drawing.Size)(resources.GetObject("m_grdMaster.Size")));
			this.m_grdMaster.TabIndex = ((int)(resources.GetObject("m_grdMaster.TabIndex")));
			this.m_grdMaster.Visible = ((bool)(resources.GetObject("m_grdMaster.Visible")));
			this.m_grdMaster.CurrentCellChanged += new System.EventHandler(this.m_grdMaster_CurrentCellChanged);
			// 
			// ThreeGridHor
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.Controls.Add(this.m_pnlFill);
			this.Controls.Add(this.m_grbParam);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.Name = "ThreeGridHor";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.Size = ((System.Drawing.Size)(resources.GetObject("$this.Size")));
			this.Load += new System.EventHandler(this.ThreeGridHorForm_Load);
			this.Controls.SetChildIndex(this.m_tbMain, 0);
			this.Controls.SetChildIndex(this.m_grbParam, 0);
			this.Controls.SetChildIndex(this.m_pnlFill, 0);
			this.m_grbParam.ResumeLayout(false);
			this.m_pnlFill.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.m_grdDetail)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdSecondDetail)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.m_grdMaster)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		/// <summary>
		///     "",  
		/// </summary>
		/// <summary>
		///     "",  
		/// </summary>
		public override void Reload()
		{
			if (!m_bInit)
				return;

			if (m_bControlFieldMaster)
				this.AddFieldFromHash(m_htMasterParam);

			if (m_bControlFieldDetail)
				this.AddFieldFromHash(m_htDetailParam);


			if (m_bControlField2Detail)
				this.AddFieldFromHash(m_ht2DetailParam);


			if (m_bMasterAll)
				m_htMasterParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);

			DataRow dr, dr2;

			if (m_dtMaster.Rows.Count == 0)
				dr = null;
			else
				dr = m_dtMaster.Rows[0];

			AddFieldFromRow(m_htDetailParam, dr, m_strConnectField);

			FillDetail(m_strTuningMaster, m_grdMaster, ref m_dtTuningMaster);


			if (m_bDetailAll)
				m_htDetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
			FillDetail(m_strTuningDetail, m_grdDetail, ref m_dtTuningDetail);

			if (m_iCount == 1)
				if (m_dtDetail.Rows.Count > 0)
					dr2 = m_dtDetail.Rows[0];
				else
					dr2 = null;
			else
				dr2 = dr;

			AddFieldFromRow(m_ht2DetailParam, dr2, m_strConnectField2);


			if (m_b2DetailAll)
				m_ht2DetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
			FillDetail(m_strTuning2Detail, m_grdSecondDetail, ref m_dtTuning2Detail);


		}


		/// <summary>
		///     
		/// </summary>
		/// <param name="sender">,  </param>
		/// <param name="e"> </param>
		private void ThreeGridHorForm_Load(object sender, EventArgs e)
		{
			//Reload();
		}

		/// </summary>
		/// <returns></returns>
		private bool ReadDictionary()
		{
			m_strTuningMaster = this.Tuning;
			using (Command cmdElement = new Command())
			{
				if (m_strTuningMaster != null && m_strTuningMaster != "")
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningMaster;
					cmdElement.Execute(true);
					m_iCount = cmdElement.DataSet.Tables[0].Rows.Count;
					if (m_iCount == 0)
						return false;

					DataTable dtElement = cmdElement.DataSet.Tables[0];
					m_strTuningDetail = dtElement.Rows[0]["tuning_detail"].ToString();
					m_strConnectField = dtElement.Rows[0]["connect_field"].ToString();
					m_strGetMaster = dtElement.Rows[0]["get"].ToString();
					m_strDeleteMaster = dtElement.Rows[0]["del"].ToString();
					m_strKeyFieldMaster = dtElement.Rows[0]["key_field"].ToString();

					if (dtElement.Rows[0]["history_field"] != DBNull.Value)
						m_bMasterAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
					else
						m_bMasterAll = false;

					m_grdMaster.CaptionText = dtElement.Rows[0]["desk"].ToString();

					if (dtElement.Rows[0]["control_field"] != DBNull.Value)
						m_bControlFieldMaster = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
					else
						m_bControlFieldMaster = false;


					if (m_iCount == 2)
					{
						m_strTuning2Detail = dtElement.Rows[1]["tuning_detail"].ToString();
						m_strConnectField2 = dtElement.Rows[1]["connect_field"].ToString();
					}

					if (dtElement.Rows[0]["read_only"] != DBNull.Value)
					{
						if (Convert.ToBoolean(dtElement.Rows[0]["read_only"]))
						{
							m_actInsert.Visible = false;
							m_actDelete.Visible = false;
							m_actEdit.Visible = false;
							m_grdMaster.ContextMenu = null;
						}
					}


				}
				else
					return false;
			}
			using (Command cmdElement = new Command())
				if (m_strTuningDetail != null && m_strTuningDetail != "")
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuningDetail;
					cmdElement.Execute(true);
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					if (cmdElement.DataSet.Tables[0].Rows.Count == 0)
						return false;
					if (m_iCount != 2)
					{
						m_strTuning2Detail = dtElement.Rows[0]["tuning_Detail"].ToString();
						m_strConnectField2 = dtElement.Rows[0]["connect_field"].ToString();
					}
					m_strGetDetail = dtElement.Rows[0]["get"].ToString();
					m_strDeleteDetail = dtElement.Rows[0]["del"].ToString();
					m_strKeyFieldDetail = dtElement.Rows[0]["key_field"].ToString();

					if (dtElement.Rows[0]["history_field"] != DBNull.Value)
						m_bDetailAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
					else
						m_bDetailAll = false;

					m_grdDetail.CaptionText = dtElement.Rows[0]["desk"].ToString();

					if (dtElement.Rows[0]["control_field"] != DBNull.Value)
						m_bControlFieldDetail = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
					else
						m_bControlFieldDetail = false;


					if (dtElement.Rows[0]["read_only"] != DBNull.Value)
					{
						if (Convert.ToBoolean(dtElement.Rows[0]["read_only"]))
						{
							m_grdDetail.ContextMenu = null;
						}
					}

				}
				else
					return false;
			using (Command cmdElement = new Command())
				if (m_strTuning2Detail != null)
				{
					cmdElement.CommandName = "UIGetDictionary";
					cmdElement.InputParams["@tuning"] = m_strTuning2Detail;
					cmdElement.Execute(true);
					if (cmdElement.DataSet.Tables[0].Rows.Count == 0)
						return false;
					DataTable dtElement = cmdElement.DataSet.Tables[0];
					m_strGet2Detail = dtElement.Rows[0]["get"].ToString();
					m_strDelete2Detail = dtElement.Rows[0]["del"].ToString();
					m_strKeyField2Detail = dtElement.Rows[0]["key_field"].ToString();

					if (dtElement.Rows[0]["history_field"] != DBNull.Value)
						m_b2DetailAll = Convert.ToBoolean(dtElement.Rows[0]["history_field"]);
					else
						m_b2DetailAll = false;

					m_grdSecondDetail.CaptionText = dtElement.Rows[0]["desk"].ToString();

					if (dtElement.Rows[0]["control_field"] != DBNull.Value)
						m_bControlField2Detail = Convert.ToBoolean(dtElement.Rows[0]["control_field"]);
					else
						m_bControlField2Detail = false;

					if (dtElement.Rows[0]["read_only"] != DBNull.Value)
					{
						if (Convert.ToBoolean(dtElement.Rows[0]["read_only"]))
						{
							m_grdSecondDetail.ContextMenu = null;
						}
					}

				}
				else
					return false;

			if (!m_bDetailAll && !m_b2DetailAll && !m_bMasterAll)
				m_grbParam.Visible = false;


			return true;

		}

		private void m_grdMaster_CurrentCellChanged(object sender, EventArgs e)
		{
			DataRow dr, dr2;

			dr = m_grdMaster.CurrentRow;
			AddFieldFromRow(m_htDetailParam, dr, m_strConnectField);

			if (m_bDetailAll)
				m_htDetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);


			if (m_iCount == 1)
				if (m_dtDetail.Rows.Count > 0)
					dr2 = m_dtDetail.Rows[0];
				else
					dr2 = null;
			else
				dr2 = dr;

			AddFieldFromRow(m_ht2DetailParam, dr2, m_strConnectField2);

			if (m_b2DetailAll)
				m_ht2DetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
			FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);


		}


		private void m_actMasterInsert_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdMaster, null, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());
			}

		}

		private void m_actMasterEdit_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdMaster, m_strKeyFieldMaster, ref m_dtTuningMaster, m_htMasterParam, out iIndex))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);
				m_grdMaster.SelectRow(m_strKeyFieldMaster, iIndex.ToString());
			}

		}

		private void m_actMasterDelete_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDeleteMaster, m_strKeyFieldMaster, m_grdMaster))
			{
				FillInside(m_strGetMaster, m_grdMaster, m_htMasterParam, ref m_dtMaster, m_actDelete, m_actEdit);

			}


		}

		private void m_chkChange_CheckedChanged(object sender, EventArgs e)
		{
			Reload();
		}

		private void m_actDeleteDetail_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDeleteDetail, m_strKeyFieldDetail, m_grdDetail))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);

			}
		}

		private void m_actInsertDetail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdDetail, null, ref m_dtTuningDetail, m_htDetailParam, out iIndex))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
				m_grdDetail.SelectRow(m_strKeyFieldDetail, iIndex.ToString());
			}

		}

		private void m_actEditDetail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdDetail, m_strKeyFieldDetail, ref m_dtTuningDetail, m_htDetailParam, out iIndex))
			{
				FillInside(m_strGetDetail, m_grdDetail, m_htDetailParam, ref m_dtDetail, m_actEditDetail, m_actDeleteDetail);
				m_grdDetail.SelectRow(m_strKeyFieldDetail, iIndex.ToString());
			}
		}


		private void m_actDelete2Detail_Execute(object sender, EventArgs e)
		{
			if (Delete(m_strDelete2Detail, m_strKeyField2Detail, m_grdSecondDetail))
			{
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);

			}

		}

		private void m_actInsert2Detail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Insert, m_grdSecondDetail, null, ref m_dtTuning2Detail, m_ht2DetailParam, out iIndex))
			{
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
				m_grdSecondDetail.SelectRow(m_strKeyField2Detail, iIndex.ToString());
			}

		}

		private void m_actEdit2Detail_Execute(object sender, EventArgs e)
		{
			int iIndex;
			if (Operation(OperationType.Edit, m_grdSecondDetail, m_strKeyField2Detail, ref m_dtTuning2Detail, m_ht2DetailParam, out iIndex))
			{
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
				m_grdSecondDetail.SelectRow(m_strKeyField2Detail, iIndex.ToString());
			}

		}


		private void m_grdDetail_CurrentCellChanged(object sender, EventArgs e)
		{
			if (m_iCount == 1)
			{
				DataRow dr2;
				dr2 = m_grdDetail.CurrentRow;
				AddFieldFromRow(m_ht2DetailParam, dr2, m_strConnectField2);
				if (m_b2DetailAll)
					m_ht2DetailParam["all"] = Convert.ToInt32(m_chkChange.Checked);
				FillInside(m_strGet2Detail, m_grdSecondDetail, m_ht2DetailParam, ref m_dt2Detail, m_actEdit2Detail, m_actDelete2Detail);
			}

		}


	}
}
/********************* SniipSoftel *****************
 *
 *    $History: ThreeGridHor.cs $
 *   
 *   *****************  Version 9  *****************
 *   User: Gavrilov     Date: 14.05.07   Time: 19:05
 *   Updated in $/Net/Common/ClientControl/MultiGrid
 *   
 *   *****************  Version 7  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 6  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *   
 *   *****************  Version 5  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/MultiGrid
 *
 ********************* SniipSoftel *****************/
