/********************* SniipSoftel *****************
 *
 *   $Author: Serg_ch $
 *   $Revision: 6 $
 *   $Date: 29.01.07 15:44 $
 *
 ********************* SniipSoftel *****************/
using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;
using System.IO;
using System.Windows.Forms;

namespace Softel.Windows.Forms
{
    /// <summary>
    /// Summary description for StaffEditor.
    /// </summary>
    public class StaffEditor : Form
    {
        private Panel panel1;
        private System.Windows.Forms.Button m_btnOk;
        private System.Windows.Forms.Button m_btnCancel;
        private ContextMenu m_cmElements;
        private MenuItem menuItem1;
        private MenuItem menuItem2;
        private IContainer components = null;

        /// <summary>
        ///   
        /// </summary>
        private PropertyGrid m_pgPreview;

        private Hashtable m_htValues = null;
        private Hashtable m_htParams = null;
        private Param m_parNew = null;
        private System.Windows.Forms.Button m_btnAdd;
        private System.Windows.Forms.Button m_btnDelete;
        private Panel panel2;
        private PropertyGrid m_pgProperty;

        /// <summary>
        ///      <see cref="System.Windows.Forms.PropertyGrid"/>
        /// </summary>
        private ParamBag m_objParamBag;

        public StaffEditor()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            m_htValues = new Hashtable();
            m_htParams = new Hashtable();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        public ParamBag GetBag()
        {
            foreach(Param parAtt in m_objParamBag.Params)
                parAtt.ClearAttribute();
            return m_objParamBag;
        }

        public void SetBag(ParamBag objParamBag)
        {
            if(objParamBag != null)
            {
                m_objParamBag = new ParamBag();
                m_htParams.Clear();
                m_htValues.Clear();
                string strName = "";
                foreach(Param objParam in objParamBag.Params)
                {
                    strName = string.Format("{0}|{1}", objParam.Name, objParam.Category);
                    m_parNew =
                        new Param(
                            objParam.Name, objParam.Type, objParam.Category, objParam.Description, objParam.DefaultValue);
                    m_htParams[strName] = m_parNew;
                    m_htValues[strName] = new Hashtable();
                    ((Hashtable) m_htValues[strName])[ResourceControl.String35] = objParam.Name;
                    ((Hashtable) m_htValues[strName])[ResourceControl.String36] = objParam.Category;
                    ((Hashtable) m_htValues[strName])[ResourceControl.String37] = objParam.Description;
                    ((Hashtable) m_htValues[strName])[ResourceControl.String38] = objParam.Type;
                    m_objParamBag.Params.Add(m_parNew);
                }
//				m_objParamBag = objParamBag;
            }
            else
                m_objParamBag = new ParamBag();
            m_pgPreview.SelectedObject = m_objParamBag;
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if(disposing)
            {
                if(components != null)
                    components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(StaffEditor));
            this.panel1 = new System.Windows.Forms.Panel();
            this.m_btnOk = new System.Windows.Forms.Button();
            this.m_btnCancel = new System.Windows.Forms.Button();
            this.m_pgPreview = new System.Windows.Forms.PropertyGrid();
            this.m_cmElements = new System.Windows.Forms.ContextMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.m_btnAdd = new System.Windows.Forms.Button();
            this.m_btnDelete = new System.Windows.Forms.Button();
            this.panel2 = new System.Windows.Forms.Panel();
            this.m_pgProperty = new System.Windows.Forms.PropertyGrid();
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.AccessibleDescription = resources.GetString("panel1.AccessibleDescription");
            this.panel1.AccessibleName = resources.GetString("panel1.AccessibleName");
            this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("panel1.Anchor")));
            this.panel1.AutoScroll = ((bool) (resources.GetObject("panel1.AutoScroll")));
            this.panel1.AutoScrollMargin = ((System.Drawing.Size) (resources.GetObject("panel1.AutoScrollMargin")));
            this.panel1.AutoScrollMinSize = ((System.Drawing.Size) (resources.GetObject("panel1.AutoScrollMinSize")));
            this.panel1.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("panel1.BackgroundImage")));
            this.panel1.Controls.Add(this.m_btnOk);
            this.panel1.Controls.Add(this.m_btnCancel);
            this.panel1.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("panel1.Dock")));
            this.panel1.Enabled = ((bool) (resources.GetObject("panel1.Enabled")));
            this.panel1.Font = ((System.Drawing.Font) (resources.GetObject("panel1.Font")));
            this.panel1.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("panel1.ImeMode")));
            this.panel1.Location = ((System.Drawing.Point) (resources.GetObject("panel1.Location")));
            this.panel1.Name = "panel1";
            this.panel1.RightToLeft = ((System.Windows.Forms.RightToLeft) (resources.GetObject("panel1.RightToLeft")));
            this.panel1.Size = ((System.Drawing.Size) (resources.GetObject("panel1.Size")));
            this.panel1.TabIndex = ((int) (resources.GetObject("panel1.TabIndex")));
            this.panel1.Text = resources.GetString("panel1.Text");
            this.panel1.Visible = ((bool) (resources.GetObject("panel1.Visible")));
            // 
            // m_btnOk
            // 
            this.m_btnOk.AccessibleDescription = resources.GetString("m_btnOk.AccessibleDescription");
            this.m_btnOk.AccessibleName = resources.GetString("m_btnOk.AccessibleName");
            this.m_btnOk.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("m_btnOk.Anchor")));
            this.m_btnOk.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("m_btnOk.BackgroundImage")));
            this.m_btnOk.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("m_btnOk.Dock")));
            this.m_btnOk.Enabled = ((bool) (resources.GetObject("m_btnOk.Enabled")));
            this.m_btnOk.FlatStyle = ((System.Windows.Forms.FlatStyle) (resources.GetObject("m_btnOk.FlatStyle")));
            this.m_btnOk.Font = ((System.Drawing.Font) (resources.GetObject("m_btnOk.Font")));
            this.m_btnOk.Image = ((System.Drawing.Image) (resources.GetObject("m_btnOk.Image")));
            this.m_btnOk.ImageAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnOk.ImageAlign")));
            this.m_btnOk.ImageIndex = ((int) (resources.GetObject("m_btnOk.ImageIndex")));
            this.m_btnOk.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("m_btnOk.ImeMode")));
            this.m_btnOk.Location = ((System.Drawing.Point) (resources.GetObject("m_btnOk.Location")));
            this.m_btnOk.Name = "m_btnOk";
            this.m_btnOk.RightToLeft = ((System.Windows.Forms.RightToLeft) (resources.GetObject("m_btnOk.RightToLeft")));
            this.m_btnOk.Size = ((System.Drawing.Size) (resources.GetObject("m_btnOk.Size")));
            this.m_btnOk.TabIndex = ((int) (resources.GetObject("m_btnOk.TabIndex")));
            this.m_btnOk.Text = resources.GetString("m_btnOk.Text");
            this.m_btnOk.TextAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnOk.TextAlign")));
            this.m_btnOk.Visible = ((bool) (resources.GetObject("m_btnOk.Visible")));
            this.m_btnOk.Click += new System.EventHandler(this.m_btnOk_Click);
            // 
            // m_btnCancel
            // 
            this.m_btnCancel.AccessibleDescription = resources.GetString("m_btnCancel.AccessibleDescription");
            this.m_btnCancel.AccessibleName = resources.GetString("m_btnCancel.AccessibleName");
            this.m_btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("m_btnCancel.Anchor")));
            this.m_btnCancel.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("m_btnCancel.BackgroundImage")));
            this.m_btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.m_btnCancel.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("m_btnCancel.Dock")));
            this.m_btnCancel.Enabled = ((bool) (resources.GetObject("m_btnCancel.Enabled")));
            this.m_btnCancel.FlatStyle = ((System.Windows.Forms.FlatStyle) (resources.GetObject("m_btnCancel.FlatStyle")));
            this.m_btnCancel.Font = ((System.Drawing.Font) (resources.GetObject("m_btnCancel.Font")));
            this.m_btnCancel.Image = ((System.Drawing.Image) (resources.GetObject("m_btnCancel.Image")));
            this.m_btnCancel.ImageAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnCancel.ImageAlign")));
            this.m_btnCancel.ImageIndex = ((int) (resources.GetObject("m_btnCancel.ImageIndex")));
            this.m_btnCancel.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("m_btnCancel.ImeMode")));
            this.m_btnCancel.Location = ((System.Drawing.Point) (resources.GetObject("m_btnCancel.Location")));
            this.m_btnCancel.Name = "m_btnCancel";
            this.m_btnCancel.RightToLeft =
                ((System.Windows.Forms.RightToLeft) (resources.GetObject("m_btnCancel.RightToLeft")));
            this.m_btnCancel.Size = ((System.Drawing.Size) (resources.GetObject("m_btnCancel.Size")));
            this.m_btnCancel.TabIndex = ((int) (resources.GetObject("m_btnCancel.TabIndex")));
            this.m_btnCancel.Text = resources.GetString("m_btnCancel.Text");
            this.m_btnCancel.TextAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnCancel.TextAlign")));
            this.m_btnCancel.Visible = ((bool) (resources.GetObject("m_btnCancel.Visible")));
            // 
            // m_pgPreview
            // 
            this.m_pgPreview.AccessibleDescription = resources.GetString("m_pgPreview.AccessibleDescription");
            this.m_pgPreview.AccessibleName = resources.GetString("m_pgPreview.AccessibleName");
            this.m_pgPreview.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("m_pgPreview.Anchor")));
            this.m_pgPreview.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("m_pgPreview.BackgroundImage")));
            this.m_pgPreview.CommandsVisibleIfAvailable = true;
            this.m_pgPreview.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("m_pgPreview.Dock")));
            this.m_pgPreview.Enabled = ((bool) (resources.GetObject("m_pgPreview.Enabled")));
            this.m_pgPreview.Font = ((System.Drawing.Font) (resources.GetObject("m_pgPreview.Font")));
            this.m_pgPreview.HelpVisible = ((bool) (resources.GetObject("m_pgPreview.HelpVisible")));
            this.m_pgPreview.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("m_pgPreview.ImeMode")));
            this.m_pgPreview.LargeButtons = false;
            this.m_pgPreview.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.m_pgPreview.Location = ((System.Drawing.Point) (resources.GetObject("m_pgPreview.Location")));
            this.m_pgPreview.Name = "m_pgPreview";
            this.m_pgPreview.RightToLeft =
                ((System.Windows.Forms.RightToLeft) (resources.GetObject("m_pgPreview.RightToLeft")));
            this.m_pgPreview.Size = ((System.Drawing.Size) (resources.GetObject("m_pgPreview.Size")));
            this.m_pgPreview.TabIndex = ((int) (resources.GetObject("m_pgPreview.TabIndex")));
            this.m_pgPreview.Text = resources.GetString("m_pgPreview.Text");
            this.m_pgPreview.ViewBackColor = System.Drawing.SystemColors.Window;
            this.m_pgPreview.ViewForeColor = System.Drawing.SystemColors.WindowText;
            this.m_pgPreview.Visible = ((bool) (resources.GetObject("m_pgPreview.Visible")));
            this.m_pgPreview.SelectedGridItemChanged +=
                new System.Windows.Forms.SelectedGridItemChangedEventHandler(this.m_pgPreview_SelectedGridItemChanged);
            // 
            // m_cmElements
            // 
            this.m_cmElements.MenuItems.AddRange(
                new System.Windows.Forms.MenuItem[]
                    {
                        this.menuItem1,
                        this.menuItem2
                    });
            this.m_cmElements.RightToLeft =
                ((System.Windows.Forms.RightToLeft) (resources.GetObject("m_cmElements.RightToLeft")));
            // 
            // menuItem1
            // 
            this.menuItem1.Enabled = ((bool) (resources.GetObject("menuItem1.Enabled")));
            this.menuItem1.Index = 0;
            this.menuItem1.Shortcut = ((System.Windows.Forms.Shortcut) (resources.GetObject("menuItem1.Shortcut")));
            this.menuItem1.ShowShortcut = ((bool) (resources.GetObject("menuItem1.ShowShortcut")));
            this.menuItem1.Text = resources.GetString("menuItem1.Text");
            this.menuItem1.Visible = ((bool) (resources.GetObject("menuItem1.Visible")));
            // 
            // menuItem2
            // 
            this.menuItem2.Enabled = ((bool) (resources.GetObject("menuItem2.Enabled")));
            this.menuItem2.Index = 1;
            this.menuItem2.Shortcut = ((System.Windows.Forms.Shortcut) (resources.GetObject("menuItem2.Shortcut")));
            this.menuItem2.ShowShortcut = ((bool) (resources.GetObject("menuItem2.ShowShortcut")));
            this.menuItem2.Text = resources.GetString("menuItem2.Text");
            this.menuItem2.Visible = ((bool) (resources.GetObject("menuItem2.Visible")));
            // 
            // m_btnAdd
            // 
            this.m_btnAdd.AccessibleDescription = resources.GetString("m_btnAdd.AccessibleDescription");
            this.m_btnAdd.AccessibleName = resources.GetString("m_btnAdd.AccessibleName");
            this.m_btnAdd.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("m_btnAdd.Anchor")));
            this.m_btnAdd.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("m_btnAdd.BackgroundImage")));
            this.m_btnAdd.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("m_btnAdd.Dock")));
            this.m_btnAdd.Enabled = ((bool) (resources.GetObject("m_btnAdd.Enabled")));
            this.m_btnAdd.FlatStyle = ((System.Windows.Forms.FlatStyle) (resources.GetObject("m_btnAdd.FlatStyle")));
            this.m_btnAdd.Font = ((System.Drawing.Font) (resources.GetObject("m_btnAdd.Font")));
            this.m_btnAdd.Image = ((System.Drawing.Image) (resources.GetObject("m_btnAdd.Image")));
            this.m_btnAdd.ImageAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnAdd.ImageAlign")));
            this.m_btnAdd.ImageIndex = ((int) (resources.GetObject("m_btnAdd.ImageIndex")));
            this.m_btnAdd.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("m_btnAdd.ImeMode")));
            this.m_btnAdd.Location = ((System.Drawing.Point) (resources.GetObject("m_btnAdd.Location")));
            this.m_btnAdd.Name = "m_btnAdd";
            this.m_btnAdd.RightToLeft = ((System.Windows.Forms.RightToLeft) (resources.GetObject("m_btnAdd.RightToLeft")));
            this.m_btnAdd.Size = ((System.Drawing.Size) (resources.GetObject("m_btnAdd.Size")));
            this.m_btnAdd.TabIndex = ((int) (resources.GetObject("m_btnAdd.TabIndex")));
            this.m_btnAdd.Text = resources.GetString("m_btnAdd.Text");
            this.m_btnAdd.TextAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnAdd.TextAlign")));
            this.m_btnAdd.Visible = ((bool) (resources.GetObject("m_btnAdd.Visible")));
            this.m_btnAdd.Click += new System.EventHandler(this.m_btnAdd_Click);
            // 
            // m_btnDelete
            // 
            this.m_btnDelete.AccessibleDescription = resources.GetString("m_btnDelete.AccessibleDescription");
            this.m_btnDelete.AccessibleName = resources.GetString("m_btnDelete.AccessibleName");
            this.m_btnDelete.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("m_btnDelete.Anchor")));
            this.m_btnDelete.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("m_btnDelete.BackgroundImage")));
            this.m_btnDelete.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("m_btnDelete.Dock")));
            this.m_btnDelete.Enabled = ((bool) (resources.GetObject("m_btnDelete.Enabled")));
            this.m_btnDelete.FlatStyle = ((System.Windows.Forms.FlatStyle) (resources.GetObject("m_btnDelete.FlatStyle")));
            this.m_btnDelete.Font = ((System.Drawing.Font) (resources.GetObject("m_btnDelete.Font")));
            this.m_btnDelete.Image = ((System.Drawing.Image) (resources.GetObject("m_btnDelete.Image")));
            this.m_btnDelete.ImageAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnDelete.ImageAlign")));
            this.m_btnDelete.ImageIndex = ((int) (resources.GetObject("m_btnDelete.ImageIndex")));
            this.m_btnDelete.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("m_btnDelete.ImeMode")));
            this.m_btnDelete.Location = ((System.Drawing.Point) (resources.GetObject("m_btnDelete.Location")));
            this.m_btnDelete.Name = "m_btnDelete";
            this.m_btnDelete.RightToLeft =
                ((System.Windows.Forms.RightToLeft) (resources.GetObject("m_btnDelete.RightToLeft")));
            this.m_btnDelete.Size = ((System.Drawing.Size) (resources.GetObject("m_btnDelete.Size")));
            this.m_btnDelete.TabIndex = ((int) (resources.GetObject("m_btnDelete.TabIndex")));
            this.m_btnDelete.Text = resources.GetString("m_btnDelete.Text");
            this.m_btnDelete.TextAlign = ((System.Drawing.ContentAlignment) (resources.GetObject("m_btnDelete.TextAlign")));
            this.m_btnDelete.Visible = ((bool) (resources.GetObject("m_btnDelete.Visible")));
            this.m_btnDelete.Click += new System.EventHandler(this.m_btnDelete_Click);
            // 
            // panel2
            // 
            this.panel2.AccessibleDescription = resources.GetString("panel2.AccessibleDescription");
            this.panel2.AccessibleName = resources.GetString("panel2.AccessibleName");
            this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("panel2.Anchor")));
            this.panel2.AutoScroll = ((bool) (resources.GetObject("panel2.AutoScroll")));
            this.panel2.AutoScrollMargin = ((System.Drawing.Size) (resources.GetObject("panel2.AutoScrollMargin")));
            this.panel2.AutoScrollMinSize = ((System.Drawing.Size) (resources.GetObject("panel2.AutoScrollMinSize")));
            this.panel2.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("panel2.BackgroundImage")));
            this.panel2.Controls.Add(this.m_pgProperty);
            this.panel2.Controls.Add(this.m_btnAdd);
            this.panel2.Controls.Add(this.m_btnDelete);
            this.panel2.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("panel2.Dock")));
            this.panel2.Enabled = ((bool) (resources.GetObject("panel2.Enabled")));
            this.panel2.Font = ((System.Drawing.Font) (resources.GetObject("panel2.Font")));
            this.panel2.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("panel2.ImeMode")));
            this.panel2.Location = ((System.Drawing.Point) (resources.GetObject("panel2.Location")));
            this.panel2.Name = "panel2";
            this.panel2.RightToLeft = ((System.Windows.Forms.RightToLeft) (resources.GetObject("panel2.RightToLeft")));
            this.panel2.Size = ((System.Drawing.Size) (resources.GetObject("panel2.Size")));
            this.panel2.TabIndex = ((int) (resources.GetObject("panel2.TabIndex")));
            this.panel2.Text = resources.GetString("panel2.Text");
            this.panel2.Visible = ((bool) (resources.GetObject("panel2.Visible")));
            // 
            // m_pgProperty
            // 
            this.m_pgProperty.AccessibleDescription = resources.GetString("m_pgProperty.AccessibleDescription");
            this.m_pgProperty.AccessibleName = resources.GetString("m_pgProperty.AccessibleName");
            this.m_pgProperty.Anchor = ((System.Windows.Forms.AnchorStyles) (resources.GetObject("m_pgProperty.Anchor")));
            this.m_pgProperty.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("m_pgProperty.BackgroundImage")));
            this.m_pgProperty.CommandsVisibleIfAvailable = true;
            this.m_pgProperty.Dock = ((System.Windows.Forms.DockStyle) (resources.GetObject("m_pgProperty.Dock")));
            this.m_pgProperty.Enabled = ((bool) (resources.GetObject("m_pgProperty.Enabled")));
            this.m_pgProperty.Font = ((System.Drawing.Font) (resources.GetObject("m_pgProperty.Font")));
            this.m_pgProperty.HelpVisible = ((bool) (resources.GetObject("m_pgProperty.HelpVisible")));
            this.m_pgProperty.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("m_pgProperty.ImeMode")));
            this.m_pgProperty.LargeButtons = false;
            this.m_pgProperty.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.m_pgProperty.Location = ((System.Drawing.Point) (resources.GetObject("m_pgProperty.Location")));
            this.m_pgProperty.Name = "m_pgProperty";
            this.m_pgProperty.RightToLeft =
                ((System.Windows.Forms.RightToLeft) (resources.GetObject("m_pgProperty.RightToLeft")));
            this.m_pgProperty.Size = ((System.Drawing.Size) (resources.GetObject("m_pgProperty.Size")));
            this.m_pgProperty.TabIndex = ((int) (resources.GetObject("m_pgProperty.TabIndex")));
            this.m_pgProperty.Text = resources.GetString("m_pgProperty.Text");
            this.m_pgProperty.ViewBackColor = System.Drawing.SystemColors.Window;
            this.m_pgProperty.ViewForeColor = System.Drawing.SystemColors.WindowText;
            this.m_pgProperty.Visible = ((bool) (resources.GetObject("m_pgProperty.Visible")));
            // 
            // StaffEditor
            // 
            this.AcceptButton = this.m_btnOk;
            this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
            this.AccessibleName = resources.GetString("$this.AccessibleName");
            this.AutoScaleBaseSize = ((System.Drawing.Size) (resources.GetObject("$this.AutoScaleBaseSize")));
            this.AutoScroll = ((bool) (resources.GetObject("$this.AutoScroll")));
            this.AutoScrollMargin = ((System.Drawing.Size) (resources.GetObject("$this.AutoScrollMargin")));
            this.AutoScrollMinSize = ((System.Drawing.Size) (resources.GetObject("$this.AutoScrollMinSize")));
            this.BackgroundImage = ((System.Drawing.Image) (resources.GetObject("$this.BackgroundImage")));
            this.CancelButton = this.m_btnCancel;
            this.ClientSize = ((System.Drawing.Size) (resources.GetObject("$this.ClientSize")));
            this.ControlBox = false;
            this.Controls.Add(this.panel2);
            this.Controls.Add(this.m_pgPreview);
            this.Controls.Add(this.panel1);
            this.Enabled = ((bool) (resources.GetObject("$this.Enabled")));
            this.Font = ((System.Drawing.Font) (resources.GetObject("$this.Font")));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon) (resources.GetObject("$this.Icon")));
            this.ImeMode = ((System.Windows.Forms.ImeMode) (resources.GetObject("$this.ImeMode")));
            this.Location = ((System.Drawing.Point) (resources.GetObject("$this.Location")));
            this.MaximumSize = ((System.Drawing.Size) (resources.GetObject("$this.MaximumSize")));
            this.MinimumSize = ((System.Drawing.Size) (resources.GetObject("$this.MinimumSize")));
            this.Name = "StaffEditor";
            this.RightToLeft = ((System.Windows.Forms.RightToLeft) (resources.GetObject("$this.RightToLeft")));
            this.StartPosition = ((System.Windows.Forms.FormStartPosition) (resources.GetObject("$this.StartPosition")));
            this.Text = resources.GetString("$this.Text");
            this.panel1.ResumeLayout(false);
            this.panel2.ResumeLayout(false);
            this.ResumeLayout(false);
        }

        #endregion

        private void AddProperty(Param parCurrent)
        {
            ParamBag objBag = new ParamBag();
            objBag.SetValue += new ParamEventHandler(pb_SetValue);
            objBag.GetValue += new ParamEventHandler(pb_GetValue);
            objBag.Params.Add(
                new Param(
                    ResourceControl.String35,
                    ParamsType.String,
                    ResourceControl.String39,
                    ResourceControl.String40,
                    parCurrent == null ? "New Param" : parCurrent.Name));
            objBag.Params.Add(
                new Param(
                    ResourceControl.String36,
                    ParamsType.String,
                    ResourceControl.String39,
                    ResourceControl.String41,
                    parCurrent == null ? "Description Param" : parCurrent.Description));
            objBag.Params.Add(
                new Param(
                    ResourceControl.String37,
                    ParamsType.String,
                    ResourceControl.String39,
                    ResourceControl.String42,
                    parCurrent == null ? ResourceControl.String44 : parCurrent.Category));
            Param parType =
                new Param(ResourceControl.String38, ParamsType.List, ResourceControl.String39, ResourceControl.String43);
            parType.List = new ArrayList();
            parType.List.Add("Int");
            parType.List.Add("Float");
            parType.List.Add("String");
            parType.List.Add("Image");
            parType.List.Add("Data");
            parType.List.Add("File");
            parType.List.Add("Folder");
            parType.List.Add("List");
            parType.List.Add("Font");
            parType.List.Add("Boolean");
            parType.List.Add("DateTime");
            parType.DefaultValue = parCurrent == null ? ParamsType.String : parCurrent.Type;

            objBag.Params.Add(parType);
            m_pgProperty.SelectedObject = objBag;
//			AdditionalParams(parCurrent, parCurrent == null ? ParamsType.String : parCurrent.Type);

            if(parCurrent == null)
            {
                m_parNew = new Param("New Param", ParamsType.String, ResourceControl.String44, "Description Param", "");
                string strName = ResourceControl.String45;
                if(!m_htParams.ContainsKey(strName))
                {
                    m_htValues[strName] = new Hashtable();
                    m_htParams[strName] = m_parNew;
                    m_objParamBag.Params.Add(m_parNew);
                    m_pgPreview.SelectedObject = m_objParamBag;
                }
            }
            m_pgProperty.Refresh();
        }

        private void m_btnAdd_Click(object sender, EventArgs e)
        {
            AddProperty(null);
        }

        public void AddAttribute(Param parNodes, Attribute attInsert)
        {
            ArrayList alAtt = new ArrayList(parNodes.Attributes);
            alAtt.Add(attInsert);
            parNodes.Attributes = (Attribute[]) alAtt.ToArray(typeof(Attribute));
        }

        private void AdditionalParams(Param objParam, ParamsType ptType)
        {
            string strName =
                string.Format(
                    "{0}|{1}",
                    m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName,
                    m_pgPreview.SelectedGridItem.PropertyDescriptor.Category);
            switch(ptType)
            {
                case ParamsType.Data:
                    m_parNew = new Param("Data Key", ParamsType.String, "Data", ResourceControl.String46, objParam.DataKey);
                    ((ParamBag) m_pgProperty.SelectedObject).Params.Add(m_parNew);
                    ((Hashtable) m_htValues[strName])["Data Key"] = objParam.DataKey;
                    m_parNew =
                        new Param("Data Value", ParamsType.String, "Data", ResourceControl.String47, objParam.DataValue);
                    ((ParamBag) m_pgProperty.SelectedObject).Params.Add(m_parNew);
                    ((Hashtable) m_htValues[strName])["Data Value"] = objParam.DataValue;
                    m_parNew =
                        new Param("Data Table", "System.Data.DataTable", "Data", ResourceControl.String48, objParam.Table);
                    ((ParamBag) m_pgProperty.SelectedObject).Params.Add(m_parNew);
                    ((Hashtable) m_htValues[strName])["Data Table"] = objParam.Table;
                    break;
            }
        }

        private void pb_SetValue(object sender, ParamEventArgs e)
        {
            string strName =
                string.Format(
                    "{0}|{1}",
                    m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName,
                    m_pgPreview.SelectedGridItem.PropertyDescriptor.Category);
            string strNewName = strName;

            if(e.Property.Name == ResourceControl.String35)
                strNewName = string.Format("{0}|{1}", e.Value, m_pgPreview.SelectedGridItem.PropertyDescriptor.Category);
            if(e.Property.Name == ResourceControl.String36)
                strNewName = string.Format("{0}|{1}", m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName, e.Value);

            Hashtable htValues = (Hashtable) m_htValues[strName];
            htValues[e.Property.Name] = e.Value;
            m_htValues[strNewName] = m_htValues[strName];
            m_htParams[strNewName] = m_htParams[strName];
            if(strNewName != strName)
            {
                m_htValues.Remove(strName);
                m_htParams.Remove(strName);
            }
            strName = strNewName;
            if(e.Property.Name == ResourceControl.String35)
            {
                ((Param) m_htParams[strName]).Name = (string) e.Value;
//					((ParamBag)m_pgPreview.SelectedObject).Params[m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName].Name = (string)e.Value;
            }
            else if(e.Property.Name == ResourceControl.String37)
            {
                ((Param) m_htParams[strName]).Description = (string) e.Value;
//					((ParamBag)m_pgPreview.SelectedObject).Params[m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName].Description = (string)e.Value;
            }
            else if(e.Property.Name == ResourceControl.String36)
            {
                ((Param) m_htParams[strName]).Category = (string) e.Value;
//					((ParamBag)m_pgPreview.SelectedObject).Params[m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName].Category = (string)e.Value;
            }
            else if(e.Property.Name == ResourceControl.String38)
            {
                ArrayList alAtt = new ArrayList(((Param) m_htParams[strName]).Attributes);
                ArrayList alAttNew = new ArrayList(((Param) m_htParams[strName]).Attributes);
                foreach(Attribute att in alAtt)
                {
                    if(att is EditorAttribute)
                        alAttNew.Remove(att);
                }
//					foreach(DictionaryEntry objEntry in m_htValues)
//					{
//						Hashtable htPar1 = (Hashtable)objEntry.Value;
//						Hashtable htPar2 = (Hashtable)objEntry.Value;
//						string strKey = "";
//						foreach(DictionaryEntry objCur in htPar1)
//						{
//							strKey = (string)objCur.Key;
//							if(strKey != "" && strKey != "" && strKey != "" && strKey != "")
//							{
//								htPar2.Remove(objCur.Key);
//								((ParamBag)m_pgProperty.SelectedObject).Params.Remove(strKey);
//								htPar1 = (Hashtable)objEntry.Value;
//							}
//						}
//					}
                ((Param) m_htParams[strName]).Attributes = (Attribute[]) alAttNew.ToArray(typeof(Attribute));
                string strType = (string) e.Value;
                ParamsType ptType = ParamsType.String;
                switch(strType)
                {
                    case "Boolean":
                        strType = "System.Boolean";
                        ptType = ParamsType.Boolean;
                        ((Param) m_htParams[strName]).DefaultValue = true;
                        break;
                    case "Data":
                        strType = "System.String";
                        ptType = ParamsType.Data;
                        AddAttribute(
                            ((Param) m_htParams[strName]),
                            new EditorAttribute(typeof(PropertyListEditor), typeof(UITypeEditor)));
                        ((Param) m_htParams[strName]).DefaultValue = "";
//							AdditionalParams((Param)m_htParams[strName], ptType);
                        break;
                    case "File":
                        strType = "System.String";
                        ptType = ParamsType.File;
                        AddAttribute(
                            ((Param) m_htParams[strName]),
                            new EditorAttribute(typeof(PropertyFileEditor), typeof(UITypeEditor)));
                        ((Param) m_htParams[strName]).DefaultValue = "";
                        break;
                    case "Float":
                        strType = "System.Double";
                        ptType = ParamsType.Float;
                        ((Param) m_htParams[strName]).DefaultValue = 0;
                        break;
                    case "Folder":
                        strType = "System.String";
                        ptType = ParamsType.Folder;
                        AddAttribute(
                            ((Param) m_htParams[strName]),
                            new EditorAttribute(typeof(PropertyFolderEditor), typeof(UITypeEditor)));
                        ((Param) m_htParams[strName]).DefaultValue = Directory.GetCurrentDirectory();
                        break;
                    case "Font":
                        strType = typeof(Font).AssemblyQualifiedName;
                        ptType = ParamsType.Font;
                        ((Param) m_htParams[strName]).DefaultValue = new Font("Tahoma", 12);
                        break;
                    case "Image":
                        strType = typeof(Image).AssemblyQualifiedName;
                        ptType = ParamsType.Image;
                        ((Param) m_htParams[strName]).DefaultValue = new Bitmap(10, 10);
                        break;
                    case "Int":
                        strType = "System.Decimal";
                        ptType = ParamsType.Int;
                        ((Param) m_htParams[strName]).DefaultValue = 0;
                        break;
                    case "List":
                        strType = "System.String";
                        ptType = ParamsType.List;
                        AddAttribute(
                            ((Param) m_htParams[strName]),
                            new EditorAttribute(typeof(PropertyListEditor), typeof(UITypeEditor)));
                        ((Param) m_htParams[strName]).DefaultValue = "";
                        break;
                    case "String":
                        strType = "System.String";
                        ptType = ParamsType.String;
                        ((Param) m_htParams[strName]).DefaultValue = "";
                        break;
                    case "DateTime":
                        strType = "System.DateTime";
                        ptType = ParamsType.DateTime;
                        ((Param) m_htParams[strName]).DefaultValue = DateTime.Now;
                        break;
                }
                ((Param) m_htParams[strName]).TypeName = strType;
                ((Param) m_htParams[strName]).Type = ptType;
            }

            m_pgProperty.Refresh();
            m_pgPreview.Refresh();
        }

        private
            void pb_GetValue(object sender, ParamEventArgs e)
        {
            if(m_pgPreview.SelectedGridItem.PropertyDescriptor != null)
            {
                string strName =
                    string.Format(
                        "{0}|{1}",
                        m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName,
                        m_pgPreview.SelectedGridItem.PropertyDescriptor.Category);
                if(m_htValues.Contains(strName))
                {
                    object objValue = ((Hashtable) m_htValues[strName])[e.Property.Name];
                    if(objValue == null)
                        e.Value = e.Property.DefaultValue;
                    else
                        e.Value = objValue;
                }
            }
        }

        private
            void m_pgPreview_SelectedGridItemChanged(object sender, SelectedGridItemChangedEventArgs e)
        {
            string strName =
                string.Format(
                    "{0}|{1}",
                    m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName,
                    m_pgPreview.SelectedGridItem.PropertyDescriptor.Category);
            if(e.NewSelection.PropertyDescriptor != null && m_htValues.Contains(strName))
            {
                m_pgProperty.Enabled = true;
                AddProperty((Param) m_htParams[strName]);
            }
            else
                m_pgProperty.Enabled = false;

            m_pgProperty.Refresh();
        }

        private
            void m_btnOk_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }

        private
            void m_btnDelete_Click(object sender, EventArgs e)
        {
            if(m_pgPreview.SelectedGridItem.PropertyDescriptor != null)
            {
                string strName =
                    string.Format(
                        "{0}|{1}",
                        m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName,
                        m_pgPreview.SelectedGridItem.PropertyDescriptor.Category);
                Param par = (Param) m_htParams[strName];
                ((ParamBag) m_pgPreview.SelectedObject).Params.Remove(par);
                m_htParams.Remove(strName);
                m_pgPreview.Refresh();
                m_pgProperty.SelectedObject = null;
                strName =
                    string.Format(
                        "{0}|{1}",
                        m_pgPreview.SelectedGridItem.PropertyDescriptor.DisplayName,
                        m_pgPreview.SelectedGridItem.PropertyDescriptor.Category);
                AddProperty((Param) m_htParams[strName]);
            }
        }
    }
}

/********************* SniipSoftel *****************
 *
 *    $History: StaffEditor.cs $
 *   
 *   *****************  Version 6  *****************
 *   User: Serg_ch      Date: 29.01.07   Time: 15:44
 *   Updated in $/Net/Common/SoftelControl/ParamsDialog
 *   
 *   *****************  Version 5  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 20:16
 *   Updated in $/Net/Common/SoftelControl/ParamsDialog
 *   
 *   *****************  Version 4  *****************
 *   User: Serg_ch      Date: 24.01.07   Time: 14:46
 *   Updated in $/Net/Common/SoftelControl/ParamsDialog
 *   
 *   *****************  Version 3  *****************
 *   User: Autobuild    Date: 19.12.06   Time: 23:18
 *   Updated in $/Net/Common/SoftelControl/PARAMSDIALOG
 *
 ********************* SniipSoftel *****************/